<?php

!defined('XIUNO_ROOT') && exit;

class control extends _control {
	//public $arrcache = array('hotlist', 'hotforums', 'userlist', 'forumlist', 'categories', 'provinces');

	function __construct() {
		parent::__construct();
	}

	public function update() {
		set_time_limit(5 * MINUTE);
		if(!$this->submitcheck()) {
			$this->view->display('admin_cache_update');
		} else {
			$update = array_keys(getgpc('update', 'P'));
			foreach($update as $module) {
				switch ($module) {
					case 'groups':
						$this->cachemodel->update('groups');
						$groups = array_keys($this->db->fetch_all("SELECT groupid FROM www_group", 'groupid'));
						foreach($groups as $groupid) {
							$this->clearcache('group', $groupid);
						}
						break;
					case 'bbs':
						$this->cachemodel->update('bbs');
						$this->cachemodel->update('forums');
						$this->cachemodel->update('forumsdata');
						$fids = array_keys($this->db->fetch_all("SELECT fid FROM bbs_forum", 'fid'));
						foreach($fids as $fid) {
							$this->clearcache('forum', $fid);
						}
						break;
					case 'tops':
						$this->cachemodel->update('top3');
						$fids = $this->db->fetch_all("SELECT fid,type FROM bbs_forum", 'fid');
						foreach($fids as $row) {
							if($row['type'] == 'group') {
								$this->clearcache('top2', $row['fid']);
							} else{
								$this->clearcache('top1', $row['fid']);
							}
						}
						break;
					case 'friendlinks':
						$this->cachemodel->update('friendlinks');
						$this->cachemodel->update('friendlink', 'common');
						$this->cachemodel->update('friendlink', 'bbs');
						$this->cachemodel->update('friendlink', 'union');
						break;
					/*
					case 'template':
						$this->_optimizer_template_cache();
						break;
					*/
					case 'setting':
						break;
					case 'deletetemplate':
						$dir = XIUNO_ROOT.'data/view/';
						$fp = opendir($dir);
						while($file = readdir($fp)) {
							if($file == '.' || $file == '..') {
								continue;
							}
							if(is_file($dir.$file)) {
								unlink($dir.$file);
							}
						}
						$this->create_style_file(array('common', 'calendar', 'editor', 'ajax', 'admin', 'my', 'bbs', 'www'));
						// 
						break;
					case 'sphinxrebuild':
						// TODO
						//pclose(popen('/usr/local/sphinx/bin/indexer --config /usr/local/sphinx/etc/sphinx.conf --rotate subject', 'r'));
						break;
					default:
						break;
				}
			}
			if(!is_file(XIUNO_ROOT.'data/cache/_runtime.js')) {
				$s = $this->merge_js(array(XIUNO_ROOT.'js/common.js', XIUNO_ROOT.'js/menu.js', XIUNO_ROOT.'js/ajax.js'));
				file_put_contents(XIUNO_ROOT.'data/cache/_runtime.js', $s);
			}
			$this->message('»ɹ', XIUNO_HOST_ADMIN.'cache-update.htm');
		}
	}

	// ϲ JS ļ
	private function merge_js($jsfiles) {
		$s = '';
		foreach($jsfiles as $jsfile) {
			$s .= "\r\n".file_get_contents($jsfile);
		}
		$s = preg_replace('#/\*.*?\*/#is', '', $s);
		$s = preg_replace('#(^\s*|\r?\n\s*|(?<=;)\s*)//.*?(?=\r?\n|$)#ism', '', $s);
		$s = preg_replace('#\s{2,}#is', ' ', $s);
		//$s = preg_replace('#[ \t]{2,}#is', ' ', $s);
		$s = trim($s);
		return $s;
	}
	
	// Żģ建棬include
	/*public function _optimizer_template_cache() {
		//  /data/view Ŀ¼
		$d = opendir(XIUNO_ROOT.'data/view');
		// Ȳ header.htm footer.htm ajax_header.htm ajax_footer.htm ģ
		file_get_contents(XIUNO_HOST_BBS.'index.htm');
		file_get_contents(XIUNO_HOST_BBS.'index.htm?inajax=1');
		while($f = readdir($d)) {
			if($f == '.' || $f == '..' || substr($f, -3) != 'php') continue;
			$file = XIUNO_ROOT.'data/view/'.$f;
			$s = file_get_contents($file);
			$p = "/\<\? include \\\$this\-\>gettpl\('(\w+)'\);\?\>/ie";

			$s2 = preg_replace($p, "\$this->cache_replace_template('\\1')", $s);
			if($s != $s2) {
				file_put_contents($file, $s2);
			}
		}
		closedir($d);
	}*/

	function create_style_file($arr) {
		create_css_cache();
	}

	function cache_replace_template($name) {
		$file = XIUNO_ROOT."data/view/$name.php";
		if($name == 'header' || $name == 'footer' || $name == 'admin_header' || $name == 'admin_footer') {
			if($name == 'admin_header') {
				$ajaxfile = XIUNO_ROOT."data/view/ajax_header.php";
			} elseif($name == 'admin_footer') {
				$ajaxfile = XIUNO_ROOT."data/view/admin_footer.php";
			} else {
				$ajaxfile = XIUNO_ROOT."data/view/ajax_$name.php";
			}
			return '<?php
				if($inajax) {
					?>'.(file_exists($ajaxfile) ? file_get_contents($ajaxfile) : '').'<?
				} else {
					?>'.(file_exists($file) ? file_get_contents($file) : '').'<?
				}
			?>';
		} else {
			if(!is_file($file)){
				$this->view->tplfile= (XIUNO_ROOT.'view/default/'.$name.'.htm');
				$this->view->objfile= (XIUNO_ROOT.'data/view/'.$name.'.php');
				$this->view->complie();

			}
			return file_get_contents($file);
		}

	}
}


// copy from install/function.php
function create_css_cache() {
	
	// Ŀ¼$csses
	$csses = array();
	//$csses = array('common', 'bbs', 'calendar', 'editor',  'editor_doc', 'my', 'www', 'admin');
	$d = opendir(XIUNO_ROOT.'view/default');
	while($f = readdir($d)) {
		preg_match('#^css_(\w+)\.htm$#', $f, $m);
		if(!empty($m[1])) {
			$csses[] = $m[1];
		}
	}
	
	// Ŀ¼styleids
	$styleids = array();
	//$styleids = array(1, 2, 3, 5);
	$d = opendir(XIUNO_ROOT.'config');
	while($f = readdir($d)) {
		preg_match('#^style_(\d+)\.php$#', $f, $m);
		if(!empty($m[1])) {
			$styleids[] = $m[1];
		}
	}
	
	foreach($csses as $css) {
		foreach($styleids as $styleid) {
			css_replace_config_const($styleid, $css);
		}
	}
}

// 溯Ϊװʱã
function css_replace_config_const($styleid, $css) {
	$arr = css_get_consts(XIUNO_ROOT.'config/style_'.$styleid.'.php');
	$srcfile = XIUNO_ROOT.'view/'.$arr['TPL'].'/css_'.$css.'.htm';
	if(!is_file($srcfile)) {
		$srcfile = XIUNO_ROOT.'view/default/css_'.$css.'.htm';
	}
	$destfile = XIUNO_ROOT.'data/view/'.$css."_$styleid.css";
	$csscontent = file_get_contents($srcfile);
	
	// ֧ģ
	$csscontent = str_replace("{template", "{subtemplate", $csscontent);
	$csscontent = preg_replace("/\{subtemplate\s+(\w+?)\}/ies", "css_getcontent('\\1', '$arr[TPL]');", $csscontent);
	
	foreach($arr as $k=>$v) {
		$csscontent = str_replace('{'.$k.'}', $v, $csscontent);
	}	
	file_put_contents($destfile, $csscontent);
}

function css_getcontent($tplfilename, $tpl) {
	$tplfile = XIUNO_ROOT."view/$tpl/$tplfilename.htm";
	if(!is_file($tplfile)) {
		$tplfile = XIUNO_ROOT."view/default/$tplfilename.htm";
	}
	return file_get_contents($tplfile); 
}

function css_get_consts($file) {
	// '.IMGURL.' 滻Ϊ 
	$s = file_get_contents($file);
	
	preg_match_all('#define\(\'(\w+)\',\s*(.*?)\);#is', $s, $m);
	foreach($m[1] as $k=>$v) {
		$arr[$v] = $m[2][$k];
	}
	//$arr['IMGURL'] = str_replace('XIUNO_HOST_IMAGE.\'', '\''.XIUNO_HOST_IMAGE.'', $arr['IMGURL']);
	$arr['XIUNO_HOST_IMAGE'] = XIUNO_HOST_IMAGE;
	foreach($arr as &$v) {
		if($v[0] == '\'' && strpos($v, '\'.') === FALSE) {
			$v = substr($v, 1, strlen($v) - 2);		
		} elseif(strpos($v, '\'') === FALSE) {
			if(!is_numeric($v)) {
				$v = isset($arr[$v]) ? $arr[$v] : '';
			}
		} else {
			// м
			$v = preg_replace('#\'\.(\w+)\.\'#isme', "\$arr['\\1']", $v);
			// ǰ
			$v = preg_replace('#(\w+)\.\'#isme', "'\''.\$arr['\\1']", $v);
			// ں
			$v = preg_replace('#\.\'(\w+)#isme', "\$arr['\\1'].'\''", $v);
			// ȥͷβ '
			if($v[0] == '\'') {
				$v = substr($v, 1, strlen($v) - 2);
			}
		}
	}
	return $arr;
}


?>