<?php

!defined('XIUNO_ROOT') && exit;

class control extends _control {
	public function __construct() {
		parent::__construct();
	}

	function __call($k, $v) {
		$this->ls();
	}

	public function ls() {
		$type = getgpc(2);
		$page = max(1, intval(getgpc(3)));
		$totalnum = $this->friendlinksmodel->get_friendlinks_num($type);
		$list = $this->friendlinksmodel->get_friendlinks_list($type, $page, XIUNO_PPP);
		$multipage = $this->page($totalnum, XIUNO_PPP, $page, XIUNO_HOST_ADMIN."friendlinks-ls-$type.htm");

		$option_string = "<select name='type' onchange=\"var flinkid = this.parentNode.id.split('_')[1]; ajaxget('friendlink-ajaxedit-' + flinkid +'.htm?value=' + this.value);\"><option value='common'></option><option value='bbs'>̳</option><option value='union'>սԺ</option></select>";
		$option_string_unchange = "<select name='type'><option value='common'></option><option value='bbs'>̳</option><option value='union'>սԺ</option></select>";
		$this->view->assign('list', $list);
		$this->view->assign('type', $type);
		$this->view->assign('option_string', $option_string);
		$this->view->assign('option_string_unchange', $option_string_unchange);
		$this->view->assign('multipage', $multipage);
		$this->view->display('admin_friendlink_ls');
	}

	public function add() {
		$name = htmlspecialchars(getgpc('name', 'P'));
		$href = getgpc('href', 'P');
		$type = getgpc('type', 'P');
		$displayorder = getgpc('displayorder', 'P');
		!in_array($type, array('common', 'bbs', 'union')) && $type='common';
		$this->db->query("INSERT INTO www_friendlink SET name='$name', href='$href', type='$type', displayorder='$displayorder'");
		$id = $this->db->insert_id();
		if(!$_FILES['attach']['error']) {
			$logodir = XIUNO_ROOT.'data/attach/logo/';
			if(!is_dir($logodir)) {
				@mkdir($logodir, 0777);
			}
			$ext = strrchr($_FILES['attach']['name'], '.');
			$newname = $logodir.$id.$ext;
			$newurl = 'data/attach/logo/'.$id.$ext;
			is_file($newname) && unlink($newname);
			move_uploaded_file($_FILES['attach']['tmp_name'], $newname);
			$this->db->query("UPDATE www_friendlink SET logo='$newurl' WHERE friendlinkid='$id'");
		}
		$this->cachemodel->update('friendlinks');
		$this->cachemodel->update('friendlink', 'bbs');
		$this->cachemodel->update('friendlink', 'common');
		$this->cachemodel->update('friendlink', 'union');
		$this->message('̳ɹ', XIUNO_HOST_ADMIN.'friendlink-ls.htm');
	}

	public function edit() {
		$friendlinkid = intval(getgpc(2));

		if(!$this->submitcheck()) {
			$friendlink = $this->db->fetch_first("SELECT * FROM www_friendlink WHERE friendlinkid='$friendlinkid'");
			$select = array('common', 'bbs', 'union');
			$select[$friendlink['type']] = 'selected="selected"';
			$this->view->assign('friendlink', $friendlink);
			$this->view->assign('select', $select);
			$this->view->display('admin_friendlink_edit');
		} else {
			$name = getgpc('name', 'P');
			$href = getgpc('href', 'P');
			$displayorder = getgpc('displayorder', 'P');
			$type = getgpc('type', 'P');
			$sql = "UPDATE www_friendlink SET name='$name', href='$href', displayorder='$displayorder', type='$type'";
			if(!$_FILES['logo']['error']) {
				$newname = XIUNO_ROOT.'data/attach/logo/'.$friendlinkid.strrchr($_FILES['logo']['name'], '.');
				$newurl = 'data/attach/logo/'.$friendlinkid.strrchr($_FILES['logo']['name'], '.');
				is_file($newname) && unlink($newname);
				move_uploaded_file($_FILES['logo']['tmp_name'], $newname);
				$sql .= ", logo='$newurl'";
			}
			$sql .= " WHERE friendlinkid='$friendlinkid'";
			$this->db->query($sql);
			$this->cachemodel->update('friendlinks');
			$this->cachemodel->update('friendlink', 'bbs');
			$this->cachemodel->update('friendlink', 'common');
			$this->cachemodel->update('friendlink', 'union');
			$this->message("༭ɹ", XIUNO_HOST_ADMIN.'friendlink-ls.htm');
		}
	}

	public function delete() {
		$friendlinks = array_keys(getgpc('delfriendlink', 'P'));
		foreach($friendlinks as $friendlinkid) {
			$logo = $this->db->result_first("SELECT logo FROM www_friendlink WHERE friendlinkid='$friendlinkid'");
			$logo && is_file($logo) && unlink($logo);
			$this->db->query("DELETE FROM www_friendlink WHERE friendlinkid='$friendlinkid'");
		}
		$this->cachemodel->update('friendlinks');
		$this->cachemodel->update('friendlink', 'bbs');
		$this->cachemodel->update('friendlink', 'common');
		$this->cachemodel->update('friendlink', 'union');
		$this->message('ɾɹ', XIUNO_HOST_ADMIN.'friendlink-ls.htm');
	}
}
?>