<?php

!defined('XIUNO_ROOT') && exit;

class control extends _control{

	function __construct() {
		parent::__construct();
	}

	public function index() {
		// ⲿ
		$page = max(1, intval(getgpc(6)));
		$fid      = getgpc('fid'     , 'P') ? getgpc('fid', 'P')      : getgpc(2);
		$username = getgpc('username', 'P') ? getgpc('username', 'P') : getgpc(3);
		$dateline = getgpc(4) || getgpc(5) ? array($this->date(getgpc(4), 'Y-m-d'), $this->date(getgpc(5), 'Y-m-d')) : getgpc('dateline', 'P');
		// 
		$date = array();
		if($dateline[0]) {
			$date[0] = $this->strtotime($dateline[0]);
		}
		if($dateline[1]) {
			$date[1] = $this->strtotime($dateline[1]);
		}
		if($username) {
			$uid = $this->usermodel->get_uid_by_username(addslashes($username));
		}
		$data = $this->logmodel->get_operation_log(array('uid'=>$uid, 'fid'=>$fid, 'dateline'=>$date), $page, XIUNO_PPP);
		$num  = $this->logmodel->get_operation_log_count(array('uid'=>$uid, 'fid'=>$fid, 'dateline'=>$date));
		if(!empty($data)) {
			foreach($data as &$value) {
				$thread = $this->threadmodel->get_thread_by_tid($value['tid']);
				$value['subject']  = $thread['subject'];
				$value['dateline'] = $this->date($value['dateline'], 'Y-m-d H:i');
				$value['forum'] = $this->forummodel->get_forum_by_fid($value['fid']);
			}
		}
		$forumhtml = $this->forummodel->get_forum_options(TRUE, $fid);
		$encode_username = urlencode($username);

		$multipage = $this->page($num, XIUNO_PPP, $page, XIUNO_HOST_ADMIN."operationlog-index-$fid-$encode_username-$date[0]-$date[1].htm");

		$this->view->assign('multipage' , $multipage);
		$this->view->assign('forumhtml' , $forumhtml);
		$this->view->assign('data'      , $data);
		$this->view->assign('username'  , $username);
		$this->view->assign('dateline'  , $dateline);
		$this->view->display('admin_operationlog');
	}

}