<?php

!defined('XIUNO_ROOT') && exit;

class control extends _control {

	public $colors = array(1=>'#A60000', 2=>'CB4C00', 3=>'#70603D', 4=>'#005B11', 5=>'#084D46', 6=>'#103B77', 7=>'#6B136B', 8=>'#383838');
	public $threadtypelist = array();
	public $forum = array();

	function __construct() {
		parent::__construct();
		$fid = getgpc(2);
		$this->forum = $this->cache('forum', $fid);
		 $this->forbid($this->forum, 'forbidviewgroup');
	}

	// б
	public function index() {
		$fid = intval(getgpc(2));
		$forum = $this->forum;
		$forum['name'] = strip_tags($forum['name']);
		$forum['rule']['brief'] = $this->replace_color($forum['rule']['brief']);
		
		$typeid = htmlspecialchars(getgpc(3));
		$page = $this->page = max(1, intval(getgpc(4)));
		
		// order by
		$get_orderby = getgpc('orderby');
		$cookie_orderby = getgpc('orderby', 'C');
		if($get_orderby) {
			$this->setcookie('orderby', $get_orderby, XIUNO_COOKIE_KEEP_TIME);
		}
		$orderby = $get_orderby ? $get_orderby : ($cookie_orderby ? $cookie_orderby : 'lastpost');
		
		// Ȩж
		$this->user['ismoderator'] = $this->forummodel->is_moderator($forum, $this->user['groupid'], $this->user['uid']);
		if(empty($forum) || ($forum['status'] && $this->user['groupid'] != XIUNO_ADMINISTRATOR_GROUPID)) {
			$this->message('̳ڣ߱Աóأ뷵ء', 'BACK');
		}

		$this->threadtypelist = $forum['threadtypes'];

		$sublist = $pforum = array();
		if($forum['type'] == 'forum') {
			$sublist = $this->forummodel->get_sublist($fid);
			$this->forummodel->format_forumlist($sublist);
		} elseif($forum['type'] == 'sub') {
			$pforum = $this->cache('forum', $forum['fup']);
			$this->navs[] = '<a href="'.XIUNO_HOST_BBS."forum-index-$pforum[fid].htm\">".strip_tags($pforum['name']).'</a>';
		} else {
			$this->message('forum type '.$forum['type'], 'BACK');
		}

		$this->navs[] = '<a href="'.XIUNO_HOST_BBS."forum-index-$fid.htm\">".strip_tags($forum['name']).'</a>';
		if($typeid == 'digest') {
			$num = $this->db->result_first("SELECT COUNT(*) FROM bbs_thread_digest WHERE fid='$fid'");
			$multipage = $this->page($num, XIUNO_TPP, $page, XIUNO_HOST_BBS."forum-index-$fid-digest.htm");
			$threadlist = $this->get_digestlist_by_fid($page, XIUNO_TPP, $num, $fid);
		} else {
			// typeid  COUNTڻȡ
			if($typeid) {
				$num = $this->db->result_first("/*cachelife=600&mckey=md5()*/ SELECT COUNT(*) FROM bbs_thread WHERE fid='$fid' AND typeid='$typeid'");
			} else {
				$num = $forum['threads'] ? $forum['threads'] : $this->db->result_first("/*cachelife=600&mckey=md5()*/ SELECT /*600*/ COUNT(*) FROM bbs_thread WHERE fid='$fid'");
			}
			$multipage = $this->page($num, XIUNO_TPP, $page, XIUNO_HOST_BBS."forum-index-$fid-$typeid.htm");
			// ֻеһҳȡö
			if($page == 1) {
				$toplist = $this->get_toplist_by_fid($fid, getvalue($forum['fup']));
				$toptids = $this->array_values($toplist, 'tid');
			}
			$threadlist = ($orderby == 'lastpost' || $typeid != 0) ? $this->get_threadlist_by_fid($page, XIUNO_TPP, $num, $fid, $typeid) : $this->get_threadlist_by_fid_page($page, XIUNO_TPP, $num, $fid);
		}
		
		foreach($threadlist as $k=>$v) {
			if(in_array($v['tid'], $toptids)) {
				unset($threadlist[$k]);
			}
		}
		
		// ötid
		// ʶ̳Ѿ
		$this->forummodel->set_visited('visitedfid', $fid);
		$this->view->assign('orderby', $orderby);

		$keyword = '';
		if($forum['keyword']) {
			$keyword = str_replace(',', ' ', $forum['keyword']).' ';
			$keyword = ''.$keyword;
		}
		
		$this->header['title'] = strip_tags($forum['name'].$keyword);
		$this->header['keywords'] = $forum['name'];
		$this->header['seokeywords'] = '';
		$this->header['description'] = $forum['name'];

		$this->view->assign_value('allowpostpoll', $this->group['allowpostpoll'] && XIUNO_BBS_POLL_ON);
		$this->view->assign('page', $page);
		$this->view->assign('fid', $fid);
		$this->view->assign('pforum', $pforum);
		$this->view->assign('forum', $forum);
		$this->view->assign('sublist', $sublist);
		$this->view->assign('typeid', $typeid);
		$this->view->assign('num', $num);
		$this->view->assign('toplist', $toplist);
		$this->view->assign('threadlist', $threadlist);
		$this->view->assign('multipage', $multipage);
		$this->view->assign('threadtypelist', $this->threadtypelist);
		$this->view->assign('group', $this->group);
		$this->view->display('bbs_forum');
	}

	// ȫվ⣬ȱȨжϣذ鲻Ӧʾ
	public function newthread() {
		$page = max(1, getgpc('2'));
		$ppp = XIUNO_TPP;
		$start = $ppp * ($page - 1);
		$num  = $this->db->result_first("SELECT COUNT(*) FROM bbs_threadindex");
		$tids = array_keys($this->db->fetch_all("SELECT * FROM bbs_threadindex ORDER BY tid DESC LIMIT $start, $ppp", 'tid'));
		$threadlist = $this->threadmodel->get_theadlist_by_tids($tids);
		$this->_format_thread($threadlist);
		$forums = $this->cache('forums');
		foreach($threadlist as $k=>&$thread) {
			$fid = $thread['fid'];
			$thread['forumname'] = "<a href=\"".XIUNO_HOST_BBS."forum-index-$fid.htm\" target=\"_blank\">".strip_tags($forums[$fid]['name'])."</a>";
		}
		$multipage = $this->page($num, $ppp, $page, XIUNO_HOST_BBS.'forum-newthread.htm');
		$this->view->assign('threadlist', $threadlist);
		$this->view->assign('multipage', $multipage);
		$this->view->display('bbs_forum_newthread');
	}


	private function get_toplist_by_fid($fid, $groupfid) {
		// ˴⣿
		$toplist = $this->topmodel->get_toplist_by_fid($fid, $groupfid);
		$this->_format_thread($toplist);
		return $toplist;
	}

	private function get_threadlist_by_fid($page, $ppp, $totalnum, $fid, $typeid=0) {
		$start = $this->page_get_start($page, $ppp, $totalnum);
		$typeidadd = $typeid ? " AND typeid='$typeid'" : '';
		$threadlist = array();
		if(!$typeidadd) {
			// tidcacheȡ 1/2
			$tids = $this->tidcachemodel->get_tid_list($fid, $page, $ppp);
			$threadlist = $this->threadmodel->get_theadlist_by_tids($tids);
		}

		if(empty($threadlist)) {
			$tidlist = $this->db->fetch_all("SELECT tid FROM bbs_thread WHERE  fid='$fid' $typeidadd ORDER BY lastpost DESC LIMIT $start, $ppp", 'tid');
			$tids = $this->array_values($tidlist, 'tid');
			$threadlist = $this->threadmodel->get_theadlist_by_tids($tids);
		}
		$this->_format_thread($threadlist, $typeid);
		return $threadlist;
	}

	// ⷢʱ
	private function get_threadlist_by_fid_page($page, $ppp, $num, $fid){
		$start = $ppp * ($page - 1);
		$threadlist = array();
		$tids = array_keys($this->db->fetch_all("SELECT tid FROM bbs_threadindex WHERE fid='$fid' ORDER BY tid DESC LIMIT $start,$ppp", 'tid'));
		$threadlist = $this->threadmodel->get_theadlist_by_tids($tids);
		$this->_format_thread($threadlist);
		return $threadlist;
	}

	private function get_digestlist_by_fid($page, $ppp, $totalnum, $fid) {
		$start = $this->page_get_start($page, $ppp, $totalnum);
		$threadlist = array();
		$tids = $this->db->fetch_all("/*cachelife=3600&mckey=md5()*/ SELECT tid FROM bbs_thread_digest WHERE fid='$fid' LIMIT $start, $ppp");
		foreach($tids as $v) {
			$tid = $v['tid'];
			$threadlist[$tid] = $this->threadmodel->get_thread_by_tid($tid);
		}
		$this->_format_thread($threadlist);
		return $threadlist;
	}

	private function _format_thread(&$arr, $typeid = 0) {
		foreach($arr as $k=>&$v) {
			if(empty($v)) {
				unset($arr[$k]);
				continue;
			}
			// һڣûcookie¼ģʶΪ
			$v['dateline'] = $this->date($v['dateline'], $this->time - $v['dateline']  > 31536000 ? 'Y-n-j' : 'n-j');
			$v['posts'] = $v['posts'] - 1;
			$v['icon'] = ($v['lastpost'] - $this->time) > DAY || $this->forummodel->get_visited('visitedtid', $v['tid']) ? 'image/bbs/thread_read.gif' : 'image/bbs/thread_unread.gif';
			if($v['typeid'] >= 100 && !empty($this->threadtypelist[$v['typeid']])) {
				$v['subject'] = ''.$this->threadtypelist[$v['typeid']]['name'].''.$v['subject'];
			}
			if($v['highlight']) {
				$color = getvalue($this->colors[$v['highlight']]);
				$v['subject'] = "<font color=\"$color\">$v[subject]</font>";
			}
			if($v['isbold']) {
				$v['subject'] = "<b>$v[subject]</b>";
			}
			$v['icons'] = '';

			if($v['is_rated']) {
				$v['subject'] .= $this->ratemodel->get_thread_rate($v['firstpid']);
			}
			if($v['displayorder']) {
				$v['topicon'] = "<img src=\"".XIUNO_HOST_IMAGE."image/bbs/top_$v[displayorder].gif\" title=\"{$v['displayorder']}ö\" />";
			} else {
				$v['topicon'] = '';
			}
			if($v['digest']) {
				$v['icons'] .= "<img src=\"".XIUNO_HOST_IMAGE."image/bbs/digest_$v[digest].gif\" title=\"$v[digest]\" />";
			}
			if($v['closed']) {
				$v['icons'] .= "<img src=\"".XIUNO_HOST_IMAGE."image/bbs/closed_$v[closed].gif\" title=\"\" />";
			}
			if($v['attachnum']) {
				$v['icons'] .= "<img src=\"".XIUNO_HOST_IMAGE."image/common/attach.gif\" title=\"\" />";
			}
			$v['pages'] = $this->posts_to_page($v['posts'] + 1, $v['tid'], $typeid);
			$v['lastpost'] = $this->date($v['lastpost'], $this->time - $v['lastpost'] > 31536000 ? 'Y-n-j' : 'n-j');
			getvalue($v['views']);
			$v['views'] += getvalue($v['viewscount']);
			$v['lastposterurl'] = urlencode($v['lastposter']);
			$v['threadtypeicon'] = '';
			// 100 ΪԤֵС100Ϊ
			if($v['typeid'] > 0 && $v['typeid'] < 100) {
				$v['threadtypeicon'] = "<img style=\"vertical-align:middle;\" src=\"".XIUNO_HOST_IMAGE."image/bbs/typeid_$v[typeid].gif\" title=\"{$this->get_typeid_name($v['typeid'])}\" />";
			}
		}
	}

	private function posts_to_page($posts, $tid, $typeid = 0) {
		if($posts < XIUNO_PPP) {
			return '';
		}
		$s = '';
		$totalpage = ceil($posts / XIUNO_PPP);
		for($i=1; $i<=$totalpage && $i<4; $i++) {
			$s .= "<a href=\"".XIUNO_HOST_BBS."thread-index-$tid-$i.htm\">$i</a> ";
		}
		if($totalpage == 4) {
			$s .= "<a href=\"".XIUNO_HOST_BBS."thread-index-$tid-$totalpage.htm\">$totalpage</a> ";
		} elseif($totalpage > 4) {
			$s .= "... <a href=\"".XIUNO_HOST_BBS."thread-index-$tid-$totalpage.htm\">$totalpage</a> ";
		}
		$s = $s ? '<img src="'.XIUNO_HOST_IMAGE.'/image/bbs/pages.gif" /> '.$s : $s;
		return $s;
	}

	public function forumlist() {
		$groupid = max(0, intval(getgpc('groupid')));
		$groups = $forums = $subs = array();
		$forumsdata = $this->cache('forumsdata');
		
		if($forumsdata['grouplist'][$groupid]) {
			$this->navs[] = '̳б';
		} else {
			$this->navs[] = '̳б';
		}
		
		$this->view->assign('groups', $forumsdata['grouplist']);
		$this->view->assign('forums', $forumsdata['forumlist']);
		$this->view->assign('subs', $forumsdata['sublist']);
		$this->view->assign('groupid', $groupid);
		$this->view->display('bbs_forumlist');
	}
}
?>