<?php

!defined('XIUNO_ROOT') && exit;

class control extends _control {
	private $tpl = '';
	private $error = '';
	private $forums = array();

	function __construct() {
		parent::__construct();
		$this->tpl = 'bbs_moderator_'.getgpc(1);
		$this->view->assign('tpl', $this->tpl);
		if($this->group['type'] != XIUNO_ADMIN_GROUP_TYPE) {
			$this->message("ûȨ޷ҳ");
		}
		$this->nav['check2'] = array('auditthreadls', 'reportls', 'rule', 'forumkeyword');
		$this->navs[] = '<a href="'.XIUNO_HOST_BBS.'moderator.htm"></a> ';
		$this->view->assign('group', $this->group);
		$this->set_navcheck(getgpc(1), 2);
		$this->forums = $this->cache('forums');
	}

	public function index() {
		$this->tpl = 'bbs_moderator_auditthreadls';
		$this->set_navcheck('auditthreadls', 2);
		$this->auditthreadls();
	}

	public function auditthreadls() {
		$fid = intval(getgpc(2));
		$page = max(1, getgpc(3));
		$option = $this->get_option($fid);
		$ppp = XIUNO_PPP;
		$start = ($page-1) * $ppp;
		if($fid) {
			$sql = "SELECT tid,username,subject,dateline FROM bbs_threadaudit WHERE fid='$fid' order by tid  LIMIT $start, $ppp";
			$totalnum = $this->db->result_first("SELECT COUNT(*) FROM bbs_threadaudit WHERE fid='$fid'");
		} else {
			$sql = "SELECT tid,username,subject,dateline FROM bbs_threadaudit LIMIT $start, $ppp";
			$totalnum = $this->db->result_first("SELECT COUNT(*) FROM bbs_threadaudit");
		}
		$threadlist = $this->db->fetch_all($sql);
		foreach($threadlist as &$thread) {
			$thread['dateline'] = $this->date($thread['dateline']);
		}
		$multipage = $this->page($totalnum, $ppp, $page, XIUNO_HOST_BBS."moderator-auditthreadls-$fid.htm");
		$this->view->assign('multipage', $multipage);
		$this->view->assign('threadlist', $threadlist);
		$this->view->assign('option', $option);
		$this->view->assign('fid', $fid);
		$this->view->display('bbs_moderator');
	}


	public function deleteauditthread() {
		$tid = intval(getgpc(2));

		if($this->delete_autid($tid)) {
			// TODO ¼
			$this->message('ɾɹ', '', array('error'=>1));
		} else {
			$this->message($this->error, '', array('error'=>1));
		}
	}

	public function passauditthread() {
		$tid = intval(getgpc(2));
		$subject = $this->stringmodel->filter_keyword(htmlspecialchars(getgpc('subject', 'P')));
		$message = $this->stringmodel->filter_keyword(getgpc('message', 'P'));
		$delattach = getgpc('delattach', 'P');
		$this->stringmodel->strip_script($message);
		$thread = $this->threadmodel->get_auditthread_by_tid($tid);
		empty($thread) && $this->message('ѱ', '', array('error'=>2));

		$forum = $this->forums[$thread['fid']];
		// жȨ
		if(!$this->forummodel->is_moderator($forum, $this->user['groupid'], $this->user['uid'])) {
			$this->message('ûȨ˴', '', array('error'=>1));
		}

		if(!empty($delattach)) {
			foreach ((array)$delattach as $aid) {
				$attach = $this->db->result_first("SELECT uid,filename FROM bbs_attachment WHERE aid='$aid'");
				if($attach['uid'] == $thread['uid']) {
					$this->db->query("DELETE FROM bbs_attachment WHERE aid='$aid'");
					@unlink(XIUNO_ROOT.$attach['filename']);
				}
			}
		}
		$this->db->query("INSERT INTO bbs_thread SET tid='$tid', fid='$thread[fid]', typeid='$thread[typeid]', username='".addslashes($thread['username'])."', uid='$thread[uid]', posts='1',  subject='$subject', dateline='$this->time', lastpost='$thread[lastpost]', attachnum='$thread[attachsum]', firstpid='$thread[firstpid]', anony='$thread[anony]'");
		$this->db->query("/*primarykey=pid*/ UPDATE bbs_post SET message='$message'  WHERE pid='$thread[firstpid]'");
		$this->db->query("DELETE FROM bbs_threadaudit WHERE tid='$tid'");

		$thread['message'] = $message;
		$thread['subject'] = $subject;
		$thread['forumname'] = $forum['name'];
		$this->postmodel->after_audit($thread);
		$user = $this->usermodel->get_user_by_uid($thread['uid'], 'groupid');
		$groupid = $user['groupid'];
		$group = $this->cache('group', $groupid);
		if($group['type'] == XIUNO_ADMIN_GROUP_TYPE) {
			$yearmonth = $this->date($this->time, 'Ym');
			if($this->db->result_first("SELECT COUNT(*) FROM www_stats_mod_history WHERE uid='{$thread['uid']}' AND yearmonth='$yearmonth'")) {
				$this->db->query("UPDATE www_stats_mod_history SET threads=threads+'1' WHERE uid='{$thread['uid']}' AND yearmonth='$yearmonth'");
			} else {
				$this->db->query("INSERT INTO www_stats_mod_history SET uid='{$thread['uid']}', yearmonth='$yearmonth', threads='1'");
			}
		}
		// TODO ¼
		$this->message('˳ɹ', '', array('error'=>1));
	}

	// 
	public function audit_prune() {
		$tids = getgpc('auditthread', 'P');
		if(empty($tids)){
			$this->message('ûѡҪ˵', 'BACK');
		}
		if(getgpc('delete', 'P')){
			foreach($tids as $tid=>$__){
				$this->delete_autid($tid);
			}
		} else if(getgpc('pass', 'P')){
			foreach($tids as $tid=>$__){
				$thread = $this->threadmodel->get_auditthread_by_tid($tid);
				$this->db->query("DELETE FROM bbs_threadaudit WHERE tid='$tid'");
				$this->db->query("INSERT INTO bbs_thread SET tid='$tid', fid='$thread[fid]', typeid='$thread[typeid]', username='".addslashes($thread['username'])."', uid='$thread[uid]', posts='1',  subject='".addslashes($subject)."', dateline='$thread[dateline]', lastpost='{$this->time}', attachnum='$thread[attachsum]', firstpid='$thread[firstpid]', anony='$thread[anony]'");

				$thread['forumname'] = $this->forums[$thread['fid']]['name'];
				$thread['lastpost'] = $this->time;
				$this->postmodel->after_audit($thread);
				$groupid = $this->db->result_first("SELECT groupid FROM www_user WHERE uid='{$thread['uid']}'");
				$group = $this->cache('group', $groupid);
				if($group['type'] == XIUNO_ADMIN_GROUP_TYPE) {
					$yearmonth = $this->date($this->time, 'Ym');
					if($this->db->result_first("SELECT COUNT(*) FROM www_stats_mod_history WHERE uid='{$thread['uid']}' AND yearmonth='$yearmonth'")) {
						$this->db->query("UPDATE www_stats_mod_history SET threads=threads+'1' WHERE uid='{$thread['uid']}' AND yearmonth='$yearmonth'");
					} else {
						$this->db->query("INSERT INTO www_stats_mod_history SET uid='{$thread['uid']}', yearmonth='$yearmonth', threads='1'");
					}
				}
			}
		} else {
			$this->message('ѡ');
		}
		$this->message('', XIUNO_HOST_BBS.'moderator-auditthreadls-'.$fid.'.htm');
	}

	private function delete_autid($tid) {
		$thread = $this->threadmodel->get_auditthread_by_tid($tid);
		if(empty($thread)) {
			$this->error = 'ѱ';
			return FALSE;
		}

		// жȨ
		if($this->user['groupid'] == XIUNO_MODERATOR_GROUPID && empty($this->forums[$thread['fid']]['moderator'][$this->user['uid']])) {
			$this->error = 'ûȨ˴';
			return FALSE;
		}
		$this->db->query("DELETE FROM bbs_threadaudit WHERE tid='$tid'");
		$this->db->query("DELETE FROM bbs_attachment WHERE tid='$tid'");
		$this->db->query("DELETE FROM bbs_post WHERE pid='$thread[firstpid]'");

		switch($thread['typeid']) {
			case BBS_THREAD_POLL :
				$this->db->query("DELETE FROM bbs_poll WHERE tid='$tid'");
				$this->db->query("DELETE FROM bbs_poll_option WHERE tid='$tid'");
				break;
			default:
				break;
		}
		RETURN TRUE;
	}

	public function auditthread() {
		$tid = intval(getgpc('2'));
		$thread = $this->threadmodel->get_auditthread_by_tid($tid);
		if(empty($thread)) {
			$this->message('ѱ', '', array('error'=>1));
		}

		// жȨ
		if($this->user['groupid'] == XIUNO_MODERATOR_GROUPID) {
			$forum = $this->cache('forum', $thread['fid']);
			if(empty($forum['moderator'][$this->user['uid']])) {
				$this->message('ûȨ˴', '', array('error'=>1));
			}
		}
		$attachlist = $this->db->fetch_all("SELECT * FROM bbs_attachment WHERE tid='$tid'");

		$post = $this->db->fetch_first("SELECT message FROM bbs_post WHERE pid='$thread[firstpid]'");
		$this->view->assign('thread', $thread);
		$this->view->assign('attachlist', $attachlist);
		$this->view->assign('post', $post);
		$this->view->display('bbs_moderator_auditthread');
	}

	public function reportls() {
		$this->navs[] = '<a href="'.XIUNO_HOST_BBS.'moderator-reportls.htm">û</a>';
		$fid = intval(getgpc(2));
		$page = max(1, getgpc(3));
		$option = $this->get_option($fid);
		$ppp = XIUNO_PPP;
		$start = ($page-1) * $ppp;
		if($fid) {
			$sql = "SELECT * FROM bbs_report WHERE fid='$fid' LIMIT $start, $ppp";
			$totalnum = $this->db->result_first("SELECT COUNT(*) FROM bbs_report WHERE fid='$fid'");
		} else {
			$sql = "SELECT * FROM bbs_report LIMIT $start, $ppp";
			$totalnum = $this->db->result_first("SELECT COUNT(*) FROM bbs_report");
		}
		$data = $this->db->fetch_all($sql);
		foreach($data as $k=>&$report) {
			$report['dateline'] = $this->date($report['dateline']);
			$thread = $this->db->fetch_first("SELECT subject, firstpid FROM bbs_thread WHERE tid='$report[tid]'");
			if(empty($thread)) {
				$this->db->query("DELETE FROM bbs_report WHERE reportid='{$report['reportid']}'");
				unset($data[$k]);
			}
			$report['posttype'] = $thread['firstpid'] == $report['pid'] ? '' : '';
			$report['subject'] = $thread['subject'];
		}
		// TODO ¼
		$multipage = $this->page($totalnum, $ppp, $page, XIUNO_HOST_BBS."moderator-reportls-$fid.htm");
		$this->view->assign('multipage', $multipage);
		$this->view->assign('data', $data);
		$this->view->assign('option', $option);
		$this->view->display('bbs_moderator');
	}

	// 
	public function report_prune() {
		$checks = array_keys(getgpc('checks', 'P'));
		if(empty($checks)){
			$this->message('ûѡҪı', 'BACK');
		}
		if(getgpc('delete', 'P')){
			foreach($checks as $reportid){
				$this->treatreport(TRUE, $reportid, 'delete');
			}
		} else if(getgpc('ignore', 'P')){
			$this->treatreport(TRUE, $reportid, 'ignore');
		} else {
			$this->message('ѡ');
		}
		$this->message('', XIUNO_HOST_BBS.'moderator-reportls.htm');
	}

	// @param call: ǷΪĵ
	public function treatreport($call = FALSE, $reportid=0, $do='') {
		$reportid = $call ? $reportid : intval(getgpc(2));
		$do = $call ? $do : getgpc('do');
		$report = $this->db->fetch_first("SELECT * FROM bbs_report WHERE reportid='$reportid'");
		if(empty($report)) {
			if($call){
				return FALSE;
			} else {
				$this->message('ѱ', '', array('error'=>1));
			}
		}
		if($this->user['groupid'] == XIUNO_MODERATOR_GROUPID) {
			$forum = $this->cache('forum', $report['fid']);
			if(!$this->forummodel->is_moderator($forum, $this->user['groupid'], $this->user['uid'])) {
				if($call){
					return FALSE;
				} else {
					$this->message('ûȨ޴˱', '', array('error'=>1));
				}
			}
		}
		$thread = $this->threadmodel->get_thread_by_tid($report['tid']);
		if(empty($thread)) {
			$this->db->query("DELETE FROM bbs_report WHERE reportid='$report[reportid]'");
			if($call){
				return FALSE;
			} else {
				$this->message('Ѿɾ', '', array('error'=>1));
			}
		}

		switch ($do) {
			case 'delete':
				$post = $this->db->fetch_first("SELECT * FROM bbs_post WHERE pid='$report[pid]'");
				$this->postmodel->delete_post($post);
				$this->creditmodel->update_credit_by_policy($report['uid'], 'report', $report['fid']);
				// TODO ֪ͨߡ֪ͨٱˡ
				$this->db->query("DELETE FROM bbs_report WHERE reportid='$report[reportid]'");

				// ٱЧ,ӳɾ
				!$call && $this->message('ɾɹ', '', array('error'=>1));
				break;
			case 'close':
				$this->db->query("/*primarykey=tid*/ UPDATE bbs_thread SET closed='1' WHERE tid='$report[tid]'");
				$this->creditmodel->update_credit_by_policy($report['uid'], 'report', $report['fid']);
				$this->db->query("DELETE FROM bbs_report WHERE reportid='$report[reportid]'");
				!$call && $this->message('رӳɹ', '', array('error'=>1));
				
				break;
			case 'ignore':
				$this->db->query("DELETE FROM bbs_report WHERE reportid='$report[reportid]'");
				// TODO ¼
				!$call && $this->message('Գɹ', '', array('error'=>1));
				break;
			default:
				$post = $this->db->fetch_first("SELECT username, message FROM bbs_post WHERE pid='$report[pid]'");
				$posttype = $thread['firstpid'] == $report['pid'] ? 'thread' : 'post';
				$this->view->assign('post', $post);
				$this->view->assign('posttype', $posttype);
				$this->view->assign('thread', $thread);
				$this->view->assign('report', $report);
				$this->view->display('bbs_moderator_treatreport');
				break;
		}
	}

	public function rule() {
		$fid = intval(getgpc(2));
		if(!$this->submitcheck()) {
			$this->navs[] = '<a href="'.XIUNO_HOST_BBS.'moderator-rule.htm"></a>';
			$option = $this->get_option($fid, FALSE);
			$forum = $this->cache('forum', $fid);
			$recommands = '';
			foreach($forum['rule']['recommands'] as $row) {
				$recommands .= $row['href']."\r\n";
			}
			$forum['rule']['recommands'] = $recommands;
			$this->view->assign('rule', $forum['rule']);
			$this->view->assign('option', $option);
			$this->view->assign('fid', $fid);
			$this->view->display('bbs_moderator');
		} else {
			$forum = $this->cache('forum', $fid);
			if(!$this->forummodel->is_moderator($forum, $this->user['groupid'], $this->user['uid'])) {
				$this->message('ûȨޱ༭˰', '', array('error'=>1));
			}

			$brief = getgpc('brief', 'P');
			//$this->stringmodel->strip_script($brief);
			$recommands = getgpc('recommands', 'P');
			preg_match_all('#thread-index-(\d+)#', $recommands, $arr);
			if(!empty($arr[1])) {
				$recommands = implode("\t", array_slice($arr[1], 0, 8));
			} else {
				$recommands = '';
			}
			$this->db->query("REPLACE INTO bbs_rule SET fid='$fid', brief='$brief', recommands='$recommands'");
			$this->cachemodel->update('forum', $fid);
			// TODO ¼
			$this->message('༭ɹ', XIUNO_HOST_BBS."moderator-rule-$fid.htm");
		}
	}

	public function forumkeyword() {
		$fid = intval(getgpc(2));
		if(!$this->submitcheck()) {
			$this->navs[] = '<a href="'.XIUNO_HOST_BBS.'moderator-forumkeyword.htm">ðؼ</a>';
			$option = $this->get_option($fid, FALSE);
			$forum = $this->cache('forum', $fid);

			$this->view->assign('option', $option);
			$this->view->assign('forum', $forum);
			//print_r($forum);
			$this->view->assign('fid', $fid);
			$this->view->display('bbs_moderator');
		} else {
			$forum = $this->cache('forum', $fid);
			if(!$this->forummodel->is_moderator($forum, $this->user['groupid'], $this->user['uid'])) {
				$this->message('ûȨðؼ', '', array('error'=>1));
			}
			$keyword = getgpc('keyword', 'P');
			if($keyword) {
				$keyword = str_replace('', ',', $keyword);
				$keywords = explode(',', $keyword);
				$keywords = array_slice($keywords, 0, 4);
				$keyword = implode(',', $keywords);
			}

			$this->db->query("/*primarykey=fid*/ UPDATE bbs_forum SET keyword='$keyword' WHERE fid='$fid'");

			$this->cachemodel->update('forums');
			$this->cachemodel->update('forum', $fid);
			$this->message('༭ɹ', XIUNO_HOST_BBS."moderator-forumkeyword-$fid.htm");
		}
	}

	public function prune() {
		$fid = intval(getgpc(2));
		$this->navs[] = '<a href="'.XIUNO_HOST_BBS.'moderator-prune.htm">ɾ</a>';
		$option = $this->get_option($fid);
		$this->view->assign('option', $option);
		$this->view->assign('fid', $fid);
		if(!$this->submitcheck()) {
			$this->view->display('bbs_moderator');
		} else if(getgpc('action') == 'search'){

			$starttime = getgpc('starttime', 'P');
			$keyword = getgpc('keyword' , 'P');
			$replyless = getgpc('replyless' , 'P');
			$username = getgpc('username' , 'P');
			$ipfrom = getgpc('ipfrom' , 'P');
			$ipto = getgpc('ipto' , 'P');
			$containreply = getgpc('containreply', 'P');
			$starttime = $starttime ? $this->time - $starttime * DAY : 0;

			$ipsql = '';
			if($ipfrom && $ipto) {
				if(substr($ipfrom, 0, 3) != substr($ipto, 0, 3)) {
					$this->message('IPΧĵһλͬ', 'BACK');
				}
				$ipfrom = $this->ip2long($ipfrom);
				$ipto = $this->ip2long($ipto);
				if($ipfrom > $ipto) {
					$ipsql = " AND userip<='$ipfrom' AND userip>='$ipto'";
				} else {
					$ipsql = " AND userip>='$ipfrom' AND userip<='$ipto'";
				}
			}

			if(empty($starttime) && empty($keyword) && empty($replyless) && empty($username) && empty($userip)) {
				$this->message('Ϊ');
			}

			$sql = 'SELECT * FROM bbs_post WHERE 1';
			if(!empty($username)) {
				$uid = $this->db->result_first("SELECT uid FROM www_userfield WHERE username='$username'");
				if(!$uid) {
					$this->message('û', 'BACK');
				}
				$sql .= " AND uid='$uid'";
			}
			$sql .= $ipsql;
			if(!empty($starttime)) {
				$sql .= " AND dateline>'$starttime'";
			}
			if(!$containreply) {
				$sql .= " AND first='1'";
			}
			$list = $this->db->fetch_all($sql, 'pid');

			foreach($list as $pid=>&$post){
				$post['dateline'] = $this->date($post['dateline']);
				$post = array_merge($post, (array)$this->db->fetch_first("/*cachelife=3600&mckey=bbs_post_$pid*/ SELECT * FROM bbs_post WHERE pid='$pid'"), (array)$this->db->fetch_first("/*cachelife=3600&mckeybbs_thread_{$post['tid']}*/ SELECT subject, posts FROM bbs_thread WHERE tid='{$post['tid']}'"));
				if($keyword){
					if(strpos($post['subject'], $keyword) === FALSE  && strpos($post['message'], $keyword) === FALSE) {
						unset($list[$pid]);
						continue;
					}
				}
				if($replyless && !$containreply && $post['posts'] >$replyless) {
					unset($list[$pid]);
					continue;
				}
				$post['subject'] = $this->xiuno_substr(strip_tags($post['subject']), 12);
				$post['message'] = $this->xiuno_substr(strip_tags($post['message']), 20);
				$post['dateline'] = $this->date($post['dateline']);
			}

			if(empty($list)) {
				$this->message('ûҵ', 'BACK');
			}

			$totalnum = count($list);
			$pids = array_keys($list);
			$list = array_slice($list, 0, 20);
			$displaynum = $totalnum > 20 ? 20 : $totalnum;
			$this->view->assign('totalnum', $totalnum);
			$this->view->assign('pids', $pids);
			$this->view->assign('list', $list);
			$this->view->assign('displaynum', $displaynum);
			$this->view->display('bbs_moderator');
		} else if(getgpc('action') == 'delete'){
			$pids = getgpc('pid', 'P');
			if($this->user['groupid'] == XIUNO_MODERATOR_GROUPID) {
				$fids = array_keys($this->db->fetch_all("SELECT fid FROM bbs_moderator WHERE uid='{$this->user['uid']}'", 'fid'));
				foreach($tids as $k=>$tid) {
					$fid = $this->db->result_first("SELECT fid FROM bbs_post WHERE pid='$pid'");
					if(!in_array($fid, $fids)) {
						unset($tids[$k]);
					}
				}
			}
			// TODO ¼
			foreach($pids as $pid){
				$this->postmodel->delete_post($this->db->fetch_first("SELECT pid, tid, fid, uid, first FROM bbs_post WHERE pid='$pid'"));
			}

			$this->message("ɾɹ", XIUNO_HOST_BBS.'moderator-prune.htm');
		}
	}

	// TODO ¼
	public function banuser() {
		if(!isset($_GET['username']) && !isset($_GET['uid'])) {
			$this->view->display('bbs_moderator');
		} else if (!$this->submitcheck()) {
			if(getgpc('username')) {
				$uid = $this->usermodel->get_uid_by_username(getgpc('username'));
				empty($uid) && $this->message('û', 'BACK');
			} else {
				$uid = getgpc('uid');
			}
			$userinfo = $this->usermodel->get_user_by_uid($uid);
			empty($userinfo) && $this->message('û', 'BACK');
			$group = $this->cache('group', $userinfo['groupid']);
			$userinfo['groupname'] = $group['name'];
			$userinfo['avatar'] = $this->get_avatar($uid, 'small', $userinfo['avatar']);
			$userinfo['regdate'] = $this->date($userinfo['regdate'], 'Y-m-d');
			$priv = $this->db->fetch_first("SELECT * FROM www_userpriv WHERE uid='$uid'");
			if(empty($priv)) {
				$priv = array('privrank'=>0);
			} else {
				if($priv['expiration']) {
					$priv['expiration'] = $this->date($priv['expiration'], 'Y-m-d H:i');
				} else {
					$priv['expiration'] = '';
				}
			}
			$status_data = array(XIUNO_NORMAL_PRIV_RANK=>'û', XIUNO_POST_DENIED_PRIV_RANK=>'ֹ', XIUNO_ACCESS_DENIED_PRIV_RANK=>'ֹ');
			$status = $status_data[$priv['privrank']];
			$this->view->assign('priv', $priv);
			$this->view->assign('status', $status);
			$this->view->assign('userinfo', $userinfo);
			$this->view->display('bbs_moderator_banuser');
		} else {
			$uid = intval(getgpc('uid'));
			$privrank = intval(getgpc('privrank', 'P'));
			$deletepost = getgpc('deletepost', 'P');
			$expiration = getgpc('expiration', 'P');
			if($expiration) {
				$expiration = $this->time + DAY * $expiration;
			}
			$groupid = $this->usermodel->get_user_by_uid($uid, 'groupid');
			$group = $this->cache('group', $groupid);

			if($privrank == XIUNO_POST_DENIED_PRIV_RANK) {
				$this->db->query("/*primarykey=uid*/ UPDATE www_user_event SET checkpriv='1' WHERE uid='{$uid}'");
				$this->db->query("/*primarykey=uid*/ UPDATE www_user SET isbanned='1' WHERE uid='{$uid}'");
				$this->db->query("REPLACE INTO www_userpriv SET uid='$uid', privrank='$privrank', expiration='$expiration'");
				$message = 'ѽûΪֹʡ';
			} else if($privrank == XIUNO_ACCESS_DENIED_PRIV_RANK) {
				$this->db->query("/*primarykey=uid*/ UPDATE www_user_event SET checkpriv='1' WHERE uid='{$uid}'");
				$this->db->query("/*primarykey=uid*/ UPDATE www_user SET isbanned='1' WHERE uid='{$uid}'");
				$this->db->query("REPLACE INTO www_userpriv SET uid='$uid', privrank='$privrank' , expiration='$expiration'");
				$message = 'ѽûΪֹԡ';
			} else if ($privrank == XIUNO_NORMAL_PRIV_RANK){
				$this->db->query("/*primarykey=uid*/ UPDATE www_user_event SET checkpriv='0' WHERE uid='{$uid}'");
				$this->db->query("/*primarykey=uid*/ UPDATE www_user SET isbanned='0' WHERE uid='{$uid}'");
				$this->db->query("DELETE FROM www_userpriv WHERE uid='$uid'");
				$message = 'ȡԳɹ';
			} else {
				$this->message('δ, 뷵', 'BACK');
			}
			if($deletepost) {
				$posts = $this->db->fetch_all("SELECT pid, fid, tid, uid, first FROM bbs_post WHERE uid='$uid'");
				foreach($posts as $post) {
					$this->postmodel->delete_post($post);
				}
			}
			$this->message($message, XIUNO_HOST_BBS.'moderator-banuser.htm');
		}
	}

	public function myoper() {
		$page = max(1, getgpc(2));
		$ppp = XIUNO_PPP;
		$start = ($page - 1) * $ppp;
		$num = $this->db->result_first("SELECT COUNT(*) FROM bbs_operationlog WHERE uid='{$this->user['uid']}'");
		$operlist = $this->db->fetch_all("SELECT * FROM bbs_operationlog WHERE uid='{$this->user['uid']}' ORDER BY operid DESC LIMIT $start, $ppp");
		$multipage = $this->page($num, $ppp, $page, XIUNO_HOST_BBS.'moderator-myoper.htm');
		foreach($operlist as &$oper) {
			$oper['dateline'] = $this->date($oper['dateline']);
			//$oper['thread'] = '<a href="'.XIUNO_HOST_BBS.'thread-index-'.$oper['tid'].'.htm" target="_blank">'.$this->db->result_first("SELECT subject FROM bbs_thread WHERE tid='$oper[tid]'").'</a>';
		}
		$this->view->assign('operlist', $operlist);
		$this->view->assign('multipage', $multipage);
		$this->view->display('bbs_moderator');
	}

	// ȡɲ̳б
	private function get_option(&$fid, $haveroot=TRUE) {
		$forums = $this->forums;
		if($this->user['groupid'] >= XIUNO_MODERATOR_GROUPID) {
			$data = $this->db->fetch_all("SELECT fid FROM bbs_moderator WHERE uid='{$this->user['uid']}'", 'fid');
			$fid && !in_array($fid, array_keys($data)) && $this->message('ûȨ޲鿴');
			$option = '';
			foreach($data as $row) {
				empty($fid) && $fid = $row['fid'];
				if($forums[$row['fid']]['type'] == 'group') {
					continue;
				}
				$option .= "<option value=\"".$row['fid']."\"".($fid==$row['fid'] ? 'selected' : '').">".$forums[$row['fid']]['name']."</option>";
			}
		} else {
			if(!$haveroot && !$fid) {
				foreach($forums as $row) {
					if($row['type'] != 'group') {
						$fid = $row['fid'];
						break;
					}
				}
			}
			$option = $this->forummodel->get_forum_options($haveroot, $fid);
		}
		return $option;
	}

	private function regex_first($regex, $string) {
		$arr = array();
		preg_match($regex, $string, $arr);
		if(!empty($arr)) {
			return $arr[1];
		} else {
			return '';
		}
	}
}
?>