<?php

!defined('XIUNO_ROOT') && exit;

class control extends _control {

	private $word;

	function __construct() {
		parent::__construct();
		$this->set_navcheck('bbs');
		$this->word = getgpc('word');
		define('UPGRADE_MAX_TID', 59161);
		define('UPGRADE_MAX_PID', 523833);
	}

	public function index() {
		// 鿴Ȩж
		$allowview = $this->group['allowview'];
		if(empty($allowview)) {
			$this->message('Բûûв鿴Ȩޡ', 'BACK');
		}

		//  cache
		$groups = $this->cache('groups');
		$this->usermodel->groups = $groups;

		// ݳʼ
		$tid = intval(getgpc(2));
		if($tid <= 0) {
			$this->message('Ҫʵⲻ', 'BACK');
		}

		$page = $this->page = max(1, intval(getgpc(3)));

		$thread = $this->threadmodel->get_thread_by_tid($tid);

		if(XIUNO_MEMCACHE_ON) {
			$mthread = $thread;
		} else {
			$mthread = array();
		}

		if(empty($thread)) {
			$thread = $this->threadmodel->get_auditthread_by_tid($tid);
			if(!empty($thread)) {
				if(!$this->user['ismoderator'] && $this->user['uid'] != $thread['uid']) {
					$this->message('У뷵ء', 'BACK');
				}
			} else {
				$this->message('ⲻ', 'BACK');
			}
		}
		$fid = $thread['fid'];

		if(getgpc('frompage')) {
			$fromtypeid = getgpc('fromtypeid');
			$frompage = getgpc('frompage');
		} else {
			$referer = isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : '';
			$referer = $this->get_referer_arg($referer);
			if($referer[0] == 'forum' && $referer[1] == 'index' && $referer[2] == $fid) {
				$fromtypeid = $referer[3];
				$frompage = $referer[4];
			} else {
				$fromtypeid = 0;
				$frompage = 1;
			}
		}

		$forum = $this->cache('forum', $fid);
		$this->forbid($forum, 'forbidviewgroup');
		$this->user['ismoderator'] = $this->forummodel->is_moderator($forum, $this->user['groupid'], $this->user['uid']);

		// Ȩ޺Ͳȷж
		if(empty($forum) || ($forum['status'] && $this->user['groupid'] != 1)) {
			$this->message('ڵ̳(fid='.$fid.')ڣ߱ԱΪأ뷵ء');
		}

		if($forum['type'] == 'sub') {
			$pforum = $this->cache('forum', $forum['fup']);
			$this->navs[] = '<a href="'.XIUNO_HOST_BBS."forum-index-$pforum[fid].htm\">$pforum[name]</a>";
		}

		$this->navs[] = "<a href=\"".XIUNO_HOST_BBS."forum-index-$fid-$fromtypeid-$frompage.htm\">".strip_tags($forum['name'])."</a>";
		$this->navs[] = "<a href=\"".XIUNO_HOST_BBS."thread-index-$tid.htm\">$thread[subject]</a>";
		
		
		// ȡб
		$num = $thread['posts'];
		$postlist = $this->threadmodel->get_postlist_by_tid_page($page, XIUNO_PPP, $tid, $this->word);
		/*if(!$postlist) {
			$postlist = $this->threadmodel->get_postlist_by_tid($page, XIUNO_PPP, $num, $tid, $this->word);
		}*/
		$multipage = $this->page($num, XIUNO_PPP, $page, XIUNO_HOST_BBS."thread-index-$tid.htm?fromtypeid=$fromtypeid&frompage=$frompage");

		$attachpids = array();
		foreach($postlist as &$post) {
			if($post['attachnum']) {
				$attachpids[] = $post['pid'];
			}
			$post['operation'] = array();
			if($post['isoperated']) {
				$operations = $this->logmodel->get_operation_log_by_pid($post['pid']);
				if($operations) {
					$post['operation'] = $operations;
				}
			}
			$post['rate'] = array();
			if($post['is_rated']) {
				$post['rate'] = $this->ratemodel->get_post_rate($post['pid']);
			}
		}
		
		$attachlist = $attachpids ? $this->threadmodel->get_attach_list($attachpids) : array();
		$this->view->assign('attachlist', $attachlist);
		
		// ȡûϢ
		$userlist = array();
		$uids = $this->array_values($postlist, 'uid');
		$userlist = $this->db->fetch_all_by_ids('www_user', 'uid', 'uid, groupid, avatar', $uids);
		foreach($userlist as &$_user) {
			$this->usermodel->format_user($_user);
		}

		// ʶѾ׼ setdata()
		$this->forummodel->set_visited('visitedtid', $tid);

		$thread['subject'] = $this->xiuno_substr($thread['subject'], strlen($thread['subject']));
		$this->header['title'] = strip_tags($thread['subject']);

		$this->header['keywords'] = $thread['subject'];
		$this->header['seokeywords'] = $thread['subject'];
		$this->header['description'] = $thread['subject'].', '.$forum['name'];

		// Ӳ鿴
		if($page == 1) {
			// е delaycol ֧
			$this->db->query("/*primarykey=tid&delaycol=views*/ UPDATE LOW_PRIORITY bbs_thread SET views=views+'1' WHERE tid='$tid'");
		}

		// ģ
		$this->view->assign('frompage', $frompage);
		$this->view->assign('fromtypeid', $fromtypeid);
		$this->view->assign('group', $this->group);
		$this->view->assign('tid', $tid);
		$this->view->assign('fid', $fid);
		$this->view->assign('page', $page);
		$this->view->assign('thread', $thread);
		$this->view->assign('forum', $forum);
		$this->view->assign('pforum', $pforum);
		$this->view->assign('num', $num);
		$this->view->assign('multipage', $multipage);
		$this->view->assign('userlist', $userlist);
		$this->view->assign('postlist', $postlist);
		$this->view->assign('groups', $groups);
		$this->view->assign_value('allowpostpoll', $this->group['allowpostpoll'] && XIUNO_BBS_POLL_ON);
		
		// ֧
		switch($thread['typeid']) {
			case BBS_THREAD_POLL:
				$this->poll_formatthread($tid);
			default:
				$this->view->assign_value('bbs_thread_messageblock', 'bbs_thread_messageblock_normal');
				break;
		}
		$this->view->display('bbs_thread');
	}

	public function show_group() {
		$groupid = intval(getgpc(2));
		$onlycontent = getgpc(3);
		$showgroup = $this->cache('group', $groupid);
		$groups = $this->cache('groups');
		$admingroup = $commongroup = $sysgroup = $specialgroup = array();

		foreach($groups as $groupid=>$group) {
			switch ($group['type']) {
				case 1:
					$admingroup[$groupid] = $group;
					break;
				case 2:
					$commongroup[$groupid] = $group;
					break;
				case 3:
					$sysgroup[$groupid] = $group;
					break;
				case 4:
					$specialgroup[$groupid] = $group;
					break;
				default:
					break;
			}
		}
		$menuid = getgpc('menuid');
		$checkarray = array('0'=>"<img src=\"".XIUNO_HOST_IMAGE."image/common/check_error.gif\" />&nbsp;", 1=>"<img src=\"".XIUNO_HOST_IMAGE."image/common/check_right.gif\" />&nbsp;");
		$this->view->assign('menuid', $menuid);
		$this->view->assign('checkarray', $checkarray);
		$this->view->assign('showarray', $showarray);
		$this->view->assign('admingroup', $admingroup);
		$this->view->assign('commongroup', $commongroup);
		$this->view->assign('sysgroup', $sysgroup);
		$this->view->assign('specialgroup', $specialgroup);
		$this->view->assign('showgroup', $showgroup);
		
		if($onlycontent) {
			$this->view->display('ajax_header');
			$this->view->display('bbs_show_group_content');
			$this->view->display('ajax_footer');
		} else {
			$this->view->display('bbs_show_group');
		}
	}

	private function poll_formatthread($tid) {
		$poll = $this->db->fetch_first("SELECT * FROM bbs_poll WHERE tid='$tid'");
		$poll['expired'] = ($poll['expiration'] > 0 && $poll['expiration'] < $this->time) ? 1 : 0;
		$polloptions = $this->db->fetch_all("SELECT * FROM bbs_poll_option WHERE tid='$tid'");
		$polled = $this->user['uid'] ? $this->postmodel->poll_check($this->user['uid'], $tid) : 0;
		$view_polled_user = $polled || $this->user['ismoderator'];
		$pollnum = 0;
		$i = 0;
		$maxpollnum = 0;
		foreach($polloptions as &$option) {
			$i++;
			$i = $i % 10;
			$maxpollnum = max($maxpollnum, $option['pollnum']);
			$pollnum += $option['pollnum'];
			$option['src'] = 'image/bbs/pollcolumn'.$i.'.gif';
			$option['check'] = $poll['ismulti'] ? '<input class="noborder" type="checkbox" name="check[]" value="'.$option['optionid'].'">'
			: '<input class="noborder" type="radio" name="check[]" value="'.$option['optionid'].'">';
		}
		$pollnum = max(1, $pollnum);
		foreach($polloptions as &$option) {
			$option['percent'] = sprintf('%.2f',$option['pollnum'] * 100 / $pollnum);
			$option['length'] = 1 + $option['pollnum'] / $maxpollnum * 450;		// 450ΪͶƱε
		}
		$this->view->assign('pollnum', $pollnum);
		$this->view->assign('poll', $poll);
		$this->view->assign('view_polled_user', $view_polled_user);
		$this->view->assign('polled', $polled);
		$this->view->assign('polloptions', $polloptions);
	}

	public function poll_polleduser() {
		$optionid = intval(getgpc(2));
		$tid = $this->db->result_first("SELECT tid FROM bbs_poll_option WHERE optionid='$optionid'");
		$fid = $this->db->result_first("SELECT fid FROM bbs_thread WHERE tid='$tid'");
		$forum = $this->cache('forum', $fid);
		$forbidviewgroup = trim($forum['forbidviewgroup']);
		if(strpos($forum['forbidviewgroup'], "\t".$this->user['groupid']."\t") !== FALSE) {
			$this->message('ûзʴ̳Ȩ', 'BACK');
		}
		$view_polled_user = $this->forummodel->is_moderator($forum, $this->user['groupid'], $this->user['uid']);
		if(!$view_polled_user) {
			$this->message('ûȨ޲鿴', '', array('error'=>1));
		}
		$userlist = $this->db->fetch_all("SELECT uid,username FROM bbs_poll_user WHERE optionid='$optionid' LIMIT 400");
		$this->view->assign_value('userlist', array_chunk($userlist, 8));
		$this->view->display('bbs_thread_poll_userlist');
	}

	public function medal_showusers() {
		$medalid = intval(getgpc(2));
		$medallist = array();
		$themedal = $this->medalmodel->get_medal_by_medalid($medalid);
		$medals = $this->medalmodel->get_usermedal_by_medalid($medalid);
		if(!empty($medals)) {
			$i = 0;
			foreach($medals as $medal) {
				$tmp_medal = $this->usermodel->get_user_by_uid($medal['uid'], 'credits, regdate', 'uid, username, avatar');
				$tmp_medal['floor'] = $i;
				$tmp_medal['avatar_src'] = $this->get_avatar($medal['uid']);
				$this->usermodel->format_user($tmp_medal);
				array_push($medallist, $tmp_medal);
				++$i;
			}
		}
		$totaluser = count($medallist);
		$this->view->assign('themedal', $themedal);
		$this->view->assign('totaluser', $totaluser);
		$this->view->assign('medallist', $medallist);
		$this->view->display('bbs_medal');
	}

	// ɾ statusΪ1
	public function repage(){
		$tid = intval(getgpc(2));
		$fid = $this->db->result_first("SELECT fid FROM bbs_thread WHERE tid='$tid'");
		$ismoderator = $this->forummodel->is_moderator($this->cache('forum', $fid), $this->user['groupid'], $this->user['uid']);
		if(!$ismoderator){
			$this->message('ûȨ', '', array('error'=>1));
		}

		$num = $this->db->result_first("SELECT COUNT(*) FROM bbs_post WHERE tid='$tid'");
		$start = intval(getgpc('start'));
		$ppp = 1000;
		$pids = $this->db->fetch_all("SELECT pid,status FROM bbs_post WHERE tid='$tid' LIMIT $start,$ppp");
		if(empty($pids)){
			$this->message('ݳɹ,ʼPAGE', XIUNO_HOST_BBS."thread-repage2-$tid.htm");
		}
		foreach($pids as $row){
			if($row['status']){
				$this->db->query("DELETE FROM bbs_post WHERE pid='$row[pid]'");
			} else {
				$start++;
			}
		}
		$this->message('ݣĿǰȣ '.$start.'/'.$num.'(ǰ¥/¥)', XIUNO_HOST_BBS."thread-repage-$tid.htm?start=$start");
	}

	//  page
	public function repage2(){
		$tid = intval(getgpc(2));
		$fid = $this->db->result_first("SELECT fid FROM bbs_thread WHERE tid='$tid'");
		$ismoderator = $this->forummodel->is_moderator($this->cache('forum', $fid), $this->user['groupid'], $this->user['uid']);
		if(!$ismoderator){
			$this->message('ûȨ', '', array('error'=>1));
		}
		$startpage = max(1, getgpc('page'));
		$page = $startpage;
		$start = ($page-1) * XIUNO_PPP;
		$num = $this->db->result_first("SELECT COUNT(*) FROM bbs_post WHERE tid='$tid'");
		if($start >= $num){
			$this->message('', XIUNO_HOST_BBS."thread-index-$tid.htm");
		}
		$totalpage = ceil($num / XIUNO_PPP);

		$per = 25 * XIUNO_PPP;

		$query = $this->db->query("SELECT pid FROM bbs_post WHERE tid='$tid' ORDER BY dateline LIMIT $start, $per");
		$i = 0;
		while($row = $this->db->fetch_array($query)){
			$i++;
			$pid = $row['pid'];
			$this->db->query("UPDATE LOW_PRIORITY bbs_post SET page='$page' WHERE pid='$pid'");
			if($i == XIUNO_PPP) {
				$this->postmodel->delete_tid_page_memcache($tid, $page);
				$page++;
				$i = 0;
			}
		}
		if($startpage == $page){
			$this->postmodel->delete_tid_page_memcache($tid, $page);
			$this->message('', XIUNO_HOST_BBS."thread-index-$tid.htm");
		}
		$this->message('ãĿǰȣ '.$page.'/'.$totalpage.'(ǰҳ/ҳ)', XIUNO_HOST_BBS."thread-repage2-$tid.htm?page=$page");
	}

	private function get_referer_arg($referer) {
		$start = strrpos($referer, '/') + 1;
		$end = strrpos($referer, '.');
		return array_pad(explode('-', substr($referer, $start, $end-$start)), 5, 0);
	}
}