<?php

define('control/my/_control.php', 1);

!defined('XIUNO_ROOT') && exit;

class _control extends base{

	public $vuser = array('uid'=>0, 'username'=>'', 'groupid'=>0, 'username_slash'=>''); // ʵĿռϢ
	
	public $self; // ǷԼĿռ
	public $uid;
	public $isfriend; // ǷǺ

	function __construct() {
		parent::__construct();
		$this->nav['check2'] = array(
			'index' => '',
			'blog' => '',
			'image' => '',
			'pm' => '',
			'post' => '',
			'friend' => '',
			'profile' => '',
			'account' => '',
			'feed' => '',
			'favorite' => '',
		);
		
		$this->set_navcheck('my', 1);
		$this->set_navcheck($_GET['m'], 2);
		$this->view->assign('self', $this->self);
		$this->view->assign('uid', $this->uid);
		$this->view->assign('vuser', $this->vuser);

	}


	public function check_login() {
		if(empty($this->user['uid'])) {
			$this->view->display('www_user_login');
			exit;
		}
	}

	/**  Ȩж
	 * @$priv Ϊ all ʱ,ʾûԷ
	 * @$priv Ϊ friend ʱ,ֻԼͺѿԷ
	 * @$priv Ϊ self ʱ,ֻԼԷ
	 */
	public function check_priv($priv = 'all') {
		switch ($priv) {
			case 'all':
				if(empty($this->user['uid']) && empty($this->vuser['uid'])) {
					$this->view->display('user-login.htm');
				}
				break;
			case 'friend':
				if(empty($this->user['uid']) && empty($this->vuser['uid'])) {
					$this->view->display('user-login.htm');
				}
				if(!$this->self && !$this->friendmodel->is_friend($this->user['uid'],$this->vuser['uid'])) {
					$this->message('Էĺѣ', '', array('error'=>1));
				}
			case 'self':
				if (!$this->self){
					if(empty($this->user['uid'])) {
						$this->view->display('user-login.htm');
					}
					else {
						$this->message('ҳֻԼܷ', '', array('error'=>1));
					}
				}
				break;
			default:
				break;
		}
	}

	public function message($message = '', $redirect = '', $extra = array()) {
		$this->_message($message, $redirect, $extra, 'my_message');
	}
	
	public function get_uid() {
		return getgpc('uid') ? getgpc('uid') : $this->user['uid'];
	}
	
	public function init_vuser($uid = FALSE) {
		$uid === FALSE && $uid = $this->get_uid();
		
		$this->vuser = $this->usermodel->get_user_by_uid($uid);
		$this->usermodel->format_user($this->vuser);
		if(empty($this->vuser)) {
			$this->message('ûڣ', array('error'=>10001));
		}
		$this->vuser['username_slash'] = addslashes($this->vuser['username']);
		$this->self = $uid == $this->user['uid'];
		$this->uid = $uid;
		
		return $uid;
	}
}
?>