<?php

!defined('XIUNO_ROOT') && exit;

class control extends _control {

	function __construct() {
		parent::__construct();
		$this->check_login();
		$this->nav['check3'] = array('search'=>'', 'invite'=>'', 'ls'=>'');
		$this->set_navcheck($_GET['a'], 3);
		$this->init_vuser();
	}

	function __call($name, $args) {
		$_GET['a'] = 'ls';
		$this->set_navcheck($_GET['a'], 3);
		$this->ls();
	}

	public function ls() {
		$page = max(1, getgpc('page'));
		$ppp = XIUNO_PPP;
		$totalnum = $this->db->result_first("SELECT COUNT(*) FROM my_friend WHERE uid='{$this->uid}'");
		$friendlist = $this->friendmodel->get_friendlist_by_page($this->uid, $page, $ppp);
		$multipage = $this->page($totalnum, XIUNO_PPP, $page, XIUNO_HOST_MY."friend-ls.htm?uid={$this->uid}", 0);
		if($friendlist) {
			foreach($friendlist as &$friend) {
				$this->usermodel->format_user($friend);
				//$friend['avatar_small'] = $this->get_avatar($friend['uid'], 'small', $friend['avatar']);
			}
		}
		$this->view->assign('friendlist', $friendlist);
		$this->view->assign('multipage', $multipage);
		$this->view->display("my_friend_ls");
	}

	// ajax
	function add() {
		$fuid = getgpc('fuid');
		if($fuid == $this->user['uid']){
			$this->message('ԼΪ', '', array('error'=>2));
		}
		if($this->friendmodel->search_friendrequest($this->user['uid'], $fuid)) {
			$this->message('Ѿ˺룬ĵȴԷĴ', '', array('error'=>4));
		} else if($this->friendmodel->is_friend($this->user['uid'], $fuid)) {
			$this->message('ԷѾĺˡ', '', array('error'=>1));
		}
		$this->friendmodel->add_request($this->user, $fuid);
		$this->eventmodel->increase_event($fuid, 'new_friendrequest');
		$this->message("ѾڶԷȷϺ֪ͨ");
	}

	function pass() {
		$fuid = getgpc('fuid');
		$pass = getgpc('pass');
		$uid = $this->user['uid'];
		$fusername = $this->usermodel->get_username_by_uid($fuid);
		if(empty($fusername)) {
			$this->message('û', '', array('error'=>1));
		}
		if($pass == 'agree') {
			$this->friendmodel->delete_request($fuid, $this->user['uid']);
			$this->eventmodel->decrease_event($this->user['uid'], 'new_friendrequest');
			//жǷѾΪ
			if($this->friendmodel->is_friend($this->user['uid'], $fuid)) {
				$this->message('ԷѾĺˡ', '', array('error'=>1));
			}
			$username = $this->usermodel->get_username_by_uid($uid);
			$this->friendmodel->add_friend($uid,$fuid, addslashes($username), addslashes($fusername));
			$this->message('Ӻѳɹ', '', array('error'=>1));
		} elseif($pass == 'disagree') {
			$this->friendmodel->delete_request($fuid, $this->user['uid']);
			$this->eventmodel->decrease_event($this->user['uid'], 'new_friendrequest');
			$this->noticemodel->add_notice($this->user['uid'], $fuid, $this->user['username'], $fusername, array(), 'denyfriendrequest');
			$this->message('ɹ', '', array('error'=>1));
		}
	}

	function delete() {
		$fuid = getgpc('fuid');
		$uid = $this->user['uid'];
		$fusername = $this->usermodel->get_username_by_uid($fuid);
		if(empty($fusername)) {
			$this->message('û', '', array('error'=>1));
		}
		$this->friendmodel->delete($uid, $fuid);
		$this->message('ɾɹ', '', array('error'=>1));
	}

	function search() {
		$submit1 = getgpc('submit1', 'R');
		if(!empty($submit1)) {
			$num = getgpc('num');
			$page = max(intval(getgpc('page')), 1);
	
			$srchusername = getgpc('srchusername', 'R');
			$email = getgpc('email', 'R');
			$province = getgpc('searchprovince', 'R');
			$city = getgpc('searchcity', 'R');
			$gender = getgpc('gender', 'R');
			$bday = getgpc('bday', 'R');
	
			$favinterest = getgpc('favinterest', 'R');
			$favbook = getgpc('favbook', 'R');
			$favsport = getgpc('favsport', 'R');
			$favmusic = getgpc('favmusic', 'R');
			$favmovie = getgpc('favmovie', 'R');
	
			if($favinterest || $favbook || $favsport || $favmusic || $favmovie) {
				$type = '';
				$favstr = '';
				if($favintrest) {
					$type = 'favintrest';
					$favstr = $favintrest;
				} elseif($favbook) {
					$type = 'favbook';
					$favstr = $favbook;
				} elseif($favsport) {
					$type = 'favsport';
					$favstr = $favsport;
				} elseif($favmusic) {
					$type = 'favmusic';
					$favstr = $favmusic;
				} elseif($favmovie) {
					$type = 'favmovie';
					$favstr = $favmovie;
				}
				if(!empty($type) && !empty($favstr)) {
					empty($num) && $num = $this->friendmodel->get_user_num_by_fav($type, $favstr);
					$multipage = $this->page($num, XIUNO_PPP, $page, XIUNO_HOST_MY."friend-search.htm?submit1=1&num=$num&$type=$favstr");
					$userlist = $this->friendmodel->get_user_list_by_fav($page, XIUNO_PPP, $num, $type, $favstr);
				}
	
			} else {
				if($province || $city) {
					$sqladd = '';
					$sqladd .= $province && empty($city) ? " AND uf.province='$province'" : '';
					$sqladd .= $city ? " AND uf.city='$city'" : '';
	
					$urladd = '';
					$urladd .= $province ? "&searchprovince=$province" : '';
					$urladd .= $city ? "&searchcity=$city" : '';
	
				} elseif($srchusername) {
					$sqladd = $srchusername ? " AND uf.username='$srchusername'" : '';
					$srchusername = urlencode($srchusername);
					$urladd = $srchusername ? "&$srchusername=$srchusername" : '';
				}  elseif($email) {
					$sqladd = $email ? " AND uf.email='$email'" : '';
					$email = urlencode($email);
					$urladd = $email ? "&email=$email" : '';
				} else {
					$year = $this->date($this->time, 'Y');
					$years = array(15=> ($year - 15), 22=>($year - 22), 30=>($year - 30), 40=>($year - 40));
					$bdaysqladd = array(
						0 => '',
						1 => " AND uf.bday_y > $years[15]",
						2 => " AND uf.bday_y < $years[15] AND uf.bday_y > $years[22]",
						3 => " AND uf.bday_y < $years[22] AND uf.bday_y > $years[30]",
						4 => " AND uf.bday_y < $years[30] AND uf.bday_y > $years[40]",
						5 => " AND uf.bday_y < $years[40]",
					);
					$sqladd = '';
					// bday_y ˵ĽһЩǰ
					$sqladd .= $bday ? $bdaysqladd[$bday] : '';
					$sqladd .= $gender ? " AND uf.gender='$gender'" : '';
	
					$urladd = '';
					$urladd .= $gender ? "&gender='$gender'" : '';
					$urladd .= $bday ? "&bday=$bday" : '';
				}
	
				empty($num) && $num = $this->db->result_first("SELECT COUNT(*) FROM www_userfield uf WHERE 1 $sqladd");
				$multipage = $this->page($num, XIUNO_PPP, $page, XIUNO_HOST_MY."friend-search.htm?submit1=yes&num=$num&$urladd", 0);
				$start = $this->page_get_start($page, XIUNO_PPP, $num);
				$uids = $this->db->fetch_all("SELECT uid FROM www_userfield uf WHERE 1 $sqladd LIMIT $start, ".XIUNO_PPP);
				$userlist = array();
				$uids = $this->array_values($uids, 'uid');
				if(XIUNO_MEMCACHE_ON) {
					foreach($uids as $uid) {
						$userlist[$uid] = $this->usermodel->get_user_by_uid($uid);
					}
				} else {
					$sqladd = $this->array_to_sql_or($uids, 'u.uid');
					$sqladd && $userlist = $this->db->fetch_all("SELECT * FROM www_user u LEFT JOIN www_userfield uf USING(uid) WHERE $sqladd", 'uid');
				}
				
			}
	
			if($userlist) {
				foreach($userlist as $key=>&$_user) {
					if($_user['uid'] && $_user['uid'] == $this->user['uid']) {
						unset($userlist[$key]);
					} else {
						$this->usermodel->format_user($_user);
					}
				}
			}
			$this->view->assign('multipage', $multipage);
			$this->view->assign('userlist', $userlist);
			$this->view->assign('num', $num);	
		} else {
			$srchusername = $email = '';
		}
		
		$this->view->assign_value('srchusername', htmlspecialchars($srchusername));
		$this->view->assign_value('email', htmlspecialchars($email));
		
		$user = $this->usermodel->get_user_by_uid($this->user['uid']);
		$provinceselect = $this->profilemodel->get_address_select('search', 1, ($province ? $province : $user['province']));
		$cityselect = $this->profilemodel->get_address_select('search', $user['province'], ($city ? $city : $user['city']));

		$user['favinterest'] = $this->format_fav('favinterest', $user['favinterest']);
		$user['favbook'] = $this->format_fav('favbook', $user['favbook']);
		$user['favsport'] = $this->format_fav('favsport', $user['favsport']);
		$user['favmusic'] = $this->format_fav('favmusic', $user['favmusic']);
		$user['favmovie'] = $this->format_fav('favmovie', $user['favmovie']);

		$user['provincename'] = $this->profilemodel->get_address_name($user['province']);
		$user['cityname'] = $this->profilemodel->get_address_name($user['city']);
		
		// ûŻȥҿܵĺ
		if(empty($submit1)) {
			$commonfriendlist = $this->friendmodel->get_commomfriend_list($this->user['uid']);
		}

		//$this->view->assign('countryselect', $countryselect);
		$genderarr = array(
			'0'=>'',
			'1'=>'',
			'2'=>'Ů',
		);
		$bdayarr = array(
			'0'=>'',
			'1'=>'0-15',
			'2'=>'16-22',
			'3'=>'23-30',
			'4'=>'31-40',
			'5'=>'40-',
		);
		$genderselect = $this->form->get_select('gender', $genderarr, $gender, array('style'=>'width: 80px;'));
		$bdayselect = $this->form->get_select('bday', $bdayarr, $bday, array('style'=>'width: 80px;'));
		$this->view->assign('genderselect', $genderselect);
		$this->view->assign('bdayselect', $bdayselect);
		$this->view->assign('provinceselect', $provinceselect);
		$this->view->assign('cityselect', $cityselect);
		$this->view->assign('commonfriendlist', $commonfriendlist);
		$this->view->assign('user', $user);
		$this->view->display("my_friend_search");
	}

	function format_fav($type, $str) {
		$userfavs = explode(' ', $str);
		$favstr	= '';
		foreach($userfavs as $favname) {
			$favstr .= empty($favname) ? '' : ' <a href="'.XIUNO_HOST_MY.'friend-search.htm?submit1=1&'.$type.'='.urlencode($favname).'">'.$favname.'</a>';
		}
		return $favstr;
	}

	function invite() {
		if(!$this->submitcheck()) {
			$this->view->display("my_friend_invite");
		} else {
			$emails = getgpc('emails', 'P');
			if(is_array($emails)) {
				$emails = implode('\r\n', $emails);
			}
			$emails = str_replace("", '\r\n', $emails);
			$emails = preg_replace("/\s+/", "\r\n", $emails);
			$emails = preg_replace("/[,]+/", "\r\n", $emails);
			$arr = explode(",", $emails);
			if(count($arr) > 100) {
				$this->message('һֻһٸѣ뷵ء');
			}

			$subject = "ãĺ {$this->user['username']} ".XIUNO_SITENAME."Ϊ";
			$message = "{$this->user['username']} ".XIUNO_SITENAME."Ϊ
				".XIUNO_SITENAME."һվ
				עᲢΪ {$this->user['username']} ĺ
				http://www.guomo.com/user-reg.htm
				{$this->_time}";
			if($this->miscmodel->sendmail($emails, $subject, $message)) {
				$this->message('ɹ', XIUNO_HOST_MY.'friend-invite.htm');
			} else {
				$this->message('ϵͳʼϵͳܳ˵⣬ʧܣԺԡ', 'BACK');
			}
		}
	}

	// б
	public function requestls() {
		$this->nav['check2']['friend'] = '';
		$this->set_navcheck('feed', 2);
		$this->set_navcheck('friendrequest', 4);
		$page = max(1, intval(getgpc(2)));
		$total = $this->friendmodel->get_request_num($this->user['uid']);
		$requestlist = $this->friendmodel->get_request_list_by_page($this->user['uid'], $page, XIUNO_PPP);
		if(empty($requestlist)) {
			$this->db->query("/*primarykey=uid*/ UPDATE www_user_event SET new_friendrequest='0' WHERE uid='{$this->user['uid']}'");
		}
		$multipage = $this->page($total, XIUNO_PPP, $page, XIUNO_HOST_MY.'friend-requestls.htm');
		foreach($requestlist as &$request) {
			$request['avatar'] =$this->get_avatar($request['fromuid'], 'small');
		}
		$this->view->assign('multipage', $multipage);
		$this->view->assign('requestlist', $requestlist);
		$this->view->display('my_friend_request_ls');
	}

	public function unvisible() {
		$fuid = intval(getgpc('fuid'));
		$value = intval(getgpc('value'));
		$this->db->query("UPDATE my_friend SET unvisible='$value' WHERE uid='{$this->user['uid']}' AND fuid='$fuid'");
		$this->message('༭ɹ');
	}

	/**
	 * $post	a=1&b=2
	 */
	public function xiuno_fopen($url, $limit = 0, $post = '', $cookie = '', $ip = '', $timeout = 15, $block = TRUE) {
		$return = '';
		$matches = parse_url($url);
		$host = $matches['host'];
		$path = $matches['path'] ? $matches['path'].($matches['query'] ? '?'.$matches['query'] : '') : '/';
		$port = !empty($matches['port']) ? $matches['port'] : 80;

		if($post) {
			$out = "POST $path HTTP/1.0\r\n";
			$out .= "Accept: */*\r\n";
			//$out .= "Referer: $boardurl\r\n";
			$out .= "Accept-Language: zh-cn\r\n";
			$out .= "Content-Type: application/x-www-form-urlencoded\r\n";
			$out .= "User-Agent: $_SERVER[HTTP_USER_AGENT]\r\n";
			$out .= "Host: $host\r\n";
			$out .= 'Content-Length: '.strlen($post)."\r\n";
			$out .= "Connection: Close\r\n";
			$out .= "Cache-Control: no-cache\r\n";
			$out .= "Cookie: $cookie\r\n\r\n";
			$out .= $post;
		} else {
			$out = "GET $path HTTP/1.0\r\n";
			$out .= "Accept: */*\r\n";
			//$out .= "Referer: $boardurl\r\n";
			$out .= "Accept-Language: zh-cn\r\n";
			$out .= "User-Agent: $_SERVER[HTTP_USER_AGENT]\r\n";
			$out .= "Host: $host\r\n";
			$out .= "Connection: Close\r\n";
			$out .= "Cookie: $cookie\r\n\r\n";
		}
		$fp = @fsockopen(($ip ? $ip : $host), $port, $errno, $errstr, $timeout);
		if(!$fp) {
			return '';
		} else {
			stream_set_blocking($fp, $block);
			stream_set_timeout($fp, $timeout);
			@fwrite($fp, $out);
			$status = stream_get_meta_data($fp);
			if(!$status['timed_out']) {
				while (!feof($fp)) {
					if(($header = @fgets($fp)) && ($header == "\r\n" ||  $header == "\n")) {
						break;
					}
				}

				$stop = false;
				while(!feof($fp) && !$stop) {
					$data = fread($fp, ($limit == 0 || $limit > 8192 ? 8192 : $limit));
					$return .= $data;
					if($limit) {
						$limit -= strlen($data);
						$stop = $limit <= 0;
					}
				}
			}
			@fclose($fp);
			return $return;
		}
	}

	public function msn() {
		if(!$this->submitcheck()) {
			$this->view->display('my_friend_msn');
		} else {
			$username = getgpc('username', 'P');
			$password = getgpc('password', 'P');
			include_once XIUNO_ROOT."lib/msn_connect_grab.php";
			$msn = new msn();
			$returned_emails = $msn->qGrab($username, $password);
			foreach($returned_emails as &$email) {
				$email[1] = iconv('UTF-8','GBK',$email[1]);
			}
			$this->view->assign('emails', $returned_emails);
			$this->view->assign('username', $username);
			if($returned_emails) {
				$this->message($returned_emails);
			} else {
				$error = 1;
				$this->view->assign('error', $error);
				$this->view->display('my_friend_msn');
			}
		}
	}
}