<?php

!defined('XIUNO_ROOT') && exit;

class control extends _control {

	function __construct() {
		parent::__construct();
		$this->nav['check3'] = array('add'=>'', 'inbox'=>'');
		$this->uid = $this->user['uid'];
		$this->check_login();
		$this->init_vuser();
	}

	function __call($name, $args) {
		$_GET['a'] = 'inbox';
		$this->inbox();
	}

	public function inbox() {
		$this->set_navcheck('inbox', 3);
		$page = max(1, intval(getgpc(2)));
		$pmlist = $this->pmmodel->get_pm_by_page($this->uid, $page, XIUNO_PPP);
		$multipage = $this->page($this->pmmodel->get_pm_num($this->uid), XIUNO_PPP, $page, XIUNO_HOST_MY.'pm-inbox.htm');
		$maxpmid = 0;
		if(!empty($pmlist)) {
			foreach($pmlist as &$pm) {
				$maxpmid = max($maxpmid, $pm['pmid']);
				$pm['dateline'] = $this->date($pm['dateline']);
				if($pm['lowid'] == $this->uid) {
					$pm['fromuid'] = $pm['highid'];
					$pm['fromuser'] = $pm['highuser'];
				} else {
					$pm['fromuid'] = $pm['lowid'];
					$pm['fromuser'] = $pm['lowuser'];
				}
			}
		}
		$this->view->assign('pmnum', $this->new['pms']);
		$this->view->assign('page',$page);
		$this->view->assign('pms',$pmlist);
		$this->view->assign('maxpmid',$maxpmid);
		$this->view->assign('multipage',$multipage);
		$this->view->display('my_pm_inbox');
	}

	// ajax
	function detail() {
		$pmid = intval($_GET[2]);
		$pm = $this->pmmodel->get_pm_by_pmid($pmid);
		if($pm['lowid'] != $this->uid && $pm['highid']!=$this->uid) {
			$this->message('Ķ˵ĶϢ');
			return;
		}
		if($pm['uid'] == $this->uid) {
			if($pm['new']) {
				$this->db->query("UPDATE my_pm SET new='0' WHERE pmid='$pmid'");
				$this->eventmodel->decrease_event($this->user['uid'], 'new_pm');
			}
		}
		$fromuser = $pm['lowid'] == $pm['uid'] ? $pm['highuser'] : $pm['lowuser'];
		$this->view->assign('fromuser', $fromuser);
		$this->view->assign('pm', $pm);
		$this->view->display('ajax_header');
		$this->view->display('my_pm_inbox.body');
		$this->view->display('ajax_footer');
	}

	function add() {
		$this->set_navcheck('add', 3);
		if(!$this->submitcheck()) {
			$touid = getgpc('touid');
			if($touid) {
				$user = $this->usermodel->get_user_by_uid($touid);
				$touser = $user['username'];
			} else {
				$touser = htmlspecialchars(getgpc('touser'));
			}
			$this->view->assign('touser', $touser);
			$this->view->assign_value("friends", $this->friendmodel->get_friends($this->uid, 30));
			$this->view->display('my_pm_add');
		} else {
			$caller = getgpc('caller', 'G');
			$touser = getgpc('touser', 'P');
			$tousers = getgpc('friend', 'P');
			$subject = htmlspecialchars(getgpc('subject','P'));
			$message = htmlspecialchars(getgpc('message','P'));
			$this->stringmodel->strip_script($message);
			
			!$subject && $subject = $this->xiuno_substr($message, 20);
			if(!empty($touser)) {
				$touid = $this->usermodel->get_uid_by_username($touser);
				!empty($touid) && $tousers[$touid] = $touser;
			}
			empty($tousers) && $this->message('ռ˲ڻռΪ', 'BACK', array('error'=>10002));
			if(empty($message) && empty($subject)) {
				$this->message('дϢ', 'BACK', array('error'=>10003));
			}
			$this->pmmodel->add_pm($subject, $message, $tousers, $this->user['uid'], $this->user['username_slash'], $this->time);

			// Ϣʷ
			if($caller == 'history') {
				$uid = $this->user['uid'];
				$fromuser = "<a href='".XIUNO_HOST_MY."index-index-$uid.htm' target='_blank'>".$this->user['username'].'</a>';
				$avatar = $this->get_avatar($this->uid, 'small');
				$dateline = $this->date($this->time, 'n-j H:i');
				$history = array(
					'avatar'=>$avatar,
					'fromuser'=>$fromuser,
					'dateline'=>$dateline,
					'subject'=>$subject,
					'message'=>$message,
				);
				$this->view->assign('history', $history);
				$this->view->display('ajax_header');
				$this->view->display('my_pm_history.body');
				$this->view->display('ajax_footer');
			} else {
				$this->message('ͳɹ<script type="text/javascript">window.onload=function(){deldata(\'message\');}</script>', XIUNO_HOST_MY.'pm-add.htm');
			}
		}
	}

	public function contact() {
		$this->set_navcheck('contact', 3);
		$friendids = $this->friendmodel->get_friendids_by_uid($this->uid);
		$friendlist = $this->db->fetch_all_by_ids('www_userfield', 'uid', 'uid, username, avatar', $friendids);
		foreach($friendlist as &$v) {
			$v['avatar_small'] = $this->get_avatar($v['uid'], 'small', $v['avatar']);
		}
		$this->view->assign('pmnum', $this->new['pms']);
		$this->view->assign('contacts', $contacts);
		$this->view->assign('friendlist', $friendlist);
		$this->view->display("my_pm_contact");
	}

	/* $pm[uid]		˵uid
	* $pm[lowid]		uidСuid
	* $pm[highid]		uidϴuid
	* $fromuid		˵uid
	*/
	public function ajaxhistory() {
		$lowid = intval(min(getgpc(2),getgpc(3)));
		$highid = intval(max(getgpc(2),getgpc(3)));
		if($lowid!=$this->uid && $highid!=$this->uid) {
			$this->message('Ȩ鿴˵ĶϢ¼');
		}

		if($lowid == 0) {
			$this->message('û');
		}

		// ȡϢб. Ĭȡһҳ
		$totalnum = $this->db->result_first("SELECT COUNT(*) FROM my_pm WHERE lowid='$lowid' AND highid='$highid'");
		$lastpage = $totalnum ? ceil($totalnum/XIUNO_PPP) : 1;
		$page = getgpc('page') ? intval(getgpc('page')) : $lastpage;
		$islastpage = $page == $lastpage;
		$ppp = 6;
		$historys = $this->pmmodel->get_pms_by_page($lowid, $highid, $page, $ppp);
		$multipage = $this->page($totalnum, XIUNO_PPP, $page, XIUNO_HOST_MY."pm-ajaxhistory-$lowid-$highid.htm?menuid=".getgpc('menuid'), NULL, getgpc('menuid')."body");

		// ȡϢ˫ͷ
		$lowavatar = $this->get_avatar($lowid, 'small');
		$highavatar = $this->get_avatar($highid, 'small');

		$fromuid = $lowid == $this->uid ? $highid : $lowid;
		$fromuser = '';

		// ʽϢ
		$newpmids = array();
		foreach ($historys as &$history) {
			if($history['uid'] == $this->user['uid'] && $history['new']) {
				$newpmids[] = $history['pmid'];
			}
			if($history['uid'] == $lowid) {
				$history['fromid'] = $highid;
				$history['avatar'] = $highavatar;
				empty($fromuser) && $fromuser = $fromuid == $history['lowid'] ? $history['lowuser'] : $history['highuser'];
				$history['fromuser'] = "<a href='".XIUNO_HOST_MY.'index-index-'.$highid.".htm' target='_blank'>".$history['highuser'].'</a>';
			} else {
				$history['fromid'] = $lowid;
				$history['avatar'] = $lowavatar;
				empty($fromuser) && $fromuser = $fromuid == $history['lowid'] ? $history['lowuser'] : $history['highuser'];
				$history['fromuser'] = "<a href='".XIUNO_HOST_MY.'index-index-'.$lowid.".htm' target='_blank'>".$history['lowuser'].'</a>';
			}
			$history['dateline'] = $this->date($history['dateline'], 'm-d H:i');
		}
		empty($fromuser) && $fromuser = $this->usermodel->get_username_by_uid($fromuid);
		!empty($newpmids) && $this->pmmodel->edit_new_pm($newpmids, $this->user['uid']);
		$this->view->assign('fromuser',$fromuser);
		$this->view->assign('fromuid', $fromuid);
		$this->view->assign('lowid', $lowid);
		$this->view->assign('highid', $highid);
		$this->view->assign('islastpage', $islastpage);
		$this->view->assign('multipage', $multipage);
		$this->view->assign('historys',$historys);
		$this->view->display('my_pm_history');
	}

	public function delete() {
		$pmids = getgpc('deletepm', 'P');
		if(empty($pmids)) {
			$this->message('ûѡҪɾĶϢ', 'BACK');
		}
		$new = 0;	// ɾĶϢмδ,Ӧ www_user_event ȥ
		$sum = 0;	// ܹɾ
		foreach($pmids as $pmid) {
			$pm = $this->pmmodel->get_pm_by_pmid($pmid);
			if($pm['uid'] == $this->uid) {
				if($pm['new'] == '1') {
					$new++;
				}
				$this->db->query("DELETE FROM my_pm WHERE pmid='$pmid'");
				$sum ++;
			}
		}
		if($new) {
			$this->eventmodel->decrease_event($this->user['uid'], 'new_pm', $new);
		}
		if($sum) {
			$this->eventmodel->decrease_event($this->user['uid'], 'pms', $sum);
		}
		$this->message('ɾɹ', XIUNO_HOST_MY.'pm-inbox.htm');
	}
}