<?php

!defined('XIUNO_ROOT') && exit;

class control extends _control {

	public $user;

	function __construct() {
		parent::__construct();
		$this->nav['check3'] = array('base'=>'',  'password'=>'', 'avatar'=>'', 'detail'=>'');
		$this->check_login();
		$this->set_navcheck('profile', 2);
		$this->set_navcheck($_GET['a'], 3);
		
		$this->user = $this->usermodel->get_user_by_uid($this->user['uid']);
		$this->usermodel->format_user($this->user);
		
		$this->init_vuser();
	}

	function __call($name, $args) {
		$_GET['a'] = $this->self ? 'base' : 'detail';
		$this->set_navcheck($_GET['a'], 3);
		$this->$_GET['a']();
	}

	public function base() {
		if(!$this->submitcheck()) {
			$countryselect = $this->profilemodel->get_address_select('profile', 0, $this->user['country']);
			$provinceselect = $this->user['country'] ? $this->profilemodel->get_address_select('profile', $this->user['country'], $this->user['province']) : '';
			$cityselect = $this->user['province'] ? $this->profilemodel->get_address_select('profile', $this->user['province'], $this->user['city']) : '';
			
			$this->view->assign('countryselect', $countryselect);
			$this->view->assign('provinceselect', $provinceselect);
			$this->view->assign('cityselect', $cityselect);
			
			$genderarr = $this->profilemodel->load_profilecache('gender');
			$genderselect = $this->form->get_radio('gender', $genderarr, $this->user['dbgender']);
			$this->view->assign('genderselect', $genderselect);
			$this->view->display("my_profile_base");
		} else {
			$country	= getgpc('profilecountry', 'P');
			$province 	= $country ? getgpc('profileprovince', 'P') : 0;
			$city 		= $province ? getgpc('profilecity', 'P') : 0;
			
			$countrystring = $provincetring = $citystring = $address;
			$country && $countrystring = $this->db->result_first("SELECT name FROM www_address WHERE id='$country'");
			$province && $provincetring = $this->db->result_first("SELECT name FROM www_address WHERE id='$province'");
			$city && $citystring = $this->db->result_first("SELECT name FROM www_address WHERE id='$city'");
			$address = $countrystring.($provincetring ? " - $provincetring" : $provincetring).($citystring ? " - $citystring" : $citystring);
			
			$bday 		= getgpc('bday', 'P');
			list($y, $m, $d) = explode('-', $bday);

			$updatearr = $updatearr2 = array();
			//$updatearr['realname']	= getgpc('realname', 'P');
			$updatearr2['gender'] 	= getgpc('gender', 'P') ? getgpc('gender', 'P') : 0;
			$updatearr2['bday'] 	= $this->strtotime($bday);
			$updatearr2['bday_y'] 	= $y;
			$updatearr2['bday_m'] 	= sprintf("%02d", $m);
			$updatearr2['bday_d'] 	= sprintf("%02d", $d);
			$updatearr2['country']	= $country;
			$updatearr2['province'] = $province;
			$updatearr2['city'] 	= $city;
			
			$sqladd = '';
			foreach($updatearr as $k=>$v) {
				$sqladd .= "$k='$v',";
			}
			$sqladd && $sqladd = substr($sqladd, 0, -1);
			
			$sqladd2 = $address ? "address='$address'," : '';
			foreach($updatearr2 as $k=>$v) {
				$sqladd2 .= "$k='$v',";
			}
			$sqladd2 && $sqladd2 = substr($sqladd2, 0, -1);

			$this->usermodel->update_user($this->user['uid'], $sqladd, $sqladd2);
			$this->feedmodel->add_feed(array('uid'=>$this->user['uid'], 'username'=>$this->user['username'], 'subject'=>''), 'profile', $this->time, $this->user['uid']);
			$this->message('³ɹ', $_SERVER['HTTP_REFERER']);
		}
	}

	public function password() {
		if(!$this->submitcheck()) {
			$this->view->display("my_profile_password");
		} else {
			$oldpassword = getgpc('oldpassword', 'P');
			$user = $this->usermodel->get_user_by_uid($this->user['uid'], '*', '*');
			$salt = $user['salt'];
			if($this->user['password'] != $this->usermodel->encrypt($oldpassword, $salt)) {
				$this->message('ľ벻ȷ뷵ء', 'BACK');
			} elseif($_POST['newpassword1'] != $_POST['newpassword2']) {
				$this->message('벻һ£뷵ء', 'BACK');
			}
			$this->usermodel->update_user_password($this->user['uid'], $_POST['newpassword1']);
			$this->message('޸ɹ', 'BACK');
		}
	}

	public function avatar() {
		$this->check_login();
		
		$styleid = getgpc('styleid', 'C');
		// ˶δӦ÷ڸģĵطȷʽͬ
		$stylefile = 'data/view/locale_'.$styleid.'.xml';
		if(!is_file($stylefile)) {
			$s = file_get_contents(XIUNO_ROOT.'image/camera/release/locale.xml');
			$s = preg_replace('/\{([A-Z0-9_]+)\}/e', "constant('\\1')", $s);
			file_put_contents(XIUNO_ROOT.$stylefile, preg_replace('/#/', "0x", $s));
		}

		if(!$this->submitcheck()) {
			$domain = XIUNO_HOST_MY;					// 
			$swfurl = XIUNO_HOST_IMAGE."image/camera/release/camera.swf";		// flash·
			$uploadurl = "image-uploadavatar.htm";				// ϴ·
			$recturl = "image-rectavatar.htm";				// ͼƬ·
			$localeurl = XIUNO_HOST_IMAGE.$stylefile;			// xmlĵ·
			$albumlist = "image-xmlalbumlist.htm";				// ·
			$imagelist = "image-xmlimagelist.htm";				// ͼƬ·

			// cookie
			$params = "&domain=".urlencode($domain);
			$params .= "&inajax=1&uid={$this->user['uid']}";
			$params .= "&HTTP_USER_AGENT=".urlencode($_SERVER['HTTP_USER_AGENT']);
			$params .= "&sid=".$_COOKIE['sid'];
			$params .= "&auth=".urlencode($_COOKIE['auth']);
			$params .= "&lastonlineupdate=".$_COOKIE['lastonlineupdate'];

			// flash 
			$flashvars = $swfurl."?uploadurl=".urlencode($uploadurl);
			$flashvars .= "&recturl=".urlencode($recturl);
			$flashvars .= "&localeurl=".urlencode($localeurl);
			$flashvars .= "&albumlist=".urlencode($albumlist);
			$flashvars .= "&imagelist=".urlencode($imagelist);
			$flashvars .= $params;
			$uploadbyflash = 1;

			$avatarurl = $this->set_home($this->user['uid']);
			$bigavatar = XIUNO_HOST_IMAGE.$avatarurl."/{$this->user['uid']}_avatar_big.jpg";
			$middleavatar = XIUNO_HOST_IMAGE.$avatarurl."/{$this->user['uid']}_avatar_middle.gif";
			$flashvars .= "&avatarurl=".urlencode($bigavatar);
			$this->view->assign('middleavatar', $middleavatar);
			$this->view->assign('bigavatar', $bigavatar);
			$this->view->assign('flashvars', $flashvars);
			$this->view->assign('uploadbyflash', $uploadbyflash);

			$this->user['avatar_big'] = $this->get_avatar($this->user['uid'], 'big');
			$this->view->display("my_profile_avatar");
		} else {
			$avatar = $this->get_uploaded_avatar();
			$this->usermodel->update_user($this->user['uid'], array('avatar'=>($avatar ? $this->time : '0')));
			$this->feedmodel->add_feed(array('uid'=>$this->user['uid'], 'username'=>$this->user['username'], 'subject'=>'ͷ'), 'profile', $this->time, $this->user['uid']);
			$this->message('޸ͷɹ', XIUNO_HOST_MY.'profile-avatar.htm');
		}
	}

	// caller: http://my.xxx.com/friend-search.htm
	public function getaddress() {
		$pid = intval(getgpc('pid'));
		$name = getgpc('name');
		$addressselect = $this->profilemodel->get_address_select($name, $pid);
		$this->message($addressselect);
	}

	// only my.php
	private function get_uploaded_avatar() {
		$uid = $this->user['uid'];
		$avatarurl = $this->set_home($uid);
		$avatardir = XIUNO_ROOT.$avatarurl;

		$bigavatar = $avatardir."/{$uid}_avatar_big.jpg";
		$middleavatar = $avatardir."/{$uid}_avatar_middle.gif";
		$smallavatar = $avatardir."/{$uid}_avatar_small.gif";
		$miniavatar = $avatardir."/{$uid}_avatar_mini.gif";

		if(!empty($_FILES['attach']['name'][0])) {
			$uploadavatar = $_FILES['attach']['tmp_name'][0];
			require_once XIUNO_ROOT.'lib/upload.class.php';
			$u = new Upload($this->setting['allowext']);
			//file_exists($bigavatar) && unlink($bigavatar);
			//file_exists($middleavatar) && unlink($middleavatar);
			//file_exists($smallavatar) && unlink($smallavatar);
			$u->thumb(XIUNO_AVATAR_WIDTH_BIG, XIUNO_AVATAR_WIDTH_BIG, $uploadavatar, $bigavatar, 'jpg', 25, 1, 1);
			$u->thumb(XIUNO_AVATAR_WIDTH_MIDDLE, XIUNO_AVATAR_WIDTH_MIDDLE, $uploadavatar, $middleavatar, 'gif');
			$u->thumb(XIUNO_AVATAR_WIDTH_SMALL, XIUNO_AVATAR_WIDTH_SMALL, $uploadavatar, $smallavatar, 'gif');
			$u->thumb(XIUNO_AVATAR_WIDTH_MINI, XIUNO_AVATAR_WIDTH_MINI, $uploadavatar, $miniavatar, 'gif');
			file_exists($uploadavatar) && unlink($uploadavatar);
		}
		return file_exists($middleavatar);
	}

	public function detail() {
		if(getgpc('username')) {
			$this->vuser = $this->usermodel->get_uid_by_username(getgpc('username'));
		} elseif($this->uid) {
			$this->vuser = $this->usermodel->get_user_by_uid($this->uid);
		}

		// ʽûϢ
		$this->usermodel->format_user($this->vuser);
		$this->vuser['province'] = $this->vuser['province'] ? $this->profilemodel->get_address_name($this->vuser['province']) : 'δ֪';

		empty($this->vuser['realname']) && $this->vuser['realname'] = 'δ֪';
		$this->view->assign('vuser', $this->vuser);
		$this->view->display('my_profile_detail');
	}
	
	private function getselect($key, $options, $selectedid=0) {
		$select = '<select name="'.$key.'" style="width:120px;">';
		foreach($options as $optionid => $optionname) {
			$select .= '<option value="'.$optionid.'" '.($selectedid == $optionid ? ' selected' : '').'>'.$optionname.'</option>';
		}
		$select .= '</select>';
		return $select;
	}

	private function mkdir_by_date($date, $dir = '.') {
		list($y, $m, $d) = explode('-', $this->date($date, 'Y-m-d'));
		!is_dir("$dir/$y") && mkdir("$dir/$y", 0777);
		!is_dir("$dir/$y/$m$d") && mkdir("$dir/$y/$m$d", 0777);
		return "$y/$m$d";
	}
	
}