<?php

!defined('XIUNO_ROOT') && exit;

class control extends _control {
	function __construct() {
		parent::__construct();
		if($this->user['groupid'] != XIUNO_ADMINISTRATOR_GROUPID){
			$this->message('ǹԱ˺Ųܷͳҳ, 뷵', 'BACK');
		}
		if(!in_array($_GET['a'], array('index', 'bbs', 'mod'))) {
			$_GET['a'] = 'index';
		}
		// жͳƻǷ
		$file = XIUNO_ROOT.'data/cache/stats_'.$_GET['a'].'.php';
		if(is_file($file) && filemtime($file) + XIUNO_STATS_CACHE_TIME < $this->time) {
			$this->clearcache('stats', $_GET['a']);
		}
		$this->nav['check2'] = array(
			'index'=>'',
			'bbs'=>'',
			'mod'=>''
		);
		$this->set_navcheck($_GET['a'], 2);
		$stats_tpl = 'www_stats'.'_'.$_GET['a'];
		$this->view->assign('stats_tpl', $stats_tpl);
	}

	public function index() {
		$stats = $this->cache('stats', 'index');
		$this->view->assign('stats', $stats);
		$this->view->display('www_stats');
	}

	public function bbs() {
		$type = getgpc(2);
		$this->nav['check3'] = array(
			'threads'=>'',
			'posts'=>'',
			'blogs'=>'',
			'regusers'=>'',
			'images'=>'',
			'attachments'=>''
		);
		if(!isset($this->nav['check3'][$type])){
			$type = 'threads';
		}
		$this->set_navcheck($type, 3);
		$stats = $this->cache('stats', 'bbs');
		$todaystats = array();
		foreach($stats['daystats'] as $k=>$v) {
			$daystats[$k] = $v[$type];
		}
		foreach($stats['monthstats'] as $k=>$v) {
			$monthstats[$k] = $v[$type];
		}
		$daystats = $this->format_graph($daystats, 450);
		$monthstats = $this->format_graph($monthstats, 450);
		$this->view->assign('daystats', $daystats);
		$this->view->assign('monthstats', $monthstats);
		$this->view->display('www_stats');
	}

	public function mod() {
		$yearmonth = getgpc('yearmonth') ? getgpc('yearmonth') : $this->date($this->time, 'Ym');
		$file = XIUNO_ROOT.'data/cache/stats_mod_'.$yearmonth.'.php';
		if(is_file($file) && filemtime($file) + XIUNO_STATS_CACHE_TIME < $this->time) {
			$this->clearcache('stats', 'mod_'.$yearmonth);
		}
		$stats = $this->cache('stats', 'mod_'.$yearmonth);
		$groups = $this->cache('groups');
		foreach($stats as &$v) {
			$v['totalonlinetime'] = $this->format_time($v['totalonlinetime']);
			$v['onlinetime'] = $this->format_time($v['onlinetime']);
			$v['groupname'] = $groups[$v['groupid']]['name'];
			$v['lastactivity'] = $this->date($v['lastactivity']);
		}
		$this->view->assign('stats', $stats);
		$this->view->display('www_stats');
	}

	// $data => array('key1'=>5, 'key2'=>20);
	// $maxlength => 100 
	// return=> array('key1'=> array('percent'=>'20%', length=>25, num=>5, src=>'image/bbs/pollcolumn1.gif');
	private function format_graph($data, $maxlength=450) {
		$return = array();
		$total = $i = $max = 0;
		$total = max(1, array_sum($data));
		$max = max($data);
		foreach($data as $key=>$value) {
			$i++;
			$i = $i % 10;
			$arr = array();
			$arr['src'] = 'image/bbs/pollcolumn'.$i.'.gif';
			$arr['num'] = $value;
			$arr['percent'] = sprintf('%.2f', $value * 100 / $total);
			$arr['length'] = 1 + $value / $max * $maxlength;
			$return[$key] = $arr;
		}
		return $return;
	}

	private function format_time($int) {
		$s = '';
		if($int > HOUR) {
			$s .= intval($int / HOUR).'Сʱ';
			$int = $int % HOUR;
		}
		$s .= intval($int / MINUTE).'';
		return $s;
	}


}
?>