<?php

!defined('XIUNO_ROOT') && exit;

class control extends _control {

	function __construct() {
		parent::__construct();

	}

	public function index() {
		$this->message('User Module');
	}

	public function ls() {
		$_GET['page'] = max(intval(getgpc(2)), 1);
		$total_num = $this->usermodel->get_user_total_num();
		$userlist = $this->usermodel->get_user_list_by_page($_GET['page'], XIUNO_PPP, $total_num);
		$multipage = $this->page($total_num, XIUNO_PPP, $_GET['page'], XIUNO_HOST_WWW."$_GET[m]-$_GET[a].htm");
		$this->view->assign('multipage', $multipage);
		$this->view->assign('userlist', $userlist);
		$this->view->display("www_user_ls");
	}

	public function reg() {
		$inajax = $this->inajax;
		if(!$this->submitcheck()) {
			$this->view->display('www_user_reg');
		} else {
			if(!$this->usermodel->check_username($_POST['username'])) {
				$this->message('ûֻӢϡ', 'BACK', array('error'=> 10001));
			} elseif($this->usermodel->get_uid_by_username($_POST['username'])) {
				$this->message('ûѾڣ뷵', 'BACK', array('error'=> 10002));
			} elseif($_POST['password'] != $_POST['password2']) {
				$this->message('ǰһ£롣', 'BACK', array('error'=> 10003));
			} elseif(!$this->usermodel->check_email($_POST['email'])) {
				$this->message('Email ʽ顣', 'BACK', array('error'=> 10004));
			}
			if($this->db->result_first("SELECT email FROM www_userfield WHERE email='$_POST[email]'")) {
				$this->message(' Email Ѿעˡ', 'BACK', array('error'=> 10004));
			}
			$uid = $this->usermodel->add_user($_POST['username'], $_POST['password'], $_POST['email']);
			
			if($uid) {
				$this->user['uid'] = $uid;
				$this->user['username'] = stripslashes($_POST['username']);
				$this->user['groupid'] = XIUNO_INIT_GROUPID;
				$this->user['newpm'] = 0;
				$this->user['home'] = $this->get_home($uid);
				$this->usermodel->set_user_cookie($this->user['uid'], $this->user['username'], $this->user['groupid']);
				$this->db->query("REPLACE INTO www_online SET  sid='{$this->sid}', ip='$this->ip', lastactivity='$this->time', url='$this->url', uid='{$this->user['uid']}',groupid='{$this->user['groupid']}', username='".addslashes($this->user['username'])."'");
				
				// 룬ֲԣӻ
				$inviteuid = getgpc('inviteuid', 'P');
				$addfriend = getgpc('addfriend', 'P');
				if(!empty($inviteuid)) {
					$addfriend && $this->add_friend($inviteuid);
				}
				
				$message = "עɹ <a href=\"".XIUNO_HOST_MY."profile.htm?uid={$this->user['uid']}\">޸ĸ</a>˽";
				$extra = $inajax ? array('nexturl'=>getgpc('nexturl')) : array();//'navuser'=>$this->ajax_get_navuser_html(), 
				
				$referer = getgpc('referer', 'P');
				$this->message($message, $referer, $extra);
			} else {
				$this->message('עʧܣϵԱ', 'BACK');
			}
		}
	}

	public function invite() {
		
		$uid = getgpc(2);
		$user = $this->usermodel->get_user_by_uid($uid);
		$user['avatar_small'] = $this->get_avatar($uid, 'small');
		$this->view->assign('uid', $uid);
		$this->view->assign('user', $user);
		$this->view->assign('extra', getgpc('extra'));
		$this->view->display('www_user_invite');
	}
	
	public function login() {
		$inajax = $this->inajax;
		if(!$this->submitcheck()) {
			$referer = getgpc('HTTP_REFERER', 'V');
			$this->view->assign('referer', $referer);
			$this->view->display('www_user_login');
		} else {
			$username = getgpc('username', 'P');
			$username_strip = stripcslashes($username);
			$password = getgpc('password', 'P');
			$username = $this->xiuno_substr($username, 16);
			if(!$this->usermodel->check_username($username)) {
				$this->logmodel->writeweblog('ûʽ', 'û'.$username.',IP'.$this->_ip);
				$this->message('ûʽֻ 4 - 30 λӢϣ롣', 'BACK', array('error'=>10001));
			}
			$uid = $this->usermodel->get_uid_by_username($username);
			if(!$uid) {
				$this->logmodel->writeweblog('û', 'û'.$username.',IP'.$this->_ip);
				$this->message('ûڣ롣', 'BACK', array('error'=>'10002'));
			}
			$user = $this->usermodel->get_user_by_uid($uid);
			if($this->usermodel->check_password($password, $user['password'], $user['salt'])) {
				$this->after_login($user);
			} else {
				$this->logmodel->writeweblog('û', 'û'.$username.', 룺'.$password.', IP'.$this->_ip);
				$this->message('дû롣', 'BACK', array('error'=>10003));
			}
		}
	}

	private function after_login(&$user) {
		$inajax = $this->inajax;
		// »ֺû
		$this->usermodel->format_user($user);
		$this->user['uid'] = $user['uid'];
		$this->user['username'] = $user['username'];
		$this->user['groupid'] = $user['groupid'];
		$this->user['home'] = $this->get_home($this->user['uid']);
		$this->user['avatar'] = $this->get_avatar($user['uid'], '');
		$this->usermodel->set_user_cookie($user['uid'], $user['username'], $user['groupid']);
		$this->db->query("REPLACE INTO www_online SET sid='{$this->sid}', ip='$this->ip', lastactivity='$this->time', url='$this->url', uid='{$this->user['uid']}',groupid='{$this->user['groupid']}', username='".addslashes($this->user['username'])."'");
		$this->update_user();
		
		$extra = $inajax ? array('nexturl'=>getgpc('nexturl')) : array();//'navuser'=>$this->ajax_get_navuser_html(), 
		$this->message('¼ɹ', getgpc('referer', 'P'), $extra);
	}
	
	// ajax ȡûϢ
	public function info() {
		$uid = getgpc(2);
		$user = $this->usermodel->get_user_by_uid($uid);
		$this->usermodel->format_user($user);
		$user['usernameurl'] = urlencode($user['username']);
		// ѫ²ȡ
		if($user['medallist']) {
			$user['medals'] = $this->medalmodel->get_medal_list_by_int($user['medallist']);
		}
		$user['mood'] = '';
		if($user['moodid']) {
			$mooddata = $this->db->fetch_first("/*cachelife=3600&mckey=my_mood_{$user['moodid']}*/ SELECT * FROM my_mood WHERE moodid='{$user['moodid']}'");
			$mooddata && $user['mood'] = $this->xiuno_substr($mooddata['message'], 80);
		}
		$this->view->assign('_user', $user);
		$this->view->display('www_user_info');
	}

	public function logout() {
		unset($this->user);
		$this->user = array();
		$this->user['uid'] = 0;
		$this->user['username'] = '';
		$this->user['groupid'] = XIUNO_GUEST_GROUPID;
		$this->db->query("REPLACE INTO www_online SET  sid='{$this->sid}', ip='$this->ip', lastactivity='$this->time', url='$this->url', uid='{$this->user['uid']}',groupid='{$this->user['groupid']}', username='".addslashes($this->user['username'])."'");
		$this->setcookie('auth', '', 0);
		$this->message("˳ɹ", '', array('navuser'=>$this->ajax_get_navuser_html()));
	}

	public function getpw() {
		if(!$this->submitcheck()) {
			$this->view->display('www_user_getpw');
		} else {
			$email = getgpc('email', 'P');
			$data = $this->db->fetch_first("SELECT * FROM www_userfield WHERE email='$email' LIMIT 1");
			if(empty($data)) {
				$this->message("$email ûע˺ţ뷵غʵ", 'BACK');
			}
			$url = XIUNO_HOST_WWW.'user-resetpwd.htm?v='.$this->encode_getpw($data['uid'], $email).'&i='.$data['uid'].'&t='.$this->authcode($this->time, 'ENCODE', XIUNO_KEY);

			$subject = XIUNO_SITENAME.' - һϢ';
			$message = "𾴵û$data[username]ãΪһϢ<br />".
				"룺<br />".
				"<a href='$url'>$url</a>";
			set_time_limit(300);
			include(XIUNO_ROOT.'lib/smtp.class.php');
			// TODO ޸ΪԼEMAIL. ʹ db ļ
			$mail = new smtp(XIUNO_MAIL_SMTP_HOST, XIUNO_MAIL_SMTP_USER, XIUNO_MAIL_SMTP_PW);
			$mail->from = XIUNO_MAIL_SMTP_USER;
			$mail->sender = XIUNO_SITENAME;
			$mail->to = $email;
			$mail->receiver = $data['username'];
			$mail->subject = $subject;
			$mail->priority = 'h';
			$mail->content = $message;
			if($mail->send()===true){
				$this->message("ͳɹ, д email");
			} else {
				$this->message('ܱǸʼʧ, :'.$mail->step.',Ϣ:'.$mail->error.'<br />Ժ', 'BACK');
			}
		}
	}

	public function resetpwd() {
		$validate = getgpc('v');
		$uid = getgpc('i');
		$time = $this->authcode(getgpc('t'), 'DECODE', XIUNO_KEY);
		if($this->time - $time > DAY) {
			$this->message('ѹ, һ', XIUNO_HOST_WWW.'index.htm');
		}
		$user = $this->usermodel->get_user_by_uid($uid);
		$email = $user['email'];
		$salt = $user['salt'];
		if($validate != $this->encode_getpw($uid, $email)) {
			$this->message('Ч', XIUNO_HOST_WWW.'index.htm');
		}
		if(!$this->submitcheck()) {
			$this->view->display('user_reset_pwd');
		} else {
			$password = getgpc('password', 'P');
			$password2 = getgpc('password2', 'P');
			if(empty($password)) {
				$this->message('', 'BACK');
			}
			if($password != $password2) {
				$this->message('벻һ£ 뷵', 'BACK');
			}
			$user = 
			$this->db->query("/*primarykey=uid*/ UPDATE www_userfield SET password='".$this->usermodel->encrypt($password, $salt)."' WHERE uid='$uid'");
			$this->message('޸ĳɹ', XIUNO_HOST_WWW.'index.htm');
		}
	}

	private function encode_getpw($uid, $email) {
		return md5($uid.$email.XIUNO_KEY);
	}

	//ajax
	public function checkusername() {
		$username = stripcslashes(trim(getgpc('username')));
		if(!$this->usermodel->check_username($username)) {
			$this->message('<img src="'.XIUNO_HOST_IMAGE.'image/common/check_error.gif" /> ûʽֻ5-30λӢ');
		} elseif($this->usermodel->get_uid_by_username(addslashes($username))) {
			$this->message('<img src="'.XIUNO_HOST_IMAGE.'image/common/check_error.gif" /> ûѾ');
		} else {
			$this->message('<img src="'.XIUNO_HOST_IMAGE.'image/common/check_right.gif" /> ʹá');
		}
	}

	//ajax
	public function checkuserexists() {
		$username = trim(getgpc('username'));
		if($this->usermodel->get_uid_by_username($username)) {
			$this->message('1');
		} else {
			$this->message('<img src="image/common/check_error.gif" /> ûڡ');
		}
	}

	private function add_friend($fuid) {
		$fusername = $this->usermodel->get_username_by_uid($fuid);
		if($this->friendmodel->search_friendrequest($this->user['uid'], $fuid)) {
			return FALSE;
		} else if($this->friendmodel->is_friend($this->user['uid'], $fuid)) {
			return FALSE;
		}
		//жǷѾΪ
		if($this->friendmodel->is_friend($this->user['uid'], $fuid)) {
			return FALSE;
		}
		$this->friendmodel->add_friend($this->user['uid'],$fuid, $this->user['username_slash'], addslashes($fusername));
		$this->feedmodel->add_feed(array('uid'=>$this->user['uid'], 'username'=>$this->user['username'], 'fuid'=>$fuid, 'fusername'=>addslashes($fusername), 'friend', $this->time));

		return TRUE;
	}
}