<?php

/*
	[Xiuno] (C)2008-2009
	This is NOT a freeware, use is subject to license terms

	$RCSfile: index.php,v $
	$Revision: 1.0 $
	$Date: 2009/05/5 14:36:00 $
	$Author: heyond $
*/

/*
	DBװMemcacheMaster/Slave
	
	÷ 
	define('XIUNO_MEMCACHE_ON', '1');
	define('XIUNO_MEMCACHE_HOST', '127.0.0.1');
	define('XIUNO_MEMCACHE_PORT', 12000);
	define('XIUNO_MEMCACHE_CACHE_LFE', 3600);
	$db = new db('192.168.1.1', 'root', 'root', 'test');
	$db->add_slave('192.168.1.2', 'root', 'root', 'test');
	$db->add_slave('192.168.1.3', 'root', 'root', 'test');
	$db->add_slave('192.168.1.4', 'root', 'root', 'test');
	
	// ͨѯ
	$arr = $db->fetch_first("SELECT * FROM bbs_thread WHERE tid='123'");
	$arr = $db->result_first("SELECT COUNT(*) FROM bbs_thread WHERE uid='222'");
	$arr = $db->fetch_all("SELECT * FROM bbs_thread WHERE uid='222' LIMIT 100");
	$db->query("UPDATE bbs_thread SET subject='abcdefg', dateline='1234567890' WHERE tid='123'");
	$db->query("DELETE FROM bbs_thread WHERE tid='123'");
	$db->query("DELETE FROM bbs_thread WHERE uid>'100' AND tid < 1000");
	
	//  Memcached Ĳѯ cachelife=3600, 3600 λΪ룬ע / * * /֮Ŀոȥ
	$arr = $db->fetch_first("/ *cachelife=3600&mckey=bbs_thread_123* / SELECT * FROM bbs_thread WHERE tid='123'");
	$arr = $db->result_first("/ *cachelife=3600&mckey=md5()* / SELECT COUNT(*) FROM bbs_thread WHERE uid='222'");
	$arr = $db->fetch_all("/ *cachelife=3600&mckey=md5()* / SELECT * FROM bbs_thread WHERE uid='222' LIMIT 100");
	
	//  Memcached 
	$db->query("/ *primarykey=tid* / UPDATE bbs_thread SET subject='abcdefg', dateline='1234567890' WHERE tid='123'");
	
	//Ҫӳٸ£Ҫڵ£ȽƵĲ
	$db->query("/ *primarykey=tid&delaycol=views* / UPDATE bbs_thread SET views=views+1 WHERE tid='123'");
	
	// ɾҸ Memcached 
	$db->query("/ *primarykey=tid* / DELETE FROM bbs_thread WHERE tid='123'");
	$db->query("/ *primarykey=tid* / DELETE FROM bbs_thread WHERE uid>'100' AND tid < 1000");
*/

// ӳٸ³ʱ
define('XIUNO_DELAY_UPDATE_TIME_OUT', 300);

class db {

	// ֧һ
	private $master;
	private $slave = array();
	private $slaves = array();

	private $master_link;
	private $slave_link;
	private $last_link;
	
	private $time;
	
	public $debug = array('memcache'=>'');// debug vars

	function __construct($dbhost, $dbuser, $dbpw = '', $dbname = '', $dbcharset='latin1') {
		$this->master = array(
			'dbhost'=> $dbhost,
			'dbuser'=> $dbuser,
			'dbpw'=> $dbpw,
			'dbname'=> $dbname,
			'dbcharset'=> $dbcharset
		);
		$this->time = time();
	}

	function __get($var) {
		if($var == 'memcache') {
			if(!XIUNO_MEMCACHE_ON) {
				return NULL;
			}
			$this->memcache = new Memcache;
	 		if($this->memcache && $this->memcache->connect(XIUNO_MEMCACHE_HOST, XIUNO_MEMCACHE_PORT)) {
	 			return $this->memcache;
	 		} else {
	 			return NULL;
	 		}
		}
	}

	public function add_slave($dbhost, $dbuser, $dbpw = '', $dbname = '', $dbcharset='latin1') {
		$this->slaves[] = array(
			'dbhost'=> $dbhost,
			'dbuser'=> $dbuser,
			'dbpw'=> $dbpw,
			'dbname'=> $dbname,
			'dbcharset'=> $dbcharset
		);
		$this->slave = $this->slaves[$this->time % count($this->slaves)];
	}

	public function memcache_set($key, $value, $life = 0) {
		if($value === FALSE) {
			$value = '';
		}
		$life = $life ? $life : XIUNO_MEMCACHE_CACHE_LFE;
		$this->memcache->set($key, $value, 0, $life);
	}

	// KEYڣ򷵻 FALSE
	public function memcache_get($key) {
		$s = $this->memcache->get($key);
		/*if($s === FALSE) {
			return FALSE;
		}
		if(empty($s) || is_numeric($s)) {
			return $s;
		}*/
		$this->debug['memcache'][] = $key;
		//$data = unserialize($s); // ttserver Ҫл
		return $s;
	}

	public function memcache_delete($key) {
		//$this->memcache->set($key, 'TT_NULL', 0, 1);
		$this->memcache->delete($key);
	}

	public function memcache_flush() {
		$this->memcache->flush();
	}

	private function connect($dbhost, $dbuser, $dbpw, $dbname, $dbcharset = '') {
		if(!$link = mysql_connect($dbhost, $dbuser, $dbpw)) {
			$this->halt('Can not connect to MySQL server:'.$dbhost);
		}

		if($dbcharset) {
			mysql_query("SET names ".$dbcharset, $link);
			//mysql_query("SET character_set_connection=".XIUNO_DBCHARSET.", character_set_results=".XIUNO_DBCHARSET.", character_set_client=binary", $this->link);
		}
		mysql_query("SET sql_mode=''", $link);
		if($dbname) {
			mysql_select_db($dbname, $link);
		}
		return $link;
	}

	public function fetch_array($query) {
		$data = mysql_fetch_assoc($query);
		return $data === FALSE ? array() : $data;
	}

	private function parse_sql($sql) {
		$sql = trim($sql);
		$arr = array();
		$arr['memcacheon'] = false;
		//$arr = array('memcacheon'=>false, 'primarykey'=>'', 'cachelife'=>'', 'slow'=>'', 'mckey'=>'', 'condition'=>'', 'action'=>'', 'tablename'=>'', 'delaycol'=>'');
		if($sql{0} == '/' && $sql{1} == '*') {
			$commentend = strpos($sql, "*/", 2);
			parse_str(substr($sql, 2, $commentend - 2), $arr);
			$sql = substr($sql, $commentend + 2);
		
			$sql = trim($sql);
			$arr['action'] = substr($sql, 0, 6);
			if($arr['action'] == 'SELECT') {
				if($arr['mckey'] == 'md5()') {
					$arr['mckey'] = md5($sql);
				}
			} elseif($arr['action'] == 'UPDATE') {
				preg_match("/UPDATE\s*(LOW_PRIORITY)?\s*(.+?)\s*SET\s*(.+)\s*WHERE\s+(.+)/ims", $sql, $m);
				$arr['cols'] = $m[3];
				$arr['tablename'] = $m[2];
				$arr['condition'] = $m[4];
				
				$arr['update'] = array();
				preg_match_all("/(\w+)\s*=\s*'(\w+)'[,\s]/is", $sql, $m);
				foreach($m[0] as $k=>$_) {
					$col = $m[1][$k];
					$arr['update'][$col] = array('col'=>$col, 'value'=>$m[2][$k], 'op'=>'=');
				}
				preg_match_all("/(\w+)\s*=\s*(\w+)\s*([+-])\s*'(\w+)'[,\s]/is", $sql, $m);
				foreach($m[0] as $k=>$_) {
					$col = $m[1][$k];
					$arr['update'][$col] = array('col'=>$col, 'value'=>$m[4][$k], 'op'=>$m[3][$k]);
				}
				if($arr['update'] && !empty($arr['delaycol'])) {
					preg_match("/\w+\s*=\s*'(\d+)'/", $arr['condition'], $m);
					$arr['conditionvalue'] = $m[1];
				}
			} elseif($arr['action'] == 'DELETE') {
				preg_match("/DELETE FROM\s*(.+?)\s*WHERE\s+(.+)/is", $sql, $m);
				$arr['cols'] = '';
				$arr['tablename'] = $m[1];
				$arr['condition'] = $m[2];
			}
			$arr['memcacheon'] = true;
		} else {
			$sql = trim($sql);
			$arr['action'] = substr($sql, 0, 6);
		}
		return $arr;
	}
	
	private function memcache_get_data_by_sql($sql, &$arr) {
		$arr = $this->parse_sql($sql);
		$arr['memcacheon'] = !empty($arr['memcacheon']) && XIUNO_MEMCACHE_ON && $this->memcache;
		if($arr['memcacheon']) {
			empty($arr['cachelife']) && $arr['cachelife'] = XIUNO_MEMCACHE_CACHE_LFE;
			$value = $this->memcache_get($arr['mckey'] == 'md5()' ? md5($sql) : $arr['mckey']);
			// ݲΪ FALSEֵ
			if($value !== FALSE) {
				return $value;
			}
		}
		return FALSE;
	}
	
	public function result_first($sql) {
		if(($data = $this->memcache_get_data_by_sql($sql, $arr)) !== FALSE) {
			return $data;
		} else {
			$data = array();
			$query = $this->query($sql);
			$data = $this->result($query, 0);
			
			$arr['memcacheon'] && $this->memcache_set($arr['mckey'] == 'md5()' ? md5($sql) : $arr['mckey'], $data, $arr['cachelife']);
			return $data;
		}
	}

	public function fetch_first($sql) {
		if(($data = $this->memcache_get_data_by_sql($sql, $arr)) !== FALSE) {
			return $data;
		} else {
			$data = array();
			$query = $this->query($sql);
			$data = $this->fetch_array($query);
			
			$arr['memcacheon'] && $this->memcache_set($arr['mckey'] == 'md5()' ? md5($sql) : $arr['mckey'], $data, $arr['cachelife']);
			return $data;
		}
	}

	public function fetch_all($sql, $keyname = '') {
		if(($data = $this->memcache_get_data_by_sql($sql, $arr)) !== FALSE) {
			return $data;
		} else {
			$data = array();
			$query = $this->query($sql);
			while($arr2 = $this->fetch_array($query)) {
				empty($keyname) ? $data[] = $arr2 : $data[$arr2[$keyname]] = $arr2;
			}
			
			$arr['memcacheon'] && $this->memcache_set($arr['mckey'] == 'md5()' ? md5($sql) : $arr['mckey'], $data, $arr['cachelife']);
			return $data;
		}
	}
	
	public function fetch_all_by_ids($tablename, $keyname, $cols, $ids) {
		$arr = array();
		if(XIUNO_MEMCACHE_ON) {
			//  memcached ȡ
			foreach($ids as $id) {
				$key = $tablename.'_'.$id;
				$data = $this->fetch_first("/*mckey={$tablename}_{$id}*/SELECT * FROM $tablename WHERE $keyname='$id'");
				$keyname ? $arr[$data[$keyname]] = $data : $arr[] = $data;
			}
		} else {
			// OR ķʽݿȡ
			$sqladd = $this->array_to_sql_or($ids, $keyname);
			if($sqladd) {
				$sql = "SELECT $cols FROM $tablename WHERE $sqladd";
				$arr = $this->fetch_all($sql, $keyname);
				$arr2 = array();
				foreach($ids as $id) {
					$arr2[$id] = $arr[$id];
				}
				$arr = $arr2;
			}
		}
		return $arr;
	}
	
	// ƴΪ SQL copy from base.php
	public function array_to_sql_or($arr, $id) {
		$sqladd = '';
		foreach($arr as $v) {
			$sqladd .= "$id='$v' OR ";
		}
		return substr($sqladd, 0, -4);
	}
	
	public function query($sql, $type = '') {
		//  Memcache
		$arr = $this->parse_sql($sql);
		if($arr['action'] == 'UPDATE' || $arr['action'] == 'DELETE') {
			if($arr['memcacheon'] && XIUNO_MEMCACHE_ON && $this->memcache) {
				if(empty($arr['condition'])) {
					$this->log("No condition\t$sql");
				}
				
				// ͨõӳٸ½
				if(!empty($arr['delaycol'])) {
					//$arr['primarykey'] && $arr['tablename'] && $arr['condition'] && $arr2 = $this->fetch_first("SELECT $arr[primarykey] FROM $arr[tablename] WHERE $arr[condition]");
					$mckey = $arr['tablename'].'_'.$arr['conditionvalue'];
					
					$data = $this->memcache_get($mckey);
					
					// ֻ delaycol 
					$delaycol = $arr['update'][$arr['delaycol']];
					switch($delaycol['op']) {
						case '=' : $data[$arr['delaycol']] = $delaycol['value']; break;
						case '+' : $data[$arr['delaycol']] += $delaycol['value']; break;
						case '-' : $data[$arr['delaycol']] -= $delaycol['value']; break;
					}
					// ӳд mysql
					// һδ洢
					if(empty($data['mclastupdate'])) {
						$data['mclastupdate'] = $this->time;
						$this->memcache_set($mckey, $data);
						return TRUE;
					// ʱ
					} elseif($this->time - $data['mclastupdate'] > XIUNO_DELAY_UPDATE_TIME_OUT) {
						$data['mclastupdate'] = $this->time;
						$this->memcache_set($mckey, $data);
						// ƴд sql 䣬
						$sql = "UPDATE $arr[tablename] SET $arr[delaycol]='".$data[$arr['delaycol']]."' WHERE $arr[condition]";
					// δʱ
					} else {
						$this->memcache_set($mckey, $data);
						return TRUE;
					}
				} else {
					$arr['primarykey'] && $arr['tablename'] && $arr['condition'] && $arr2 = $this->fetch_all("SELECT $arr[primarykey] FROM $arr[tablename] WHERE $arr[condition]");
					foreach($arr2 as $v) {
						$mckey = $arr['tablename'].'_'.$v[$arr['primarykey']];// ע⣬ԼΪ tablename_123 ָʽ
						$data = $this->memcache_get($mckey);
						if($data === FALSE) {
							continue;
						}
						// ݣ $tid ʱ, ʱ ͻһ.
						if($data === array()) {
							$this->memcache_delete($mckey);
							continue;
						}
						
						$this->memcache_delete($mckey);
						
					}// end foreach
				
				} // end delaycol
			}
		}

		// Լ select show ⣬Ϊд replace
		$fromsalve = ($arr['action'] == 'SELECT' || substr($arr['action'], 0, 4) == 'SHOW');
		// жǷд
		if(empty($this->slave)) {
			// ûпĻĬϴֻд
			if(empty($this->master_link)) {
				$this->last_link = $this->master_link = $this->slave_link = $this->connect($this->master['dbhost'], $this->master['dbuser'], $this->master['dbpw'], $this->master['dbname'], $this->master['dbcharset']);
				$this->debug[intval($this->slave_link)] = $this->master['dbhost'];
			}
		} else {
			if($fromsalve) {
				// ݣӷ
				if(empty($this->slave_link)) {
					$this->last_link = $this->slave_link = $this->connect($this->slave['dbhost'], $this->slave['dbuser'], $this->slave['dbpw'], $this->slave['dbname'], $this->slave['dbcharset']);
					$this->debug[intval($this->slave_link)] = $this->slave['dbhost'];
				}
			} else {
				// дݿ⣬
				if(empty($this->master_link)) {
					$this->last_link =  $this->master_link = $this->connect($this->master['dbhost'], $this->master['dbuser'], $this->master['dbpw'], $this->master['dbname'], $this->master['dbcharset']);
					$this->debug[intval($this->master_link)] = $this->master['dbhost'];
				}
			}
		}
		
		if(XIUNO_DEBUG) {
			$starttime = microtime(1);
		}
		if(!($query = mysql_query($sql, $this->last_link)) && $type != 'SILENT') {
			$this->halt('MySQL Query Error', $sql);
		}
		if(XIUNO_DEBUG) {
			$subtime = number_format(microtime(1) - $starttime, 6);
			XIUNO_DEBUG && $this->debug['sql'][] = array('sql'=>$sql, 'time'=> $subtime, 'dbhost'=>$this->debug[intval($this->last_link)]);
		}
		return $query;
	}

	public function affected_rows() {
		return mysql_affected_rows($this->last_link);
	}

	public function error() {
		return (($this->last_link) ? mysql_error($this->last_link) : mysql_error());
	}

	private function errno() {
		return intval(($this->last_link) ? mysql_errno($this->last_link) : mysql_errno());
	}

	public function result($query, $row) {
		$data = mysql_num_rows($query) > 0 ? mysql_result($query, $row) : '';
		return $data;
	}

	public function num_rows($query) {
		$query = mysql_num_rows($query);
		return $query;
	}

	public function num_fields($query) {
		return mysql_num_fields($query);
	}

	public function free_result($query) {
		return mysql_free_result($query);
	}

	public function insert_id() {
		return ($id = mysql_insert_id($this->last_link)) >= 0 ? $id : $this->result($this->query("SELECT last_insert_id()"), 0);
	}

	public function fetch_row($query) {
		$query = mysql_fetch_row($query);
		return $query;
	}

	public function fetch_fields($query) {
		return mysql_fetch_field($query);
	}

	// ֻȡһӵķ汾
	public function version() {
		return mysql_get_server_info($this->last_link);
	}

	public function close() {
		return mysql_close($this->last_link);
	}

	public function halt($message = '', $sql = '') {

		$this->log(substr(mysql_error(), 0, 150)."\t".$sql);

		if(getgpc('inajax')) {
			getvalue($_SERVER['XIUNO_ERROR']);
			$this->ajaxmessage($message.$sql.mysql_error().$_SERVER['XIUNO_ERROR']);
		} else {
			//print_r(debug_backtrace());
			debug_print_backtrace();
			ob_flush();
			exit($message.'<br /><br />'.$sql.'<br /> '.mysql_error());
		}
	}

	public function log($string = '') {
		$fp = fopen(XIUNO_ROOT.'data/log/mysqlerror.php', 'ab+');
		$date = gmdate('Y-m-d H:i:s', $this->time + 8 * 3600);
		$string = $date."\t".$string;
		$length = strlen($string);
		if($length > 300 - 2) {
			$string = substr($string, 0, 300 - 2)."\r\n";
		} else {
			$string = $string.str_repeat(' ', 300 - 2 - $length)."\r\n";
		}
		fwrite($fp, $string);
		fclose($fp);
	}
	
	// ˴ƻṹ, db 㱾ӦֱκݣAJAX
	public function ajaxmessage($s) {
		include XIUNO_ROOT.'data/view/ajax_header_1.php';
		$menuid = getgpc('menuid');
		$ajax['extrastr'] = '<closebutton>0</closebutton><error>2</error><servererror><![CDATA['.$s.']]></servererror>';
		echo $s;
		include XIUNO_ROOT.'data/view/ajax_footer_1.php';
		exit;
	}

	function __destruct() {
		if($this->last_link) {
			$this->close();
		}
		if(XIUNO_MEMCACHE_ON) {
			// fastcgi ģʽԶά memcache tcp ӣرա
			//$this->memcache->close();
		}
	}
}
?>