<?php

define('model/addressmodel.php', 1);

class addressmodel {

	private $db;
	private $base;
	private $arr = array();

	function __construct(&$base) {
		$this->base = $base;
		$this->db = $base->db;
	}

	public function get_address_page($page, $pagesize) {
		$startpage = ($page - 1)*$pagesize;
		$data = $this->db->fetch_all("SELECT * FROM www_address LIMIT $startpage, $pagesize");
		$address = array();
		foreach($data as $arr) {
			$this->arr = array();
			$parentname = $this->get_address_parentname_recursive($arr['id']);
			$arr['parentname'] = implode('=>', $parentname);
			array_push($address, $arr);
		}
		return $address;
	}

	public function get_address_count($pid) {
		return $this->db->result_first("SELECT COUNT(*) FROM www_address WHERE parentid='$pid'");
	}

	public function get_address_parentname_recursive($id) {
		$arr = $this->db->fetch_first("SELECT * FROM www_address WHERE id='$id'");
		if(!empty($arr)) {
			$this->get_address_parentname_recursive($arr['parentid']);
			array_push($this->arr, $arr['name']);
		}
		return $this->arr;
	}

	public function get_address_by_id($id) {
		$data = $this->db->fetch_first("/*cachelife=3600&mckey=www_address_$id*/ SELECT * FROM www_address WHERE id='$id'");
		return $data;
	}

	public function get_address_by_pid($pid) {
		$data = $this->db->fetch_all("SELECT * FROM www_address WHERE parentid='$pid'");
		return $data;
	}

	public function delete_address_by_id($id) {
		$this->db->query("DELETE FROM www_address WHERE id='$id'");
	}

	public function delete_address_by_pid($pid) {
		$this->db->query("DELETE FROM www_address WHERE parentid='$pid'");
	}

	public function add_address($name, $parentid, $level) {
		$this->db->query("INSERT INTO www_address SET name='$name', parentid='$parentid', level='$level'");
	}
}
?>