<?php

define('model/blogmodel.php', 1);

class blogmodel {

	private $db;
	private $categoryids = array();

	function __construct(&$base) {
		$this->base = $base;
		$this->db = $base->db;
	}

	// ־б
	public function get_blog_list($page, $ppp, $totalnum, $uid, $categoryid=0, $rank=3) {
		$where = empty($categoryid) ? "uid='$uid'" : "categoryid='$categoryid' AND uid='$uid'";
		$start = $this->base->page_get_start($page, $ppp, $totalnum);
		$bloglist = $this->db->fetch_all("SELECT * FROM my_blog WHERE $where ORDER BY blogid DESC LIMIT $start, $ppp");

		foreach($bloglist as $key => &$blog) {
			$blog['message']	= $blog['isprivate'] < $rank ? $this->base->xiuno_substr(strip_tags($blog['message']), 600) : '־Ѿ˽ɷʣ';
			$blog['dateline']	= $this->base->date($blog['dateline']);
			$blog['avatar']		= $this->base->get_avatar($blog['uid'], 'small');
		}
		return $bloglist;
	}

	// ־
	public function update_blog_views($blogid) {
		return $this->db->query("UPDATE my_blog SET views=views+'1' WHERE blogid='$blogid'");
	}

	public function get_blog_by_blogid($blogid) {
		$blog = $this->db->fetch_first("SELECT * FROM my_blog WHERE blogid='$blogid'");
		if(!empty($blog)) {
			$blog['avatar']		= $this->base->get_avatar($blog['uid'], 'small');
			//$blog['message']	= $this->base->xiuno_substr(strip_tags($blog['message']), 600);
			$blog['dateline']	= $this->base->date($blog['dateline']);
			$blog['categoryname']	= empty($blog['categoryid']) ? 'ĬϷ' : $this->get_category_name($blog['categoryid']);
		}
		return $blog;
	}

	// ־
	public function add_blog($subject, $message, $uid, $username, $dateline, $categoryid, $isprivate=0) {
		$category = $this->get_category_by_id($categoryid);
		$categoryname = $category['categoryname'];
		$this->db->query("INSERT INTO my_blog SET uid='$uid', username='$username', dateline='$dateline', subject='$subject', message='$message', categoryid='$categoryid', categoryname='$categoryname', isprivate='$isprivate'");
		$blogid = $this->db->insert_id();
		if($blogid) {
			$this->db->query("/*primarykey=uid*/ UPDATE www_user SET blogs=blogs+'1' WHERE uid='$uid'");
			$this->db->query("UPDATE my_blogcategory SET blogs=blogs+'1' WHERE categoryid='$categoryid'");
		}
		return $blogid;
	}

	// ༭־
	public function edit_blog($blogid, $subject, $message, $categoryid, $isprivate, $uid) {
		$orgblog = $this->get_blog_by_blogid($blogid);
		$cateadd = '';
		if($orgblog['categoryid'] != $categoryid) {
			$cateadd = "categoryid='$categoryid', ";
		}
		return $this->db->query("UPDATE my_blog SET subject='$subject', message='$message', $cateadd isprivate='$isprivate' WHERE blogid='$blogid'");
	}

	// ־
	public function category($blogidarr, $categoryid=0) {
		$updatenum = 0;
		foreach($blogidarr as $blogid) {
			$categoryid1 = $this->db->result_first("SELECT categoryid FROM my_blog WHERE blogid='$blogid'");
			$this->db->query("UPDATE my_blog SET categoryid='$categoryid' WHERE blogid='$blogid'");
			if($this->db->affected_rows()) {
				$this->update_category_blogs($categoryid1, $categoryid);
				$updatenum++;
			}
		}
		return $updatenum;
	}

	// ɾ־
	public function delete_blog($blogid, $blog) {
		$this->db->query("DELETE FROM my_blog WHERE blogid='$blogid'");
		if($this->db->affected_rows()) {
			$this->db->query("DELETE FROM my_blogreply WHERE blogid='$blogid'");
			$this->db->query("DELETE FROM my_favorite WHERE id='$blogid' AND type='blog'");
			$this->db->query("DELETE FROM my_favorite WHERE id='$blogid' AND type='blog'");
			$this->db->query("/*primarykey=uid*/ UPDATE www_user SET blogs=blogs-'1' WHERE uid='$blog[uid]'");
			$this->db->query("UPDATE my_blogcategory SET blogs=blogs-'1' WHERE categoryid='$blog[categoryid]'");
			return true;
		} else {
			return false;
		}
	}

	// 
	public function get_blog_category_total($uid) {
		return  $this->db->result_first("SELECT COUNT(*) FROM my_blogcategory WHERE uid='$uid'");
	}

	// б
	public function get_category_list($uid) {
		return $this->db->fetch_all("SELECT * FROM my_blogcategory WHERE uid='$uid' ORDER BY displayorder DESC LIMIT 0, 40", 'categoryid');
	}

	// Ƿ
	public function check_categoryname_exist($categoryname, $uid) {
		return $this->db->result_first("SELECT categoryid FROM my_blogcategory WHERE categoryname='$categoryname' AND uid='$uid'");
	}

	//־
	public function create_category($uid, $categoryname) {
		$this->db->query("INSERT INTO my_blogcategory SET uid='$uid', categoryname='$categoryname'");
		$cateid = $this->db->insert_id();
		return $cateid;
	}

	// ûid־ĬϷid, 򴴽ĬϷ
	public function get_default_categoryid($uid) {
		$categoryid = $this->db->result_first("SELECT defaultblogcateid FROM www_userfield WHERE uid='$uid'");
		if(empty($categoryid)) {
			$categoryid = $this->create_category($this->base->user['uid'], 'ĬϷ');
			$this->base->usermodel->update_user($uid, "defaultblogcateid='$categoryid'");
		}
		return $categoryid;
	}

	//༭־
	public function edit_category($categoryid, $categoryname, $displayorder, $orgcate) {
		empty($orgcate) && $orgcate = $this->get_category_by_id($categoryid);
		$sqladd = '';
		if($orgcate['categoryname'] != $categoryname) {
			$sqladd = ($sqladd ? ',' : '')."categoryname='$categoryname'";
			// ־ categoryname洢ٲѯ
			$this->db->query("UPDATE my_blog SET categoryname='$categoryname' WHERE categoryid='$categoryid'");
		}
		if($orgcate['displayorder'] != $displayorder) {
			$sqladd = ($sqladd ? ',' : '')."displayorder='$displayorder'";
		}
		if($sqladd) {
			$this->db->query("UPDATE my_blogcategory SET $sqladd WHERE categoryid='$categoryid'");
			return $this->db->affected_rows();
		} else {
			return 0;
		}
	}
	
	// ɾ־
	public function delete_category($categoryid) {
		$this->db->query("DELETE FROM my_blogcategory WHERE categoryid='$categoryid'");
		$num = intval($this->db->affected_rows());
		if($num) {
			 $defaultcateid = $this->get_default_categoryid($this->base->user['uid']);
			 $this->db->query("UPDATE my_blog SET categoryname='ĬϷ' WHERE categoryid='$categoryid'");
			 $this->db->query("UPDATE my_blog SET categoryid='$defaultcateid' WHERE categoryid='$categoryid'");
			 $this->db->query("UPDATE my_blogcategory SET blogs=blogs+'$num' WHERE categoryid='$defaultcateid'");
		}
		return $num;
	}

	// ȡ
	public function get_category_name($categoryid) {
		if(!isset($this->categoryids[$categoryid])) {
			$this->categoryids[$categoryid] = $this->db->result_first("SELECT categoryname FROM my_blogcategory WHERE categoryid='$categoryid'");
		}
		return $this->categoryids[$categoryid];
	}

	// ݷidȡ
	public function get_category_by_id($categoryid) {
		return $this->db->fetch_first("SELECT * FROM my_blogcategory WHERE categoryid='$categoryid'");
	}

	// ־
	public function update_category_blogs($categoryid1, $categoryid2) {
		$categoryid1 && $this->db->query("UPDATE my_blogcategory SET blogs=blogs-'1' WHERE categoryid='$categoryid1'");
		$categoryid2 && $this->db->query("UPDATE my_blogcategory SET blogs=blogs+'1' WHERE categoryid='$categoryid2'");
	}
	
	// ʵȡͼƬ
	public function get_friend_bloglist_by_uid_page($uid, $page, $ppp, $fuidarr, &$totalnum) {
		$blogids = array();
		if(XIUNO_MEMCACHE_ON) {
			$mckey = XIUNO_SITENAME.'friend_blogs'.$uid;
			$blogids = $this->db->memcache_get($mckey);
		}
		if($blogids !== FALSE) {
			$start = ($page - 1) * $ppp;
			foreach($fuidarr as $uid) {
				$blogids = array_merge($blogids, $this->base->recentmodel->get_recent('blog', $uid));
			}
			XIUNO_MEMCACHE_ON && $this->db->memcache_set($mckey, $blogids, 86400);
		}
		
		$totalnum = count($blogids);
		if(!$blogids) {
			return array();
		}
		$start = ($page - 1) * $ppp;
		$blogarr = array_slice($blogids, $start, $ppp);
		
		$sqladd = '';
		foreach($blogarr as $blogid) {
			$sqladd .= "blogid='$blogid' OR ";
		}
		$sqladd = substr($sqladd, 0, -4);
		$sqladd && $bloglist = $this->db->fetch_all("/*cachelife=86400&mckey=md5()*/ SELECT * FROM my_blog WHERE $sqladd", 'blogid');
		foreach($bloglist as &$blog) {
			$blog['avatar_small'] = $this->base->get_avatar($blog['uid'], 'small');
			$blog['dateline'] = $this->base->date($blog['dateline']);
		}
		return $bloglist;
	}
	

}
?>