<?php

define('model/feedmodel.php', 1);

class feedmodel {

	private $db;

	function __construct(&$base) {
		$this->base = $base;
		$this->db = $base->db;
	}

	/**
	 * insert the feed infomation into database
	 *
	 * @param array $subject
	 * @param string $type
	 * @param int $dateline
	 * @param int $uid feed
	 */
	public function add_feed($subject, $type, $dateline, $uid) {
		$s = addslashes(serialize($subject));
		if($type == 'image') {
			// ϲ5֮ڵͼƬFEED
			$time = $dateline - 300; //5 * MINUTE;
			$feed = $this->db->fetch_first("SELECT * FROM my_feed WHERE uid='$uid' AND dateline>'$time' ORDER BY dateline DESC LIMIT 1");
			if($feed['type'] == 'image') {
				$t = unserialize($feed['subject']);
				$subject['aids'] = (array)$t['aids'] + (array)$subject['aids'];
				$subject['aids'] = array_slice($subject['aids'], -4, 4, true);
				$s = addslashes(serialize($subject));
				$this->db->query("UPDATE my_feed SET subject='$s' WHERE feedid='$feed[feedid]'");
				return TRUE;
			}
		}
		$this->db->query("INSERT INTO my_feed SET type='$type', uid='$uid', dateline='$dateline', subject='$s'");
		$feedid = $this->db->insert_id();
		$this->db->query("REPLACE INTO my_feed_active_2day SET uid='$uid', dateline='$dateline'");
		$this->db->query("REPLACE INTO my_feed_active_2week SET uid='$uid', dateline='$dateline'");
		$this->base->recentmodel->update_recent('feed', $uid, $feedid);
	}
	
	// feed
	public function gc() {
		$time = time();
		// $time = $this->base->time();	˴modelãܴ⣬ȷûٸΪbaseȡʱ䡣
		$time1 = $time - (86400 * 2);
		$time2 = $time - (86400 * 14);
		$this->db->query("DELETE FROM my_feed_active_2day WHERE dateline<'$time1'");
		$this->db->query("DELETE FROM my_feed_active_2week WHERE dateline<'$time2'");
		return TRUE;
	}
	
	public function get_feed_by_page($uid, $page, $ppp, $own=0) {
		$feedlist = array();
		$start = ($page - 1) * $ppp;
		if($own) {
			$feedlist =  $this->db->fetch_all("SELECT * FROM my_feed WHERE uid='$uid' ORDER BY dateline DESC LIMIT $start,$ppp");
		} else {
			$fuidarr = $this->base->friendmodel->get_active_friends($uid, $page == 1 ? '2day' : '2week');
			$sqladd = '';
			
			foreach($fuidarr as $v) {
				$sqladd .= 'uid='.$v.' OR ';
			}
			$sqladd = substr($sqladd, 0, -4);
			if(!$sqladd) {
				return array();
			}
			if($page == 1) {
				$recentfeedarr = $this->db->fetch_all("SELECT * FROM my_feed_recent where $sqladd");
				$feedidarr = array();
				foreach($recentfeedarr as $v) {
					unset($v['uid']);
					$feedidarr = array_merge($feedidarr,$v);
				}
				asort($feedidarr, SORT_NUMERIC);
				$feedidarr = array_slice($feedidarr, 0, 20);
				$feedlist = $this->db->fetch_all_by_ids('my_feed', 'feedid', '*', $feedidarr);
				
			} else {
				$feedlist =  $this->db->fetch_all("SELECT * FROM my_feed where $sqladd ORDER BY dateline DESC LIMIT $start, $ppp", 'feedid');
			}
		}
		foreach($feedlist as &$feed) {
			$feed = $this->format_feed($feed);
		}
		return $feedlist;
	}

	public function delete_feed($feedid) {
		$this->db->query("UPDATE my_feed SET type='normal', subject='Ѿɾ' WHERE feedid='$feedid'");
		return true;
	}


	// TODO ÿfeedЧ,ָĿǷ
	// @param own:
	// Ϊ0ʱʽΪ "Ѷ̬"
	// Ϊ1ʱʽΪ "ҵĶ̬"
	public function format_feed($feed, $own=0, $feedid=0) {
		if(empty($feed['subject'])) {
			return array('subject'=>'');
		}
		if($feed['type'] != 'normal') {
			$arr = unserialize($feed['subject']);
		}
		if(empty($arr)) {
			$this->base->logmodel->writeweblog('feed лʧ', 'feedid'.$feedid);
			return false;
		}
		$type = $feed['type'];
		switch ($type) {
			case 'blog':
				$feed['icon'] = "<img src='".XIUNO_HOST_IMAGE."image/common/home_icon_blog.gif' align='absmiddle'/>";
				$feed['subject'] = $this->get_user_link($arr['uid'], $arr['username'])." һƪ͡<a href='".XIUNO_HOST_MY."blog-detail-$arr[blogid].htm?uid=".$arr['uid']."' target='_blank'>$arr[subject]</a>";
				if (!empty($arr['aids'])) {
					$s = '<div class="imgbox">';
					foreach((array)$arr['aids'] as $imageid=>$filename) {
						$s .= '<a href="'.XIUNO_HOST_MY.'image-detail-'.$imageid.'.htm?uid='.$arr['uid'].'" target="_blank"><img src="'.XIUNO_HOST_IMAGE.$filename.'" onload="if(this.width>=120) this.width=\'120\';if(this.height >=90) this.height=\'90\'" /></a>';
					}
					$s .= '</div>';
					$feed['subject'] .= $s;
				}
				break;
			case 'shareblog':
				$feed['icon'] = "<img src='".XIUNO_HOST_IMAGE."image/common/home_icon_shareblog.gif' align='absmiddle'/>";
				$feed['subject'] = $this->get_user_link($arr['uid'], $arr['username'])." һƪ͡<a href='".XIUNO_HOST_MY."blog-detail-$arr[blogid].htm' target='_blank'>$arr[subject]</a>";
				break;
			case 'sharethread':
				$feed['icon'] = "<img src='".XIUNO_HOST_IMAGE."image/common/home_icon_sharethread.gif' align='absmiddle'/>";
				$feed['subject'] = $this->get_user_link($arr['uid'], $arr['username'])." һƪ<a href='".XIUNO_HOST_BBS."thread-index-$arr[tid].htm' target='_blank'>$arr[subject]</a>";
				break;
			case 'mood':
				$feed['icon'] = "<img src='".XIUNO_HOST_IMAGE."image/common//home_icon_mood.gif' align='absmiddle'/>";
				$mood = $this->base->xiuno_substr($arr['mood'], 40);
				$feed['subject'] = $this->get_user_link($arr['uid'], $arr['username'])." ԼΪ <span style='color:".COLORALERT2.";'>$mood</span>";
				break;
			case 'image':
				$feed['icon'] = "<img src='".XIUNO_HOST_IMAGE."image/common/home_icon_image.gif' align='absmiddle'/>";
				$aidnum = 0;
				$s = '<div class="imgbox">';
				foreach((array)$arr['aids'] as $imageid=>$filename) {
					$s .= '<a href="'.XIUNO_HOST_MY.'image-detail-'.$imageid.'.htm?uid='.$arr['uid'].'" target="_blank"><img src="'.XIUNO_HOST_IMAGE.$filename.'" onload="if(this.width>=120) this.width=\'120\';if(this.height >=90) this.height=\'90\'" /></a>';
				}
				$s .= '</div>';
				$feed['subject'] = $this->get_user_link($arr['uid'], $arr['username'])." ϴͼƬ<br/>".$s;
				break;
			case 'post':
				$feed['icon'] = "<img src='".XIUNO_HOST_IMAGE."image/common/home_icon_reply.gif' align='absmiddle'/>";
				$feed['subject'] = $this->get_user_link($arr['uid'], $arr['username'])."  <a href='".XIUNO_HOST_BBS."forum-index-$arr[fid].htm' target='_blank'>".strip_tags($arr['forumname'])."</a> һƪ<a href='".XIUNO_HOST_BBS."thread-index-$arr[tid].htm' target='_blank'>$arr[subject]</a>";
				break;
			case 'profile':
				$feed['icon'] = "<img src='".XIUNO_HOST_IMAGE."image/common/home_icon_reply.gif' align='absmiddle'/>";
				$feed['subject'] = $this->get_user_link($arr['uid'], $arr['username'])." ޸$arr[subject]<a href='".XIUNO_HOST_MY."index-index-$arr[uid].htm'></a>鿴";
				break;
			case 'normal':
			default:
				break;
		}
		isset($feed['dateline']) && $feed['dateline'] = $this->base->date($feed['dateline']);
		return $feed;
	}

	public function get_user_link($uid, $username) {
		return "<a href='".XIUNO_HOST_MY.'index-index-'.$uid.".htm' target='_blank'>$username</a>";
	}
}
?>