<?php

define('model/friendmodel.php', 1);

class friendmodel {

	private $db;
	private $base;

	function __construct(&$base) {
		$this->base = $base;
		$this->db = $base->db;
	}

	public function get_friendlist_by_page($uid, $page, $ppp) {
		$start = ($page-1) * $ppp;
		$query = $this->db->query("SELECT fuid, fuser, unvisible FROM my_friend WHERE uid='$uid' LIMIT $start,$ppp");
		$data = array();
		while($row = $this->db->fetch_array($query)) {
			$fid = $row['fuid'];
			$friend = array();
			$friend['uid'] = $fid;
			$friend['username'] = $row['fuser'];
			$friend['unvisible'] = $row['unvisible'];
			//$friend = array_merge($friend, $this->db->fetch_first("SELECT uid, lastactivity, avatar FROM www_user WHERE uid='$fid'"));
			$friend = array_merge($friend, $this->base->usermodel->get_user_by_uid($fid, '*'));
			$data[$fid] = $friend;
		}
		return $data;
	}

	public function get_friends($uid, $limit = 0) {
		$sqladd = $limit ? " LIMIT 30" : '';
		return $this->db->fetch_all("SELECT fuid, fuser FROM my_friend WHERE uid='$uid' $sqladd", 'fuid');
	}
	
	// 
	public function get_active_friends($uid, $range = '2day') {
		$tablename = $range == '2day' ? 'my_feed_active_2day' : 'my_feed_active_2week';
		$fuidarr = $this->get_friends($uid);
		$sqladd = '';
		foreach($fuidarr as $v) {
			$sqladd .= 'uid='.$v['fuid'].' OR ';
		}
		$sqladd = substr($sqladd, 0, -4);
		if(!$sqladd) {
			return array();
		}
		return array_keys($this->db->fetch_all("/*cachelife=86400&mckey=md5()*/SELECT uid FROM $tablename WHERE $sqladd", 'uid'));
	}

	public function get_friendids_by_uid($uid, $limit = 0) {
		$sqladd = $limit ? " LIMIT $limit" : '';
		return array_keys($this->db->fetch_all("SELECT fuid FROM my_friend WHERE uid='$uid' $sqladd", 'fuid'));
	}

	/*public function get_friends_id_visible($uid) {
		$data = $this->db->fetch_all("SELECT fuid, unvisible FROM my_friend WHERE uid='$uid'", 'fuid');
		$returns = array();
		foreach($data as $friend) {
			if(!$friend['unvisible']) {
				$returns[] = $friend['fuid'];
			}
		}
		return $returns;
	}*/

	public function is_friend($uid, $fuid) {
		return $this->db->result_first("SELECT COUNT(*) FROM my_friend WHERE uid='$uid' AND fuid='$fuid' LIMIT 1");
	}

	public function add_friend($uid,$fuid, $username, $fusername) {
		$this->db->query("INSERT INTO my_friend SET uid='$uid', fuid='$fuid', fuser='$fusername'");
		$this->db->query("INSERT INTO my_friend SET uid='$fuid', fuid='$uid', fuser='$username'");
	}

	public function delete($uid, $fuid) {
		$this->db->query("DELETE FROM my_friend WHERE uid='$uid' AND fuid='$fuid'");
		$this->db->query("DELETE FROM my_friend WHERE uid='$fuid' AND fuid='$uid'");
	}

	// жϺǷ
	public function search_friendrequest($uid, $fuid) {
		return $this->db->result_first("SELECT COUNT(*) FROM my_friendrequest WHERE fromuid='$uid' AND touid='$fuid'");
	}

	public function add_request($user, $fuid) {
		$this->db->query("INSERT INTO my_friendrequest SET fromuid='{$user['uid']}', fromuser='{$user['username_slash']}', touid='$fuid'");
	}

	public function get_request_list_by_page($uid, $page, $ppp) {
		$start = ($page-1) * $ppp;
		return $this->db->fetch_all("SELECT * FROM my_friendrequest WHERE touid='$uid' LIMIT $start, $ppp");
	}

	public function delete_request($fromuid, $touid) {
		$this->db->query("DELETE FROM my_friendrequest WHERE fromuid='$fromuid' AND touid='$touid'");
	}

	public function get_request_num($uid) {
		return $this->db->result_first("SELECT COUNT(*) FROM my_friendrequest WHERE touid='$uid'");
	}

	public function get_user_num_by_fav($type, $favstr) {
		return $this->db->result_first("/*cachelife=3600&mckey=md5()*/ SELECT COUNT(*) FROM my_userfavor WHERE type='$type' AND value='$favstr'");
	}

	public function get_user_list_by_fav($page, $ppp, $totalnum, $type, $favstr) {
		$start = $this->base->page_get_start($page, $ppp, $totalnum);
		$userlist = $this->db->fetch_all("SELECT uid FROM my_userfavor WHERE type='$type' AND value='$favstr' LIMIT $start, $ppp");
		foreach($userlist as $key=>$user) {
			$userlist[$key] = array_merge($this->db->fetch_first("SELECT * FROM www_user WHERE uid='$user[uid]'"),
				$this->db->fetch_first("SELECT * FROM www_userfield WHERE uid='$user[uid]'"));
		}
		return $userlist;
	}
	
	public function get_commomfriend_list($uid) {
		$fuids = $this->get_friendids_by_uid($uid, 20);
		$ids = array();
		foreach($fuids as $id) {
			$ids = array_merge($ids, $this->get_friendids_by_uid($id, 2));
		}
		$userlist = $this->db->fetch_all_by_ids('www_userfield', 'uid', '*', $ids);
		foreach($userlist as &$user) {
			$this->base->usermodel->format_user($user);
		}
		return $userlist;
	}
}
?>