<?php

define('model/groupmodel.php', 1);

class groupmodel {

	private $db;
	private $base;

	function __construct(&$base) {
		$this->base = $base;
		$this->db = $base->db;
	}

	public function get_groups_by_groupid($groupid) {
		$group = $this->db->fetch_first("SELECT * FROM www_group WHERE groupid='$groupid'");
		$group['raterange'] = $this->str2rate($group['raterange']);
		return $group;
	}

	public function rate2str($rate) {
		$arr = array();
		foreach($rate as $id=>$row) {
			if(empty($row['used'])) {
				continue;
			}
			$arr[] = $id."\t".$row['minrate']."\t".$row['maxrate']."\t".$row['mrpd'];
		}
		return implode("\n", $arr);
	}

	public function str2rate($str) {
		$data = $arr = array();
		$arr = explode("\n", $str);
		foreach($arr as $v) {
			list($id, $minrate, $maxrate, $mrpd) = explode("\t", $v);
			$data[$id]['minrate'] = $minrate;
			$data[$id]['maxrate'] = $maxrate;
			$data[$id]['mrpd']    = $mrpd;
		}
		return $data;
	}

	public function get_groups($type = 0) {
		$sqladd = $type ? "type='$type'" : '1';
		return $this->db->fetch_all("SELECT * FROM www_group WHERE $sqladd ORDER BY groupid ASC", 'groupid');
	}

	public function delete_group_by_id($groups) {
		$ids = $this->base->implode($groups);
		$this->db->query("DELETE FROM www_group WHERE groupid IN($ids)");
	}

	public function add_group($type, $name, $creditsfrom, $creditsto, $maxattachsize) {
		$this->db->query("INSERT INTO www_group SET type='$type', name='$name', creditsfrom='$creditsfrom', creditsto='$creditsto', maxattachsize='$maxattachsize'");
		return $this->db->insert_id();
	}

	public function update_group($groupid, $type, $name, $creditsfrom, $creditsto, $maxattachsize) {
		$this->db->query("UPDATE www_group SET type='$type', name='$name', creditsfrom='$creditsfrom', creditsto='$creditsto', maxattachsize='$maxattachsize' WHERE groupid='$groupid'");
	}

	public function upgrade_groupid_by_credits($uid, $groupid, $credits) {
		$query = $this->db->query("SELECT groupid FROM www_group WHERE type='2' AND creditsfrom>'$credits' AND creditsto<'$credits' LIMIT 1");
		if($groupid != $this->db->result($query, 0)) {
			$this->db->query("/*primarykey=uid*/ UPDATE www_user SET groupid='$groupid' WHERE uid='$uid'");
		}
	}

	public function get_grouplist() {
		$arr = $arr2 = array();
		$arr = $this->db->fetch_all("SELECT * FROM www_group");
		foreach($arr as $v) {
			$arr2[$v['groupid']] = array('name'=>$v['name'], 'type'=>$v['type'],'creditsfrom'=>$v['creditsfrom'], 'creditsto'=>$v['creditsto']);
		}
		return $arr2;
	}

	//޸ûȨ
	public function update_groupallow($groupid, $allow){
		if(!empty($allow) && is_array($allow)) {
			$str = '';
			foreach ($allow as $key => $value) {
				if($str) {
					$str.= ",";
				}
				$str .= "$key='$value'";
			}
			if($this->db->query("UPDATE www_group SET $str WHERE groupid='$groupid'")) {
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}
}
?>