<?php

define('model/newsclassmodel.php', 1);

class newsclassmodel {

	private $db;
	private $base;

	function __construct(&$base) {
		$this->base = $base;
		$this->db = $base->db;
	}

	public function get_allnewsclass() {
		$arr = $arr2 = array();
		$arr = $this->db->fetch_all("SELECT * FROM www_newsclass WHERE 1");
		foreach($arr as $k=>&$v) {
			$arr2[$v['newsclassid']] = $v;
		}
		return $arr2;
	}

	public function get_allnewsclass2() {
		$arr = $arr2 = array();
		$arr = $this->db->fetch_all("SELECT * FROM www_newsclass WHERE 1");
		foreach($arr as $k=>&$v) {
			$arr2[$v['newsclassid']] = $v['name'];
		}
		return $arr2;
	}

	public function get_newsclass($newsclassid) {
		$arr = array();
		$arr = $this->db->fetch_first("SELECT * FROM www_newsclass WHERE newsclassid='$newsclassid'");
		return $arr;
	}

	public function add_newsclass($arr) {
		if($arr['name']) {
			$this->db->query("INSERT INTO www_newsclass SET newsclasspid='$arr[newsclasspid]', name='$arr[name]'");
		}
		return $this->db->insert_id();
	}

	public function update_newsclass($arr, $newsclassid) {
		if($arr['name']) {
			$this->db->query("UPDATE www_newsclass SET newsclasspid='$arr[newsclasspid]', name='$arr[name]' WHERE newsclassid='$newsclassid'");
		}
		return $this->db->affected_rows();
	}

	public function delete_newsclass($newsclassid) {
		if($newsclassid) {
			$this->db->query("DELETE FROM www_newsclass WHERE newsclassid='$newsclassid'");
		}
		return $this->db->affected_rows();
	}

	public function to_options($newsclasses, $newsclasspid=0, $selectedids=array(), $unselectedids=array(),  $level=0, $symbols=''){
		//ж϶
		$selectedids = is_array($selectedids) ? $selectedids : array($selectedids);
		static $limit = 0;
		if($limit++ > 100000){
			die('over flow');
		}
		$symbol_first = '';
		$symbol_pre = '';
		$symbol_son = "";
		$symbol_son_lastone = "";
		$symbol_blank = '';
		//ݵǰλãݸһķ
		$sons = $this->get_sons($newsclasses, $newsclasspid);
		$sonsnum = count($sons);
		$s = '';
		if(is_array($sons) && $sonsnum) {
			$i = 0;
			foreach($sons as $newsclassid=>$son) {
				$i++;
				if(in_array($newsclassid, $unselectedids)) {
					continue;
				}
				$symbol = $i == $sonsnum ? $symbol_son_lastone : $symbol_son;//һ
				$symbol = $level==0 && $i==1 ? $symbol_first : $symbol;//һ
				$selected = in_array($newsclassid, (array)$selectedids) ? ' selected' : '';
				$s .= "<option value=\"{$son['newsclassid']}\"  $selected>".$symbols.$symbol."{$son['name']}</option>\r\n";
				//жϴݵķ
				//һΪգΪ |
				$s .= $this->to_options($newsclasses, $son['newsclassid'], $selectedids, $unselectedids, $level+1, $symbols.($i==$sonsnum ? $symbol_blank : $symbol_pre));
			}
		}
		return $s;
	}

	public function get_tree($newsclasses, $newsclasspid=0, $level = 1){
		static $limit = 0;
		if($limit++ > 100000){
			die('over flow');
		}
		$s = '<ul style=\"padding:0px\">';
		//ж϶
		$sons = $this->get_sons($newsclasses, $newsclasspid);
		$sonsnum = count($sons);
		if(is_array($sons) && $sonsnum) {
			$i = 0;
			foreach($sons as $newsclassid=>$son) {
				$i++;
				$s .= "<li style=\"padding-left:".(1 * $level)."\"\"><a href=\"".XIUNO_HOST_WWW."news-ls-$son[newsclassid].htm\" target=\"_blank\"><b>$son[name]</b></a>
					 <input type=\"text\" name=\"displayorder[{$son['newsclassid']}]\" value=\"{$son['displayorder']}\" size=\"4\">
					 <a href=\"".XIUNO_HOST_ADMIN."newsclass-edit-$son[newsclassid].htm\">[༭]</a>
					 <a href=\"javascript:if(window.confirm('ȷɾ÷ӷ'))window.location='".XIUNO_HOST_ADMIN."newsclass-delete-$son[newsclassid].htm'\">[ɾ]</a></li>\r\n";
				$s .= "<ul style=\"padding:0px;margin:0px;\">".$this->get_tree($newsclasses, $son['newsclassid'], $level+1)."</ul>";
			}
		}
		$s .= '</ul>';
		return $s;
	}

	public function get_deletetree($newsclasses, $newsclasspid=0, $level = 1){
		static $limit = 0;
		if($limit++ > 100000){
			die('over flow');
		}
		$s = '<ul style=\"padding:0px\">';
		//ж϶
		$sons = $this->get_sons($newsclasses, $newsclasspid);
		$sonsnum = count($sons);
		if(is_array($sons) && $sonsnum) {
			$i = 0;
			foreach($sons as $newsclassid=>$son) {
				$i++;
				$s .= "<li style=\"padding-left:".(1*$level)."\"\">
				 	<input type=\"checkbox\" value=\"$son[newsclassid]\" name=\"delete[$son[newsclassid]]\">
					<a href=\"".XIUNO_HOST_ADMIN."news.php?newsclassid=$son[newsclassid]\" target=\"_blank\"><b>$son[name]</b></a></li>\r\n";
				$s .= "<ul style=\"padding:0px;margin:0px;\">".$this->get_deletetree($newsclasses, $son['newsclassid'], $level+1)."</ul>";
			}
		}
		$s .= '</ul>';
		return $s;
	}

	//ȡһ
	public function get_sons($newsclasses, $newsclasspid=0){
		$arr = array();
		foreach($newsclasses as $newsclassid=>$newsclass) {
			if($newsclass['newsclasspid'] == $newsclasspid && $newsclass['newsclassid'] != $newsclasspid) {
				$arr[$newsclassid] = $newsclass;
			}
		}
		return $arr;
	}

	//ƼȡӣĬȡ5
	public function get_allson($newsclasses, $newsclasspid=0, $deep=5){
		static $limit = 0;
		if($limit++ > 100000){
			die('over flow');
		}
		$arr = array();
		if($deep>0){
			if(is_array($newsclasses)){
				foreach($newsclasses as $newsclass){
					if($newsclass['newsclasspid'] == $newsclasspid){
						$arr[$newsclass['newsclassid']] =  $newsclass;
						$arr = $arr + $this->get_allson($newsclasses, $newsclass['newsclassid'], $deep-1, $i);
					}
				}
			}
		}
		return $arr;
	}

	//޷ർ
	public function get_lastlevels($newsclasses, $newsclassid, $includeroot = false) {
		$i = 0;//memory over flow
		$navnewsclasslist = array();
		while(1) {
			$newsclasspid = $newsclasses[$newsclassid]['newsclasspid'];
			if($i++ > 20 || $newsclasspid == 0) {
				break;
			}
			$newspclass =  $newsclasses[$newsclasspid];
			$navnewsclasslist[] = $newspclass;
			$newsclassid = $newspclass['newsclassid'];
		}
		if(!$includeroot && $navnewsclasslist) {
			array_pop($navnewsclasslist);
		}
		return $navnewsclasslist;
	}
}
?>