<?php

define('model/ratemodel.php', 1);

class ratemodel {

	private $db;

	function __construct(&$base) {
		$this->base = $base;
		$this->db = $base->db;
	}

	public function get_thread_rate($pid) {
		$ratelist = $this->db->fetch_all("SELECT * FROM bbs_rate WHERE pid='$pid'");
		$extcredits = $this->base->setting['extcredits'];
		if(!empty($ratelist)) {
			$data = array('1'=>0, '2'=>0, '3'=>0, '4'=>0);
			foreach($ratelist as $rate) {
				$data[1] += $rate['value1'];
				$data[2] += $rate['value2'];
				$data[3] += $rate['value3'];
				$data[4] += $rate['value4'];
			}
			$s .= '<span  class="alert">[ ';
			foreach($data as $extcredit=>$value) {
				if($value) {
					$name = $extcredits[$extcredit]['title'];
					$s .= $name.($value > 0 ? '+'.$value : $value).' ';
				}
			}
			$s .= ']</span>';
		}
		return $s;
	}

	public function get_post_rate($pid) {
		$return = array();
		$ratelist = $this->db->fetch_all("SELECT * FROM bbs_rate WHERE pid='$pid'");
		$extcredits = $this->base->setting['extcredits'];
		foreach($ratelist as &$rate) {
			$rate['dateline'] = $this->base->date($rate['dateline']);
			$rate['message'] = '';
			$data = array();
			for($i=1; $i<=4; $i++) {
				$value = 'value'.$i;
				if($rate[$value]) {
					$data[] = $extcredits[1]['title'].' '.($rate[$value] > 0 ? '+'.$rate[$value] : $rate[$value]);
				}
			}
			$rate['message'] = implode(', ', $data);
		}
		return $ratelist;
	}
}
?>