<?php

define('model/recentmodel.php', 1);

class recentmodel {

	private $db;
	private $base;

	function __construct(&$base) {
		$this->base = $base;
		$this->db = $base->db;
	}

	public function get_recent($module, $uid) {
		$tablename = $this->get_recent_table_by_module($module);
		$data = $this->db->fetch_first("SELECT * FROM $tablename WHERE uid='$uid'");
		if(empty($data)) {
			return FALSE;
		}
		unset($data['uid']);
		return array_diff($data, array(0));
	}

	// $id Ϊ blogid imageid iduid
	public function update_recent($module, $uid, $id)  {
		$tablename = $this->get_recent_table_by_module($module);
		if(empty($id) || !$uid) {
			return false;
		}
		$data = $this->db->fetch_first("SELECT * FROM $tablename WHERE uid='$uid'");
		if(empty($data)) {
			$data = array($id);
			$sql = "INSERT INTO $tablename SET uid='$uid', id1='$id'";
		} else {
			unset($data['uid']);
			if($data['id1'] == $id) {
				return array_diff($data, array(0));
			}
			$data = array_diff($data, array(0, $id));
			array_unshift($data, $id);
			$data = array_values($data);
			$sqladd = '';
			for($i=0; $i<12; $i++) {
				$j = $i+1;
				if(!empty($data[$i])) {
					$sqladd .= "id$j='$data[$i]',";
				}
			}
			$sqladd = substr($sqladd, 0, -1);
			$sql = "UPDATE $tablename SET $sqladd  WHERE uid='$uid'";
		}
		$this->db->query($sql);
		return $data;
	}
	
	public function get_recent_table_by_module($module) {
		if($module == 'home') {
			return 'my_home_recent';
		} elseif($module == 'blog') {
			return 'my_blog_recent';
		} elseif($module == 'image') {
			return 'www_image_recent';
		} elseif($module == 'feed') {
			return 'my_feed_recent';
		}
	}
}
?>