<?php

define('model/usermodel.php', 1);

class usermodel {

	private $db;
	private $base;

	private $users;// ޳ظ user
	private $genders = array('', '', 'Ů');
	public $groups;
	public $group;
	function __construct(&$base) {
		$this->base = $base;
		$this->db = $base->db;
	}

	/*
		÷:
			1. ȡֶ
			get_user_by_uid(123);

			2. ȡֶָ
			get_user_by_uid(123, 'uid, bday', 'username');

			3. һֶ
			get_user_by_uid(123, '*');
	*/
	public function get_user_by_uid($uid, $usercols = '', $userfieldcols = '') {
		$user = array();
		if(empty($usercols) && empty($userfieldcols)) {
			$usercols = $userfieldcols = '*';
		}
		if($usercols) {
			$user = (array)$this->db->fetch_first("/*mckey=www_user_$uid*/ SELECT $usercols FROM www_user WHERE uid='$uid'");
		}
		if($userfieldcols) {
			$user += (array)$this->db->fetch_first("/*mckey=www_userfield_$uid*/ SELECT $userfieldcols FROM www_userfield WHERE uid='$uid'");
		}
		return $user;
	}

	/*
		÷
		update_user(123, "avatar='1', blog=blog+'1'", "username='admin2'")
	*/
	public function update_user($uid, $usercols, $userfieldcols = '') {
		if($usercols) {
			$this->db->query("/*primarykey=uid*/ UPDATE www_user SET $usercols WHERE uid='$uid'");
		}
		if($userfieldcols) {
			$this->db->query("/*primarykey=uid*/ UPDATE www_userfield SET $userfieldcols WHERE uid='$uid'");
		}
		return TRUE;
	}

	// user-reg
	public function add_user($username, $password, $email) {
		$excreditsqladd = '';
		foreach($this->base->setting['extcredits'] as $k=>$v) {
			$excredit = $v['init'] ? $v['init'] : 0;
			$excreditsqladd .= ", extcredits$k='$excredit'";
		}
		
		$salt = substr(uniqid(rand()), -6);
		$password = $this->encrypt($password, $salt);
		
		$this->db->query("INSERT INTO www_user SET regdate='{$this->base->time}', lastactivity='{$this->base->time}', groupid='".XIUNO_INIT_GROUPID."', credits='0' $excreditsqladd");
		$uid = $this->db->insert_id();
		
		// Ĭ
		$this->db->query("INSERT INTO my_album SET uid='$uid', username='$username', albumname='Ĭ', images='0', lastupdate='0', isprivate='0', cover='', coverid='0', password='' ");
		$albumid = $this->db->insert_id();

		// ¼
		$this->db->query("INSERT INTO www_user_event SET uid='$uid'");

		// Ĭ־
		$this->db->query("INSERT INTO my_blogcategory SET uid='$uid', categoryname='ĬϷ'");
		$cateid = $this->db->insert_id();
		
		
		$this->db->query("INSERT INTO www_userfield SET uid='$uid', username='$username', password='$password', salt='$salt', email='$email', regip='{$this->base->ip}', defaultalbumid='$albumid', defaultblogcateid='$cateid'");

		return $uid;
	}

	// user-reg
	public function check_username($username) {
//		return (strpos(stripcslashes($username), '\\') === FALSE) && strlen($username) <= 16;
		$username = str_replace("\t", '', $username);
		return strlen($username) <= 16;
	}

	// user-reg
	public function check_email($email) {
		return strlen($email) > 6 && preg_match("/^[\w\-\.]+@[\w\-\.]+(\.\w+)+$/", $email);
	}

	public function check_password($inputpassword, $dbpassword, $salt) {
		return $this->encrypt($inputpassword, $salt) == $dbpassword;
	}
	
	public function encrypt($password, $salt) {
		return md5(md5($password).$salt);
	}
	// user-ls
	public function get_user_total_num() {
		return $this->db->result_first("/*mckey=md5()*/SELECT COUNT(*) FROM www_user");
	}

	// user-ls
	public function get_user_list_by_page($page, $ppp, $totalnum) {
		$start = ($page - 1) * $ppp;
		$totalpage = ceil($totalnum / $ppp);
		$pagebydesc = $page > 1000 && $page > ($totalpage / 2) ? TRUE : FALSE;
		if($pagebydesc) {
			$firstpagesize = $totalnum % $ppp;
			$ppp2 = $page == $totalpage && $firstpagesize ? $firstpagesize : $ppp;
			$realpage = $totalpage - $page + 1;
			$start = max(0, ($realpage - 2) * $ppp + $firstpagesize);
			$ppp = $ppp2;
			$orderby = 'ORDER BY uid DESC';
			$arr = $this->get_user_list($start, $ppp, $orderby);
			return array_reverse($arr, TRUE);
		} else {
			return $this->get_user_list($start, $ppp, 'ORDER BY uid');
		}
	}

	// user-ls
	public function get_user_list($start = 0, $limit = 10, $orderby='') {
		$query = $this->db->query("SELECT * FROM www_user $orderby LIMIT $start, $limit");
		$user = $userlist = array();
		while($user = $this->db->fetch_array($query)) {
			$userfield = $this->db->fetch_first("SELECT * FROM www_userfield WHERE uid='$user[uid]'");
			$user = array_merge($user, (array)$userfield);
			$this->format_user($user);
			$userlist[] = $user;
		}
		return $userlist;
	}

	// user-ls ο͵ϡ
	public function format_user(&$user) {
		$ban = empty($user['isbanned']) || $this->base->user['groupid'] == 1 ? 0 : 1;
		$user['regdate'] = isset($user['regdate']) ? $this->base->date($user['regdate'], 'Y-n-j') : '';
		$user['bday'] = isset($user['bday_y']) ? $user['bday_y'].'-'.$user['bday_m'].'-'.$user['bday_d'] : '';
		$user['isonline'] = isset($user['lastactivity']) ? $this->base->time - $user['lastactivity'] < XIUNO_ONLINE_HOLD_TIME : FALSE;//15
		$user['lastactivity'] = isset($user['lastactivity']) ? $this->base->date($user['lastactivity']) : '';
		empty($user['isonline']) && $user['offlineday'] = ceil(($this->base->time - $user['lastactivity']) / DAY);
		$user['regip'] = isset($user['regip']) ? long2ip($user['regip']) : '';
		$user['home'] = isset($user['uid']) ? $this->base->get_home($user['uid']) : '';
		$user['avatar_big'] = $this->base->get_avatar($user['uid'], 'big', $ban ? 0 : $user['avatar']);
		$user['avatar_middle'] = $this->base->get_avatar($user['uid'], 'middle', $ban ? 0 : $user['avatar']);
		$user['avatar_small'] = $this->base->get_avatar($user['uid'], 'small', $ban ? 0 : $user['avatar']);
		$user['attachsum'] = isset($user['attachsum']) ? $this->format_byte($user['attachsum']) : '0K';
		$user['maxattachsize'] = isset($user['maxattachsize']) ? $this->format_byte($user['maxattachsize']) : '';
		$user['dbgender'] = getvalue($user['gender']);
		$user['gender'] = isset($user['gender']) && isset($this->genders[$user['gender']]) ? $this->genders[$user['gender']] : '';
		$user['onlinetime'] = isset($user['onlinetime']) ? $this->format_time($user['onlinetime']) : '';
		if(isset($user['groupid'])) {
			if(empty($this->groups)) {
				$groups = $this->base->cache('groups');
				$this->groups = $groups;
			}
			$user['group'] = $this->groups[$user['groupid']]['name'];
		}
	}

	// ֻԼʱ
	public function upgrade_user_group(&$user, $force = FALSE) {

		// Զû顣
		if(empty($this->groups)) {
			$groups = $this->base->cache('groups');
			$this->groups = $groups;
		}

		// ͨû飬
		if($this->groups[$user['groupid']]['type'] != XIUNO_NORMAL_GROUP_TYPE && !$force) return FALSE;
		foreach((array)$this->groups as $groupid=>$v) {
			if($v['type'] != 2) continue;

			if($v['creditsfrom'] <= $user['credits'] && $v['creditsto'] >= $user['credits'] && $user['groupid'] != $groupid) {
				$user['groupid'] = $groupid;
				$user['group'] = $v['name'];
				// cookie
				!$force && $this->set_user_cookie($user['uid'], $user['username'], $user['groupid']);
				$this->db->query("/*primarykey=uid*/ UPDATE www_user SET groupid='$user[groupid]' WHERE uid='$user[uid]'");
				!$force && $this->db->query("UPDATE www_online SET groupid='$user[groupid]' WHERE uid='$user[uid]'");
				break;
			}
		}
	}

	public function set_user_cookie($uid, $username, $groupid) {
		$time = $this->base->time;
//		$ip = $this->base->ip;
		$ip = getgpc('REMOTE_ADDR', 'V');
		$useragent = getgpc('HTTP_USER_AGENT', 'V');
		$useragent = substr(md5(substr($useragent, 0, 50)), 0, 8);

		$auth = $this->base->authcode("$uid	$username	$groupid	$ip	$useragent");
		$this->base->setcookie('auth', $auth, XIUNO_COOKIE_KEEP_TIME);
	}

	// my-password
	public function update_user_password($uid, $password) {
		$salt = $this->db->result_first("SELECT salt FROM www_userfield WHERE uid='$uid'");
		$password = $this->encrypt($password, $salt);
		$this->db->query("/*primarykey=uid*/ UPDATE www_userfield SET password='$password' WHERE uid='$uid'");
	}
	// pm-add
	public function get_uid_by_username($username) {
		return $this->db->result_first("SELECT uid FROM www_userfield WHERE username='$username'");
	}

	public function get_username_by_uid($uid) {
		if(XIUNO_MEMCACHE_ON) {
			$data = $this->get_user_by_uid($uid);
			return $data['username'];
		} else {
			return $this->db->result_first("SELECT username FROM www_userfield WHERE uid='$uid'");
		}
	}

	public function format_time($time) {
		$seconds 	= intval($time % MINUTE);
		$minutes 	= intval($time % HOUR / MINUTE);
		$hours 		= intval($time / HOUR);
		return $hours > 0 ? "$hours Сʱ" : "$minutes ";
	}

	public function format_byte($filesize) {
		if($filesize >= 1073741824) {
			$filesize = round($filesize / 1073741824 * 100) / 100 . ' GB';
		} elseif($filesize >= 1048576) {
			$filesize = round($filesize / 1048576 * 100) / 100 . ' MB';
		} elseif($filesize >= 1024) {
			$filesize = round($filesize / 1024 * 100) / 100 . ' KB';
		} else {
			$filesize = $filesize . ' Bytes';
		}
		return $filesize;
	}

}
?>