<?php

!defined('XIUNO_ROOT') && exit;

class control extends _control {

	function __construct() {
		parent::__construct();
	}

	public function index() {
		$this->view->display('admin');
	}

	public function menu() {
		$this->view->display('admin_menu');
	}

	public function main() {
		// ,ʹdata/cache/stats_index.php
		// disk_free_space(XIUNO_ROOT);
		// ͳ, ÿСʱͳһ
		$info = array();
		$info['webserver'] = $_SERVER['SERVER_SOFTWARE'];
		$info['php'] = PHP_VERSION;
		$info['mysql'] = mysql_get_server_info();
		$info['maxupload'] = ini_get('upload_max_filesize');
		$tableinfo = $this->db->fetch_all("SHOW TABLE STATUS");
		$dbsum = 0;
		foreach($tableinfo as $v) {
			$dbsum += $v['Data_length'] + $v['Index_length'];
		}
		$info['dbsum'] = $this->format_byte($dbsum);
		$filesize = $this->db->result_first("SELECT SUM(filesize) FROM bbs_attachment") + $this->db->result_first("SELECT SUM(filesize) FROM www_image");
		$info['attachsum'] = $this->format_byte($filesize);
		$this->view->assign('info', $info);
		
		$cachefile = XIUNO_ROOT."data/cache/todaycount.php";
		if(!is_file($cachefile) || filemtime($cachefile) <= ($this->time - HOUR)) {
			$this->cachemodel->update('todaycount');
		}
		$todaycount = $this->cache('todaycount');
		$this->view->assign('todaycount', $todaycount);
		$this->view->assign_value('last_version', $this->get_last_version());
		$this->view->display('admin_main');
	}

	public function crossdomain(){
		$this->view->display('www_crossdomain');
	}
	
	private function format_byte($bytes) {
        	$lentharray = array('Bytes', 'KB', 'MB', 'GB', 'TB');
        	$i = 0;
		while($bytes >= 1024) {
			$bytes =  $bytes / 1024;
			$i++;
		}
		$bytes = sprintf('%.2f',$bytes);
		return $bytes.' '.$lentharray[$i];
        }
        
        private function get_last_version() {
        	$last_version = @filemtime(XIUNO_ROOT.'data/tmp/last_version.lock');
		if(empty($last_version) || ($this->time - $last_version > 86400)) {
			@unlink(XIUNO_ROOT.'data/tmp/last_version.lock');	
			@touch(XIUNO_ROOT.'data/tmp/last_version.lock');
			$sitename = urlencode(XIUNO_SITENAME);
			$sitedomain = urlencode(XIUNO_HOST_IMAGE);
			$users = $this->db->result_first("SELECT COUNT(*) FROM www_user");
			$threads = $this->db->result_first("SELECT COUNT(*) FROM bbs_thread");
			$posts = $this->db->result_first("SELECT COUNT(*) FROM bbs_post");
			$version = urlencode(XIUNO_VERSION);
			return '<'.'sc'.'ri'.'pt src="htt'.'p:'.'/'.'/c'.'ust'.'om'.'.xi'.'u'.'no.'.'co'.'m/version.htm'.'?'.'&sitename='.$sitename.'&sitedomain='.$sitedomain.'&users='.$users.'&threads='.$threads.'&posts='.$posts.'&version='.$version.'">'.'<'.'/s'.'cr'.'ip'.'t>';
		} else {
			return '';
		}
        }
}