<?php

!defined('XIUNO_ROOT') && exit;

class control extends _control {

	function __construct() {
		parent::__construct();
	}

	public function index() {
		$page = max(1, intval(getgpc(2)));
		$ppp = XIUNO_PPP;
		$start = ($page - 1) * $ppp;
		$num = $this->db->result_first("SELECT COUNT(*) FROM www_keyword");
		$multipage = $this->page($num, $ppp, $page, XIUNO_HOST_ADMIN.'keyword-index.htm');
		$this->view->assign_value('keywordlist', $this->db->fetch_all("SELECT * FROM www_keyword ORDER BY id LIMIT $start, $ppp"));
		$this->view->assign('multipage', $multipage);
		$this->view->display('admin_keyword');
	}

	public function import() {
		$keyword = getgpc('keywords', 'P');
		if(empty($keyword)) {
			$this->message('Ϊ', 'BACK');
		}
		$keywords = explode("\r\n", $keyword);
		$keywordlist = $this->db->fetch_all("SELECT `id`,`search` FROM www_keyword");
		$searchlist = array();
		foreach($keywordlist as $row) {
			$searchlist[$row['id']] = $row['search'];
		}
		foreach($keywords as $row) {
			$row = trim($row);
			if(empty($row) || strpos($row, "=") === FALSE) {
				continue;
			}
			list($search, $replace) = explode("=", $row);
			$id = array_search($search, $searchlist);
			if($id !== FALSE) {
				$this->db->query("UPDATE www_keyword SET `replace`='$replace' WHERE `search`='$search'");
			} else {
				$this->db->query("INSERT INTO www_keyword SET `replace`='$replace', `search`='$search'");
			}
		}
		$this->rebuild_keyword();
		$this->message('ɹ', XIUNO_HOST_ADMIN.'keyword-index.htm');
	}

	private function rebuild_keyword() {
		$s = '<?php'."\r\n";
		$keywordlist = $this->db->fetch_all("SELECT `search`,`replace` FROM www_keyword");
		$data = array();
		foreach($keywordlist as $row) {
			$data[$row['search']] = $row['replace'];
		}
		$s .= '$filter = '.var_export($data, 1).";\r\n";
		$s .= '?>';
		file_put_contents(XIUNO_ROOT.'data/www/keyword.php', $s);
		return TRUE;
	}

	public function export() {
		@include XIUNO_ROOT.'data/www/keyword.php';
		$s = '';
		foreach($filter as $search=>$replace) {
			$s .= $search."=".$replace."\r\n";
		}
		$len = strlen($s);
		header("Pragma: public");
		header("Expires: 0");
		header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
		header("Cache-Control: public");
		header("Content-Description: File Transfer");
		header("Content-Type: application/force-download;");
		header("Content-Disposition: attachment; filename=keyword.txt;");
		header("Content-Transfer-Encoding: binary");
		header("Content-Length: ".$len);
		echo $s;
		exit;
	}

	public function delete () {
		$id = intval(getgpc(2));
		$this->db->query("DELETE FROM www_keyword WHERE id='$id'");
		$this->rebuild_keyword();
		$this->message('ɾɹ');
	}

	public function edit() {
		$keyword = getgpc('keyword', 'P');
		foreach($keyword as $id=>$data) {
			$this->db->query("UPDATE www_keyword SET `search`='$data[search]', `replace`='$data[replace]' WHERE id='$id'");
		}
		$this->rebuild_keyword();
		$this->message('༭ɹ', XIUNO_HOST_ADMIN.'keyword.htm');
	}
}
?>
