<?php

!defined('XIUNO_ROOT') && exit;

class control extends _control {

	function __construct() {
		parent::__construct();
	}

	public function index() {
		$type = getgpc('2');
		$page = intval(max(1, getgpc('3')));
		$tpp = 25;
		switch ($type) {
			case 'mysql':
				$file = XIUNO_LOG_DIR.'mysqlerror.php';
				$total = filesize($file) / 300;
				$multipage = $this->page($total, $tpp, $page, XIUNO_HOST_ADMIN.'log-index-'.$type.'.htm');
				$fp = fopen($file, 'rb');
				fseek($fp, ($page - 1) * $tpp * 300) + 15;
				$data = explode("\r\n", fread($fp, 300 * $tpp - 2));
				foreach($data as $key=>&$row) {
					if(empty($row)) {
						unset($data[$key]);
					}
					$row = explode("\t", trim($row));
				}
				$this->view->assign('data', $data);
				$this->view->assign('multipage', $multipage);
				$this->view->display('admin_log_mysql');
				break;
			case 'web':
				$file = XIUNO_LOG_DIR.'web.php';
				$total = filesize($file) / XIUNO_WEB_LOG_LENGTH;
				$multipage = $this->page($total, $tpp, $page, XIUNO_HOST_ADMIN.'log-index-'.$type.'.htm');
				$fp = fopen($file, 'rb');
				fseek($fp, ($page - 1) * $tpp * 150 + 15);
				$data = explode("\r\n", fread($fp, 150 * $tpp - 2));
				foreach($data as $key=>&$row) {
					if(empty($row)) {
						unset($data[$key]);
					}
					$row = explode("\t", trim($row));
				}
				$this->view->assign('data', $data);
				$this->view->assign('multipage', $multipage);
				$this->view->display('admin_log_web');
				break;
			default:
				break;
		}
	}
}
?>