<?php

!defined('XIUNO_ROOT') && exit;

class control extends _control{

	private $groupslist;
	function __construct() {
		parent::__construct();

		$groups = $this->cache('groups');
		$groupslist = array();
		foreach($groups as $k=>$group) {
			$groupslist[$k] = $group['name'];
		}
		$this->groupslist = $groupslist;
	}

	function __call($name, $args) {
		$this->ls();
	}

	public function ls() {
		$submit = getgpc('submit', 'R') ? 1 : 0;
		if($submit) {
			$ppp = XIUNO_PPP;
			$page = max(1, intval(getgpc('page')));
			$username = str_replace('*', '%', getgpc('username', 'R'));
			$email = str_replace('*', '%', getgpc('email', 'R'));
			$postsfrom = getgpc('postsfrom', 'R');
			$poststo = getgpc('poststo', 'R');
			$creditsfrom = getgpc('creditsfrom', 'R');
			$creditsto = getgpc('creditsto', 'R');
			$regipfrom = getgpc('regipfrom', 'R');
			$regipto = getgpc('regipto', 'R');
			$attachsumfrom = getgpc('attachsumfrom', 'R');
			$attachsumto = getgpc('attachsumto', 'R');
			$groupid = getgpc('groupid', 'R');

			if($username || $email || $regipfrom || $regipto || $attachsumfrom || $attachsumto) {
				$sqladd = $username ? "username LIKE '".$username."'" : '1 ';
				$sqladd .= $email ? "AND email LIKE '".$email."'" : '';
				$sqladd .= $regipfrom ? " AND regip>='".$this->ip2long($regipfrom)."'" : '';
				$sqladd .= $regipto ? " AND regip<='".$this->ip2long($regipto)."'" : '';
				$sqladd .= $attachsumfrom ? " AND attachsum>='$attachsumfrom'" : '';
				$sqladd .= $attachsumto ? " AND attachsum<='$attachsumto'" : '';

				$urladd = $username ? "&username=$username" : '';;
				$urladd .= $email ? "&email=$email" : '';
				$urladd .= $regip ? "&regipfrom=$regipfrom" : '';
				$urladd .= $regip ? "&regipto=$regipto" : '';
				$urladd .= $attachsum ? "&attachsumfrom=$attachsumfrom" : '';
				$urladd .= $attachsum ? "&attachsumto=$attachsumto" : '';

				$totalnum = $this->db->result_first("SELECT COUNT(*) FROM www_userfield WHERE $sqladd");
				$start = $this->page_get_start($page, $ppp, $totalnum);
				$userlist = $this->db->fetch_all("SELECT uid FROM www_userfield WHERE $sqladd LIMIT $start, $ppp", 'uid');
			} elseif($postsfrom || $poststo || $creditsfrom || $creditsto || $groupid) {
				$sqladd = $postsfrom ? "posts>='$postsfrom'" : '1 ';
				$sqladd .= $poststo ? " AND posts<='$poststo'" : '';
				$sqladd .= $creditsfrom ? " AND credits>='$creditsfrom'" : '';
				$sqladd .= $creditsto ? " AND credits<='$creditsto'" : '';
				$sqladd .= $groupid ? " AND groupid='$groupid'" : '';

				$urladd = $postsfrom ? "&postsfrom=$postsfrom" : '';
				$urladd .= $poststo ? "&postsfrom=$poststo" : '';
				$urladd .= $creditsfrom ? "&creditsfrom=$creditsfrom" : '';
				$urladd .= $creditsto ? "&creditsto=$creditsto" : '';
				$urladd .= $groupid ? "&groupid=$groupid" : '';

				$totalnum = $this->db->result_first("SELECT COUNT(*) FROM www_user WHERE $sqladd");
				$start = $this->page_get_start($page, $ppp, $totalnum);
				$userlist = $this->db->fetch_all("SELECT uid FROM www_user WHERE $sqladd LIMIT $start, $ppp", 'uid');
			}

			if($userlist) {
				foreach($userlist as $uid=>&$user) {
					if(empty($uid)) continue;
					$user = $this->usermodel->get_user_by_uid($uid);
					$user['lastip'] = long2ip($user['lastip']);
					$user['regip'] = long2ip($user['regip']);
					$user['lastactivity'] = $this->date($user['lastactivity']);
					$user['regdate'] = $this->date($user['regdate']);
					$user['groupid'] = $this->get_groupname($user['groupid']);
				}
			}
			$multipage = $this->page($totalnum, $ppp, $page, XIUNO_HOST_WWW."user-ls.htm?submit=$submit".$urladd, 0);
			$this->view->assign('userlist', $userlist);
			$this->view->assign('multipage', $multipage);
		}

		$groups = $this->groupslist;
		$groupoption = '';
		foreach ($groups as $k => $group){
			$groupoption .='<option value="'.$k.'">'.$group.'</option>';
		}
		$this->view->assign('submit', $submit);
		$this->view->assign('groupoption', $groupoption);
		$this->view->display('admin_user_ls');
	}

	public function edit() {
		$uid = getgpc('uid');
		$user = $this->usermodel->get_user_by_uid($uid);
		if(empty($user)) {
			$this->message('ûڡ');
		}
		if(!$this->submitcheck()) {
			$groups = $this->groupslist;
			$groupoption = '';
			foreach ($groups as $k => $group) {
				if($k == $user['groupid']) {
					$groupoption .='<option value="'.$k.'" selected>'.$group.'</option>';
				} else {
					$groupoption .='<option value="'.$k.'">'.$group.'</option>';
				}
			}
			//$user['lastip'] = long2ip($user['lastip']);
			$user['regip'] = long2ip($user['regip']);
			$user['lastactivity'] = $this->date($user['lastactivity'], 'Y-n-j');
			$user['regdate'] = $this->date($user['regdate'], 'Y-n-j');
			$this->view->assign('groupoption', $groupoption);
			$this->view->assign('user', $user);
			$this->view->display('admin_user_edit');
		} else {
			$username = getgpc('username', 'P');
			$password = getgpc('password', 'P');
			$groupid = getgpc('groupid', 'P');
			$email = getgpc('email', 'P');
			$posts = getgpc('posts', 'P');
			$extcredits1 = getgpc('extcredits1', 'P');
			$extcredits2 = getgpc('extcredits2', 'P');
			$onlinetime = getgpc('onlinetime', 'P');
			$regip = $this->ip2long(getgpc('regip', 'P'));
			$attachsum = getgpc('attachsum', 'P');
			$lastactivity = $this->strtotime(getgpc('lastactivity', 'P'));
			$regdate = $this->strtotime(getgpc('regdate', 'P'));
			
			if(!empty($password)) {
				$this->usermodel->update_user_password($uid, $password);
			}
			$this->db->query("/*primarykey=uid*/ UPDATE www_user SET groupid='$groupid',posts='$posts',
				extcredits1='$extcredits1',extcredits2='$extcredits2',onlinetime='$onlinetime',
				lastactivity='$lastactivity', regdate='$regdate' WHERE uid='$uid'");
			$this->db->query("/*primarykey=uid*/ UPDATE www_userfield SET username='".addslashes($username)."',email='$email',
				attachsum='$attachsum', regip='$regip' WHERE uid='$uid'");
			if($user['groupid'] != $groupid){
				$this->eventmodel->increase_event($this->user['uid'], 'updatecookie');
			}
			$this->message('༭ɹ', $_SERVER['REQUEST_URI']);
		}
	}

	public function delete() {
		if(!empty($_POST['delete'])) {
			$uids = $this->implode($_POST['delete']);
		} else {
			$uid = getgpc('uid');
			$uids = "'$uid'";
		}
		$attachlist = $this->db->fetch_all("SELECT * FROM bbs_attachment WHERE uid IN ($uids)");
		$imglist = $this->db->fetch_all("SELECT * FROM www_image WHERE uid IN ($uids)");
		foreach($attachlist as $attach) {
			$attach['filename'] && file_exists(XIUNO_ROOT.$attach['filename']) && unlink(XIUNO_ROOT.$attach['filename']);
		}
		foreach($imglist as $img) {
			$attach['filename'] && file_exists(XIUNO_ROOT.$img['filename']) && unlink(XIUNO_ROOT.$img['filename']);
		}
		//note ɾû
		$this->db->query("/*primarykey=aid*/ DELETE FROM bbs_attachment WHERE uid IN ($uids)");
		$this->db->query("/*primarykey=imageid*/ DELETE FROM www_image WHERE uid IN ($uids)");
		$this->db->query("/*primarykey=pmid*/ DELETE FROM my_pm WHERE uid IN ($uids)");
		$this->db->query("/*primarykey=tid*/ DELETE FROM bbs_thread WHERE uid IN ($uids)");
		$pids = $this->db->fetch_all("SELECT pid FROM bbs_post WHERE uid IN ($uids)");
		
		$this->db->query("/*primarykey=pid*/ DELETE FROM bbs_post WHERE uid IN ($uids)");
		$this->db->query("/*primarykey=uid*/ DELETE FROM my_friend WHERE uid IN ($uids)");
		$this->db->query("DELETE FROM my_friend WHERE fuid IN ($uids)");
		$this->db->query("/*primarykey=uid*/ DELETE FROM www_user WHERE uid IN ($uids)");
		$this->db->query("/*primarykey=uid*/ DELETE FROM www_userfield WHERE uid IN ($uids)");
		$this->db->query("/*primarykey=uid*/ DELETE FROM www_user_event WHERE uid IN ($uids)");
		$this->message('ɾɹ');
	}

	function get_groupname($gid){
		return $this->db->result_first("SELECT name FROM www_group WHERE groupid='$gid'");
	}
}