<?php

/*
[Xiuno] (C)2008-2009
This is NOT a freeware, use is subject to license terms

$RCSfile: index.php,v $
$Revision: 1.0 $
$Date: 2009/05/5 14:36:00 $
$Author: heyond $
*/
class base{
	public $time = 0;
	public $_time = '';
	public $ip = 0;
	public $_ip = '';
	public $sid = '';
	public $group = array();
	public $debug = 0;
	public $isrobot = 0;
	public $user = array();
	public $new = array();
	//public $db;	// __get()
	//public $view;	// __get()
	public $nav = array(
		'check1' => array('my'=>'', 'www'=>'', 'bbs'=>'', 'admin'=>''),
		'check2' => array()
	);
	public $navs = array();
	public $header = array();
	public $setting = array();
	public $session = array();
	public $url = '';
	
	//public $runtime = array();//ʱıظѯ

	protected $needseccode = FALSE;

	private $cachehaveavatar = array();
	private $inajax = 0;
	private $ajax = array('extra'=>array('closebutton'=>0, 'error'=>0), 'extrastr'=>'<closebutton>0</closebutton><error>0</error>');

	function __construct() {
		$this->init();
	}

	function __get($var) {
		if($var == 'db') {
			$master = $this->setting['master'];
			$slaves = $this->setting['slaves'];
			$this->db = new db($master['dbhost'], $master['dbuser'], $master['dbpw'], $master['dbname'], $master['dbcharset']);
			if($slaves) {
				foreach($slaves as $slave) {
					$this->db->add_slave($slave['dbhost'], $slave['dbuser'], $slave['dbpw'], $slave['dbname'], $slave['dbcharset']);
				}
			}
			unset($master, $slaves, $this->setting['master'], $this->setting['slaves']);
		} else if($var == 'view') {
			//require XIUNO_ROOT.'lib/template.class.php';
			$this->view = new Template();
			$this->view->assign_value('navuser_html', $this->ajax_get_navuser_html());
			// debug
			$this->view->assign('_ip', $this->_ip);
			$this->view->assign('_time', $this->_time);
			XIUNO_DEBUG && $this->view->assign('db', $this->db);
			$this->view->assign('nav', $this->nav);
			$this->view->assign('navs', $this->navs);
			$this->view->assign('header', $this->header);
			$this->view->assign('user', $this->user);

			//common.js Զ
			$this->view->assign('inajax', $this->inajax);
			$this->view->assign('m', $_GET['m']);
			$this->view->assign('a', $_GET['a']);
			$this->view->assign('ajax', $this->ajax);
			$this->view->assign_value('nexturl', getgpc('nexturl'));
			$this->view->assign_value('menuid', getgpc('menuid'));
		} else if(substr($var, -5) == 'model') {
			!defined("model/$var.php") && include XIUNO_ROOT."model/$var.php";
			$this->$var = new $var($this);
		} else if($var == 'form') {
			!defined("lib/form.class.php") && include XIUNO_ROOT."lib/form.class.php";
			$this->$var = new Form();
		} else {
			// error log
		}
		return $this->$var;
	}

	function __call($method, $parms) {
		$this->message('Action '.$method.' does not exists.', '', array('error'=>1));
	}

	function __destruct() {
		!XIUNO_DEBUG && $this->init_cron();
		if(!empty($this->session)) {
			$data = serialize($this->session);
			if(strlen($data) > 255*4) {
				$data1 = $data2 = $data3 = $data4 = '';
			} else {
				$data1 = addslashes(substr($data, 0, 255));
				$data2 = addslashes(substr($data, 255, 255));
				$data3 = addslashes(substr($data, 255*2, 255));
				$data4 = addslashes(substr($data, 255*3, 255));
			}
			$this->db->query("REPLACE INTO www_session SET data1='$data1', data2='$data2', data3='$data3', data4='$data4', sid='{$this->sid}'");
		}
	}

	/************ ʼ ************/

	private function init() {
		$this->init_var();
		$this->init_user();
		$this->init_group();
		$this->init_online();
		$this->init_event();
		XIUNO_DEBUG && $this->init_cron();
	}

	private function init_var() {
		//require XIUNO_CONFIG_FILE;
		//require XIUNO_ROOT.'config/constant.php';
		$this->setting = &$_ENV['xiuno']['setting'];
		$this->user = array(
			'uid' => 0,
			'username' => '',
			'groupid' => 0
		);
		$this->header = array(
			'title'=>XIUNO_SITENAME,
			'description'=>XIUNO_DESCRIPTION,
			'keywords'=>XIUNO_KEYWORDS,
			'navigation'=>'',
			'seokeywords'=>XIUNO_KEYWORDS
		);
		$this->_ip = getvalue($_SERVER['HTTP_X_FORWARDED_FOR'], $_SERVER['REMOTE_ADDR']);
		$this->ip = $this->ip2long($this->_ip);
		define('FORMHASH', $this->formhash());
		$this->time = time();
		$this->_time = $this->date($this->time, 'Y-n-j H:i');
		$this->url = $_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
		$this->isrobot = $this->isrobot();
		$this->inajax = getgpc('inajax');
		
		if(isset($_GET['navtoggle'])) {
			$_COOKIE['navtoggle'] = intval($_GET['navtoggle']);
			$this->setcookie('navtoggle', $_GET['navtoggle'], 8640000);
		}
		if(XIUNO_ALLOW_IP && XIUNO_ALLOW_IP != $this->_ip) {
			exit('ϻ');
		}
	}

	private function init_user() {
		// COOKIE[sid]Ϊ ʼ
		$this->sid = isset($_GET['sid']) ? $_GET['sid'] : getgpc('sid', 'C');
		if(empty($this->sid)) {
			$this->sid = $this->init_sid();
			return NULL;
		}

		// COOKIE[auth]ʽȷ ı䣨IPͷIP,ʼ
		$auth = isset($_GET['auth']) ? $_GET['auth'] : getgpc('auth', 'C');
		if($auth) {
			$arr = explode("\t", $this->authcode($auth, 'DECODE'));
			isset($arr[4]) && list($uid, $username, $groupid, $ip, $useragent) = $arr;

			// УIPΡֹCOOKIEáIPȡʵIP
			!empty($ip) && $ip1 = explode('.', $ip);
			$ip2 = explode('.', getgpc('REMOTE_ADDR', 'V'));
			$HTTP_USER_AGENT = getgpc('HTTP_USER_AGENT') ? getgpc('HTTP_USER_AGENT') : getgpc('HTTP_USER_AGENT', 'V');
			$HTTP_USER_AGENT = substr(md5(substr($HTTP_USER_AGENT, 0, 50)), 0, 8);

			// 棺˴ܻᵼ˳ĳЩûIPǱ仯ġ  && $ip1[0] == $ip2[0] && $ip1[1] == $ip2[1]
			if(!empty($useragent)  && $useragent == $HTTP_USER_AGENT) {
				$this->user['uid'] = $uid;
				$this->user['username_slash'] = addslashes($username);
				$this->user['username'] = $username;
				$this->user['groupid'] = $groupid;
			} else {
				$this->sid = $this->init_sid();
			}
		}
	}

	private function init_group() {
		$this->user['groupid'] = !empty($this->user['groupid']) ? $this->user['groupid'] : ($this->isrobot ? XIUNO_SEARCH_ENGINE_GROUPID : XIUNO_GUEST_GROUPID);
		$this->group = $this->cache('group', $this->user['groupid']);
		$this->view->assign('group', $this->group);
		return TRUE;
	}

	private function init_event() {
		if(empty($this->user['uid'])) {
			return FALSE;
		}
		$this->new = $this->db->fetch_first("/*mckey=www_user_event_{$this->user['uid']}*/ SELECT * FROM www_user_event WHERE uid='{$this->user['uid']}'");
		if(empty($this->new)) {
			if($this->db->result_first("SELECT COUNT(*) FROM www_user WHERE uid='{$this->user['uid']}'")) {
				$this->db->query("INSERT INTO www_user_event SET uid='{$this->user['uid']}'");
			} else {
				$this->init_sid();
				exit('˺ſܱɾ, Զ˳¼, ˢºοݵ½ˢЧɾCOOKIE');
			}
		}
		if($this->new['updatecookie']) {
			$this->eventmodel->decrease_event($this->user['uid'], 'updatecookie', $this->new['updatecookie']);
			$groupid = $this->db->result_first("SELECT groupid FROM www_user WHERE uid='{$this->user['uid']}'");
			$this->usermodel->set_user_cookie($this->user['uid'], $this->user['username'], $groupid);
			$this->db->query("UPDATE www_online SET groupid='$groupid' WHERE uid='{$this->user['uid']}'");
			$this->user['groupid'] = $groupid;
			$this->init_group();
		}

		// رȨ޵û
		if($this->new['checkpriv']) {
			$userpriv = $this->db->fetch_first("SELECT * FROM www_userpriv WHERE uid='{$this->user['uid']}'");
			$expiration = $userpriv['expiration'];
			if($expiration && $expiration < $this->time) {
				$this->db->query("/*primarykey=uid*/ UPDATE www_user SET isbanned='0' WHERE uid='{$this->user['uid']}'");
				$this->db->query("/*primarykey=uid*/ UPDATE www_user_event SET checkpriv='0' WHERE uid='{$this->user['uid']}'");
				$this->db->query("DELETE FROM www_userpriv WHERE uid='{$this->user['uid']}'");
			} else {
				if($userpriv['privrank'] == XIUNO_ACCESS_DENIED_PRIV_RANK) {
					exit('ԲʺűֹʣʲôϵԱ');
				} else if($userpriv['privrank'] == XIUNO_POST_DENIED_PRIV_RANK) {
					$this->group['allowpost'] = 0;
				}
			}
		}

		if(XIUNO_SECCODE_ON && $this->time - $this->new['lastsubmit'] < 30) {
			$this->needseccode = TRUE;
		}
		$this->view->assign('needseccode', $this->needseccode);
		$this->view->assign('new', $this->new);
	}

	// $_COOKIE[auth] : uid	username	groupid	ip
	private function init_online() {
		$lastonlineupdate = getgpc('lastonlineupdate', 'C');// cookie дŵΪʱ
		if(empty($lastonlineupdate) || $lastonlineupdate < $this->time + XIUNO_TIME_OFFSET * HOUR) {
			$this->setcookie('lastonlineupdate', $this->time + XIUNO_TIME_OFFSET * HOUR + XIUNO_UPDATE_USER_TIME_SPAN, DAY);
			$this->url = addslashes($this->url);
			if(!empty($_COOKIE['sid'])) {
				$this->db->query("REPLACE INTO www_online SET sid='$this->sid', uid='{$this->user['uid']}', username='".addslashes($this->user['username'])."', groupid='{$this->user['groupid']}', ip='$this->ip', url='$this->url', lastactivity='{$this->time}'");
				if($this->user['uid']) {
					$this->update_user();
				}
			}
		}
	}

	private function init_cron() {
		// XIUNO_CRON_MYSQL_QUEUE_TIME
		if($this->time > min(XIUNO_CRON_ONLINE_TIME, XIUNO_CRON_TODAYPOST_TIME)) {
			$this->cronmodel->run();
		}
	}

	private function init_sid() {
		// ظ룬ֹsidͬ
		$sid = substr(md5($this->ip.rand(1, MAX_INT_32)), 0, 16);
		$this->setcookie('sid', $sid, XIUNO_COOKIE_KEEP_TIME);
		$this->setcookie('auth', '', XIUNO_COOKIE_KEEP_TIME);
		return $sid;
	}

	/************ ĺ ************/

	// ػ
	public function cache($cachename, $arg = '') {
		$cachename2 = $cachename.($arg ? "_$arg" : '');
		$cachefile = XIUNO_ROOT."data/cache/$cachename2.php";
		if(!is_file($cachefile)) {
			$this->cachemodel->update($cachename, $arg);
		}
		!defined("data/cache/$cachename2.php") && include $cachefile;
		return $_ENV['xiuno']['cache'][$cachename2];
	}

	// 棬Ӧ÷cachemodel.php
	public function clearcache($cachename, $arg = '') {
		$cachefile = XIUNO_ROOT."data/cache/$cachename".($arg ? "_$arg" : '').".php";
		if(is_file($cachefile)) {
			unlink($cachefile);
		}
	}

	public function setcookie($key, $value, $keeptime, $cookiedomain='') {
		$cookiedomain = $cookiedomain ? $cookiedomain : XIUNO_COOKIE_DOMAIN;
		setcookie($key, $value, $this->time + $keeptime, '/', $cookiedomain);
	}

	public function message($message = '', $redirect = '', $extra = array()) {
		$this->_message($message, $redirect, $extra, 'message');
	}
	
	// ķΪԴⲿֱӵáҪһΪAJAX
	public function _message($message = '', $redirect = '', $extra = array(), $messagetpl = 'message') {
		if($this->inajax) {
			$this->ajax_message($message, $extra);
			exit;
		}
		
		$this->navs[] = 'ϵͳϢ';
		// jsõĿͻ˻
		//$extra = $extra == 'CLEARDATA' ? '<script>setdata("message", "");</script>' : '';
		$this->view->assign_value('extrastr', '');	// extra Ϊ ajax ר
		$this->view->assign('message', $message);
		$this->view->assign('redirect', $redirect);
		$this->view->display($messagetpl);
		exit;
	}
	
	/**
		$this->ajax_message('ɾɹ');
		$this->ajax_message('ɾɹ', array('error'=>0, 'closebutton'=>0, 'abc'=>'123'));
	**/
	
	public function ajax_message($message, $extra = array()) {
		$inajax = $this->inajax;
		
		// ǰ̨ʾرհť
		!isset($extra['closebutton']) && $extra['closebutton'] = 1;
		
		// ʾΪϢʾǰ̨Ӵʾ
		!isset($extra['ismessage']) && $extra['ismessage'] = 1;
		
		$this->ajax['extra'] = array_merge($this->ajax['extra'], $extra);
		//error_log(print_r($this->ajax['extra'], 1).$_SERVER['REQUEST_URI'], 3, 'd:/log2.txt');
		// AJAX ת
		if($inajax == 1 && getgpc('message')) {
			$this->ajax['extra'] = getgpc('extra');// 飬˴ܲȫҪ  stripslashes + htmlspecialchar
			
			$message = stripslashes(getgpc('message'));
		} elseif($inajax == 2) {
			// 򣬴˴ $extra
			// Ҫֱʾ
			$referer = getgpc('HTTP_REFERER', 'V');
			$arr = parse_url($referer);
			if($arr['host'] != $_SERVER['HTTP_HOST']) {
				$this->message_ajax_jump($message, $this->ajax['extra']);
				exit;
			}
		}
		
		$extrastr = '';
		if(is_array($this->ajax['extra'])) {
			foreach($this->ajax['extra'] as $k=>$v) {
				$extrastr .= "<$k><![CDATA[$v]]></$k>\r\n";
			}
		}
		$message = "$message";
		
		$this->ajax['extrastr'] = $extrastr;
		$this->view->assign('ajax', $this->ajax);
		$this->view->assign('message', $message);
		$this->view->display('ajax_message');
		exit;
	}


	// iframe ύݣصݻIFRAMEУȡҪheaderͬһ
	public function message_ajax_jump($message, $extra = array()) {
		$referer = getgpc('HTTP_REFERER', 'V');
		$arr = parse_url($referer);
		
		if(empty($arr['host'])) {
			$host = getgpc('HTTP_HOST', 'V');
		} else {
			$host = empty($arr['port']) ? $arr['host'] : $arr['host'].':'.$arr['port'];
		}
		$extraurl = $this->array_to_url($extra, 'extra');
		$message = rawurlencode($message);
		$menuid = getgpc('menuid');
		// menu_width menu_title servererror Ҫ
		$portadd = $arr['port'] ? ':'.$arr['port'] : '';
		header("Expires: -1");
		header("Cache-Control: no-store, private, post-check=0, pre-check=0, max-age=0", FALSE);
		header("Pragma: no-cache");
		//  rewrite ? 
		//  path define('XIUNO_HOST_BBS', 'http://localhost/xiuno3.0/?domain-bbs-');
		header("Location: http://$host$portadd/?index-message.htm?inajax=1&menuid=$menuid&$extraurl&message=$message");
		exit;
	}
	
	// жǷͬһ
	private function is_samedomain($url1, $host) {
		// https://www.domain.com:8080/user-login.htm
		// https://localhost:8080/xiuno3.0/
		preg_match('#^https?://([^/])(:\d+)?/#');
	}
	
	//  rewrite, 
/*	public function get_uri() {
	
	}*/

	public function authcode($string, $operation = 'ENCODE', $key = 'randomstring') {
		$coded = '';
		$keylength = strlen($key);
		$string = $operation == 'DECODE' ? base64_decode($string) : $string;
		for($i = 0; $i < strlen($string); $i += $keylength) {
			$coded .= substr($string, $i, $keylength) ^ $key;
		}
		$coded = $operation == 'ENCODE' ? str_replace('=', '', base64_encode($coded)) : $coded;
		return $coded;
	}

	public function page($num, $perpage, $curpage, $mpurl, $rewrite = 1, $showid = '') {
		$multipage = '';
		$urladd = '';
		if(!$rewrite) {
			$mpurl .= strpos($mpurl, '?') ? '&' : '?';
		}else{
			list($mpurl, $urladd) = explode('.htm', $mpurl);
			$urladd = '.htm'.$urladd;
		}

		$rewritepage = $rewrite ? '-' : 'page=';
		$checkedid = 0; // 
		if($num > $perpage) {
			$pageurls = array();
			$page = 15;
			$offset = 10;
			$pages = ceil($num / $perpage);
			if($page > $pages) {
				$from = 1;
				$to = $pages;
			} else {
				$from = $curpage - $offset;
				$to = $from + $page - 1;
				if($from < 1) {
					$to = $curpage + 1 - $from;
					$from = 1;
					if($to - $from < $page) {
						$to = $page;
					}
				} elseif($to > $pages) {
					$from = $pages - $page + 1;
					$to = $pages;
				}
			}
			$ajaxadd = $showid ? ' onclick="return ajaxget(this.href, \''.$showid.'\');"' : '';
			$multipage = ($curpage - $offset > 1 && $pages > $page ? '<a href="'.$mpurl.$rewritepage.'1'.$urladd.'"'.$ajaxadd.'>|&lsaquo;</a>' : '').($curpage > 1 ? '<a href="'.$mpurl.$rewritepage.($curpage - 1).$urladd.'"'.$ajaxadd.'>&lsaquo;&lsaquo;</a>' : '');
			if($curpage - $offset > 1 && $pages > $page) {
				$pageurls[] = '<a href="'.$mpurl.$rewritepage.'1'.$urladd.'"'.$ajaxadd.'>|&lsaquo;</a>';
				if($curpage > 1) {
					$pageurls[] = '<a href="'.$mpurl.$rewritepage.($curpage - 1).$urladd.'"'.$ajaxadd.'>&lsaquo;&lsaquo;</a>';
				}
			}
			
			for($i = $from; $i <= $to; $i++) {
				if($i == $curpage) {
					if(STYLE_EFFECT_ON) {
						$pageurls[] = '<a href="'.$mpurl.$rewritepage.$i.$urladd.'"'.$ajaxadd.'><b>'.$i.'</b></a>';
					} else {
						$pageurls[] = '<b>'.$i.'</b>';// checked
					}
					$checkedid = count($pageurls) - 1;
				} else {
					$pageurls[] = '<a href="'.$mpurl.$rewritepage.$i.$urladd.'"'.$ajaxadd.'>'.$i.'</a>';
				}
			}
			if($curpage < $pages) {
				$pageurls[] = '<a href="'.$mpurl.$rewritepage.($curpage + 1).$urladd.'"'.$ajaxadd.'>&rsaquo;&rsaquo;</a>';
				if($to < $pages) {
					$pageurls[] = '<a href="'.$mpurl.$rewritepage.$pages.$urladd.'"'.$ajaxadd.'>&rsaquo;|</a>';
				}
			}
			if(STYLE_EFFECT_ON) {
				$multipage = $this->page_style_effect($pageurls, $checkedid);
			} else {
				$multipage = implode($pageurls, '');
			}
		}
		return $multipage;
	}
	
	public function page_style_effect($pageurls, $checkedid) {
		$s = $first = $last = $sep = '';
		$n = count($pageurls);
		$first = '<li class="first'.($checkedid == 0 ? ' firstchecked' : '').'">'.array_shift($pageurls).'</li><li class="sep"></li>';
		$last = '<li class="sep"></li><li class="last'.($checkedid == $n - 1 ? ' lastchecked' : '').'">'.array_pop($pageurls).'</li>';
		foreach($pageurls as $k=>$url) {
			$s .= "$sep<li".($k + 1 == $checkedid ? ' class="checked"' : '').">$url</li>";
			empty($sep) && $sep = '<li class="sep"></li>';
		}
		
		$s = "<ul class=\"label1\">$first$s$last</ul>";
		return $s;
	}

	public function page_get_start($page, $ppp, $totalnum) {
		$totalpage = $totalnum ? ceil($totalnum / $ppp) : 1;
		$page =  max(1, min($totalpage, intval($page)));
		return ($page - 1) * $ppp;
	}

	public function submitcheck() {
		return getgpc('formhash', 'P') == FORMHASH ? true : false;
	}

	public function seccodecheck() {
		if($this->needseccode && (($this->session_start() && $this->session['seccode'] != strtolower(getgpc('seccode', 'P'))) || empty($this->session['seccode']))){
			$this->message('֤', 'BACK');
		} else {
			$this->session['seccode'] = '';
		}
	}

	public function update_lastsubmit() {
		if($this->user['uid']) {
			$this->db->query("/*primarykey=uid*/ UPDATE www_user_event SET lastsubmit='{$this->time}' WHERE uid='{$this->user['uid']}'");
		}
	}

	public function update_user() {
		if(empty($this->user['uid'])) return FALSE;

		$onlinetime = XIUNO_UPDATE_USER_TIME_SPAN;
		// ¼֣жǷҪ
		// todo ͶϢء
		$user = $this->usermodel->get_user_by_uid($this->user['uid'], '*');
		$credits = $user['credits'];

		$this->db->query("/*primarykey=uid*/ UPDATE LOW_PRIORITY www_user SET lastip='$this->ip', lastactivity='{$this->time}', onlinetime=onlinetime+'".$onlinetime."' WHERE uid='{$this->user['uid']}'");
		if($this->group['type'] == 1) {
			$yearmonth = $this->date($this->time, 'Ym');
			if($this->db->result_first("SELECT COUNT(*) FROM www_stats_mod_history WHERE uid='{$this->user['uid']}' AND yearmonth='$yearmonth'")) {
				$this->db->query("UPDATE www_stats_mod_history SET onlinetime=onlinetime+'$onlinetime' WHERE uid='{$this->user['uid']}' AND yearmonth='$yearmonth'");
			} else {
				$this->db->query("INSERT INTO www_stats_mod_history SET uid='{$this->user['uid']}', yearmonth='$yearmonth', onlinetime='$onlinetime'");
			}
		}
		return TRUE;
	}

	public function set_home($uid) {
		//100/00/00/00
		$uid = sprintf("%011d", $uid);
		$s1 = substr($uid, -3);
		$s2 = substr($uid, -6, 3);
		$dir1 = XIUNO_ROOT."data/home/$s1";
		$dir2 = XIUNO_ROOT."data/home/$s1/$s2";
		!is_dir($dir1) && mkdir($dir1, 0777);
		!is_dir($dir2) && mkdir($dir2, 0777);
		return "data/home/$s1/$s2";
	}

	public function get_home($uid) {
		$uid = sprintf("%011d", $uid);
		$s1 = substr($uid, -3);
		$s2 = substr($uid, -6, 3);
		return "data/home/$s1/$s2";
	}

	public function set_navcheck($module, $level = '1', $status = true) {
		$key = "check$level";
		$this->nav[$key][$module] = $status ? 'ed' : '';
	}
	
	// õһ飬ʽ磺
	/**
		array('1'=>'<img src="xxx" />', 2=>'<img src="xxx">')
	*/
	public function get_avatars($uids, $size = 'small') {
		//  memcacheȡ
		$return = array();
		$uids = array_unique($uids);
		$uids = array_diff($uids, array(0));
		if(XIUNO_MEMCACHE_ON) {
			foreach($uids as $uid) {
				if(empty($uid)) continue;
				$user = $this->db->fetch_first("/*mckey=www_user_$uid*/ SELECT * FROM www_user WHERE uid='$uid'");
				$return[$user['uid']] = $this->get_avatar($user['uid'], $size, $user['avatar']);
			}
		} else {
			$sqladd = $this->array_to_sql_or($uids, 'uid');
			$arr = $sqladd ? $this->db->fetch_all("SELECT uid, avatar FROM www_user WHERE $sqladd", 'uid') : array();
			foreach($arr as $v) {
				$return[$v['uid']] = $this->get_avatar($v['uid'], $size, $v['avatar']);
			}
		}
		return $return;
	}

	//  $avatar ʾͷʱ 0 ʾϵͳͷ
	public function get_avatar($uid, $size = '', $avatar = FALSE) {
		$size = $size ? '_'.$size : '_middle';
		if($uid && $avatar === FALSE){
			if(!isset($this->cachehaveavatar[$uid])) {
				$avatar = $this->db->result_first("SELECT avatar FROM www_user WHERE uid='$uid'");
				$this->cachehaveavatar[$uid] = $avatar;
			}
			$avatar = $this->cachehaveavatar[$uid];
		}
		if($uid && $avatar) {
			$dir = $this->get_home($uid);
			$src = XIUNO_HOST_IMAGE.$dir."/{$uid}_avatar$size".($size == '_big' ? '.jpg' : '.gif');
		} else {
			$src = XIUNO_HOST_IMAGE.'image/common/noavatar.gif';
		}
		switch($size) {
			case '_mini': $width = XIUNO_AVATAR_WIDTH_MINI; break;
			case '_small': $width = XIUNO_AVATAR_WIDTH_SMALL; break;
			case '_middle': $width = XIUNO_AVATAR_WIDTH_MIDDLE; break;
			case '_big': $width = XIUNO_AVATAR_WIDTH_BIG; break;
			default : $width = XIUNO_AVATAR_WIDTH_MIDDLE ;
		}
		return ($uid ? "<a href='".XIUNO_HOST_MY."index-index-$uid.htm' target=\"_blank\">" : '').'<img width="'.$width.'" src="'.$src.'?update='.$avatar.'" />'.($uid ? '</a>' : '');
	}

	public function get_thumb($filename) {
		$pos = strrpos($filename, '.');
		$s = substr($filename, 0, $pos).'_thumb'.substr($filename, $pos);
		return $s;
	}

	//$newpmsound = empty($_COOKIE['closepm']) ? '<bgsound src="'.XIUNO_HOST_IMAGE.'image/common/pm_1.mp3">' : '';
	protected function ajax_get_navuser_html() {
		$onlines = $this->db->result_first("/*cachelife=60&mckey=md5()*/ SELECT COUNT(*) FROM www_online");
		$s = '';
		if(empty($this->user['uid'])) {
			$s .= '<a href="" onclick="ajaxmenu(\''.XIUNO_HOST_WWW.'user-login.htm\');return false;">¼</a> | ';
			$s .= '<a href="" onclick="ajaxmenu(\''.XIUNO_HOST_WWW.'user-reg.htm\');return false;">ע</a>';
		} else {
			$s .= empty($this->user['username']) ? $this->db->result_first("SELECT email FROM www_userfield WHERE uid='{$this->user['uid']}'")." | " :'<a href="'.XIUNO_HOST_MY.'index.htm">'.$this->user['username'].'</a>';
			$s .= '<span style="color:'.COLOR4.'"> ( '.$this->group['name'].' ) </span> |';
			$s .= '<img src="'.IMGURL.'home.gif" align="absmiddle" style="margin-top: -4px; margin-right: 2px;"/><a href="'.XIUNO_HOST_MY.'index.htm" class="navcheck'.$this->nav['check1']['my'].'">ҵĿռ</a> | ';
			$newpmsound = '';
			$s .= '<a href="'.XIUNO_HOST_MY.'pm-inbox.htm">Ϣ'.(empty($this->new['new_pm']) ? '<span id="newpmimg"></span></a> | ' : '<img src="'.XIUNO_HOST_IMAGE.'image/common/newpm.gif" title="¶Ϣ" />'.'</a>| '.$newpmsound);
			if(!empty($this->new['new_friendrequest'])) {
				$s .= '<a href="'.XIUNO_HOST_MY.'friend-requestls.htm"> <img src="'.XIUNO_HOST_IMAGE.'image/common/newpm.gif" title="µĺ" /></a>| ';
			}
			$this->user['groupid'] == XIUNO_ADMINISTRATOR_GROUPID && $s .= '<a href="'.XIUNO_HOST_WWW.'user-ls.htm">Աб</a> | ';
			$this->group['type'] == XIUNO_ADMIN_GROUP_TYPE && $s .= '<a href="'.XIUNO_HOST_BBS.'moderator.htm"></a> | ';
			$this->user['groupid'] == XIUNO_ADMINISTRATOR_GROUPID && $s .= '<a href="'.XIUNO_HOST_WWW.'stats.htm">ͳ</a> | ';
			$this->user['groupid'] == XIUNO_ADMINISTRATOR_GROUPID && $s .= '<a href="'.XIUNO_HOST_ADMIN.'index.htm" target="_blank"></a> | ';
			$s .= '<a href="" onclick="return ajaxconfirm(\'ȷҪ˳\', \''.XIUNO_HOST_WWW.'user-logout.htm\', function(s){ajaxalert(s.message.text, s.error.text); setTimeout(function(){window.location.reload()}, 1000)});">˳</a>';
		}
		$s .= $this->user['groupid'] == 1 ? ' <a href="'.XIUNO_HOST_BBS.'misc-online.htm">(ߣ<b style="color:#b00">'.$onlines.'</b>)</a>' : '(ߣ<b style="color:#b00">'.$onlines.'</b>)';
		return $s;
	}

	private function isrobot() {
		$spiders = 'Bot|Crawl|Spider|slurp|sohu-search|lycos|robozilla';
		$browsers = 'MSIE|Netscape|Opera|Konqueror|Mozilla|Chrome';
		if(preg_match("/($browsers)/i", $_SERVER['HTTP_USER_AGENT'])) {
			return FALSE;
		} elseif(preg_match("/($spiders)/i", $_SERVER['HTTP_USER_AGENT'])) {
			return TRUE;
		}
		return FALSE;
	}

	private function formhash() {
		return substr(md5(substr($this->time, 0, -5).XIUNO_KEY), 16);
	}


	/************ PHP ************/

	// substr for gbk
	// start only for '0'
	public function xiuno_substr($s, $len) {
		$s = substr($s, 0, $len);
		$len = min(strlen($s), $len);
		for($i=0; $i<$len; $i++) {
			ord($s[$i]) > 127 && $i++;
		}
		return ($i == $len) ? $s : substr($s, 0, -1);
	}

	// TODO ڻ
	public function session_start() {
		if($this->sid) {
			$data = $this->db->fetch_first("SELECT * FROM www_session WHERE sid='{$this->sid}'");
			$this->session = $data['data1'] ? unserialize($data['data1'].$data['data2'].$data['data3'].$data['data4']) : array();
			return TRUE;
		} else {
			return FALSE;
		}
	}

	// compatible with 64/32 bit
	public function ip2long($ip) {
		$long = ip2long($ip);
		return $long > MAX_INT_32 ? ($long - (MAX_INT_32 + 1) * 2)  : $long;
	}

	public function strtotime($str, $now=NULL) {
		return strtotime($str.' GMT', $now) - XIUNO_TIME_OFFSET * HOUR;
	}

	public function implode($arr) {
		// ȥհ
		$arr = array_diff((array)$arr, array('', 0));
		return $arr ? "'".implode("','", $arr)."'" : '';
	}

	public function date($time, $format = '') {
		if(!$format) {
			if($this->time - $time < MONTH) {
				return $this->format_lasttime($this->time - $time);
			} else {
				$format = 'Y-n-j';
			}
		}
		return gmdate($format, $time + HOUR * XIUNO_TIME_OFFSET);
	}

	private function format_lasttime($time) {
		$word = $time > 0 ? 'ǰ' :  '';
		$time = abs($time);
		$seconds 	= intval($time % MINUTE);
		$minutes 	= intval($time / MINUTE);
		$hours 		= intval($time / HOUR);
		$days 		= intval($time / DAY);
		if($days) {
			return $days.''.$word;
		} elseif($hours) {
			return $hours.'Сʱ'.$word;
		} elseif($minutes) {
			return $minutes.''.$word;
		} elseif($seconds) {
			return $seconds.''.$word;
		} else {
			return 'ղ';
		}
	}
	
	// 滻ɫ <font color="red" ...
	public function replace_color($s) {
		return str_replace(array(1=>'red', 2=>'orange', 3=>'yellow', 4=>'green', 5=>'cyan', 6=>'blue', 7=>'purple', 8=>'gray', 9=>'#FF0000'), array(1=>'#A60000', 2=>'CB4C00', 3=>'#70603D', 4=>'#005B11', 5=>'#084D46', 6=>'#103B77', 7=>'#6B136B', 8=>'#383838', 9=>'#A60000'), $s);
	}
	
	// ȡ2άĳһ
	public function array_values($arr, $key) {
		$arr2 = array();
		foreach($arr as $v) {
			$arr2[] = $v[$key];
		}
		return $arr2;
	}
	
	// ƴΪ SQL
	public function array_to_sql_or($arr, $id) {
		$sqladd = '';
		foreach($arr as $v) {
			$sqladd .= "$id='$v' OR ";
		}
		return substr($sqladd, 0, -4);
	}
	
	public function array_to_url($arr, $arrayname = '') {
		$s = $sep = '';
		foreach($arr as $k=>$v) {
			$s .= "$sep".($arrayname ? "{$arrayname}[{$k}]" : $k)."=".rawurlencode($v);
			$sep = '&';
		}
		return $s;
	}
	
	public function unlink_rumtime() {
		@is_file(XIUNO_ROOT.'data/cache/_runtime.php') && unlink(XIUNO_ROOT.'data/cache/_runtime.php');
		@is_file(XIUNO_ROOT.'data/cache/_runtime_bbs.php') && unlink(XIUNO_ROOT.'data/cache/_runtime_bbs.php');
	}
}
?>