<?php

!defined('XIUNO_ROOT') && exit;

class control extends _control {

	function __construct() {
		parent::__construct();
	}

	public function index() {
		$pid = intval(getgpc(2));
		$post = $this->threadmodel->get_post_by_pid($pid);

		if(empty($post)) {
			$this->message('ʧܣҪֵӿܲڻɾ', '', array('error'=>1));
		}

		if($post['uid'] == $this->user['uid']) {
			$this->message('ʧܣܸԼ', '', array('error'=>1));
		}
		$tid = $post['tid'];
		$thread = $this->threadmodel->get_thread_by_tid($tid);
		if(empty($thread)) {
			$this->message('ʧܣҪֵܲڻɾ', '', array('error'=>1));
		}
		$fid = $thread['fid'];
		$forum = $this->cache('forum', $fid);



		// Ȩ޺Ͳȷж
		$this->user['ismoderator'] = $this->forummodel->is_moderator($forum, $this->user['groupid'], $this->user['uid']);
		if(!$this->user['ismoderator']) {
			$this->message('<errot>4</error><message>ʧܣûжԴȨ</message>');
		}

		// ظ֤
		$rate_users = $this->db->fetch_all("SELECT uid FROM bbs_rate WHERE pid='$pid'", 'uid');
		if(isset($rate_users[$this->user['uid']])) {
			$this->message('ʧܣظ', '', array('error'=>1));
		}

		// 
		$today = $this->strtotime($this->date($this->time, 'Y-m-d'));
		$ratelist = $this->db->fetch_all("SELECT * FROM bbs_rate WHERE uid='{$this->user['uid']}' AND dateline>'$today'");
		$value1 = $value2 = $value3 = $value4 = 0;
		foreach($ratelist as $rate) {
			$rate['value1'] > 0 && $value1 += $rate['value1'];
			$rate['value2'] > 0 && $value2 += $rate['value2'];
			$rate['value3'] > 0 && $value3 += $rate['value3'];
			$rate['value4'] > 0 && $value4 += $rate['value4'];
		}

		if(!$this->submitcheck()) {
			$extcredits = $this->setting['extcredits'];
			$data = $row = array();
			for($i=1; $i<=4; $i++) {
				if(isset($this->group['raterange'][$i])) {
					$value = 'value'.$i;
					$row['i'] = $i;
					$row['name'] = $extcredits[$i]['title'];
					$row['maxrate'] = $this->group['raterange'][$i]['maxrate'];
					$row['minrate'] = $this->group['raterange'][$i]['minrate'];
					$row['remain'] = $this->group['raterange'][$i]['mrpd'] - $$value;
					$data[] = $row;
				}
			}

			$this->view->assign('pid', $pid);
			$this->view->assign('data', $data);
			$this->view->display('bbs_rate');
		} else {
			$rates = getgpc('rates', 'P');
			$reason    = getgpc('reason', 'P');
			$pm        = getgpc('pm', 'P');

			$sqladd = "pid='$pid'";
			foreach($rates as $k=>&$rate) {
				if(!isset($this->group['raterange'][$k])) {
					$this->message('ʧܣǷ', '', array('error'=>1));
				}
				if($rate > $this->group['raterange'][$k]['maxrate'] || $rate < $this->group['raterange'][$k]['minrate']) {
					$this->message('ʧܣַΧ', '', array('error'=>1));
				}
				$value = 'value'.$k;
				if($rate + $$value > $this->group['raterange'][$k]['mrpd']) {
					$this->message('ʧܣյʣ', '', array('error'=>1));
				}
				if($rate) {
					$sqladd .= ", value{$k}='$rate' ";
				}
			}
			if(!$sqladd) {
				$this->message('ʧܣΪ', '', array('error'=>1));
			}

			// û
			$this->creditmodel->update_credit($post['uid'], $rates, $post['username']);
			// βдÿּ¼
			$this->db->query("INSERT INTO bbs_rate SET uid='{$this->user['uid']}', username='{$this->user['username_slash']}', $sqladd");
			// Ӻͻظֵ
			if($post['first']) {
				$this->db->query("/*primarykey=tid*/ UPDATE bbs_thread SET is_rated='1' WHERE tid='$tid'");
			}
			$this->db->query("/*primarykey=pid*/ UPDATE bbs_post SET is_rated='1' WHERE pid='$pid'");

			// ͶϢ֪ͨ
			if($pm) {
				$message = $this->format_rate_message($this->setting['extcredits'], $rates);
				$this->pm_tousers($thread, $post, ''.$message, $reason, $post['page']);
			}
			// д¼
			$this->write_rate_log($post, ''.$message, $reason, $pid ,$post['page']);
			$this->message('ֲɹ', '', array('error'=>0));
		}
	}

	// Ϣ֪ͨ()
	private function pm_tousers($thread, $post, $action, $reason, $page=1) {
		$subject = 'ϵͳϢ';
		$subject  .= ($post['first'] ? '' : '');
		$subject  .= $thread['subject'];
		$subject .= $post['first'] ? '' : 'Ļظ';
		$subject .= $reason ? "".$reason : '';
		$subject .= "Ա $action";
		$pageadd = $page > 1 ? '-'.$page : '';
		$url = $thread['tid'].$pageadd;
		$message = '⡿<a href="'.XIUNO_HOST_BBS."thread-index-$url.htm\" target=\"_blank\">".addslashes($thread['subject']).'</a><br />';
		$message .= 'ʱ䡿'.$this->date($this->time, 'Y-n-j H:i');
		$this->pmmodel->system_message(addslashes($subject), addslashes($message), array($post['uid']=>addslashes($post['username'])));
	}

	// д־
	private function write_rate_log($thread, $action, $reason, $pid, $page) {
		$this->logmodel->insert_bbs_operation_log($thread['fid'], $thread['tid'], $this->user['uid'], $this->user['username_slash'], $action, $this->time, $reason, $thread['subject'], $pid, $page);
	}

	private function format_rate_message($extcredits, $rates) {
		$data = array();
		foreach($rates as $k=>$rate) {
			$data[] = $extcredits[$k]['title'].' '.($rate > 0 ? '+'.$rate : $rate);
		}
		return implode(', ', $data);
	}
}
?>