<?php

!defined('XIUNO_ROOT') && exit;

class control extends _control {

	function __construct() {
		parent::__construct();
		$this->nav['check3'] = array('friend'=>'', 'my'=>'', 'add'=>'', 'manage'=>'', 'categoryls'=>'');
		$this->set_navcheck($_GET['a'], 3);
		$this->init_vuser();
	}

	function __call($name, $args) {
		$_GET['a'] = 'ls';
		$this->set_navcheck($_GET['a'], 3);
		
		$this->ls();
	}

	// ־б
	function ls() {
		$this->isfriend = $this->self ? 1 : $this->friendmodel->is_friend($this->uid, $this->user['uid']);
		$rank 		= $this->self ? 3 : ($this->isfriend ? 2 : 1);
		
		$page		= max(1, getgpc('page'));
		$categoryid	= max(0, intval($_GET[2]));
		$category	= empty($categoryid) ? '' : $this->blogmodel->get_category_by_id($categoryid);
		if(empty($category)) {
			$user = $this->usermodel->get_user_by_uid($this->uid, 'blogs');
			$num = $user['blogs'];
		} else {
			$num = $category['blogs'];
		}
		$multipage = $this->page($num, XIUNO_PPP, $page, XIUNO_HOST_MY."blog-ls-$categoryid.htm?uid=".$this->uid, FALSE);
		$bloglist = $this->blogmodel->get_blog_list($page, XIUNO_PPP, $num, $this->uid, $categoryid);
		foreach($bloglist as &$blog) {
			$blog['message'] = $blog['isprivate'] < $rank ? $this->xiuno_substr(strip_tags($blog['message']), 600) : '־Ѿ˽ɷʣ';
		}
		
		$categoryls = $this->blogmodel->get_category_list($this->uid);
		$this->view->assign('categoryls', $categoryls);

		$this->navs[] = "<a href=\"".XIUNO_HOST_MY."blog-ls-$categoryid.htm?uid=$this->uid&page=$page\">־б</a>";
		$this->view->assign('multipage', $multipage);
		$this->view->assign('num', $num);
		$this->view->assign('bloglist', $bloglist);
		$this->view->assign('category', $category);
		$this->view->assign('categoryid', $categoryid);
		$this->view->display('my_blog_ls');
	}

	// ־б
	function friendls() {
		$page = max(1, intval(getgpc('page')));
		$ppp = XIUNO_PPP;
		$fuidarr  = $this->friendmodel->get_active_friends($this->user['uid']);
		$bloglist = $this->blogmodel->get_friend_bloglist_by_uid_page($this->uid, $page, $ppp, $fuidarr, $num);
		
		$multipage = $this->page($num, XIUNO_PPP, $page, XIUNO_HOST_MY."blog-friendls.htm?uid=".$this->uid, FALSE);

		$this->navs[]  = "<a href=\"".XIUNO_HOST_MY."blog-friendls.htm?uid=$this->uid&page=$page\">־</a>";
		$this->view->assign('multipage', $multipage);
		$this->view->assign('num', $num);
		$this->view->assign('bloglist', $bloglist);
		$this->view->display('my_blog_friend');
	}

	// ־
	function detail() {
		
		$this->isfriend = $this->self ? 1 : $this->friendmodel->is_friend($this->uid, $this->user['uid']);
		$rank 	= $this->self ? 3 : ($this->isfriend ? 2 : 1);
		
		$this->set_navcheck('ls', 3);
		$blogid = intval($_GET[2]);
		$blog	= $this->blogmodel->get_blog_by_blogid($blogid);
		if(empty($blog))  {
			$this->message('־ڡ');
		}
		if($blog['isprivate'] >= $rank && !$this->group['allowmodspace']) {
			$this->message('־˽Ȩ鿴');
		}
		if($blog['uid'] != $this->user['uid'] && !in_array($blogid, $blogids)) {
			$this->blogmodel->update_blog_views($blogid);
			$blogids[] = $blogid;
		}

		$this->navs[] = "<a href=\"".XIUNO_HOST_MY."blog-ls-{$blog['categoryid']}.htm?uid={$blog['uid']}\">".($blog['uid'] == $this->user['uid'] ? "ҵ־" : "־")."</a>";
		$this->navs[] = '<a href="'.XIUNO_HOST_MY.'blog-detail-'.$blogid.'.htm">־</a>';
		
		// ظбùģ
		$this->replymodel->get_replylist_by_page('blog', $blog['blogid'], $blog['replies'], max(1, intval(getgpc('page'))));
		
		$this->view->assign('blog', $blog);
		$this->view->display('my_blog_detail');
	}

	// ־
	function add() {
		$this->navs[] = "<a href=\"".XIUNO_HOST_MY."blog-add.htm\">־</a>";
		$this->check_login();
		
		if(!$this->submitcheck()) {
			$categoryselect = $this->_get_category_select($this->user['uid'], 0);
			$isprivateradio = $this->form->get_radio('isprivate', array('κ', '', '˽'), 0);
			$blog = array();
			
			$this->view->assign_value('caller', 'add');
			$this->view->assign('categoryselect', $categoryselect);
			$this->view->assign('isprivateradio', $isprivateradio);
			$this->view->display("my_blog_add_edit");
		} else {
			$categoryid	= intval(getgpc('categoryid', 'P'));
			$isprivate	= intval(getgpc('isprivate', 'P'));
			$subject	= $this->stringmodel->filter_keyword(htmlspecialchars(getgpc('subject', 'P')));
			$message	= $this->stringmodel->filter_keyword(getgpc('message', 'P'));
			
			$arr = array();
			preg_match_all('/<!--imageid=(\d+)-->/', $message, $arr);
			$this->stringmodel->strip_script($message);
			
			$categoryid	= empty($categoryid) ? $this->blogmodel->get_default_categoryid($this->user['uid']) : $categoryid;

			if(empty($subject)) {
				$this->message('д־⣬Ժ鿴', 'BACK');
			}
			if($blogid = $this->blogmodel->add_blog($subject, $message, $this->user['uid'], $this->user['username_slash'], $this->time, $categoryid, $isprivate)) {
				if(!$isprivate) {
					$imageids = array_slice($arr[1] , 0, 4);
					$imagelist = $this->db->fetch_all_by_ids('www_image', 'imageid', '*', $imageids);
					$aids = array();
					foreach($imagelist as $v) {
						$aids[$v['imageid']] = $this->get_thumb($v['filename']);
					}
					$this->feedmodel->add_feed(array('uid'=>$this->user['uid'], 'username'=>$this->user['username'], 'blogid'=>$blogid, 'subject'=>stripslashes($subject), 'aids'=>$aids), 'blog', $this->time, $this->user['uid']);
					$this->recentmodel->update_recent('blog', $this->user['uid'], $blogid);
				}
				$this->message('־ɹ<script type="text/javascript">window.onload=function(){deldata(\'message\');}</script>', XIUNO_HOST_MY."blog-detail-$blogid.htm");
			} else {
				$this->message('·ʧ', 'BACK');
			}
		}
	}

	// ༭־
	function edit() {
		$this->check_login();
		$this->set_navcheck('add', 3);
		$this->navs[] = "<a href=\"".XIUNO_HOST_MY."blog-edit-$blogid.htm?uid=$this->uid\">༭־</a>";
		
		$blogid = intval($_GET[2]);
		$blog = $this->blogmodel->get_blog_by_blogid($blogid);
		if($blog['uid'] != $this->user['uid'] && !$this->group['allowmodspace']) {
			$this->message('ûȨ༭˵־');
		}

		if(!$this->submitcheck()) {
			
			$categoryselect = $this->_get_category_select($this->user['uid'], $blog['categoryid']);
			$isprivateradio = $this->form->get_radio('isprivate', array('κ', '', '˽'), $blog['isprivate']);
			
			$this->view->assign_value('caller', 'edit');
			$this->view->assign('categoryselect', $categoryselect);
			$this->view->assign('isprivateradio', $isprivateradio);
			$this->view->assign('blog', $blog);
			$this->view->display("my_blog_add_edit");
		} else {
			
			$subject	= $this->stringmodel->filter_keyword(htmlspecialchars(getgpc('subject', 'P')));
			$message	= $this->stringmodel->filter_keyword(getgpc('message', 'P'));
			$this->stringmodel->strip_script($message);
			$categoryid	= intval(getgpc('categoryid', 'P'));
			$isprivate	= intval(getgpc('isprivate', 'P'));
			
			if(!empty($subject) && $this->blogmodel->edit_blog($blogid, $subject, $message, $categoryid, $isprivate, $this->user['uid'])) {
				if($blog['categoryid'] != $categoryid) {
					$this->blogmodel->update_category_blogs($blog['categoryid'], $categoryid);
				}
				$this->message('༭ɹ<script type="text/javascript">window.onload=function(){deldata(\'message\');}</script>', XIUNO_HOST_MY."blog-detail-$blogid.htm", 'CLEARDATA');
			} else {
				$this->message('༭ʧܡ', 'BACK');
			}
		}
	}

	// ɾ־
	function delete() {
		$this->check_login();
		$blogids = getgpc('blogid') ? getgpc('blogid') : getgpc('delete', 'P');
		foreach((array)$blogids as $blogid) {
			$blog = $this->blogmodel->get_blog_by_blogid($blogid);
			if(empty($blog)) {
				continue;
			}
			if($blog['uid'] != $this->user['uid'] && !$this->group['allowmodspace']) {
				continue;
			}
			$this->blogmodel->delete_blog($blogid, $blog);
		}
		$this->message('ɾɹ', '', array('error'=>0));
	}

	// ־
	function manage() {
		$this->check_priv('self');
		
		if(!$this->submitcheck()) {
			$categoryid	= intval(getgpc('categoryid'));
			$page		= max(intval(getgpc('page')), 1);
			$ppp 		= 30;
			
			// ȡû־
			$category	= empty($categoryid) ? '' : $this->blogmodel->get_category_by_id($categoryid);
			if(empty($category)) {
				$user = $this->usermodel->get_user_by_uid($this->uid, 'blogs');
				$num = $user['blogs'];
			} else {
				$num = $category['blogs'];
			}

			$multipage	= $this->page($num, $ppp, $page, "blog-manage.htm?categoryid=$categoryid&uid=".$this->uid, FALSE);
			$bloglist	= $this->blogmodel->get_blog_list($page, $ppp, $num, $this->uid, $categoryid);
			$categoryls	= $this->blogmodel->get_category_list($this->uid);

			$this->navs[] = "<a href=\"".XIUNO_HOST_MY."blog-manage.htm?uid=$this->uid&categoryid=$categoryid&page=$page\">־</a>";
			$this->view->assign('categoryid', $categoryid);
			$this->view->assign('num', $num);
			$this->view->assign('multipage', $multipage);
			$this->view->assign('bloglist', $bloglist);
			$this->view->assign('categoryls', $categoryls);
			$this->view->assign('categoryid', $categoryid);
			$this->view->display('my_blog_manage');
		} else {
			$blogid = getgpc('blogid', 'P');
			$categoryid	= intval(getgpc('categoryid', 'P'));
			$blogidarr = is_array($blogid) ? $blogid : explode(',', $blogid);
			if($this->blogmodel->category($blogidarr, $categoryid)) {
				$this->message('ɹ', '', array('error'=>1));
			} else {
				$this->message('ʧ', '', array('error'=>1));
			}
		}
	}

	// б
	function categoryls() {
		$this->check_priv('self');
		$categoryls = $this->blogmodel->get_category_list($this->uid);
		$this->navs[]  .= "<a href=\"".XIUNO_HOST_MY."blog-categoryls.htm?uid=$this->uid\">־</a>";
		$this->view->assign('categoryls', $categoryls);
		$this->view->display('my_blog_cate_ls');
	}

	// ӷ
	function addcategory() {
		$this->check_priv('self');
		$menuid = getgpc('menuid');
		if(!$this->submitcheck()) {
			$this->view->assign('menuid', $menuid);
			$this->view->display("my_blog_cate_add");
		} else {
			$categoryname = getgpc('categoryname', 'P');
			if(empty($categoryname)) {
				$this->message('', '', array('error'=>1));
			}
			if($this->blogmodel->get_blog_category_total($this->user['uid']) >= 40) {
				$this->message('㴴ķѾﵽ40', '', array('error'=>1));
			}
			if($this->blogmodel->check_categoryname_exist($categoryname, $this->user['uid'])) {
				$this->message('÷Ѿڣѡ', '', array('error'=>1));
			} elseif($categoryid = $this->blogmodel->create_category($this->user['uid'], $categoryname)){
				$this->message('ӳɹ', '', array('categoryid'=>$categoryid, 'categoryname'=>$categoryname));
			} else {
				$this->message('ʧܣ', '', array('error'=>1));
			}
		}
	}

	// ༭
	function editcategory() {
		$this->check_priv('self');
		$categoryids 	= getgpc('categoryid', 'P');
		$categorynames	= getgpc('categoryname', 'P');
		$displayorders	= getgpc('displayorder', 'P');
		$affected_rows  = 0;
		foreach($categoryids as $k=>$v) {
			$categoryid = $v;
			$categoryname = $categorynames[$k];
			$displayorder = $displayorders[$k];
			$orgcate = $this->blogmodel->get_category_by_id($categoryid);
			// Ȩж
			if($orgcate['uid'] != $this->user['uid']) {
				continue;
			}
			$this->blogmodel->edit_category($categoryid, $categoryname, $displayorder, $orgcate);
		}
		$this->message("ɹ༭ $affected_rows ¼", XIUNO_HOST_MY.'blog-categoryls.htm');
	}

	// ɾ ajax
	function delcategory() {
		$this->check_priv('self');
		$menuid = getgpc('menuid');
		$categoryid = intval(getgpc(2));
		$category = $this->blogmodel->get_category_by_id($categoryid);
		if($category['uid'] != $this->user['uid']) {
			$this->message('Ȩɾû־ࡣ', '', array('error'=>10001));
		}
		if($categoryid == $this->blogmodel->get_default_categoryid($this->user['uid'])) {
			$this->message('ɾĬϷ', '', array('error'=>10002));
		}
		if(!empty($categoryid) && $this->blogmodel->delete_category($categoryid)) {
			$this->message('ɾɹ', '', array('error'=>0));
		} else {
			$this->message('༭ʧ', '', array('error'=>10003));
		}
	}

	public function shareblog() {
		if(!XIUNO_SHARE_ON) {
			$this->message('˹ѱر', '', array('error'=>1));
		}
		$blogid = intval(getgpc(2));
		$this->session_start();
		if(isset($this->session['sharedblog']) && in_array($blogid, $this->session['sharedblog'])) {
			$this->message('Ѿƪ͡', '', array('error'=>1));
		} else {
			$blog = $this->db->fetch_first("SELECT subject,isprivate FROM my_blog WHERE blogid='$blogid'");
			if($blog['isprivate']) {
				$this->message('־ǹ־ܷ', '', array('error'=>1));
			} else {
				$this->feedmodel->add_feed(array('uid'=>$this->user['uid'], 'username'=>$this->user['username'], 'blogid'=>$blogid, 'subject'=>$blog['subject']), 'shareblog', $this->time, $this->user['uid']);
				$this->session['sharedblog'][] = $blogid;
				$this->message('ɹ', '', array('error'=>0));
			}
		}
	}
	
	private function _get_category_select($uid, $checkedid = 0) {
		$categoryls	= $this->blogmodel->get_category_list($uid);
		$categoryselect = '<select id="categoryselect" name="categoryid">';
		foreach ($categoryls as $category) {
			$checked = $checkedid == $category['categoryid'] ? ' selected=" selected"' : '';
			$categoryselect .= '<option value="'.$category['categoryid'].'" '.$checked.'>'.$category['categoryname'].'</option>';
		}
		$categoryselect .= '</select>';
		return $categoryselect;
	}
}