<?php

!defined('XIUNO_ROOT') && exit;

class control extends _control {
	public $action2;
	
	function __construct() {
		parent::__construct();
		$this->nav['check3'] = array('blog'=>'', 'thread'=>'', 'music'=>'');
		$this->action2 = getgpc(2);
		!in_array($this->action2, array('thread', 'blog')) && $this->action2 = 'thread';
		$this->set_navcheck($this->action2, 3);
		$this->init_vuser();
	}

	function __call($name, $args) {
		$this->ls();
	}

	// ղб
	function ls() {
		$page		= max(1, getgpc('page'));
		$type		= $this->action2;
		$num		= $this->favoritemodel->get_favorite_num($this->user['uid'], $type);
		$multipage	= $this->page($num, XIUNO_PPP, $page, "favorite-ls-$type.htm?uid=".$this->user['uid'], FALSE);
		$favoritelist	= $this->favoritemodel->get_favorite_list($page, XIUNO_PPP, $num, $this->user['uid'], $type);
		$favoritetype	= array('blog'=>'־', 'thread'=>'');

		$this->navs[]  = "<a href=\"".XIUNO_HOST_MY."favorite-ls-$type.htm?uid={$this->user['uid']}&page=$page\">ղص{$favoritetype[$type]}</a>";
		$this->view->assign('multipage', $multipage);
		$this->view->assign('num', $num);
		$this->view->assign('favoritelist', $favoritelist);
		$this->view->assign('favoritetype', $favoritetype);
		$this->view->assign('type', $type);
		$this->view->display('my_favorite');
	}

	// ղ
	function add() {
		$this->check_login();
		$id = max(0, getgpc(2));
		$type = getgpc(3) ? getgpc(3) : 'thread';
		if($this->favoritemodel->check_favorite_exist($id, $this->user['uid'], $type)) {
			$this->message('Ѿղظ', '', array('error'=>1));
		}
		if(!empty($id) && $this->favoritemodel->add_favorite($id, $this->user['uid'], $type)) {
			$this->message('ղسɹ', '', array('error'=>0));
		} else {
			$this->message('ղʧ', '', array('error'=>1));
		}
	}

	// ɾղ
	function delete() {
		$this->check_login();
		$favoriteid = getgpc('favoriteid') ? getgpc('favoriteid') : 0;
		if(!empty($favoriteid) && $this->favoritemodel->delete_favorite($favoriteid)) {
			$this->message('ɾɹ', '', array('error'=>0));
		} else {
			$this->message('ɾʧ', '', array('error'=>1));
		}
	}
}

?>