<?php

!defined('XIUNO_ROOT') && exit;

class control extends _control {

	function __construct() {
		parent::__construct();
		if(empty($this->user['uid'])) {
//			$this->ajax_message('ȵ¼');
			$this->view->display('user-login.htm');
		}
		$this->set_navcheck('feed', 2);
		$this->set_navcheck('hello', 4);
	}

	function __call($name, $args) {
		$this->ls();
	}

	public function ls() {
		$page = max(intval(getgpc('2')), 1);
		$total = $this->new['new_hello'];
		$hellolist = $this->hellomodel->get_hello_by_page($this->user['uid'], $page, XIUNO_PPP);
		$multipage = $this->page($total, XIUNO_PPP, $page, XIUNO_HOST_MY.'hello-ls.htm');
		require XIUNO_ROOT.'config/hello.php';
		$uid = $this->user['uid'];
		$touser = "<a href='".XIUNO_HOST_MY."index-index-$uid.htm' target='_blank'/>".$this->user['username']."</a>";
		foreach($hellolist as &$hello) {
			$hello['fromuid'] = $hello['direct'] == 1 ? $hello['highid'] : $hello['lowid'];
			$hellohighid = $hello['highid'];
			$hellolowid = $hello['lowid'];
			$fromuser = $hello['direct'] == 1 ? "<a href='".XIUNO_HOST_MY."index-index-$hellohighid.htm' target='_blank'/>".$hello['highuser']."</a>"
			: "<a href='".XIUNO_HOST_MY."index-index-$hellolowid.htm' target='_blank'/>".$hello['lowuser']."</a>";
			$message = $helloconfig[$hello['typeid']]['message'];
			$hello['message'] = str_replace(array('{from}', '{to}'), array($fromuser, $touser), $message);
			$hello['dateline'] = $this->date($hello['dateline']);
			$hello['icon'] = "<img src='".XIUNO_HOST_MY."image/hello/hello_".$hello['typeid'].".gif' />";

		}
		$this->view->assign('hellolist', $hellolist);
		$this->view->assign('multipage', $multipage);
		$this->view->display('my_hello');
	}

	public function send() {
		$touid = intval(getgpc('touid'));
		if($touid == $this->user['uid']) {
			$this->message('ܸԼк', '', array('error'=>1));
		}
		$touser = $this->usermodel->get_username_by_uid($touid);
		$typeid = intval(getgpc('typeid', 'P'));
		$helloid = intval(getgpc('helloid'));
		$avatar = $this->get_avatar($touid, 'small');
		if(empty($touser)) {
			$this->message('ûڡ');
		}
		if(!getgpc('confirm')) {
			require XIUNO_ROOT.'config/hello.php';
			foreach($helloconfig as $k=>$hello) {
				if(!$hello['isshow']) {
					unset($helloconfig[$k]);
				}
			}
			$this->view->assign_value('hello', array_chunk($helloconfig, 3));
			$this->view->assign('recallhelloid', $helloid);
			$this->view->assign('touid', $touid);
			$this->view->assign('touser', $touser);
			$this->view->assign('avatar', $avatar);
			$this->view->display('my_hello_send');
		} else {
			$dateline = $this->time;
			if($touid < $this->user['uid']) {
				$lowid = $touid;
				$highid = $this->user['uid'];
				$lowuser = addslashes($touser);
				$highuser = $this->user['username_slash'];
				$direct = 1; // high->low
			} else {
				$lowid = $this->user['uid'];
				$highid = $touid;
				$lowuser = $this->user['username_slash'];
				$highuser = addslashes($touser);
				$direct = 0; // low->high
			}
			$this->db->query("INSERT INTO my_hello SET lowid='$lowid', highid='$highid', lowuser='$lowuser', highuser='$highuser', direct='$direct', typeid='$typeid', dateline='$dateline', uid='$touid', new='1'");
			$this->eventmodel->increase_event($touid, "new_hello");
			if($helloid) {
				$this->db->query("UPDATE my_hello SET new='0' WHERE helloid='$helloid'");
				if($this->db->affected_rows()) {
					$this->eventmodel->decrease_event($this->user['uid'], "new_hello");
				}
			}
			$arr = array();
			$this->message('кɹ');
		}
	}

	public function delete() {
		$helloid = intval(getgpc('2'));
		if($this->hellomodel->delete_hello($helloid, $this->user['uid'])) {
			$this->message('ɾɹ', XIUNO_HOST_MY.'hello-ls.htm');
		} else {
			$this->message("Ϣѱɾ", XIUNO_HOST_MY.'hello-ls.htm', array('error'=>1));
		}
	}

	public function history() {
		$ppp = 50;
		$data = $this->db->fetch_all("SELECT * FROM my_hello WHERE lowid='{$this->user['uid']}' LIMIT $ppp", 'helloid')+
		$this->db->fetch_all("SELECT * FROM my_hello WHERE highid='{$this->user['uid']}' LIMIT $ppp", 'helloid');
		$avatars = array($this->user['uid']=>$this->get_avatar($this->user['uid'], 'small'));
		require XIUNO_ROOT.'config/hello.php';
		foreach ($data as &$hello) {
			$hello['fromuid'] = $hello['direct'] == 1 ? $hello['highid'] : $hello['lowid'];
			$fromuser = $hello['direct'] == 1 ? "<a href='".XIUNO_HOST_MY.'index-index-'.$hello['highid'].".htm' target='_blank'/>".$hello['highuser']."</a>"
			: "<a href='".XIUNO_HOST_MY.'index-index-'.$hello['lowid'].".htm' target='_blank'/>".$hello['lowuser']."</a>";
			$touser = $hello['direct'] == 1 ? "<a href='".XIUNO_HOST_MY.'index-index-'.$hello['lowid'].".htm' target='_blank'/>".$hello['lowuser']."</a>"
			: "<a href='".XIUNO_HOST_MY.'index-index-'.$hello['highid'].".htm' target='_blank'/>".$hello['highuser']."</a>";
			$message = $helloconfig[$hello['typeid']]['message'];
			$hello['message'] = str_replace(array('{from}', '{to}'), array($fromuser, $touser), $message);
			$hello['icon'] = "<img src='".XIUNO_HOST_IMAGE."image/hello/hello_".$hello['typeid'].".gif' />";
		/*	if(!empty($avatars[$hello['fromuid']])) {
				//$hello['fromavatar'] = $avatars[$hello['fromuid']];
			}else {
				//$avatars[$hello['fromuid']] = $this->get_avatar($hello['fromuid'], 'small');
				//$hello['fromavatar'] = $avatars[$hello['fromuid']];
			}
			if(!empty($avatars[$hello['uid']])) {
				//$hello['toavatar'] = $avatars[$hello['uid']];
			}else {
				//$avatars[$hello['uid']] = $this->get_avatar($hello['uid'], 'small');
				//$hello['toavatar'] = $avatars[$hello['uid']];
			}*/
			$hello['dateline'] = $this->date($hello['dateline']);
		}
		krsort($data);
		$this->view->assign('hellolist', $data);
		$this->view->assign('avatar', $avatars[$this->user['uid']]);
		$this->view->display('my_hello');
	}

}