<?php

!defined('XIUNO_ROOT') && exit;

class control extends _control {

	function __construct() {
		parent::__construct();
	}
	
	function __call($_, $__) {
		$this->index();
	}
	
	public function index() {
		$uid = getgpc('uid') ? getgpc('uid') : getgpc(2);
		$username = getgpc('username');
		if(empty($uid) && empty($username)) {
			$this->self = true;
			$uid = $this->user['uid'];
		} else {
			empty($uid) && $uid = $this->usermodel->get_uid_by_username($username);
			$this->self = false;
		}
		$this->uid = $uid;
		$this->init_vuser($uid);
		
		$this->vuser['groupname'] = $this->db->result_first("SELECT name FROM www_group WHERE groupid='{$this->vuser['groupid']}'");
		
		$this->navs[] = $this->self ? 'ҵĿռ' : $this->vuser['username'].'Ŀռ';
		
		// ǰ,ʾϽ.
		$moderatorinfo = array();
		if($this->vuser['groupid'] == XIUNO_SUPER_MODERATOR_GROUPID) {
			$moderatorinfo[] = 'а';
		} else if($this->vuser['groupid'] == XIUNO_MODERATOR_GROUPID){
			$fids =  $this->db->fetch_all("SELECT fid FROM bbs_moderator WHERE uid='$this->uid'", 'fid');
			$forums = $this->cache('forums');
			foreach($fids as $fid=>$__){
				$moderatorinfo[] = "<a href=\"".XIUNO_HOST_BBS."forum-index-".$fid.".htm\" target=\"_blank\">".$forums[$fid]['name']."</a>";
			}
		}
		
		// ѫ
		$medallist = $this->medalmodel->get_medal_list_by_int($this->vuser['medallist']);
		
		// 
		if($this->vuser['moodid']) {
			$mood = $this->db->fetch_first("/*cachelife=3600&mckey=moodid_{$this->vuser['moodid']}*/ SELECT * FROM my_mood WHERE moodid='{$this->vuser['moodid']}'");
			if($mood['message']) {
				$this->vuser['mood'] = $mood['message'];
				$this->vuser['mooddate'] = $this->date($mood['dateline']);
			} else {
				$this->vuser['mood'] = '';
				$this->vuser['mooddate'] = '';
			}
		}
		
		// feed
		$feedlist = $this->feedmodel->get_feed_by_page($this->vuser['uid'], 1, XIUNO_PPP, 1);
		
		// ԰
		// ظбùģ
		$page = max(1, intval(getgpc('page')));
		$this->replymodel->get_replylist_by_page('user', $this->vuser['uid'], $this->vuser['replies'], $page);
		
		// ÿ
		$visitorlist = array();
		if(XIUNO_MY_VISITOR_ON) {
			if($this->self) {
				$visitorids = $this->recentmodel->get_recent('home', $this->vuser['uid']);
			} else {
				if($this->user['uid']) {
					$visitorids = $this->recentmodel->update_recent('home', $this->vuser['uid'], $this->user['uid']);
				} else {
					$visitorids = $this->recentmodel->get_recent('home', $this->vuser['uid']);
				}
			}
		}
		$visitorlist = $this->db->fetch_all_by_ids('www_userfield', 'uid', 'uid, username, avatar', $visitorids);
		
		foreach($visitorlist as &$v) {
			$this->usermodel->format_user($v);
			$v['usernamecut'] = $this->xiuno_substr($v['username'], 10);
		}
		
		// б
		$friendids = $this->friendmodel->get_friendids_by_uid($this->uid, 15);
		$friendlist = $this->db->fetch_all_by_ids('www_userfield', 'uid', 'uid, username, avatar', $friendids);
		foreach($friendlist as &$v) {
			$this->usermodel->format_user($v);
			$v['usernamecut'] = $this->xiuno_substr($v['username'], 10);
		}
		
		// ҳ
		if(XIUNO_MY_HOMEVIEWS_ON) {
			if(!$this->self) {
				// һηʣ߹
				define('XIUNO_HOME_VIEW_EXPIRATION', 180);
				$visited_array = explode(',', getgpc('visitedhomes', 'C'));
				$visiteddata = '';
				$visiteduids = array();
				foreach($visited_array as $v) {
					list($vuid, $expiration) = explode('_', $v);
					if($expiration > $this->time) {
						$visiteddata .= $vuid.'_'.$expiration.',';
						$visiteduids[$vuid] = $vuid;
					}
				}
				$visiteddata = strlen($visiteddata) ? substr($visiteddata, 0, -1) : '';
				if(empty($visiteduids[$user['uid']])) {
					$this->db->query("/*primarykey=uid&delaycol=homeviews*/ UPDATE www_user SET homeviews=homeviews+'1' WHERE uid='{$this->visited['uid']}'");
					$visiteddata .= ($visiteddata ? ',' : '').$user['uid'].'_'.($this->time + XIUNO_HOME_VIEW_EXPIRATION);
				}
				$this->setcookie('visitedhomes', $visiteddata, XIUNO_COOKIE_KEEP_TIME);
			}
		}
		
		$this->view->assign('visitorlist', $visitorlist);
		$this->view->assign('friendlist', $friendlist);
		$this->view->assign('multipage', $multipage);
		$this->view->assign('totalnotes', $totalnotes);
		$this->view->assign('feedlist', $feedlist);
		$this->view->assign('noticelist', $noticelist);
		$this->view->assign('medallist', $medallist);
		$this->view->assign('moderatorinfo',$moderatorinfo);
		$this->view->assign('vuser', $this->vuser);
		$this->view->display('my_index');
	}
	
	// 
	public function mood() {
		$this->init_vuser();
		$this->check_login();
		$mood = trim(htmlspecialchars(getgpc('mood', 'P')));
		if(empty($mood)) {
			$this->message("д", '', array('error'=>1));
		}
		$this->db->query("INSERT INTO my_mood SET uid='{$this->user['uid']}', message='$mood', dateline='$this->time'");
		$moodid = $this->db->insert_id();
		$this->db->query("/*primarykey=uid*/ UPDATE www_user SET moodid='$moodid' WHERE uid='{$this->user['uid']}'");
		$mood = $this->xiuno_substr($mood, 100);
		$this->feedmodel->add_feed(array('uid'=>$this->user['uid'], 'username'=>$this->user['username'], 'mood'=>stripslashes($mood)), 'mood', $this->time, $this->user['uid']);
		$this->message($mood);
	}

	// ʷ
	public function moodhistory() {
		$this->init_vuser();
		$uid = getgpc('uid') ? getgpc('uid') : $this->user['uid'];
		$page = max(1, getgpc('page'));
		$ppp = 16;
		$start = ($page-1) * $ppp;
		$totalnum = $this->db->result_first("SELECT COUNT(*) FROM my_mood WHERE uid='$uid'");
		$moodlist = $this->db->fetch_all("SELECT * FROM my_mood WHERE uid='{$uid}' ORDER BY `moodid` DESC LIMIT $start,$ppp");
		$multipage = $this->page($totalnum, $ppp, $page, XIUNO_HOST_MY.'index-moodhistory.htm?uid='.$uid.'&menuid='.getgpc('menuid'), NULL, getgpc('menuid')."body");
		foreach($moodlist as &$mood) {
			$mood['dateline'] = $this->date($mood['dateline']);
		}
		$this->view->assign('multipage', $multipage);
		$this->view->assign('moodlist', $moodlist);
		$this->view->display('my_mood');
	}

	// ɾ
	public function mooddelete() {
		$this->init_vuser();
		$moodid = intval(getgpc(2));
		if($this->db->result_first("SELECT uid FROM my_mood WHERE moodid='$moodid'") == $this->user['uid']) {
			$this->db->query("/*primarykey=moodid*/ DELETE FROM my_mood WHERE moodid='$moodid'");
			$this->message('ɾɹ');
		}
		$this->message('ɾ˵', '', array('error'=>1));

	}

	// ajaxfeedϢ
	public function ajaxinfo() {
		$this->init_vuser();
		$action = getgpc('action');
		$uid = $this->user['uid'];
		if($action == 'hello') {
			require XIUNO_ROOT.'config/hello.php';
			$hellolist = $this->hellomodel->get_hello_by_page($this->user['uid'], 1, XIUNO_PPP);
			foreach($hellolist as &$hello) {
				$hello['fromuid'] = $hello['direct'] == 1 ? $hello['highid'] : $hello['lowid'];
				$fromuser = $hello['direct'] == 1 ? "<a href='".XIUNO_HOST_MY."index-index-$hello[highid].htm\" target='_blank'/>".$hello['highuser']."</a>"
				: "<a href='".XIUNO_HOST_MY."index-index-$hello[lowid].htm' target='_blank'/>".$hello['lowuser']."</a>";
				$message = $helloconfig[$hello['typeid']]['message'];
				$hello['message'] = str_replace(array('{from}', '{to}'), array($fromuser, $touser), $message);
				$hello['dateline'] = $this->date($hello['dateline']);
				$hello['icon'] = "<img src='".XIUNO_HOST_MY."image/hello/hello_".$hello['typeid'].".gif' />";
			}
			$this->view->assign('hellolist', $hellolist);
			$this->view->display('ajax_header');
			$this->view->display('my_index_hello');
			$this->view->display('ajax_footer');
		} else {
			$own = $action == 'own' ? 1 : 0;
			$feedlist = $this->feedmodel->get_feed_by_page($uid, 1, XIUNO_PPP, $own);
			$this->view->assign('feedlist', $feedlist);
			$this->view->assign('own', $own);
			
			$this->view->display('ajax_header');
			$this->view->display('my_index.feedbody');
			$this->view->display('ajax_footer');
		}
	}

}