<?php

!defined('XIUNO_ROOT') && exit;

class control extends _control {

	function __construct() {
		parent::__construct();
		$this->init_vuser();
	}

	// ajax ԰巭ҳ
	public function ajaxls() {
		$modulename = getgpc(2);
		$moduleid = intval(getgpc(3));
		$totalnum = intval(getgpc('totalnum'));
		if(empty($totalnum)) {
			$totalnum = $this->replymodel->get_totalnum_by_moduleid($moduleid);
		}

		// ظбùģ
		$this->replymodel->get_replylist_by_page($modulename, $moduleid, $totalnum, max(1, intval(getgpc('page'))));
		
		$this->view->display('ajax_header');
		$this->view->display('my_reply.pagebody');
		$this->view->display('ajax_footer');
	}

	function add() {
		$this->check_login();
		
		$modulename = getgpc(2);
		$moduleid = getgpc(3);
		$message = nl2br(htmlspecialchars(getgpc('message', 'P')));
		if(empty($message)) {
			$this->message('ݲΪ', '', array('error'=>1));
		}
		
		$module	 = $this->replymodel->get_module_by_moduleid($modulename, $moduleid);
		if(empty($module)) {
			$this->message('־', '', array('error'=>1));
		}
		
		$replyid = $this->replymodel->add_reply($modulename, $moduleid, $message, $this->user['uid'], $this->user['username'], $module['uid']);
		
		if(empty($replyid)) {
			$this->message('ʧ', '', array('error'=>1));
		}
		$avatar  = $this->get_avatar($this->user['uid'], 'small');
		
		$reply = array(
			'replyid'=>$replyid, 
			'avatar_small'=>$avatar, 
			'uid'=>$this->user['uid'], 
			'username'=>$this->user['username'], 
			'dateline'=>'ղ', 
			'message'=>$message
		);
		
		/*if($modulename == 'blog') {
			$message = $this->xiuno_substr($message, 60);
			if($this->user['uid'] != $module['uid']) {
				$this->noticemodel->add_notice($this->user['uid'], $this->uid, $this->user['username'], $this->vuser['username'], array('blogid'=>$module['blogid'], 'subject'=>$module['subject'], 'message'=>$message, ), 'blogreply');
			}
		}
		*/
		$this->view->assign('reply', $reply);
		$this->view->assign_value('modulename', $modulename);
		$this->view->assign_value('moduleid', $moduleid);
		$this->view->display('ajax_header');
		$this->view->display('my_reply.row');
		$this->view->display('ajax_footer');
	}

	function delete() {
		
		$this->check_login();
		
		$modulename = getgpc(2);
		$moduleid = getgpc(3);
		$replyid = getgpc(4);
		
		if(empty($replyid)) {
			$this->message('ָID', '', array('error'=>10001));
		}
		$reply = $this->replymodel->get_reply_by_replyid($modulename, $replyid);
		list($replytable, $moduletable, $modulekey) = $this->replymodel->get_tablename_by_module($modulename);
		if(empty($reply)) {
			$this->message('ԲڣѾɾ', '', array('error'=>10002));
		}
		
		if($this->replymodel->delete_reply_by_replyid($modulename, $reply[$modulekey], $replyid)){
			$this->message('ɾɹ');
		} else {
			$this->message('ûɾȨ', '', array('error'=>10003));
		}
	}
}	