<?php

!defined('XIUNO_ROOT') && exit;

class control extends _control {

	function __construct() {
		parent::__construct();
		$this->set_navcheck('www');
		$this->navs[] = '<a href="'.XIUNO_HOST_WWW.'guestbook-index.htm">԰</a>';
		$this->needseccode = TRUE;
	}
	
	public function index() {
		$page = max(1, intval(getgpc(2)));
		$ppp = XIUNO_PPP;
		$start = ($page - 1) * $ppp;
		$notelist = $this->db->fetch_all("SELECT * FROM www_guestbook ORDER BY noteid DESC LIMIT $start,$ppp");
		$total = getgpc($total) ? getgpc($total) : $this->db->result_first("SELECT COUNT(*) FROM www_guestbook");
		$multipage = $this->page($total, $ppp, $page, XIUNO_HOST_WWW.'guestbook-index.htm?total='.$total);
		$uids = array();
		foreach($notelist as &$note) {
			$note['dateline'] = $this->date($note['dateline']);
			$note['admindateline'] = $this->date($note['admindateline']);
			$note['userip'] = long2ip($note['userip']);
			$uids[] = $note['uid'];
			$note_visible = !$note['adminonly'] || $this->group['type'] == 1 || $this->user['uid'] == $note['uid'];
			!$note_visible && $note['message'] = 'Խɼ';
		}
		$avatarlist = $this->get_avatars($uids, 'small');
		$this->view->assign('avatarlist', $avatarlist);
		$this->view->assign('notelist', $notelist);
		$this->view->assign('multipage', $multipage);
		$this->view->display('www_guestbook');
	}
	
	public function add() {
		if($this->submitcheck()) {
			$this->seccodecheck();
			$message = htmlspecialchars(getgpc('message', 'P'));
			$adminonly = intval(getgpc('adminonly', 'P'));
			$uid = $this->user['uid'];
			$username = $this->user['username'] ? $this->user['username_slash'] : htmlspecialchars(getgpc('username', 'P'));
			$this->db->query("INSERT INTO www_guestbook SET uid='$uid', username='$username', dateline='{$this->time}', userip='{$this->ip}',message='$message', adminonly='$adminonly'");
			$this->message('ɹ', XIUNO_HOST_WWW.'guestbook.htm');
		} else {
			$this->message('Ƿʡ');
			exit;
		}
	}
	
	public function reply() {
		$noteid = intval(getgpc('2'));
		if($this->group['type'] != 1) {
			$this->message('ǹԱûлظȨ');
		}
		if(!$this->submitcheck()) {
			$note = $this->db->fetch_first("SELECT * FROM www_guestbook WHERE noteid='$noteid'");
			$this->view->assign('note', $note);
			$this->view->assign('noteid', $noteid);
			$this->view->display('www_guestbook_reply');
		} else {
			$reply = htmlspecialchars(getgpc('rely_message', 'P'));
			$this->db->query("UPDATE www_guestbook SET adminmessage='$reply', adminuid='{$this->user['uid']}', adminuser='{$this->user['username_slash']}', admindateline='{$this->time}' WHERE noteid='$noteid'");
			$this->message("ظɹ");
		}
	}
	
	public function delete() {
		$noteid = intval(getgpc('2'));
		if($this->group['type'] != 1) {
			$this->message('ǹԱûɾȨ', '', array('error'=>1));
		}
		$this->db->query("DELETE FROM www_guestbook WHERE noteid='$noteid'");
		$this->message('ɾɹ', '', array('error'=>0));
	}
}
?>