<?php

!defined('XIUNO_ROOT') && exit;

class control extends _control {
	// sqlserver->mysqlserver
	function __construct() {
		parent::__construct();
		/* TODO У KEY */
		//$key = getgpc('key');
		
		// TODO:
		exit;
	}

	// mysql
	public function mysqlqueue() {
		$s = file_get_contents(XIUNO_ROOT.'data/tmp/mysql_queue.sql');
		echo $this->rsyncmodel->encode($s);
		is_file(XIUNO_ROOT.'data/tmp/mysql_queue.sql.bak') && unlink(XIUNO_ROOT.'data/tmp/mysql_queue.sql.bak');
		rename(XIUNO_ROOT.'data/tmp/mysql_queue.sql', XIUNO_ROOT.'data/tmp/mysql_queue.sql.bak');
		touch(XIUNO_ROOT.'data/tmp/mysql_queue.sql');
	}

	public function mysqlqueuecomplete() {
		unlink(XIUNO_ROOT.'data/tmp/mysql_queue.sql.bak');
		echo 'TRUE';
	}

	// ļͬ
	public function setting() {
		$file = getgpc('file');
	}

	// . ˷webgetwebload getsqlload õ,ʾ
	public function monitor() {
		$key = '';
		$webinfo = $sqlinfo = array();
		foreach($this->webserver as $web) {
			if($web == $_SERVER['HTTP_HOST']) {
				$webinfo[$web] = $this->getwebload(0);
			} else {
				$url = $web.'rsync-getwebload.htm?key='.$key;
				$webinfo[$web] = unserialize($this->rsyncmodel->decode(file_get_contents($url)));
			}
		}
		$sqlinfo = $this->get_sql_load();

		/*
		$this->view->assign('sqlinfo', $sqlinfo);
		$this->view->assign('webinfo', $webinfo);
		$this->view->display('www_monitor');
		*/
	}

	// $format = 1 Ϊⲿ, ʽΪ̶ʽ
	// $format = 0 Ϊڲ, øʽ
	public function getwebload($format = 1) {
		$data = array();
		$data['loadavg'] = $this->get_loadavg();
		$data['meminfo'] = $this->get_meminfo();
		$data['cpuusage'] = $this->get_cpu_use();
		$data['diskusage'] = $this->get_disk_use();
		if(!$format) {
			return $data;
		} else {
			echo $this->rsyncmodel->encode(serialize($data));
			return false;
		}
	}

	private function get_sql_load() {
		$sqlload = array();
		foreach ($this->sqlserver as $sqlserver) {
			$db = new db();
			$db->connect($sqlserver, XIUNO_DBUSER, XIUNO_DBPW, XIUNO_DBNAME, XIUNO_DBCHARSET);
			$sqlload[$sqlserver] = $this->get_sqlserver_info($db);
		}
		return $sqlload;
	}

	private function get_sqlserver_info($db) {
		$info = array();
		$row = $db->fetch_first("show VARIABLES like '%key_buffer_size%'");
		$info['key_buffer'] = $row['Value'];

		$row = $db->fetch_first("show VARIABLES like '%key_cache_block_size%'");
		$info['block_size'] = $row['Value'];

		$data = $db->fetch_all("show processlist");
		$info['processes'] = count($data);
		$data = $db->fetch_all("show status", 'Variable_name');

		//  key_buffer δʹ
		$info['Key_blocks_unused'] = $data['Key_blocks_unused']['Value'];

		// ʹ˶ key_buffer
		$info['Key_blocks_used'] = $data['Key_blocks_used']['Value'];

		// еһĴϸߣִдȫɨ裻磬SELECT col1 FROM fooٶcol1
		$info['Handler_read_first'] = $data['Handler_read_first']['Value'];

		//ݼһеϸߣ˵ѯͱȷ
		$info['Handler_read_key'] = $data['Handler_read_key']['Value'];

		// ݹ̶λöһеִдѯҪԽֵϸߡʹ˴ҪMySQLɨĲѯûȷʹü
		$info['Handler_read_rnd'] = $data['Handler_read_rnd']['Value'];

		// ܲѯ
		$info['Queries'] = $data['Queries']['Value'];

		// 
		$info['Connections'] = $data['Connections']['Value'];

		// ڱڸһе
		$info['Handler_update'] = $data['Handler_update']['Value'];

		// ڱڲһе
		$info['Handler_write'] = $data['Handler_write']['Value'];

		// ӻݿ
		$info['Key_read_requests'] = $data['Key_read_requests']['Value'];

		// Ӳ̶ȡݿĴKey_readsϴKey_buffer_sizeֵ̫СKey_reads/Key_read_requests㻺ʧʡ
		$info['Key_reads'] = $data['Key_reads']['Value'];

		// Ӳд뽫ݿдĴ
		$info['Key_writes'] = $data['Key_writes']['Value'];

		// ݿд뻺
		$info['Key_write_requests'] = $data['Key_write_requests']['Value'];

		// Ѿͬʱʹõӵ
		$info['Max_used_connections'] = $data['Max_used_connections']['Value'];

		$info['Table_locks_immediate'] = $data['Table_locks_immediate']['Value'];

		$info['Table_locks_waited'] = $data['Table_locks_waited']['Value'];
		$info['Slow_queries'] = $data['Slow_queries']['Value'];
		$info['Uptime'] = $data['Uptime']['Value'];

		return $info;
	}

	public function get_loadavg() {
		$return = array();
		$loadavg = explode(' ', file_get_contents('/proc/loadavg'));
		$return['last1'] = $loadavg[0];
		$return['last5'] = $loadavg[1];
		$return['last15'] = $loadavg[2];
		$return['process'] = current(explode('/', $loadavg[3]));
		return $return;
	}

	private function get_meminfo() {
		$return = array();
		$meminfo = explode("\n", file_get_contents('/proc/meminfo'));
		$return['total'] = preg_replace('/[^\d]/', '', $meminfo[0]);
		$return['free'] = preg_replace('/[^\d]/', '', $meminfo[1]) + preg_replace('/[^\d]/', '', $meminfo[2]) + preg_replace('/[^\d]/', '', $meminfo[3]);
		$return['usage'] = sprintf('%.2f', $return['free'] / $return['total'] * 100).'%';
		return $return;
	}

	private  function get_cpu_use() {
		$return = exec('top -b -p 1 -n 1 | grep Cpu | awk \'{print $2}\'');
		return preg_replace('/[^\d\.%]/', '', $return);
	}

	/*Array ( 	[0] => Filesystem 	Size 	Used	 Avail	 Use% 	Mounted on
	[1] => /dev/hda1 	69G 	62G 	3.4G 	95% 	/
	[2] => tmpfs 		982M 	0 	982M	 0% 	/dev/shm
	[3] => /dev/hdc1 	151G 	20G 	123G 	14% 	/data2/mysql )
	*/
	private function get_disk_use() {
		$fp = exec('df -h', $output);
		$lenth = count($output);
		$return = array('size'=>0, 'used'=>0, 'usage'=>'');
		for($i=1; $i<$lenth; $i++) {
			$data = explode(' ', preg_replace('/\s+/', ' ',  $output[$i]));
			$return['size'] += $this->get_size_by_unit($data[1]);
			$return['used'] += $this->get_size_by_unit($data[2]);
		}
		$return['usage'] = sprintf('%.2f', $return['userd'] / $return['size'] * 100).'%';
		return $return;
	}

	//	  1G ת 1024M
	private function get_size_by_unit($string) {
		$num = substr($string, 0, -1);
		$unit = substr($string, -1);
		if($unit == 'G') {
			return $num * 1024;
		} else if($unit == 'M'){
			return $num;
		}
	}

}
?>