<?php

/*
	[Xiuno] (C)2008-2009
	This is NOT a freeware, use is subject to license terms

	$RCSfile: index.php,v $
	$Revision: 1.0 $
	$Date: 2009/05/5 14:36:00 $
	$Author: heyond $
*/

define('XIUNO_DEBUG', 0);

function getgpc($k, $var = 'G') {
	switch($var) {
		case 'G': $var = &$_GET; break;
		case 'P': $var = &$_POST; break;
		case 'C': $var = &$_COOKIE; break;
		case 'R': $var = &$_REQUEST; break;
		case 'V': $var = &$_SERVER; break;
	}
	return isset($var[$k]) ? $var[$k] : NULL;
}

function getvalue(&$data, $default='') {
	$data = isset($data) ? $data : $default;
	return $data;
}

function xiuno_addslashes(&$var) {
	if(is_array($var)) {
		foreach($var as $k=>&$v) {
			xiuno_addslashes($v);
		}
	} else {
		$var = addslashes($var);
	}
}

// 浽ȫֱڳʱxiuno_shutdown_handle()Ϣ
function xiuno_error_handle($errno, $errstr, $errfile, $errline) {
	if(strpos($errstr, 'Non-static method') !== FALSE) {
		return;
	}
	$s = "URL:".$_SERVER['REQUEST_URI']."<br />\r\n";
	//$s .= "Rrrorno:".$errno."<br />\r\n";
	$s .= "<b>Error:</b>".$errstr."<br />\r\n";
	$s .= "<b>File:</b>".$errfile.' ';
	$s .= "<b>Line:</b>".$errline."<br />\r\n";
	$s .= "\r\n------------------------------------<br />\r\n";
	empty($_SERVER['XIUNO_ERROR']) && $_SERVER['XIUNO_ERROR'] = '';
	$_SERVER['XIUNO_ERROR'] .= addslashes($s);
}

/*
	$_GET ¸ʽ
	$_SERVER['REQUEST_URI'] Ϊ¸ʽRewrite
	/mybbs/?bbs-thread-index-123.htm
	/mybbs/?bbs-thread-index-123.htm?styleid=2&refer=http%3A%2F%2Fwww.domain.com%2Fmybbs%2Fthread-index-123.htm%3Fa%3Db
	/mybbs/?www-user-info-1.htm&menuid=menu1&nexturl=http%3A//localhost/xiuno4.0/image/common/noavatar.gif%3Fupdate%3D0
	/mybbs/bbs-thread-index-123.htm
	/mybbs/bbs-thread-index-123.htm?styleid=2&refer=http%3A%2F%2Fwww.domain.com%2Fmybbs%2Fthread-index-123.htm%3Fa%3Db
	
	      |<-------$s1------->|     |<----------------------------$s2----------------------------------------------->|
*/
function xiuno_parse_requesturl($requesturl, &$get) {
	
	$requesturl = str_replace('/index.php', '/', $requesturl);
	$requesturl = str_replace('/?', '/', $requesturl);
	$requesturl = str_replace('.htm?', '?', $requesturl);
	
	$sep = strrpos($requesturl, '?');
	if($sep !== FALSE) {
		$s1 = substr($requesturl, 0, $sep);
		$s2 = substr($requesturl, $sep + 1);
	} else {
		$s1 = $requesturl;
		$s2 = '';
	}
	
	$s1 = str_replace('.htm', '', $s1);
	$sep = strrpos($s1, '/');
	if($sep !== FALSE) {
		$s1 = substr($s1, $sep + 1);
	}
	
	$arr1 = explode('-', $s1);
	if(count($arr1)) {
		$get['domain'] = addslashes($arr1[0]);
		array_shift($arr1);
	}
	parse_str($s2, $arr2);
	xiuno_addslashes($arr1);
	$get += $arr1;
	$get += $arr2;
	
	$get['m'] = isset($get[0]) && preg_match("/^\w+$/", $get[0]) ? $get[0] : 'index';
	$get['a'] = isset($get[1]) && preg_match("/^\w+$/", $get[1]) ? $get[1] : 'index';
}

error_reporting(XIUNO_DEBUG ? E_ALL : 0);

XIUNO_DEBUG && set_error_handler("xiuno_error_handle");

$starttime = microtime(1);

// 
define('XIUNO_IN_LOCAL', $_SERVER['REMOTE_ADDR'] == '127.0.0.1' || substr($_SERVER['REMOTE_ADDR'], 0, 7) == '192.168');

// ȫֳ
define('XIUNO_ROOT', str_replace('\\', '/', getcwd()).'/');
define('XIUNO_CONFIG_FILE', XIUNO_ROOT.'config/global.php');

set_magic_quotes_runtime(0);

date_default_timezone_set('Etc/GMT+8');

PHP_VERSION < '5.0' && exit('Required PHP version 5.0.* or later.');

// 

unset($GLOBALS, $_ENV, $HTTP_GET_VARS, $HTTP_POST_VARS, $HTTP_COOKIE_VARS, $HTTP_SERVER_VARS, $HTTP_ENV_VARS);

$_GET = array();

$_SERVER['starttime'] = $starttime;

// ʼ $_GET ---------------------------> start

// IIS $_SERVER['REQUEST_URI']
if(!isset($_SERVER['REQUEST_URI'])) {
	if(isset($_SERVER['HTTP_X_REWRITE_URL'])) {
		$_SERVER['REQUEST_URI'] = $_SERVER['HTTP_X_REWRITE_URL'];
	} else if(isset($_SERVER['HTTP_REQUEST_URI'])) {
		$_SERVER['REQUEST_URI'] = $_SERVER['HTTP_REQUEST_URI'];
	} else {
		if(isset($_SERVER['SCRIPT_NAME'])) {
			$_SERVER['HTTP_REQUEST_URI'] = $_SERVER['SCRIPT_NAME'];
		} else {
			$_SERVER['HTTP_REQUEST_URI'] = $_SERVER['PHP_SELF'];
		}
		if($_SERVER['QUERY_STRING']) {
			$_SERVER['HTTP_REQUEST_URI'] .= '?' . $_SERVER['QUERY_STRING'];
		}
		$_SERVER['REQUEST_URI'] = $_SERVER['HTTP_REQUEST_URI'];
	}
}

xiuno_parse_requesturl($_SERVER['REQUEST_URI'], $_GET);

//  HTTP ͷ
header('Content-Type: text/html; charset=GBK');

// runtime ļϲ includeЧ
if(XIUNO_DEBUG) {
	include XIUNO_ROOT.'config/global.php';
	include XIUNO_ROOT.'config/db.php';
	include XIUNO_ROOT.'config/bbs.php';
	include XIUNO_ROOT.'config/constant.php';
	include XIUNO_ROOT.'lib/db.class.php';
	include XIUNO_ROOT.'lib/template.class.php';
	include XIUNO_ROOT.'control/base.php';
} else {
	// ͬ϶
	$content = '';
	if($_GET['domain'] == 'bbs') {
		$runtime = XIUNO_ROOT.'data/cache/_runtime_bbs.php';
	} else {
		$runtime = XIUNO_ROOT.'data/cache/_runtime.php';
	}
	if (!is_file($runtime)) {
		$content .= php_strip_whitespace(XIUNO_ROOT.'config/global.php');
		$content .= php_strip_whitespace(XIUNO_ROOT.'config/db.php');
		$content .= php_strip_whitespace(XIUNO_ROOT.'config/bbs.php');
		$content .= php_strip_whitespace(XIUNO_ROOT.'config/constant.php');
		$content .= php_strip_whitespace(XIUNO_ROOT.'lib/db.class.php');
		$content .= php_strip_whitespace(XIUNO_ROOT.'lib/template.class.php');
		$content .= php_strip_whitespace(XIUNO_ROOT.'control/base.php');
		if($_GET['domain'] == 'bbs') {
			$content .= php_strip_whitespace(XIUNO_ROOT.'control/bbs/_control.php');
			$content .= php_strip_whitespace(XIUNO_ROOT.'model/forummodel.php');
			$content .= php_strip_whitespace(XIUNO_ROOT.'model/threadmodel.php');
			$content .= php_strip_whitespace(XIUNO_ROOT.'model/tidcachemodel.php');
			$content .= php_strip_whitespace(XIUNO_ROOT.'model/topmodel.php');
			$content .= php_strip_whitespace(XIUNO_ROOT.'data/cache/groups.php');
		}
		file_put_contents($runtime, $content);
	}
	include $runtime;
}

// ʼ $_GET ---------------------------> end
if(empty($_GET['inajax'])) {
	ob_start('gz_handle');
} else {
	ob_start();
}

// װʱ rewrite
if(getgpc('_checkrewrite_')) {
	die('ok');
}

if(!XIUNO_INSTALLED) {
	header('Location:install/');
}

//  GPC
$get_magic_quotes_gpc = get_magic_quotes_gpc();
if(!$get_magic_quotes_gpc) {
	xiuno_addslashes($_GET);
	xiuno_addslashes($_POST);
	xiuno_addslashes($_COOKIE);
}

// ʼ $_COOKIE['styleid']
$styleid = intval(isset($_GET['styleid']) ? $_GET['styleid'] : getgpc('styleid', 'C'));
if(!@include(XIUNO_ROOT.'config/style_'.$styleid.'.php')) {
	$styleid = XIUNO_STYLEID;
	include(XIUNO_ROOT.'config/style_'.$styleid.'.php');
}

// 浽 cookie
if($styleid != $_COOKIE['styleid']) {
	setcookie('styleid', $styleid, 864000 + time(), '/', XIUNO_COOKIE_DOMAIN);
}
$_COOKIE['styleid'] = $styleid;

//  $_GET[m] Ӧģ飬ҵ $_GET[a]()
!defined('control/bbs/_control.php') && include XIUNO_ROOT.'control/'.$_GET['domain'].'/_control.php';
if(include XIUNO_ROOT.'control/'.$_GET['domain'].'/'.$_GET['m'].'.php') {
	$control = new control();

	if(method_exists($control, $_GET['a'])) {
		$r = new ReflectionMethod($control, $_GET['a']);
		if(($r->getDeclaringClass()->name == 'base' && $_GET['a'] != 'message') || $r->isProtected() || $r->isPrivate() ) {
			exit('forbidden');
		} else {
 			$control->$_GET['a']();
		}
	} else {
		$control->__call($_GET['a'], NULL);
	}
} else {
	//  http://xxx.domain.com/  xxx Ϊ
	header('Location:'.XIUNO_HOST_BBS.'index.htm');
	//exit(XIUNO_ROOT.'control/'.$_GET['domain'].'/'.$_GET['m'].'.php does not exists!');
}
?>