<?php

function getgpc($k, $var='G') {
	switch($var) {
		case 'G': $var = &$_GET; break;
		case 'P': $var = &$_POST; break;
		case 'C': $var = &$_COOKIE; break;
		case 'R': $var = &$_REQUEST; break;
		case 'V': $var = &$_SERVER; break;
	}
	return isset($var[$k]) ? $var[$k] : NULL;
}

function get_env(&$env, &$ini, &$func, &$write, &$uploadwrite) {
	$env['php_version']['current'] = PHP_VERSION;
	$env['php_version']['need'] = '5.0';
	$env['php_version']['status'] = PHP_VERSION >= 5;
	$arr = array();
	preg_match('/\w+/', $_SERVER['SERVER_SOFTWARE'], $arr);
	$env['web_server']['current'] = $arr[0];
	$env['web_server']['need'] = '';
	$env['web_server']['status'] = TRUE;

	$gd_info = gd_info();
	preg_match('/\d(?:.\d)+/', $gd_info['GD Version'], $arr);
	$gd_version = $arr[0];
	$env['gd_version']['current'] = $gd_version;
	$env['gd_version']['need'] = '1.0';
	$env['gd_version']['status'] = $gd_version >= 1;

	$ini['short_open_tag']['status'] = ini_get('short_open_tag');
	$ini['short_open_tag']['need'] = 'On';
	$ini['short_open_tag']['current'] = $ini['short_open_tag']['status'] ? 'On' : 'Off';
	
/*	$ini['register_globals']['status'] = !ini_get('register_globals');
	$ini['register_globals']['need'] = 'Off';
	$ini['register_globals']['current'] = $ini['short_open_tag']['status'] ? 'Off' : 'On';
	
	$ini['magic_quotes_gpc']['status'] = get_magic_quotes_gpc();
	$ini['magic_quotes_gpc']['need'] = 'On';
	$ini['magic_quotes_gpc']['current'] = $ini['magic_quotes_gpc']['status'] ? 'On' : 'Off';*/

	$arr = array('mysql_connect', 'fsockopen', 'file_get_contents', 'iconv');
	foreach($arr as $v) {
		$func[$v.'()']['status'] = function_exists($v);
		$func[$v.'()']['need'] = '֧';
	}

	$writedir = array(
		'data', 'data/attach', 'data/attach/album', 'data/attach/bbs', 'data/attach/bbsrule', 'data/attach/news', 'data/cache'
		,'data/log', 'data/tmp', 'data/view', 'data/www', 'config/global.php', 'config/bbs.php', 'config/db.php');

	foreach($writedir as $dir) {
		$write[$dir]['status'] = writeable(XIUNO_ROOT.$dir);
	}
	
	$upload_tmp_dir = ini_get('upload_tmp_dir');
	$upload_tmp_dir = $upload_tmp_dir ? $upload_tmp_dir : getenv('TEMP');
	$uploadwrite = array($upload_tmp_dir, writeable($upload_tmp_dir));
}

function writeable($var) {
	if(is_file($var)){
		return is_writeable($var);
	} else {
		if(is_dir($var) && chdir($var) && @touch('test_writeable.txt') && is_file('test_writeable.txt')) {
			unlink('test_writeable.txt');
			return TRUE;
		} else {
			return false;
		}
	}
}

function cleardir($dir) {
	$fp = opendir($dir);
	while($file = readdir($fp)) {
		if(is_dir($dir.$file)) {
			continue;
		}
		@unlink($dir.$file);
	}
}

/*	function config_replace($file, $data) {
	$content = file_get_contents($file);
	$regex = array();
	$replace = array();
	foreach($data as $k=>$v) {
		if(is_array($v)){
			$regex[] = "/\\\$$k\s*=\s*array.*?;/ims";
			$replace[] = "\\\$$k = ".var_export($v, 1).";";
		} else {
			$regex[] = "/define\('".$k."', \'?[^\(\)\'\\\"]*\'?\);/";
			$replace[] = "define('$k', '$v');";
		}
	}
	$content = preg_replace($regex, $replace, $content);
	@file_put_contents($file, $content);
}*/

function show_msg($s, $jump=''){
	if($jump == 'BACK') {
		$jump = 'javascript:history.back()';
	}
	include XIUNO_ROOT.'install/view/message.php';
}

function random_string($len) {
	$pool = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
	$pool_length = strlen($pool) - 1;
	$str = '';
	for ($i=0; $i < $len; $i++){
		$str .= $pool[mt_rand(0, $pool_length)];
	}   
	return $str;  
}

function install_database($arr, $xiunoadmin, $adminpasswd) {
	$link = array();
	$xiuno = file_get_contents(XIUNO_ROOT.'install/xiuno.sql');
	$xiuno = str_replace("\r\n", "\n", $xiuno);
	$xiuno = preg_replace('#/\*.*?\*/#ism', '', $xiuno);	// ȥע
	$xiunoarr = explode(";\n", $xiuno);
	
	$xiunodata = file_get_contents(XIUNO_ROOT.'install/xiuno_data.sql');
	$xiunodata = str_replace("\r\n", "\n", $xiunodata);
	$xiunodataarr = explode(";\n", $xiunodata);
	$xiunodataaddress = file_get_contents(XIUNO_ROOT.'install/xiuno_data_address.sql');
	
	$salt = substr(uniqid(rand()), -6);
	$adminpasswd = md5(md5($adminpasswd).$salt);

	foreach($xiunoarr as $v) {
		db_querys($v);
	}
	foreach($xiunodataarr as $v) {
		db_querys($v);
	}
	db_querys($xiunodataaddress);
	
	db_querys("TRUNCATE www_userfield");
	db_querys("INSERT INTO `www_userfield` SET uid='1', defaultalbumid='1', defaultblogcateid='1', username='$xiunoadmin', password='".$adminpasswd."', salt='$salt'");
	db_querys("UPDATE `www_user` SET regdate='".time()."' WHERE uid='1'");

}

function db_connect($dbhost, $dbuser, $dbpw, $dbname, &$mysqlerror) {
	global $links;
	$link = md5($dbhost.$dbuser.$dbpw);
	$links[$link] = mysql_connect($dbhost, $dbuser, $dbpw);
	if($links[$link]) {
		if(!mysql_select_db($dbname, $links[$link])) {
			mysql_query("CREATE DATABASE IF NOT EXISTS $dbname", $links[$link]);
			mysql_select_db($dbname, $links[$link]);
		}
		$mysqlerror = mysql_error();
		if($mysqlerror) {
			return FALSE;
		} else {
			mysql_query("SET NAMES latin1", $links[$link]);
			mysql_query("SET sql_mode=''");
			return $links[$link];
		}
	} else {
		$mysqlerror = mysql_error();
		return FALSE;
	}
}

function db_querys($sql) {
	global $links;
	if(!$sql) return;
	foreach($links as $link) {
		if($link) {
			if(!mysql_query($sql, $link)) {
				echo mysql_error();
				debug_print_backtrace();
				exit;
			}
		}
	}
}

// һӵĲѯ
function db_fetch_first($sql, $link = FALSE) {
	global $links;
	if(empty($link)) {
		foreach($links as $_link) {
			if($_link) {
				$link = $_link;
				break;
			}
		}
	}
	$query = mysql_query($sql);
	return mysql_fetch_assoc($query);
}

// ֶ֧ $links
function db_query($sql, $link = '') {
	$query = mysql_query($sql, $link);
	if(!$query) {
		echo 'MySQL error:'.$sql.mysql_error();
		debug_print_backtrace();
		exit;
	} else {
		return $query;
	}
}


function get_styleids() {
	$dir = XIUNO_ROOT.'config';
	$d = opendir($dir);
	$arr = array();
	while($f = readdir($d)) {
		preg_match('#style_(\d+).php#isx', $f, $m);
		if($m[1]) {
			$arr[] = $m[1];
		}
	}
	return $arr;
}

//XIUNO_FOOTER_NEWSCODE
/*function update_footer_newscode() {
	$query = db_query("SELECT * FROM www_news WHERE newsclassid='1';");
	$s = '';
	while($data = mysql_fetch_assoc($query)) {
		$s .= "<a href=\"".XIUNO_HOST_WWW."news-ls2-$newsid.htm\">$data[subject]</a> - ";
	}
}*/

function install_set_data($key, $value) {
	$file = XIUNO_ROOT.'data/tmp/install.data';
	if(!is_file($file)) {
		touch($file);
		$arr = array();
	} else {
		$s = file_get_contents($file);
		$arr = unserialize($s);
	}
	$arr[$key] = serialize($value);
	$s = serialize($arr);
	file_put_contents($file, $s);
}

function install_get_data($key = '') {
	$file = XIUNO_ROOT.'data/tmp/install.data';
	if(!is_file($file)) {
		return array();
	}
	$s = file_get_contents($file);
	$arr = (array)unserialize($s);
	foreach($arr as &$v) {
		$v = unserialize($v);
	}
	return $key ? $arr[$key] : $arr;
}

function install_file_get_contents($url) {
	/*$ext = array('http'=>array('method'=>'GET','timeout'=>5)); 
	$context = stream_context_create($ext); 
	return @file_get_contents($url); */
	return install_fopen($url, 4);
	
//	return file_get_contents($url, false, $context); 
}

function create_runtime_js() {
	if(!is_file('../data/cache/_runtime.js')) {
		// ȥעͣϲ
		$s = "\r\n".file_get_contents('../js/common.js');
		$s .= "\r\n".file_get_contents('../js/menu.js');
		$s .= "\r\n".file_get_contents('../js/ajax.js');
		$s = preg_replace('#/\*.*?\*/#is', '', $s);
		$s = preg_replace('#(^\s*|\r?\n\s*|(?<=;)\s*)//.*?(?=\r?\n|$)#ism', '', $s);
		$s = preg_replace('#\s{2,}#is', ' ', $s);
		//$s = preg_replace('#[ \t]{2,}#is', ' ', $s);
		$s = trim($s);
		file_put_contents('../data/cache/_runtime.js', $s);
	}
}

function str_str_count($haystack, $needle) {
	$i = 0;
	$pos = 0;
	while(1) {
		$pos = strpos($haystack, $needle, $pos);
		if($pos === FALSE) {
			break;
		} else {
			$pos++;
		}
		$i++;
	}
	return $i;
}

function create_css_cache() {
	
	// Ŀ¼$csses
	$csses = array();
	//$csses = array('common', 'bbs', 'calendar', 'editor',  'editor_doc', 'my', 'www', 'admin');
	$d = opendir(XIUNO_ROOT.'view/default');
	while($f = readdir($d)) {
		preg_match('#^css_(\w+)\.htm$#', $f, $m);
		if(!empty($m[1])) {
			$csses[] = $m[1];
		}
	}
	
	// Ŀ¼styleids
	$styleids = array();
	//$styleids = array(1, 2, 3, 5);
	$d = opendir(XIUNO_ROOT.'config');
	while($f = readdir($d)) {
		preg_match('#^style_(\d+)\.php$#', $f, $m);
		if(!empty($m[1])) {
			$styleids[] = $m[1];
		}
	}
	
	foreach($csses as $css) {
		foreach($styleids as $styleid) {
			css_replace_config_const($styleid, $css);
		}
	}
}

function get_url() {
	return $url = 'http://'.preg_replace("/\:\d+/", '', $_SERVER['HTTP_HOST']).($_SERVER['SERVER_PORT'] && $_SERVER['SERVER_PORT'] != 80 ? ':'.$_SERVER['SERVER_PORT'] : '');
}

function get_path() {
	$PHP_SELF = $_SERVER['PHP_SELF'] ? $_SERVER['PHP_SELF'] : $_SERVER['SCRIPT_NAME'];
	return $path = substr($PHP_SELF, 0, strpos($PHP_SELF, '/install'));
}

function css_replace_config_const($styleid, $css) {
	$arr = css_get_consts(XIUNO_ROOT.'config/style_'.$styleid.'.php');
	$srcfile = XIUNO_ROOT.'view/'.$arr['TPL'].'/css_'.$css.'.htm';
	if(!is_file($srcfile)) {
		$srcfile = XIUNO_ROOT.'view/default/css_'.$css.'.htm';
	}
	$destfile = XIUNO_ROOT.'data/view/'.$css."_$styleid.css";
	$csscontent = file_get_contents($srcfile);
	
	// ֧ģ
	$csscontent = str_replace("{template", "{subtemplate", $csscontent);
	$csscontent = preg_replace("/\{subtemplate\s+(\w+?)\}/ies", "css_getcontent('\\1', '$arr[TPL]');", $csscontent);
	
	foreach($arr as $k=>$v) {
		$csscontent = str_replace('{'.$k.'}', $v, $csscontent);
	}	
	file_put_contents($destfile, $csscontent);
}

function css_getcontent($tplfilename, $tpl) {
	$tplfile = XIUNO_ROOT."view/$tpl/$tplfilename.htm";
	if(!is_file($tplfile)) {
		$tplfile = XIUNO_ROOT."view/default/$tplfilename.htm";
	}
	return file_get_contents($tplfile); 
}

function css_get_consts($file) {
	// '.IMGURL.' 滻Ϊ 
	$s = file_get_contents($file);
	
	preg_match_all('#define\(\'(\w+)\',\s*(.*?)\);#is', $s, $m);
	foreach($m[1] as $k=>$v) {
		$arr[$v] = $m[2][$k];
	}
	//$arr['IMGURL'] = str_replace('XIUNO_HOST_IMAGE.\'', '\''.XIUNO_HOST_IMAGE.'', $arr['IMGURL']);
	//$arr['IMGURL'] = '';
	$arr['XIUNO_HOST_IMAGE'] = XIUNO_HOST_IMAGE;
	foreach($arr as &$v) {
		if(!$v) continue;
		if($v[0] == '\'' && strpos($v, '\'.') === FALSE) {
			$v = substr($v, 1, strlen($v) - 2);		
		} elseif(strpos($v, '\'') === FALSE) {
			if(!is_numeric($v)) {
				$v = isset($arr[$v]) ? $arr[$v] : '';
			}
		} else {
			// м
			$v = preg_replace('#\'\.(\w+)\.\'#isme', "\$arr['\\1']", $v);
			// ǰ
			$v = preg_replace('#(\w+)\.\'#isme', "'\''.\$arr['\\1']", $v);
			// ں
			$v = preg_replace('#\.\'(\w+)#isme', "\$arr['\\1'].'\''", $v);
			// ȥͷβ '
			if($v[0] == '\'') {
				$v = substr($v, 1, strlen($v) - 2);
			}
		}
	}
	return $arr;
}



function install_fopen($url, $timeout = 15) {
	$limit = 500000;
	$ip = '';
	$return = '';
	$matches = parse_url($url);
	$host = $matches['host'];
	$path = $matches['path'] ? $matches['path'].($matches['query'] ? '?'.$matches['query'] : '') : '/';
	$port = !empty($matches['port']) ? $matches['port'] : 80;

	$out = "GET $path HTTP/1.0\r\n";
	$out .= "Accept: */*\r\n";
	//$out .= "Referer: $boardurl\r\n";
	$out .= "Accept-Language: zh-cn\r\n";
	$out .= "User-Agent: $_SERVER[HTTP_USER_AGENT]\r\n";
	$out .= "Host: $host\r\n";
	$out .= "Connection: Close\r\n";
	$out .= "Cookie:\r\n\r\n";
	$host == 'localhost' && $ip = '127.0.0.1';
	$fp = @fsockopen(($ip ? $ip : $host), $port, $errno, $errstr, $timeout);
	if(!$fp) {
		return '';
	} else {
		stream_set_blocking($fp, TRUE);
		stream_set_timeout($fp, $timeout);
		@fwrite($fp, $out);
		$status = stream_get_meta_data($fp);
		if(!$status['timed_out']) {
			while (!feof($fp)) {
				if(($header = @fgets($fp)) && ($header == "\r\n" ||  $header == "\n")) {
					break;
				}
			}

			$stop = false;
			while(!feof($fp) && !$stop) {
				$data = fread($fp, ($limit == 0 || $limit > 8192 ? 8192 : $limit));
				$return .= $data;
				if($limit) {
					$limit -= strlen($data);
					$stop = $limit <= 0;
				}
			}
		}
		@fclose($fp);
		return $return;
	}
}

?>