<?php

define('XIUNO_VERSION_INSTALL', '1.0.2');

@set_time_limit(0);// ĳЩBT˸ĺ
define('XIUNO_ROOT', dirname(dirname(str_replace('\\', '/', __FILE__))).'/');
error_reporting(E_ALL);

include XIUNO_ROOT.'install/function.php';
if(is_file(XIUNO_ROOT.'data/install.lock')) {
	show_msg('⵽ϵͳѰװXiuno, °װ, ɾ data/install.lockļ');
}

$step = intval(getgpc('step', 'R'));
$img_right = '<img src="image/check_right.gif" />';
$img_error = '<img src="image/check_error.gif" />';
$img_warn = '<img src="image/check_warn.gif" />';
switch($step) {
	case '0':	// license
		include XIUNO_ROOT.'install/view/header.php';
		include XIUNO_ROOT.'install/view/show_license.php';
		include XIUNO_ROOT.'install/view/footer.php';
		break;
	case '1':	// env
	
		// ʼֵ
		install_set_data('rewriteon', '');
		
		$env = $ini = $func = $write = array();
		get_env($env, $ini, $func, $write, $uploadwrite);
		include XIUNO_ROOT.'install/view/header.php';
		include XIUNO_ROOT.'install/view/check_env.php';
		include XIUNO_ROOT.'install/view/footer.php';
		break;
	case '2':
		$action = getgpc('action');
		$url = get_url();
		$path = get_path();
		$checkurl = "$url{$path}/bbs-index.htm?_checkrewrite_=1";
		if($action == 'ajaxcheckrewrite') {
			$status = install_file_get_contents($checkurl) == 'ok' ? '1' : '0';
			echo "json_return = '$status';";
			exit;
		}
		// /Rewrite 
		// ѯʰװĸ
		include XIUNO_ROOT.'install/view/header.php';
		include XIUNO_ROOT.'install/view/check_rewrite.php';
		include XIUNO_ROOT.'install/view/footer.php';
		exit;
	
	case '3': 	
		$rewriteon = getgpc('rewriteon', 'P');
		install_set_data('rewriteon', $rewriteon);
		
		$laststep = install_get_data();
		
		// db
		include XIUNO_ROOT.'install/view/header.php';
		include XIUNO_ROOT.'install/view/db_form.php';
		include XIUNO_ROOT.'install/view/footer.php';
		break;
	case '4':
		$laststep = install_get_data();
		if(empty($laststep)) {
			$laststep = array(
				'rewriteon'=>0,
			);
		}
		
		// ֤Ϣ
		$hints = array(
			'dbhost'=>'дݿַ',
			'dbuser'=>'дݿû',
			//'dbpassword'=>'дݿ',
			'dbname'=>'дݿ',
			'xiunoadmin'=>'дԱû',
			'adminpasswd'=>'дԱ',
			'adminpasswd2'=>'дԱȷ',
			'admin_pass_confirm'=>'дͨж',
		);
		foreach($hints as $k=>$v){
			if(empty($_POST[$k])){
				show_msg($v, 'BACK');
			}
		}
		if(strlen($_POST['xiunoadmin']) > 16) {
			show_msg('Ա˺ųȲܳ16λ', 'BACK');
		}
		if($_POST['adminpasswd2'] != $_POST['adminpasswd']) {
			show_msg('벻һ', 'BACK');
		}
		
		
		include XIUNO_ROOT.'model/settingmodel.php';
		$setting = new settingmodel($null);
		
		// Slave MySQL
		$slavehost = getgpc('slavehost', 'P');
		$slavename = getgpc('slavename', 'P');
		$slaveuser = getgpc('slaveuser', 'P');
		$slavepassword = getgpc('slavepassword', 'P');
		$slaves = array();
		foreach((array)$slavehost as $k=>$v) {
			$slaves[$k] = array(
				'dbhost'=> $slavehost[$k],
				'dbuser'=> $slaveuser[$k],
				'dbpw'=> $slavepassword[$k],
				'dbname'=> $slavename[$k],
				'dbcharset'=> 'latin1',
			);
			
		}
		
		// Master MySQL
		$dbinfo = array(
			'master' => array(
				'dbhost'=> $_POST['dbhost'],
				'dbuser'=> $_POST['dbuser'],
				'dbpw'=> $_POST['dbpassword'],
				'dbname'=> $_POST['dbname'],
				'dbcharset'=> 'latin1',
			),
			'slaves' => $slaves
		);
		
		// ӣҽӡ
		$links = array();
		$master = $dbinfo['master'];
		$link = db_connect($master['dbhost'], $master['dbuser'], $master['dbpw'], $master['dbname'], $mysqlerror);
		if(!$link) {
			show_msg('ݿӺ˺Уз뷵ؼ飬Ϣ'.$mysqlerror, 'BACK');
		}
		
		foreach($dbinfo['slaves'] as $slave) {
			$link = db_connect($slave['dbhost'], $slave['dbuser'], $slave['dbpw'], $slave['dbname'], $mysqlerror);
			if(!$link) {
				show_msg('ݿӺ˺Уз뷵ؼ飬Ϣ'.$mysqlerror, 'BACK');
			}
		}
		
		// Memcached
		$memcachehost = getgpc('memcachehost', 'P');
		$memcacheport = getgpc('memcacheport', 'P');
		if($memcachehost && $memcacheport) {
			if(!extension_loaded('memcache')) {
				show_msg('PHP Memcache չûп', 'BACK');
			}
			$memcache = new Memcache;
			if(!@$memcache->connect($memcachehost, $memcacheport)) {
				show_msg('memcached ʧܣ Memcached Ƿ', 'BACK');
			}
			$dbinfo['XIUNO_MEMCACHE_ON'] = 1;
			$dbinfo['XIUNO_MEMCACHE_HOST'] = $memcachehost;
			$dbinfo['XIUNO_MEMCACHE_PORT'] = $memcacheport;
		} else {
			$dbinfo['XIUNO_MEMCACHE_ON'] = 0;
			$dbinfo['XIUNO_MEMCACHE_HOST'] = '';
			$dbinfo['XIUNO_MEMCACHE_PORT'] = '';
		}
		
		// װݿ
		$tmparr = $dbinfo['slaves'];
		$tmparr[] = $dbinfo['master'];
		install_database($tmparr, $_POST['xiunoadmin'], $_POST['adminpasswd']);
		
		// дļ db.php
		$setting->set('db', 'master', $dbinfo['master']);
		$setting->set('db', 'slaves', $dbinfo['slaves']);
		$setting->set('db', 'XIUNO_MEMCACHE_ON', $dbinfo['XIUNO_MEMCACHE_ON']);
		$setting->set('db', 'XIUNO_MEMCACHE_HOST', $dbinfo['XIUNO_MEMCACHE_HOST']);
		$setting->set('db', 'XIUNO_MEMCACHE_PORT', $dbinfo['XIUNO_MEMCACHE_PORT']);
		
		// дļ global.php
		$imagemagickdir = str_replace('\\', '/', stripslashes(getgpc('imagemagickdir', 'P')));
		if($imagemagickdir && !is_file(str_replace('//', '/', $imagemagickdir.'/convert'))) {
			$imagemagickdir = '';
		}
		
		$phpcgipath = str_replace('\\', '/', stripslashes(getgpc('phpcgipath', 'P')));
		if($phpcgipath && is_file($phpcgipath)) {
			$setting->set('global', 'XIUNO_PHP_CGI_PATH', $phpcgipath);
		}

		// дļ global.php
		$time = time();
		$domains = array('www', 'bbs', 'my', 'admin', 'so');
		foreach($domains as $domain) {
			$setting->set('global', 'XIUNO_HOST_'.strtoupper($domain), ($laststep['rewriteon'] ? '' : '?').$domain.'-');
		}
		
		$url = get_url();
		$path = get_path();
		$imageurl = $url.$path.'/';
		$setting->set('global', 'XIUNO_HOST_IMAGE', $imageurl);
		$setting->set('global', 'XIUNO_CRON_SQL_CACHE_TIME', $time);
		$setting->set('global', 'XIUNO_CRON_ONLINE_TIME', $time);
		$setting->set('global', 'XIUNO_CRON_TODAYPOST_TIME', $time);
		$setting->set('global', 'XIUNO_CRON_MYSQL_QUEUE_TIME', $time);
		$setting->set('global', 'XIUNO_WAIT_TIME', 2);
		$setting->set('global', 'XIUNO_ATTACH_DIR', XIUNO_ROOT.'data/attach/');
		$setting->set('global', 'XIUNO_TMP_DIR', XIUNO_ROOT.'data/tmp/');
		$setting->set('global', 'XIUNO_LOG_DIR', XIUNO_ROOT.'data/log/');
		$setting->set('global', 'XIUNO_ADMIN_PASS_CONFIRM', md5($_POST['admin_pass_confirm']));
		$setting->set('global', 'XIUNO_IMAGEMAGICK_DIR', $imagemagickdir);
		$setting->set('global', 'XIUNO_KEY', random_string(16));
		
		$setting->set('global', 'XIUNO_VERSION', XIUNO_VERSION_INSTALL);
		$setting->set('global', 'XIUNO_STAT_TOTAL_MEMBER', 1);
		$setting->set('global', 'XIUNO_START_TIME', time());
		
		$setting->set('global', 'XIUNO_REWRITE_ON', $laststep['rewriteon']);
		$setting->set('global', 'XIUNO_INSTALLED', '1');
		$setting->save('global');
		include_once XIUNO_ROOT.'config/global.php';
		
		// ļ bbs.php
		$setting->set('bbs', 'XIUNO_BBS_FORUMS_CACHE_UPDATE_TIME', $time);
		
		//  css log ļ
		cleardir(XIUNO_ROOT.'data/cache/');
		cleardir(XIUNO_ROOT.'data/view/');
		//cleardir(XIUNO_ROOT.'data/tmp/');
		cleardir(XIUNO_ROOT.'data/log/');
		
		file_put_contents(XIUNO_ROOT.'data/log/mysqlerror.php', "<?php exit;?>\r\n");
		file_put_contents(XIUNO_ROOT.'data/log/web.php', "<?php exit;?>\r\n");
		// 
		touch(XIUNO_ROOT.'data/install.lock');

		create_runtime_js();
		create_css_cache();
		
		$setting->save('bbs');
		$setting->save('db');
		$setting->save('global');
		show_msg('װɹӽվ㡣', '../');
		 break;
	 default:
	 	show_msg('ȷ', 'index.php');
	 	break;
}
