<?php
class Form {
	
	public function get_radio_yes_no($name, $checkedkey = FALSE) {
		return $this->get_radio($name, array(1=>'', 0=>''), $checkedkey);
	}	
	
	public function get_checkbox_yes_no($name, $checkedkey = FALSE) {
		return $this->get_checkbox($name,  array(1=>'', 0=>''), $checkedkey);
	}
	
	/**
	÷ Form::get_radio('ishidden', array('', ''), 0);
	*/
	public function get_radio($name, $arr, $checkedkey = FALSE) {
		$s = '';
		foreach($arr as $k=>$v) {
			$checked = $checkedkey !== FALSE && $k == $checkedkey ? ' checked="checked"' : '';
			$s .= "<input type=\"radio\" name=\"$name\" value=\"$k\" class=\"noborder\"$checked />$v \r\n";
		}
		return $s;
	}
	
	public function get_select($name, $arr, $checkedkey = FALSE, $extra = array()) {
		$id = isset($extra['id']) ? " id=\"$extra[id]\"" : '';
		$style = isset($extra['style']) ? " style=\"$extra[style]\"" : '';
		$onchange = isset($extra['onchange']) ? " onchange=\"$extra[onchange]\"" : '';
		$s = "<select name=\"$name\"$id$onchange$style> \r\n";
		foreach($arr as $k=>$v) {
			$checked = $checkedkey !== FALSE && $k == $checkedkey ? ' selected="selected"' : '';
			$s .= "<option value=\"$k\"$checked>$v</option> \r\n";
		}
		$s .= "</select> \r\n";
		return $s;
	}
	
	public function get_checkbox($name, $arr, $ischecked) {
		$s = '';
		$checked = $ischecked ? ' checked="checked"' : '';
		$checkedtext = $arr[$ischecked];
		$s .= "<input type=\"checkbox\" name=\"$name\" value=\"1\" class=\"noborder\"$checked />$checkedtext \r\n";
		return $s;
	}
	
	
}
/** ÷

$f = new Form();
echo $f->get_checkbox_yes_no('aaa', 0);
echo $f->get_checkbox('aaa', array('', ''), 0);

echo $f->get_radio_yes_no('aaa', 0);
echo $f->get_radio('aaa', array('', ''), 0);
echo $f->get_radio('aaa', array('a'=>'aaa', 'b'=>'bbb', 'c'=>'ccc', ), 'b');

echo $f->get_select('aaa', array('a'=>'aaa', 'b'=>'bbb', 'c'=>'ccc', ), 'a');

*/

?>