<?php
/*
	[Xiuno] (C)2008-2009
	This is NOT a freeware, use is subject to license terms

	$RCSfile: index.php,v $
	$Revision: 1.0 $
	$Date: 2009/05/5 14:36:00 $
	$Author: heyond $
*/

function str_replace_offset($org, $start, $len, $new) {
	$left = substr($org, 0, $start);
	$right = substr($org, $start + $len);
	return $left.$new.$right;
}

class Template {

	//public
	private $tpldir;
	private $defaultdir;
	private $objdir;

	public $tplfile;
	public $objfile;

	public $vars;//
	public $force = 0;

	private $var_regexp = "\@?\\\$[a-zA-Z_]\w*(?:\[[\w\.\"\'\[\]\$]+\])*";
	private $vtag_regexp = "\<\?=(\@?\\\$[a-zA-Z_]\w*(?:\[[\w\.\"\'\[\]\$]+\])*)\?\>";
	private $const_regexp = "\{([\w]+)\}";

	public $removespace = 0;
	public $styleeffecton = 0;

	function __construct() {
		$this->tpldir = XIUNO_ROOT.'view/'.TPL;
		$this->objdir = XIUNO_ROOT.'data/view';
		//$this->removespace = XIUNO_DEBUG;
		$this->styleeffecton = STYLE_EFFECT_ON;
		$this->defaultdir = XIUNO_ROOT.'view/default';
	}

	// publlic
	public function assign($k, &$v) {
		$this->vars[$k] = &$v;
	}

	public function assign_value($k, $v) {
		$this->vars[$k] = $v;
	}

	// publlic
	public function display($file) {
		$blockname = '';
		if(strpos($file, '.') !== FALSE) {
			$arr = explode('.', $file);
			$file = $arr[0];
			$blockname = $arr[1];
		}
		extract($this->vars, EXTR_SKIP);
		include $this->gettpl($file, $blockname);
	}

	public function gettpl($file, $blockname = '') {
		isset($_GET['inajax']) && ($file == 'header' || $file == 'footer') && $file = 'ajax_'.$file;
		isset($_GET['inajax']) && ($file == 'admin_header' || $file == 'admin_footer') && $file = 'ajax_'.substr($file, 6);
		$this->tplfile = $this->tpldir.'/'.$file.'.htm';

		if(empty($blockname)) {
			$this->objfile = $this->objdir.'/'.$file.'_'.$_COOKIE['styleid'].'.php';
		} else {
			$this->objfile = $this->objdir.'/'.$file.'__'.$blockname.'_'.$_COOKIE['styleid'].'.php';
		}
		
		// ˴ܻӰЧ
		$tplfilemtime = is_file($this->tplfile) ? filemtime($this->tplfile) : false;
		if(!$tplfilemtime) {
			$this->tplfile = $this->defaultdir.'/'.$file.'.htm';
			$tplfilemtime = filemtime($this->tplfile);
		}
		$objfilemtime = is_file($this->objfile) ? filemtime($this->objfile) : 0;
		//жǷȽϹ
		if($this->force || $objfilemtime < $tplfilemtime) {
			if(empty($blockname)) {
				$s = file_get_contents($this->tplfile);
			} else {
				$s = file_get_contents($this->tplfile);
				$s = $this->_getblock($s, $blockname);
			}
			$this->complie($s);
		}
		return $this->objfile;
	}
	
	public function complie($template) {
		//$template = file_get_contents($this->tplfile);
				
		// subtemplate block
		for($i = 0; $i < 3; $i++) {
			if(XIUNO_DEBUG) {
				$template = preg_replace("/\{subtemplate\s+(\w+?)\}/is", "{template \\1}", $template);
			} else {
				$template = preg_replace("/\{subtemplate\s+(\w+?)\}/ies", "\$this->getcontent('\\1');", $template);
			}
			$template = preg_replace("/\{subtemplate\s+(\w+?)\\.(\w+?)\}/ies", "\$this->getblock('\\1', '\\2');", $template);
		}
		$template = $this->clearblock($template);
		
		// 
		if($this->styleeffecton) {
			// صĴ
			include_once XIUNO_ROOT.'lib/template_style_effect.php';
			$template = style_convert_button($template);
			$template = style_convert_table($template, 'table1');
			$template = style_convert_table($template, 'table3');
			$template = style_convert_table($template, 'table4');
			$template = style_convert_label($template);
		}
		
		// AJAX Ԥ
		$template = $this->replace_ajax_header_footer($template);
		
		// TODO ȥJSеע // JSͻд 
		$template = preg_replace('#\r\n\s*//[^\r\n]*#ism', '', $template);
		
		$template = preg_replace("/\<\!\-\-\{(.+?)\}\-\-\>/s", "{\\1}", $template);
		/*$template = preg_replace("/(?:\{?)($this->var_regexp)(?(1)\}|)/", "<?=\\1?>", $template);*/
		$template = preg_replace("/($this->var_regexp|\{$this->var_regexp\})/", "<?=\\1?>", $template);
		$template = preg_replace("/\<\?=\{(.+?)\}\?\>/", "<?=\\1?>", $template);//
		$template = preg_replace("/\{($this->const_regexp)\}/", "<?=\\1?>", $template);
		
		//  $data[key] -> $data['key']
		$template = preg_replace("/\<\?=(\@?\\\$[a-zA-Z_]\w*)((\[[\\$\[\]\w]+\])+)\?\>/ies", "\$this->arrayindex('\\1', '\\2')", $template);
		//$template = preg_replace("/\<\?=(\@?\\\$[a-zA-Z_]\w*)((\[\w+\])+)\?\>/ies", "\$this->arrayindex('\\1', '\\2')", $template);

		/*$template = preg_replace("/(?<!\<\?\=|\\\\)$this->var_regexp/", "<?=\\0?>", $template);*/

		$template = preg_replace("/\{\{eval (.*?)\}\}/ies", "\$this->stripvtag('<? \\1?>')", $template);
		$template = preg_replace("/\{eval (.*?)\}/ies", "\$this->stripvtag('<? \\1?>')", $template);
		$template = preg_replace("/\{for (.*?)\}/ies", "\$this->stripvtag('<? for(\\1) {?>')", $template);

		$template = preg_replace("/\{elseif\s+(.+?)\}/ies", "\$this->stripvtag('<? } elseif(\\1) { ?>')", $template);
		for($i=0; $i<3; $i++) {
			$template = preg_replace("/\{loop\s+$this->vtag_regexp\s+$this->vtag_regexp\s+$this->vtag_regexp\}(.+?)\{\/loop\}/ies", "\$this->loopsection('\\1', '\\2', '\\3', '\\4')", $template);
			$template = preg_replace("/\{loop\s+$this->vtag_regexp\s+$this->vtag_regexp\}(.+?)\{\/loop\}/ies", "\$this->loopsection('\\1', '', '\\2', '\\3')", $template);
		}
		$template = preg_replace("/\{if\s+(.+?)\}/ies", "\$this->stripvtag('<? if(\\1) { ?>')", $template);

		$template = preg_replace("/\{template\s+(\w+?)\}/is", "<? include \$this->gettpl('\\1');?>", $template);
		$template = preg_replace("/\{template\s+(.+?)\}/ise", "\$this->stripvtag('<? include \$this->gettpl(\\1); ?>')", $template);
		
		$template = preg_replace("/\{else\}/is", "<? } else { ?>", $template);
		$template = preg_replace("/\{\/if\}/is", "<? } ?>", $template);
		$template = preg_replace("/\{\/for\}/is", "<? } ?>", $template);

		$template = preg_replace("/$this->const_regexp/", "<?=\\1?>", $template);//{else} Ҳϳʽ˴ҪעȺ˳??

		// KEYж
		$template = preg_replace("/\<\?=\@(\\\$[a-zA-Z_]\w*)((\[[\\$\[\]\w\']+\])+)\?\>/ies", "\$this->array_keyexists('\\1', '\\2')", $template);
		$template = "<? if(!defined('XIUNO_ROOT')) exit('Access Denied');?>\r\n$template";

		if($this->removespace) {
			$template = str_replace("/\r\n+/", "\n", $template);
			$template = preg_replace("/\n+/", "\n", $template);
			$template = preg_replace("/[ \t]+/", " ", $template);
		}
		if(!($fp = fopen($this->objfile, 'wb'))) {
                        return FALSE;
                }
                flock($fp, LOCK_EX);
                fwrite($fp, $template, strlen($template));
                fclose($fp);
		//file_put_contents($this->objfile, $template);
	}
	
	private function getcontent($tplfilename) {
		$tplfile = $this->tpldir."/$tplfilename.htm";
		if(!is_file($tplfile)) {
			$tplfile = $this->defaultdir."/$tplfilename.htm";
		}
		return file_get_contents($tplfile); 
	}

	private function getblock($tplfilename, $blockname) {
		$tplfile = $this->tpldir."/$tplfilename.htm";
		if(!is_file($tplfile)) {
			$tplfile = $this->defaultdir."/$tplfilename.htm";
		}
		$s = file_get_contents($tplfile);
		return $this->_getblock($s, $blockname);
	}
	
	private function _getblock($s, $blockname) {
		preg_match('#<!--{block\.'.$blockname.'}-->(.*?)<!--{/block\.'.$blockname.'}-->#ism', $s, $m);
		if(isset($m[1])) {
			$m[1] = $this->clearblock($m[1]);
			return $m[1];
		}
		return '';
	}
	
	private function clearblock($s) {
		return preg_replace('#<!--{/?block\.(\w+)}-->#ism', '', $s);
	}
	
	private function arrayindex($name, $items) {
		$items = preg_replace("/\[([a-zA-Z_]\w*)\]/is", "['\\1']", $items);
		return "<?=$name$items?>";
	}

	private function array_keyexists($name, $items) {
		return "<?php echo isset($name$items) ? $name$items : '';?>";
	}

	private function stripvtag($s) {
		return preg_replace("/$this->vtag_regexp/is", "\\1", str_replace("\\\"", '"', $s));
	}

	private function loopsection($arr, $k, $v, $statement) {
		$arr = $this->stripvtag($arr);
		$k = $this->stripvtag($k);
		$v = $this->stripvtag($v);
		$statement = str_replace("\\\"", '"', $statement);
		return $k ? "<? if(!empty($arr)) { foreach($arr as $k=>&$v) {?>$statement<?}}?>" : "<? if(!empty($arr)) { foreach($arr as &$v) {?>$statement<? }} ?>";
	}

	private function replace_ajax_header_footer($template) {
		preg_match_all('#{template ajax_header}(.*?){template ajax_footer}#ism', $template, $m, PREG_OFFSET_CAPTURE);
		$arr = array_reverse($m[0]);
		foreach($arr as $v) {
			$org = $v[0];
			$start = $v[1];
			$new = preg_replace('#{template ajax_header}\s*(<(?:menu_\w+)>(?:.*(?!ajax_footer))</menu_\w+>\s*)*(.*?){template ajax_footer}#ism', '{template ajax_header}<root>
			<menuid>$menuid</menuid>
			$ajax[extrastr]
			<servererror><![CDATA[ $_SERVER[XIUNO_ERROR] ]]></servererror>
			\\1
			<message><![CDATA[\\2]]>
			</message>
			</root>{template ajax_footer}', $org);
			$template = str_replace_offset($template, $start, strlen($org), $new);
		}
		return $template;
	}
}

/*

Usage:
require_once 'lib/template.class.php';
$this->view = new Template();
$this->view->assign('page', $page);
$this->view->assign('userlist', $userlist);
$this->view->display("user_ls");

*/

?>