<?php

define('model/cachemodel.php', 1);

/* ÷

$group = $this->cahe('group', 1);
$forum = $this->cahe('forum', 1);
$forums = $this->cahe('forums');
$groups = $this->cahe('groups');

*/
class cachemodel {

	private $db;
	private $base;

	function __construct(&$base) {
		$this->base = $base;
		$this->db = $base->db;
		set_time_limit(600);
	}

	public function update($module = '', $arg = '') {
		$method = "get_$module";
		if(method_exists($this, $method)) {
			$data = $this->$method($arg);
		} else {
			exit('cachemodel: '.$method.' is not exists');
		}
		$cachename2 = $module.($arg ? "_$arg" : '');
		$this->cache_to_file('_ENV[\'xiuno\'][\'cache\'][\''.$cachename2.'\']', $data, ($arg ? $module.'_'.$arg : $module));
	}

	private function cache_to_file($varname, $var, $filename) {
		$s = "<?php\r\n";
		$s .= "\r\ndefine('data/cache/$filename.php', 1);\r\n";
		$s .= '$'.$varname.' = '.var_export($var, TRUE).";\r\n";
		$s .= "\r\n?>";
		if(!($fp = fopen(XIUNO_ROOT."data/cache/$filename.php", 'wb'))) {
			return FALSE;
		}
		flock($fp, LOCK_EX);
		fwrite($fp, $s, strlen($s));
		fclose($fp);
	}

	private function get_sons_by_fid($fid, $forums) {
		$fids = array();
		foreach($forums as $forum2) {
			if($forum2['fup'] == $fid) {
				$fids[] = $forum2['fid'];
				foreach($forums as $forum3) {
					if($forum3['fup'] == $forum2['fid']) {
						$fids[] = $forum3['fid'];
					}
				}
			}
		}
		return $fids;
	}

	private function get_top1($fid) {
		$tids = $this->db->fetch_all("SELECT tid FROM bbs_thread_displayorder WHERE fid='$fid' AND displayorder='1'");
		$threads = array();
		foreach($tids as $v) {
			$tid = $v['tid'];
			$threads[$tid] = $this->base->threadmodel->get_thread_by_tid($tid);
		}
		return $threads;
	}

	// $fid Ϊ groupfid
	private function get_top2($groupfid) {
		//  cache ڣ
		!defined('data/cache/forums.php') && include XIUNO_ROOT.'data/cache/forums.php';
		empty($forums) && $forums = $this->db->fetch_all("SELECT * FROM bbs_forum", 'fid');

		// ˴Ҫ֪ fid   parent fid
		//$groupfid = $this->get_group_fid($fid, $forums);
		$tids = array();
		$sons = $this->get_sons_by_fid($groupfid, $forums);
		foreach($sons as $fid) {
			$tids = array_merge($tids, $this->db->fetch_all("SELECT tid FROM bbs_thread_displayorder WHERE fid='$fid' AND displayorder='2'"));
		}
		$threads = array();
		foreach($tids as $v) {
			$tid = $v['tid'];
			$threads[$tid] = $this->base->threadmodel->get_thread_by_tid($tid);
		}
		return $threads;
	}

	private function get_top3() {
		$tids = $this->db->fetch_all("SELECT tid FROM bbs_thread_displayorder WHERE displayorder='3'");
		$threads = array();
		foreach($tids as $v) {
			$tid = $v['tid'];
			$threads[$tid] = $this->base->threadmodel->get_thread_by_tid($tid);
		}
		return $threads;
	}

	private function get_friendlinks() {
		$bbs = $this->db->fetch_all("SELECT * FROM www_friendlink WHERE type='bbs' ORDER BY displayorder DESC");
		$common = $this->db->fetch_all("SELECT * FROM www_friendlink WHERE type='common' ORDER BY displayorder DESC");
		$union = $this->db->fetch_all("SELECT * FROM www_friendlink WHERE type='union' ORDER BY displayorder DESC");
		return array('bbs'=>$bbs, 'common'=>$common, 'union'=>$union);
	}

	private function get_friendlink($level) {
		$data = $this->db->fetch_all("SELECT * FROM www_friendlink WHERE type='$level' ORDER BY displayorder DESC");
		return $data;
	}

	// ķ forumsdataɵforumsdata.cache.php С£岻ʱ
	private function get_forums() {
		$forums = $this->db->fetch_all("SELECT fid, fup, type, name, description, audit, threads, posts, todayposts, status, displayorder, lastpost FROM bbs_forum", 'fid'); // ORDER BY displayorder
		foreach($forums as &$v) {
			if(!empty($v['fup'])) {
				$forums[$v['fup']]['sub'] = TRUE;
			}
			if(empty($v['sub'])) {
				$v['sub'] = FALSE;
			}
			$v['moderator'] = array();
		}
		$moderators = $this->db->fetch_all("SELECT uid,fid,username FROM bbs_moderator");
		foreach($moderators as $moderator) {
			$fid = $moderator['fid'];
			$uid = $moderator['uid'];
			$username = $moderator['username'];
			$forums[$fid]['moderator'][$uid] = $username;
		}
		return $forums;
	}

	private function get_forumsdata(){
		//$sql = "SELECT fid, fup, type, name, description, threads, posts, todayposts, status, displayorder, lastpost, cols FROM bbs_forum ORDER BY displayorder DESC, threads DESC";
		return $this->base->forummodel->get_forums_by_sql();
	}
	
/*	// ҳʹ
	private function get_simpleforums() {
		$sql = "SELECT fid, fup, type, name, threads, posts, todayposts, status FROM bbs_forum  WHERE type <> 'sub' ORDER BY displayorder DESC, threads DESC";
		return $this->base->forummodel->get_forums_by_sql($sql);
	}*/

	// "SELECT fid, fup, type, name, description, threads, posts, todayposts, status, displayorder, lastpost FROM bbs_forum ORDER BY displayorder DESC, threads DESC"
	
	
	// ĳ̳
	private function get_forum($fid) {
		$forum = $this->db->fetch_first("SELECT * FROM bbs_forum WHERE fid='$fid'");
		if(empty($forum)) {
			return array();
		}
		$pforum = $forum;
		if($pforum['type'] != 'group') {
			$pforum = $this->db->fetch_first("SELECT * FROM bbs_forum WHERE fid='$pforum[fup]'");
		}
		if($pforum['type'] != 'group') {
			$pforum = $this->db->fetch_first("SELECT * FROM bbs_forum WHERE fid='$pforum[fup]'");
		}
		$forum['groupfid'] = $pforum['fid'];

		if(empty($forum)) {
			return array();
		}
		$typeids = $this->db->fetch_all("SELECT typeid, fid, name, displayorder FROM bbs_threadtype WHERE fid='$fid'", 'typeid');
		$forum['typeids'] = $typeids;
		$forum['forbidviewgroup'] = "\t".$forum['forbidviewgroup']."\t";
		$forum['forbidpostgroup'] = "\t".$forum['forbidpostgroup']."\t";
		$forum['forbidthreadgroup'] = "\t".$forum['forbidthreadgroup']."\t";
		$forum['creditpolicy'] = $this->base->forummodel->explodecreditpolicy($forum['creditpolicy']);
		$moderators = $this->db->fetch_all("SELECT uid,fid,username FROM bbs_moderator WHERE fid='$fid'");
		$forum['moderator'] = array();
		foreach($moderators as $moderator) {
			$uid = $moderator['uid'];
			$username = $moderator['username'];
			$forum['moderator'][$uid] = $username;
		}
		$forum['sub'] = 0;
		if($forum['type'] == 'forum' && $this->db->result_first("SELECT COUNT(*) FROM bbs_forum WHERE fup='$fid'")) {
			$forum['sub'] = 1;
		}

		$rule = $this->db->fetch_first("SELECT * FROM bbs_rule WHERE fid='$fid'");
		$forum['rule'] = $this->format_rule($rule);
		$arr = array();
		// heyonddebug
		$forum['threadtypes'] = $this->base->forummodel->get_threadtype_list_by_fid($fid);
		return $forum;
	}

	private function format_rule($row){
		$rule = array();
		$rule['brief'] = $row['brief'];
		$rule['recommands'] = array();
		$recommands = trim($row['recommands']);
		if($recommands) {
			$arr = explode("\t", $recommands);
			foreach($arr as $tid) {
				$rule['recommands'][] = array('href'=>XIUNO_HOST_BBS.'thread-index-'.$tid.'.htm', 'subject'=>$this->db->result_first("SELECT subject FROM bbs_thread WHERE tid='$tid'"));
			}
		}
		return $rule;
	}


	private function get_groups() {
		$this->base->unlink_rumtime();
		return $this->base->groupmodel->get_grouplist();
	}

	private function get_group($groupid) {
		$arr = $this->db->fetch_first("SELECT * FROM www_group WHERE groupid='$groupid'");
		if($arr['type'] != 1) {
			unset($arr['allowdigest'], $arr['allowtop'], $arr['allowdelete'], $arr['allowup'], $arr['allowdown'], $arr['allowclose'], $arr['allowmove'], $arr['allowhighlight'], $arr['raterange']);
		} else {
			$arr['raterange'] = $this->base->groupmodel->str2rate($arr['raterange']);
		}
		return $arr;
	}

	private function get_medals() {
		return $this->db->fetch_all("SELECT * FROM bbs_medal", 'medalid');
	}

	private function get_bbs() {
		return array('annlist'=>$this->get_annlist(), 'newlist'=>$this->get_newlist(), 'forumgroups'=>$this->get_forumgroups());
	}

	// 
	private function get_annlist() {
		$annlist = $this->db->fetch_all("SELECT  id, subject, starttime FROM www_announcement WHERE (starttime=0 OR starttime<='{$this->base->time}') AND (endtime=0 OR endtime>'{$this->base->time}') ORDER BY displayorder ASC LIMIT 100");
		if($annlist) {
			foreach($annlist as &$ann) {
				$ann['starttime'] = $this->base->date($ann['starttime'], 'Y-n-j');
			}
		}
		return $annlist;
	}

	// ȡ̳ҳµбȵȡ
	private function get_newlist() {
		// ʾ
		!defined('config/bbs.php') && include XIUNO_ROOT.'config/bbs.php';

		if(!XIUNO_BBS_INDEX_NEWPOST_ON) {
			return array();
		}
		$systemfid = XIUNO_SYSTEM_FID;

		$maxtid = $this->db->result_first("SELECT MAX(tid) FROM bbs_thread") - 100;
		$threadlist = $this->db->fetch_all("SELECT fid, tid, subject, dateline, uid, username FROM bbs_thread WHERE tid>'$maxtid' ORDER BY tid DESC LIMIT 20", 'tid');

		$maxtid = $maxtid - 1000; // 1000ȡظ
		$hotlist = $this->db->fetch_all("SELECT fid, tid, subject, dateline, uid, username, posts FROM bbs_thread WHERE tid>'$maxtid' ORDER BY posts DESC LIMIT 40", 'tid');
		//$maxtid = $maxtid - 100000; // 10wȡ
		$digestids = $this->db->fetch_all("SELECT tid FROM bbs_thread_digest ORDER BY tid DESC LIMIT 80"); //
		$digestids = $this->base->array_values($digestids, 'tid');
		$digestlist = $this->db->fetch_all_by_ids('bbs_thread', 'tid', '*', $digestids);

		$threadkeys = array_keys($threadlist);
		$postkeys = array_keys($hotlist);

		// ϵͳ̳ӣظӡ
		$fids = $this->db->fetch_all("SELECT fid FROM bbs_forum WHERE fup='$systemfid'", 'fid');
		$fids = array_keys($fids);

		$i = 0;
		foreach($threadlist as $k=>&$v) {
			if(in_array($v['fid'], $fids)) {
				$i++;
				unset($threadlist[$k]);
				continue;
			}
			if($i++ > 10) {
				unset($threadlist[$k]);
				continue;
			}
			$v['dateline'] = $this->base->date($v['dateline']);
			$v['subject'] = $this->base->xiuno_substr(strip_tags($v['subject']), 30);
		}
		$i = 0;
		foreach($hotlist as $k=>&$v) {
			if(in_array($v['fid'], $fids)) {
				$i++;
				unset($hotlist[$k]);
				continue;
			}
			if(in_array($k, $threadkeys)) {
				$i++;
				unset($hotlist[$k]);
				continue;
			}
			if($i++ > 10) {
				unset($hotlist[$k]);
				continue;
			}
			$v['dateline'] = $this->base->date($v['dateline']);
			$v['subject'] = $this->base->xiuno_substr(strip_tags($v['subject']), 30);
		}
		$hotlist = array_slice($hotlist, 0, 11);
		$i = 0;
		foreach($digestlist as $k=>&$v) {
			if(in_array($v['fid'], $fids)) {
				$i++;
				unset($digestlist[$k]);
				continue;
			}
			if(in_array($k, $threadkeys) || in_array($k, $postkeys)) {
				$i++;
				unset($digestlist[$k]);
				continue;
			}
			if($i++ > 10) {
				unset($digestlist[$k]);
				continue;
			}
			$v['dateline'] = $this->base->date($v['dateline']);
			$v['subject'] = $this->base->xiuno_substr(strip_tags($v['subject']), 30);
		}
		$digestlist = array_slice($digestlist, 0, 11);
		return array('threadlist'=>$threadlist, 'hotlist'=>$hotlist, 'digestlist'=>$digestlist);
	}

	private function get_forumgroups() {
		return $this->db->fetch_all("SELECT fid, name FROM bbs_forum WHERE type='group' AND status='0' ORDER BY displayorder DESC", 'fid');
	}

	// ͳ
	private function get_todaycount() {
		$todaycount = array();
		// ȫվͳ
		$todaycount['totalattach'] = $this->db->result_first("SELECT COUNT(*) FROM bbs_attachment");
		$todaycount['totalimages'] = $this->db->result_first("SELECT COUNT(*) FROM www_image");
		$todaycount['totalusers'] = $this->db->result_first("SELECT COUNT(*) FROM www_user");
		$todaycount['totalposts'] = $this->db->result_first("SELECT COUNT(*) FROM bbs_post");
		$todaycount['totalthreads'] = $this->db->result_first("SELECT COUNT(*) FROM bbs_thread");
		$todaycount['totalblogs'] = $this->db->result_first("SELECT COUNT(*) FROM my_blog");
		$todaycount['totalfeeds'] = $this->db->result_first("SELECT COUNT(*) FROM my_feed");

		// ͳƣȫɨ裬ҪŻ
		list($y, $n, $d) = explode('-', gmdate('Y-n-d', $this->base->time + XIUNO_TIME_OFFSET * HOUR));
		$time = gmmktime(0, 0, 0, $n, $d, $y);
		$todaycount['todayattach'] = $this->db->result_first("SELECT COUNT(*) FROM bbs_attachment WHERE dateline>'$time'");
		$todaycount['todayimages'] = $this->db->result_first("SELECT COUNT(*) FROM www_image WHERE dateline>'$time'");
		$todaycount['todayregs'] = $this->db->result_first("SELECT COUNT(*) FROM www_user WHERE regdate>'$time'");
		$todaycount['todayblogs'] = $this->db->result_first("SELECT COUNT(*) FROM my_blog WHERE dateline>'$time'");
		$todaycount['todayfeeds'] = $this->db->result_first("SELECT COUNT(*) FROM my_feed WHERE dateline>'$time'");
		$todaycount['todaythreads'] = $this->db->result_first("SELECT COUNT(*) FROM bbs_thread WHERE dateline>'$time'");
		$forums = $this->base->cache('forums');
		$todaycount['todayposts'] = 0;
		foreach($forums as $forum) {
			$todaycount['todayposts'] += $forum['todayposts'];
		}
		return $todaycount;
	}

	private function get_stats($type) {
		$data = array();
		switch($type){
			case 'index':
				$data['totalusers'] = $this->db->result_first("SELECT COUNT(*) FROM www_user");
				$data['totaladmins'] = 0;
				$groups = $this->db->fetch_all("SELECT groupid FROM www_group WHERE type='1'");
				foreach($groups as $v){
					$data['totaladmins'] += $this->db->result_first("SELECT COUNT(*) FROM www_user WHERE groupid='{$v['groupid']}'");
				}
				$data['totalforums'] = $this->db->result_first("SELECT COUNT(*) FROM bbs_forum");
				$data['totalthreads'] = $this->db->result_first("SELECT COUNT(*) FROM bbs_thread");
				$data['totalposts'] = $this->db->result_first("SELECT COUNT(*) FROM bbs_post");
				$data['totalattachs'] = $this->db->result_first("SELECT COUNT(*) FROM bbs_attachment");
				$data['totalattachsize'] = $this->base->usermodel->format_byte(intval($this->db->result_first("SELECT SUM(filesize) FROM bbs_attachment")) + intval($this->db->result_first("SELECT SUM(filesize) FROM www_image")));
				$data['totalimages'] = $this->db->result_first("SELECT COUNT(*) FROM www_image");
				$data['totalblogs'] = $this->db->result_first("SELECT COUNT(*) FROM my_blog");
				$data['totalfeeds'] = $this->db->result_first("SELECT COUNT(*) FROM my_feed");
				$data['totalpms'] = $this->db->result_first("SELECT COUNT(*) FROM my_pm");
				$data['freedisk'] = $this->base->usermodel->format_byte(disk_free_space(XIUNO_ROOT.'data'));
				break;
			case 'bbs':
				$result = $this->db->fetch_all("SELECT * FROM www_stats ORDER BY id DESC LIMIT 20"); // 20
				$daystats = array();
				foreach($result as $value) {
					$k = $value['year'].'-'.$value['month'].'-'.$value['day'];
					$daystats[$k] = $value;
				}
				$data['daystats'] = array_reverse($daystats, TRUE);
				$months = $this->db->fetch_all("SELECT DISTINCT year,month from www_stats order by id DESC limit 12"); // 12
				$monthstats = array();
				foreach($months as $month) {
					$monthstats[$month['year'].'-'.$month['month']] = $this->db->fetch_first("SELECT SUM(threads) AS threads, SUM(posts) AS posts, SUM(regusers) AS regusers, SUM(blogs) AS blogs, SUM(images) AS images, SUM(attachments) AS attachments FROM www_stats WHERE year='$month[year]' AND month='$month[month]'");
				}
				$data['monthstats'] = array_reverse($monthstats, TRUE);
				break;
			default:
				if(preg_match('/mod_(\d+)/', $type, $arr)){
					$yearmonth = $arr[1];
					$grouptypes = $this->db->fetch_all("SELECT groupid FROM www_group WHERE type='1'");
					$data = array();
					foreach($grouptypes as $group) {
						$groupid = $group['groupid'];
						$data = array_merge($data, $this->db->fetch_all("SELECT u.threads AS totalthreads,u.posts AS totalposts, u.credits, u.onlinetime AS totalonlinetime,u.groupid, u.lastactivity, u.credits, uf.username, s.* from www_user u LEFT JOIN www_stats_mod_history s USING(uid) LEFT JOIN www_userfield uf USING(uid) WHERE u.groupid='$groupid' AND s.yearmonth='$yearmonth'"));
					}
				}
				break;
		}
		return $data;
	}
}
?>