<?php

define('model/cronmodel.php', 1);

/*
	1. ÿһһ www_sqlcache
	2. ÿ10ӣһ߱ www_online
	3. ÿһν̳
*/

class cronmodel {

	private $db;
	private $base;

	function __construct(&$base) {
		$this->base = $base;
		$this->db = $base->db;
		//define('XIUNO_SQL_CACHE_GC_TIME', 7 * DAY);//һһ memcache ϡ
		define('XIUNO_ONLINE_TIME_GC_TIME', 600);//ʮһ
		//define('XIUNO_CLEAR_EXPIRED_FEED_TIME', 86400);//ÿ0
		//define('XIUNO_CLEAR_FEED', 86400);// ÿ0feed
		//define('XIUNO_REBUILD_FEEDID', 2 * MONTH);//ؽһfeed ID

		set_time_limit(600);
		ignore_user_abort(true);
		
	} // XIUNO_CRON_CLEAR_FEED_TIME XIUNO_CRON_REBUILD_FEEDID_TIME

	// ̨WEBܻظִУӵķ
	public function run() {
		$time = $this->base->time;
		$settingfile = XIUNO_CONFIG_FILE;
		if(!$this->cron_lock('cron_global')) {
			return FALSE;
		}
		$s = file_get_contents($settingfile);
		
		// ÿʮһΡ
		if($time > XIUNO_CRON_ONLINE_TIME) {
			!defined('config/bbs.php') && include XIUNO_ROOT.'config/bbs.php';

			// ߱
			$expiry = $time - XIUNO_ONLINE_HOLD_TIME;//ʱ
			$this->db->query("DELETE FROM www_online WHERE lastactivity<'$expiry'");
			
			// ´μƻʱ
			$nexttime = $time + XIUNO_ONLINE_TIME_GC_TIME;
			$this->base->settingmodel->set('global', 'XIUNO_CRON_ONLINE_TIME', $nexttime);

			// øüƻʱ䣬̳·
			if(XIUNO_BBS_INDEX_NEWPOST_ON) {
				$this->base->cachemodel->update('bbs');
			}

			// øüƻʱ䣬ͳƻԱ
			$this->base->settingmodel->set('global', 'XIUNO_STAT_TOTAL_MEMBER', $this->db->result_first("SELECT COUNT(*) FROM www_user"));
			
			// øüƻ񣬸̳
			$this->base->clearcache('forumsdata');
			$this->base->unlink_rumtime();
		}

		// ÿ0һ, ˳¼ͳϢ
		// ˳޸ıԵ©
		if($time > XIUNO_CRON_TODAYPOST_TIME) {
			$s2 = gmdate('Y-n-d', $time + XIUNO_TIME_OFFSET * 3600);
			list($y, $n, $d) = explode('-', $s2);
			$nexttime = gmmktime(0, 0, 0, $n, $d + 1, $y) - XIUNO_TIME_OFFSET * 3600;
			$this->base->settingmodel->set('global', 'XIUNO_CRON_TODAYPOST_TIME', $nexttime);
			
			// TODO:ֱͳƣҪĽȽϺķԴֻɨ趨ܣûȫɨ bbs_post
			$yestoday = $time - DAY;
			$todayposts = $this->db->result_first("SELECT SUM(todayposts) FROM bbs_forum");
			$todaythreads = $this->db->result_first("SELECT COUNT(*) FROM bbs_thread WHERE dateline>'$yestoday'");
			$todayreguser = $this->db->result_first("SELECT COUNT(*) FROM www_user WHERE regdate>'$yestoday'");
			$todayblogs = $this->db->result_first("SELECT COUNT(*) FROM my_blog WHERE dateline>'$yestoday'");
			$todayimages = $this->db->result_first("SELECT COUNT(*) FROM www_image WHERE dateline>'$yestoday'");
			$todayattachments = $this->db->result_first("SELECT COUNT(*) FROM bbs_attachment WHERE dateline>'$yestoday'");
			list($year, $month, $day) = explode('-', $this->base->date($yestoday, 'Y-m-d'));
			$this->db->query("UPDATE bbs_forum SET todayposts='0' WHERE 1");
			$this->db->query("INSERT INTO www_stats SET year='$year', month='$month', day='$day', threads='$todaythreads', posts='$todayposts', regusers='$todayreguser', blogs='$todayblogs', images='$todayimages', attachments='$todayattachments'");

			// Feed
			$this->base->feedmodel->gc();
			$nexttime = $time - MONTH;
			$this->base->unlink_rumtime();
		}

		// 5ִһ WEBŻִиöδ
		
		$this->cron_unlock('cron_global');
		$this->base->unlink_rumtime();
	}

	public function run_bbs() {
		$time = $this->base->time;
		$settingfile = XIUNO_ROOT.'config/bbs.php';
		!defined('config/bbs.php') && include_once $settingfile;

		if(!$this->cron_lock('cron_bbs')) {
			return FALSE;
		}
		$s = file_get_contents($settingfile);

		// ÿ5ɾһ data/cache/forums.php
		if($time > XIUNO_BBS_FORUMS_CACHE_UPDATE_TIME) {
			$this->base->clearcache('forums');
			$this->base->clearcache('forumsdata');
			$nexttime = $time + 300;
			$this->base->settingmodel->set('bbs', 'XIUNO_BBS_FORUMS_CACHE_UPDATE_TIME', $nexttime);
			$this->base->unlink_rumtime();
		}

		$this->cron_unlock('cron_bbs');
		$this->base->unlink_rumtime();
	}

	function cron_lock($cronname) {
		$time = $this->base->time;
		$lockfile = XIUNO_ROOT.'data/tmp/cron_'.$cronname.'.lock';
		if(file_exists($lockfile)) {
			// жļʱ䣬һӣΪѾ
			if($time - filemtime($lockfile) < 60) {
				// ʾд룬ǰ
				return FALSE;
			} else {
				// ļڣɾɡ
				unlink($lockfile);
				touch($lockfile);
				return TRUE;
			}
		} else {
			touch($lockfile);
		}
		if(!is_writable($lockfile)) {
			return FALSE;
		}
		return TRUE;
	}

	function cron_unlock($cronname) {
		$lockfile = XIUNO_ROOT.'data/tmp/cron_'.$cronname.'.lock';
		unlink($lockfile);
		return true;
	}
/*
	private function xiuno_file_put_contents($settingfile, $s) {
		if(strlen($s) < 100) {
			$this->base->logmodel->writeweblog('settingд', substr($settingfile, -7).$s);
			return false;
		}
		copy($settingfile, $settingfile.'.bak');
		$fp = fopen($settingfile, 'wb');
		flock($fp, LOCK_EX);
		fwrite($fp, $s);
		fclose($fp);
	}*/

}
?>