<?php

define('model/logmodel.php', 1);

class logmodel {

	private $db;
	private $base;

	function __construct(&$base) {
		$this->base = $base;
		$this->db = $base->db;
	}

	public function get_operation_log_by_pid($pid) {
		$data = $this->db->fetch_all("SELECT * FROM bbs_operationlog WHERE pid='$pid' ORDER BY operid DESC;");
		foreach ($data as &$v) {
			$v['dateline'] = $this->base->date($v['dateline'], 'Y-m-d H:i:s');
		}
		return $data;
	}

	public function insert_bbs_operation_log($fid, $tid, $uid, $username, $typename, $dateline, $reason, $subject, $pid=0, $page=1) {
		$sql  = "INSERT LOW_PRIORITY INTO bbs_operationlog (pid,fid,tid,uid,page,username,typename,dateline,reason, subject)";
		$sql .= " VALUES ('$pid','$fid','$tid','$uid','$page','$username','$typename','$dateline','$reason', '$subject');";
		return $this->db->query($sql);
	}

	/**
	 * Ҳ¼
	 *
	 * @param array $values		array('id'=>1,'dateline'=>array(123456789,234567890))
	 * @param array $limit		array(0,30)
	 * @return array
	 */
	public function get_operation_log($values, $page, $ppp) {
		$str = '';
		$start = ($page - 1) * $ppp;
		foreach($values as $key=>$value) {
			if($value) {
				if(is_array($value)) {
					if($value[0]) {
						if($str) {
							$str .= ' AND ';
						}
						$str .= "$key>$value[0]";
					}
					if($value[1]) {
						if($str) {
							$str .= ' AND ';
						}
						$str .= "$key<$value[1]";
					}
				} else {
					if($str) {
						$str .= ' AND ';
					}
					$str .= "$key=$value";
				}
			}
		}
		$sql = "SELECT * FROM bbs_operationlog WHERE 1 $str ORDER BY operid DESC LIMIT $start, $ppp";
		return $this->db->fetch_all($sql);
	}

	public function get_operation_log_count($values) {
		$str = '';
		foreach($values as $key=>$value) {
			if($value) {
				if(is_array($value)) {
					if($value[0]) {
						if($str) {
							$str .= ' AND ';
						}
						$str .= "$key>$value[0]";
					}
					if($value[1]) {
						if($str) {
							$str .= ' AND ';
						}
						$str .= "$key<$value[1]";
					}
				} else {
					if($str) {
						$str .= ' AND ';
					}
					$str .= "$key=$value";
				}
			}
		}
		$sql = "SELECT COUNT(*) FROM bbs_operationlog WHERE 1 $str";
		return $this->db->result_first($sql);
	}

	public function writeweblog($subject, $message) {
		$fp = fopen(XIUNO_LOG_DIR.'web.php', 'ab+');
		$date = $this->base->date($this->base->time, 'Y-m-d H:i:s');
		$string = $date."\t".$subject."\t".$message;
		$length = strlen($string);
		if($length > XIUNO_WEB_LOG_LENGTH - 2) {
			$string = substr($string, 0, XIUNO_WEB_LOG_LENGTH - 2)."\r\n";
		} else {
			$string = $string.str_repeat(' ', XIUNO_WEB_LOG_LENGTH -2 - $length)."\r\n";
		}
		fwrite($fp, $string);
		fclose($fp);
	}
}
?>