<?php

define('model/newsmodel.php', 1);

class newsmodel {

	private $db;
	private $base;

	function __construct(&$base) {
		$this->base = $base;
		$this->db = $base->db;
	}

	public function add_news($arr, $thumb = '') {
		if($arr['subject']) {
			$this->db->query("INSERT INTO www_news SET newsclassid='$arr[newsclassid]', subject='$arr[subject]', message='$arr[message]', dateline='".$this->base->time."', thumb='$thumb', uid='{$this->base->user['uid']}'");
			$insertid = $this->db->insert_id();
		}
		return $insertid;
	}

	public function get_total_num_by_newsclassid($newsclassid) {
		$sqladd = $newsclassid ? "WHERE newsclassid='$newsclassid'" : '';
     		$data = $this->db->result_first("SELECT COUNT(*) FROM www_news $sqladd");
		return $data;
	}

	public function delete_news($arr) {
		$i = 0;
		foreach((array)$arr as $newid) {
	     		if($this->db->query("/*primarykey=newsid*/ DELETE FROM www_news WHERE newsid='$newid'")) {
	     			$i++;
	     		}
		}
		return $i;
	}

	public function delete_news_attach_by_message($newsid, $message) {
     		$arr = $this->db->fetch_all("SELECT imageid, filename FROM www_image WHERE newsid='$newsid'");
     		$affectedrows = 0;
		foreach((array)$arr as $v) {
			if(strpos($message, $v['filename']) === FALSE) {
				file_exists(XIUNO_ROOT.$v['filename']) && unlink(XIUNO_ROOT.$v['filename']);
				$this->db->query("DELETE FROM www_image WHERE imageid='$v[imageid]'");
				$affectedrows ++;
			}
		}
		return $affectedrows;
	}

	public function get_news_by_newsid($newsid) {
     		$arr = $this->db->fetch_first("/*cachelife=3600&mckey=www_news_$newsid*/ SELECT * FROM www_news WHERE newsid='$newsid'");
		return $arr ? $this->format_news($arr) : array();
	}

	public function update_news($arr, $newsid) {
     		$this->db->query("/*primarykey=newsid*/ UPDATE www_news SET subject='$arr[subject]', message='$arr[message]', newsclassid='$arr[newsclassid]' WHERE newsid='$newsid'");
		return $this->db->affected_rows();
	}

	public function get_news_by_newsclassid_page($page, $ppp, $totalnum, $newsclassid) {
     		$start = ($page - 1) * $ppp;
		$totalpage = ceil($totalnum / $ppp);
		if($start >= $totalnum) {
			$start = $totalnum - $ppp;
			$start = $start > 0 ? $start : 0;
		}
		return $this->get_news_by_newsclassid($start, $ppp, $newsclassid);
	}

	public function get_news_by_newsclassid($start, $ppp, $newsclassid) {
		$sqladd = $newsclassid ? "WHERE newsclassid='$newsclassid'" : '';
		$query = $this->db->query("SELECT * FROM www_news $sqladd ORDER BY displayorder DESC LIMIT $start, $ppp");
		$data = $datas = array();
		while($data = $this->db->fetch_array($query)) {
			$data = $this->format_news($data);
			$datas[] = $data;
		}
		return $datas;
	}

	public function format_news($data) {
		$data['dbdateline'] = $data['dateline'];
		$data['dateline'] = $this->base->date($data['dateline']);
		return $data;
	}

	public function get_filename_by_aid($aid) {
		$data = $this->db->result_first("SELECT filename FROM www_image WHERE aid ='$aid' LIMIT 1");
		return $data;
	}

	//----------------> user ls
	public function get_news_totalnum_by_condition($sqladd) {
		$num = $this->db->result_first("SELECT COUNT(*) AS num FROM www_news WHERE $sqladd", 100);
		return $num;
	}

	public function get_news_list_by_condition($page, $ppp, $totalnum, $sqladd) {
		$start = $this->base->page_get_start($page, $ppp, $totalnum);
		$arr = $this->db->fetch_all("SELECT * FROM www_news WHERE $sqladd LIMIT $start, $ppp");
		if($arr) {
			foreach($arr as $k=>&$v) {
				$v['image'] = substr($v['thumb'], 0, -4);
				$v['message'] = $this->base->xiuno_substr(strip_tags($v['message']), 800);
			}
		}
		return $arr;
	}
	public function get_news_list_by_group($array) {
		return $this->db->fetch_all("SELECT * FROM www_news WHERE newsid in('".implode("','", $array)."')");
	}
}
?>