<?php

define('model/noticemodel.php', 1);

class noticemodel {

	private $db;
	private $base;

	function __construct(&$base) {
		$this->base = $base;
		$this->db = $base->db;
	}
	
	public function add_notice($fromuid, $touid, $fromusername, $tousername, $subject, $type = 'normal') {
		if($type != 'normal') {
			$subject = addslashes(serialize($subject));
		}
		$this->db->query("INSERT INTO my_notice SET fromuid='$fromuid', touid='$touid', fromusername='$fromusername', tousername='$tousername', type='$type', subject='$subject', dateline='{$this->base->time}'");
	}
	
	public function get_noticelist_by_uid_page($uid, $start, $length) {
		
		$noticelist = $this->db->fetch_all("SELECT * FROM my_notice WHERE touid='$uid' ORDER BY noticeid DESC LIMIT $start, $length");
		foreach($noticelist as &$notice) {
			$this->format_notice($notice);
			$notice['dateline'] = $this->base->date($notice['dateline']);
		}
		return $noticelist;
	}
	
	public function format_notice(&$notice) {
		if($notice['type'] != 'normal') {
			$arr = unserialize($notice['subject']);
		}
		switch($notice['type']) {
			case 'blogreply':
				$notice['icon'] = "<img src='".XIUNO_HOST_IMAGE."image/common/home_icon_reply.gif' align='absmiddle'/>";
				$notice['subject'] = $this->get_user_link($notice['fromuid'], $notice['fromusername'])." Ĳ <a href='".XIUNO_HOST_MY."blog-detail-$arr[blogid].htm' target='_blank'>$arr[subject]</a> <br />$arr[message]";
				break;
			case 'imagereply':
				$notice['icon'] = "<img src='".XIUNO_HOST_IMAGE."image/common/home_icon_reply.gif' align='absmiddle'/>";
				$s = '<div class="imgbox">';
				$s .= '<a href="'.XIUNO_HOST_MY.'image-detail-'.$arr['imageid'].'.htm?uid='.$notice['fromuid'].'" target="_blank"><img src="'.XIUNO_HOST_IMAGE.$arr['filename'].'" onload="if(this.width>=120) this.width=\'120\';if(this.height >=90) this.height=\'90\'" /></a>';
				$s .= '<span>'.$arr['message'].'</span>';
				$s .= '</div>';
				$notice['subject'] = $this->get_user_link($notice['fromuid'], $notice['fromusername'])." ͼƬ<br />".$s;
				break;
			case 'denyfriendrequest':
				$notice['icon'] = "<img src='".XIUNO_HOST_IMAGE."image/common/denyfriendrequest.gif' align='absmiddle'/>";
				$notice['subject'] = $this->get_user_link($notice['fromuid'], $notice['fromusername'])." ĺ";
			case 'normal':
				$notice['icon'] = "<img src='".XIUNO_HOST_IMAGE."image/common/denyfriendrequest.gif' align='absmiddle'/>";
				break;
			default:
				break;
		}
	}
	
	private function get_user_link($uid, $username) {
		return "<a href='".XIUNO_HOST_MY.'index-index-'.$uid.".htm' target='_blank'>$username</a>";
	}
	
			
}	
?>