<?php

define('model/pmmodel.php', 1);

class pmmodel {

	private $db;

	function __construct(&$base) {
		$this->base = $base;
		$this->db = $base->db;
	}

	public function get_pm_by_pmid($pmid) {
        	$pm = $this->db->fetch_first("SELECT * FROM my_pm WHERE pmid='$pmid'");
        	return $this->format_pm($pm);
        }

	private function format_pm($pm) {
        	$pm['dateline'] = $this->base->date($pm['dateline']);
        	$pm['subject'] = '<span'.($pm['new'] ? ' class="bold"' : '').'>'.$pm['subject'].'</span>';
        	return $pm;
        }

        /********************
         * tousers Ϊ,ʽΪ
	 * array('uid1' =>' username1', 'uid2' => 'username2'.....);
	 *********************/
	public function add_pm($subject, $message, $tousers, $uid, $username) {
			$dateline = $this->base->time;
			$sql = "INSERT INTO my_pm(`uid`, `lowid`,`lowuser`,`highid`,`highuser`,`new`,`dateline`,`subject`,`message`) VALUES ";
			$toids = array_keys($tousers);
			$i = 0;
			foreach($tousers as $k=>$v) {
				$i++;
				if($uid > $k) {
					$highid = $uid;
					$highuser = $username;
					$lowid = $k;
					$lowuser = $v;
				} else {
					$highid = $k;
					$highuser = $v;
					$lowid = $uid;
					$lowuser = $username;
				}
				$sql .= "('$k', '$lowid','$lowuser','$highid','$highuser','1','$dateline','$subject','$message'),";
			}
			$sql = substr($sql, 0, -1);
			$this->db->query($sql);
			foreach($toids as $touid) {
				$this->base->eventmodel->increase_event($touid, 'new_pm');
			}
	}

	public function system_message($subject, $message, $tousers){
		$dateline = $this->base->time;
		$sql = "INSERT INTO my_pm(`uid`, `lowid`,`lowuser`,`highid`,`highuser`,`new`,`dateline`,`subject`,`message`) VALUES ";
		foreach($tousers as $uid=>$username) {
			$sql .= "('$uid', '0','ϵͳԱ','$uid','$username','1','$dateline','$subject','$message'),";
			$this->base->eventmodel->increase_event($uid, 'new_pm');
		}
		$sql = substr($sql, 0, -1);
		$this->db->query($sql);
	}


        public function get_pms_by_page($lowid, $highid, $page, $ppp) {
        	$start = ($page-1) * $ppp;
		return $this->db->fetch_all("SELECT * FROM my_pm WHERE lowid='$lowid' AND highid='$highid' ORDER BY pmid LIMIT $start,$ppp");
        }

        // TODO ֤uidǷ
        public function get_pm_by_page($uid, $page, $ppp) {
        	$start = ($page-1) * $ppp;
        	return $this->db->fetch_all("SELECT * FROM my_pm WHERE uid='$uid' ORDER BY pmid DESC LIMIT $start,$ppp", 'pmid');
        }

        // @$newpmids array
        public function edit_new_pm($newpmids, $uid) {
		$i = 0;
        	foreach($newpmids as $pmid) {
			$this->db->query("UPDATE my_pm SET new='0' WHERE pmid='$pmid'");
			$i++;
		}
		$this->base->eventmodel->decrease_event($uid, 'new_pm', $i);
        }

        public function get_new_pmlist($uid, $fuid) {
		$lowid = min($uid, $fuid);
		$highid = max($uid, $fuid);
		$newpmlist = $this->db->fetch_all("SELECT * FROM my_pm WHERE lowid='$lowid' AND highid='$highid' ORDER by pmid DESC limit 5", 'pmid');
		if(!empty($newpmlist)) {
			$i = 0;
			foreach($newpmlist as $k=>&$pm) {
				if($pm['new'] && $pm['uid'] == $uid){
					$pm['dateline'] = $this->base->date($pm['dateline'], 'm-d H:i');
					$pm['fromuser'] = $pm['lowid'] == $uid ? $pm['highuser'] : $pm['lowuser'];
					$this->db->query("UPDATE my_pm SET new='0' WHERE pmid='{$pm['pmid']}'");
					$i++;
				} else {
					unset($newpmlist[$k]);
				}
			}
			$this->base->eventmodel->decrease_event($uid, 'new_pm', $i);
			ksort($newpmlist);
			return $newpmlist;
		} else {
			return array();
		}
        }

        public function get_pm_num($uid) {
        	return $this->db->result_first("SELECT COUNT(*) FROM my_pm WHERE uid='$uid'");
        }
}
?>