<?php

define('model/postmodel.php', 1);

class postmodel {

	private $db;
	private $base;

	function __construct(&$base) {
		$this->base = $base;
		$this->db = $base->db;
	}

	/**
	 * ɾ
	 *
	 * @param array/int $tids
	 */
	public function delete_thread($tids) {
		$tids = array_unique((array)$tids);
		$totalpost = 0;
		$postuids = $threaduids = $threadfids = $forumlist = $posts = $attachuids = $policy = $fidtids = array();
		$updatetop = array();
		foreach((array)$tids as $tid) {
			$thread = $this->db->fetch_first("SELECT * FROM bbs_thread WHERE tid='$tid'");
			if(empty($thread)) {
				continue;
			}
			$fid = $thread['fid'];
			$fidtids[$fid][] = $tid;

			// ˭
			getvalue($threaduids[$thread['uid']], 0);
			$threaduids[$thread['uid']]++;

			// ĸ̳
			getvalue($threadfids[$thread['fid']], 0);
			$threadfids[$thread['fid']]++;
			getvalue($policy[$thread['uid']][$thread['fid']]['_thread'], 0);
			$policy[$thread['uid']][$thread['fid']]['_thread']++;

			// ˭
			$attachs = $this->db->fetch_all("SELECT * FROM bbs_attachment WHERE tid='$tid'");
			foreach((array)$attachs as $attach) {
				unlink(XIUNO_ROOT.$attach['filename']);
				getvalue($attachuids[$attach['uid']], 0);
				$attachuids[$attach['uid']] += $attach['filesize'];
//				getvalue($policy[$attach['uid']][$thread['fid']]['_upload'], 0);
//				$policy[$attach['uid']][$thread['fid']]['_upload']++;
			}
			$this->db->query("DELETE FROM bbs_attachment WHERE tid='$tid'");

			// ˭
			$posts = $this->db->fetch_all("SELECT fid, pid, uid FROM bbs_post WHERE tid='$tid'");
			foreach((array)$posts as $post) {
				getvalue($postuids[$post['uid']], 0);
				$postuids[$post['uid']]++;
				$totalpost++ ;
				!isset($forumlist[$post['fid']]) && $forumlist[$post['fid']] = 0;
				$forumlist[$post['fid']]++;
				getvalue($policy[$post['uid']][$thread['fid']]['_post'], 0);
				$policy[$post['uid']][$thread['fid']]['_post']++;
			}

                        //  ɾ
                        if($tid && $thread['typeid'] == BBS_THREAD_POLL) {
                        	$this->db->query("/*primarykey=tid*/ DELETE FROM bbs_poll WHERE tid='$tid'");
                        	$this->db->query("/*primarykey=tid*/ DELETE FROM bbs_poll_user WHERE tid='$tid'");
                        	$this->db->query("/*primarykey=tid*/ DELETE FROM bbs_poll_option WHERE tid='$tid'");
                        }

			// ɾ ظ
			$this->db->query("/*primarykey=tid*/ DELETE FROM bbs_thread WHERE tid='$tid'");
			$this->db->query("/*primarykey=tid*/ DELETE FROM bbs_threadindex WHERE tid ='$tid'");
			//$pids = $this->db->fetch_all("SELECT pid FROM bbs_post WHERE tid='$tid'", 'pid');
			
			$this->db->query("/*primarykey=tid*/ DELETE FROM bbs_post WHERE tid='$tid'");

			// ɾ¥ظϢ
			$this->db->query("DELETE FROM bbs_post_reply WHERE tid='$tid'");

			// Ϊöö
			if($thread['displayorder'] > 0) {
				$updatetop[$fid][$thread['displayorder']] = TRUE;
				$this->db->query("DELETE FROM bbs_thread_displayorder WHERE tid='$tid'");
			}

			// Ϊ¾
			if($thread['digest'] > 0) {
				$this->db->query("DELETE FROM bbs_thread_digest WHERE tid='$tid'");
			}
		}

		// ö棬һͶ
		if($updatetop) {
			$havetop3 = FALSE;
			foreach($updatetop as $fid=>$val) {
				foreach($val as $displayorder=>$__) {
					$havetop3 = $havetop3 ? $havetop3 : ($displayorder == 3 ? TRUE : FALSE);
					$this->base->cachemodel->update('top', $fid);
				}
			}
			if($havetop3) {
				$this->base->cachemodel->update('tops');
			}
		}

		// ûС
		foreach((array)$attachuids as $uid=>$filesize) {
			$this->db->query("/*primarykey=uid*/ UPDATE LOW_PRIORITY www_userfield SET attachsum=attachsum-'$filesize' WHERE uid='$uid'");
		}

		// û
		foreach((array)$postuids as $uid=>$count) {
			!isset($threaduids[$uid]) && $threaduids[$uid] = 0;
			$this->db->query("/*primarykey=uid*/ UPDATE LOW_PRIORITY www_user SET posts=posts-'$count',threads=threads-'{$threaduids[$uid]}' WHERE uid='$uid'");
		}
		foreach($policy as $uid=>$actions) {
			$this->base->creditmodel->update_credit_by_actions($uid, $actions);
		}

		// ̳, 󷢱
		foreach((array)$forumlist as $fid=>$count) {
			$this->base->forummodel->set_forum_lastpost($fid, ",threads=threads-'{$threadfids[$fid]}',posts=posts-'$count'");
		}

		// һ
		if(XIUNO_BBS_TID_CACHE_1_ON) {
			foreach($fidtids as $fid=>$tids) {
				$this->base->tidcachemodel->delete_tids($fid, $tids);
			}
		}

		// TODO: ¼ɾ, ⱻSPHINXʱҪ
		$fp = fopen(XIUNO_TMP_DIR.'deleted_tid.txt', 'ab+');
		flock($fp, LOCK_EX);
		fwrite($fp, "\t".implode("\t", $tids));
		fclose($fp);
	}

	/**
	 * ɾӣظ
	 *
	 * @param array $post
	 * @param bool $updatestatus ǷɾĬϳɾΪtrueʱֻǸbbs_post״̬λstatus=1
	 * @return true
	 */
	public function delete_post($post) {
		$tid = $post['tid'];
		$fid = $post['fid'];
		$pid = $post['pid'];
		$uid = $post['uid'];
		if($post['first']) {
			$this->delete_thread($tid);
		} else {
			$policy = array();
			getvalue($policy[$fid]['_post'], 0);
			$policy[$fid]['_post']++;
			// û
			$attachs = $this->db->fetch_all("SELECT * FROM bbs_attachment WHERE pid='$pid'");
			$attachuids = array();
			foreach((array)$attachs as $attach) {
				// ͼ
				unlink(XIUNO_ROOT.$attach['filename']);
				$attachuids[$attach['uid']] += $attach['filesize'];
				getvalue($policy[$fid]['_upload'], 0);
				$policy[$fid]['_upload']++;
			}
			$this->db->query("DELETE FROM bbs_attachment WHERE pid='$pid'");

			foreach((array)$attachuids as $uid=>$filesize) {
				$this->db->query("/*primarykey=uid*/ UPDATE LOW_PRIORITY www_userfield SET attachsum=attachsum-'$filesize' WHERE uid='$uid'");
			}

			if(XIUNO_BBS_POST_PAGE_ON) {
				// ɾʱ߻ƣɾӣڶڲʱŻ
				$this->db->query("/*primarykey=pid*/ UPDATE LOW_PRIORITY bbs_post SET status='1' WHERE pid='$pid'");
				// bbs_postfield
			} else {
				// ͳɾӣɾ
				$this->db->query("/*primarykey=pid*/ DELETE LOW_PRIORITY FROM bbs_post WHERE pid='$pid'");
			}

			// û
			$this->db->query("/*primarykey=uid*/ UPDATE LOW_PRIORITY www_user SET posts=posts-'1' WHERE uid='$uid'");

			// 
			$this->db->query("/*primarykey=tid*/ UPDATE LOW_PRIORITY bbs_thread SET posts=posts-'1' WHERE tid='$tid'");

			// ̳
			$this->db->query("/*primarykey=fid*/ UPDATE LOW_PRIORITY bbs_forum SET posts=posts-'1' WHERE fid='$fid'");

			// ɾ¥ظϢ
			$this->db->query("DELETE LOW_PRIORITY FROM bbs_post_reply WHERE pid='$pid'");
			$this->base->creditmodel->update_credit_by_actions($uid, $policy);
		}
		return TRUE;
	}

	// ĳлظ pageֶ. ڴɾĳڵĻ
	public function update_thread_page($tid, $ppp) {
		$pids = $this->db->fetch_all("SELECT pid,status FROM bbs_post WHERE tid='$tid'");

		foreach($pids as $row){
			if($row['status']){
				$this->db->query("DELTE FROM bbs_post WHERE pid='$row[pid]'");
			}
		}
		$query = $this->db->query("SELECT pid FROM bbs_post WHERE tid='$tid' ORDER BY dateline");
		$page = 1;
		$i = 0;
		while($row = $this->db->fetch_array($query)){
			$i++;
			$pid = $row['pid'];
			$this->db->query("UPDATE bbs_post SET page='$page' WHERE pid='$pid'");
			if($i == 20) $page++;
		}
	}

	public function poll_check($uid, $tid) {
		return $this->db->result_first("SELECT COUNT(*) FROM bbs_poll_user WHERE  uid='$uid' AND tid='$tid'");
	}

	public function poll_validate($checks, $tid) {
		$maxcheck = $this->db->result_first("SELECT maxcheck FROM bbs_poll WHERE tid='$tid'");
		$data = array();
		foreach($checks as $optionid) {
			if($this->db->result_first("SELECT tid FROM bbs_poll_option WHERE optionid='$optionid'") == $tid) {
				$data[] = $optionid;
			}
		}
		return array_slice($data, 0, $maxcheck);
	}

	// feed lastpost  
	// Ҫ˵ֱӵô˺
	public function after_audit($data) {
		$this->base->tidcachemodel->add_tid($data['fid'], $data['tid']);

		//  feed
		$this->base->feedmodel->add_feed(array('uid'=>$data['uid'], 'username'=>$data['username'], 'tid'=>$data['tid'], 'subject'=>$data['subject'], 'fid'=>$data['fid'], 'forumname'=>strip_tags($data['forumname'])), 'post', $this->base->time, $data['uid']);

		// ̳󷢱
		$lastpost = "{$this->base->time}	{$data['username']}	{$data['subject']}	{$data['tid']}";
		$this->db->query("UPDATE LOW_PRIORITY bbs_forum SET threads=threads+'1', posts=posts+'1', todayposts=todayposts+'1', lastpost='".addslashes($lastpost)."' WHERE fid='$data[fid]'");

		// û
		$this->base->creditmodel->update_credit_by_policy($data['uid'], 'thread', $data['fid']);
		$this->db->query("/*primarykey=uid*/ UPDATE www_user SET threads=threads+'1', posts=posts+'1' WHERE uid='{$data['uid']}'");
	}

	public function update_isoperated($pid) {
		return $this->db->query("/*primarykey=pid*/ UPDATE bbs_post SET isoperated='1' WHERE pid='$pid' LIMIT 1;");
	}
	public function get_tid($fid) {
		$this->db->query("INSERT INTO bbs_threadindex set fid='$fid'");
		return $this->db->insert_id();
	}

	public function delete_tid_page_memcache($tid, $page) {
		$page = max(1, $page);
		XIUNO_MEMCACHE_ON && $this->db->memcache_delete(md5("SELECT pid FROM bbs_post WHERE tid='$tid' AND page='$page'"));
	}
}
?>