<?php

define('model/profilemodel.php', 1);

class profilemodel {

	private $db;
	private $base;
	private $profilecache;

	function __construct(&$base) {
		$this->base = $base;
		$this->db = $base->db;
	}

	public function load_profilecache($key) {
		if(empty($this->profilecache)) {
			include XIUNO_ROOT.'./config/profile.php';
			$this->profilecache = $profilecache;
		}
		return $this->profilecache[$key];
	}

	public function delete_user_fav($uid) {
		$this->db->query("DELETE FROM my_userfavor WHERE uid='$uid'");
		return TRUE;
	}

	public function xiuno_explode($s) {
		$s = str_replace(array('', ',', "", '', '', '', "\t", "\r\n", "\n"), ' ', $s);
		$s = preg_replace("/\s+/", ' ', $s);
		return explode(' ', $s);
	}

	public function update_user_fav($uid, $type, $favstr) {
		$valuearr = $this->xiuno_explode($favstr);
		$valuestr = '';
		foreach($valuearr as $val) {
			$val && $valuestr .= ($valuestr ? ',' : '')."('$uid','$type','$val')";
		}
		$valuestr && $this->db->query("INSERT INTO my_userfavor VALUES $valuestr");
		return $favstr;
	}

	public function get_user_fav($uid, $type) {
		$favarr = $this->db->fetch_all("SELECT value FROM my_userfavor WHERE uid='$uid' AND type='$type'");
		$favstr = '';
		foreach((array)$favarr as $fav) {
			$favstr .= ($favstr ? ' ' : '').$fav['value'];
		}
		return $favstr;
	}
	
	// ȡַб
	/**
		˵
		<select id="country_name1"
		<select id="province_name1"
		<select id="city_name1"
	*/
	public function get_address_select($name, $pid, $checkedid = FALSE) {
		$addresslist = $this->get_address_list($pid);
		if(empty($addresslist)) {
			return '';
		}
		$addr = $this->get_address_by_id($pid);
		getvalue($addr['level']);
		$nextlevel = $addr['level'] + 1;
		
		// 
		if($nextlevel == 1) {
			$selectname = $name.'country';
			$nextselectid = $name.'province';
			$nextselectid2 = $name.'city';
		} elseif($nextlevel == 2) {
			$selectname = $name.'province';
			$nextselectid = $name.'city';
			$nextselectid2 = $name.'area';
		} elseif($nextlevel == 3) {
			$selectname = $name.'city';
			$nextselectid = $name.'area';
			$nextselectid2 = '';
		} else {
			return '';
		}
		
		$url = XIUNO_HOST_MY."profile-getaddress.htm?name=$name&pid=";
		$onchange = "ajaxget('$url'+this.value, '$nextselectid', '')";
		// ¼˵
		$onchange .=($nextselectid2 ? ';if($(\''.$nextselectid2.'\'))show(\''.$nextselectid2.'\', \'none\')' : '');
		return $this->base->form->get_select($selectname, $addresslist, $checkedid, array('onchange'=>$onchange));
	}

	// ȡַб
	private function get_address_list($pid) {
		$arr2 = array('' => 'ѡ');
		$arr = $this->db->fetch_all("SELECT id,name FROM www_address WHERE parentid='$pid'");
		foreach($arr as $v) {
			$arr2[$v['id']] = $v['name'];
		}
		return $arr2;
	}

	// ȡַб
	private function get_address_by_id($id) {
		return $this->db->fetch_first("SELECT id, name, level FROM www_address WHERE id='$id'");
	}

	public function get_address_name($addressid) {
		return $this->db->result_first("SELECT name FROM www_address WHERE id='$addressid'");
	}

	// array(1,1,1,1,1,1,)
	public function array2int($arr) {
		$int = 0;
		foreach($arr as $val) {
			$int = $int | pow(2, $val);
		}
		return $int;
	}

	public function int2array($int) {
		$arr = str_split(strrev(decbin($int)));
		return $arr;
	}
}
?>