<?php

define('model/stringmodel.php', 1);

class stringmodel {

	private $db;
	private $base;
	private $search = array();
	private $replace = array();

	function __construct(&$base) {
		$this->base = $base;
		$this->db = $base->db;
	}

	public function strip_script(&$s) {
		$s = preg_replace('/style\s*=\s*\'([^\'])\'/ise', "\$this->strip_style_comment('\\1')", $s);
		$s = preg_replace('/style\s*=\s*\"([^\"]+)\"/ise', "\$this->strip_style_comment('\\1')", $s);
		$s = preg_replace('/(xss|javax|java|vbs|vbscript|javascript|expression)\s*:\s*\S+?\(\S+?\)/is', '', $s);
		$s = str_replace('javascript:', '', $s);
		$s = preg_replace('/expression\s*\(/', 'express(', $s);
		$s = preg_replace('/on(\w+)\s*=/is', 'no\\1=', $s);
		//$s = preg_replace('/(?<!url)\s*\(\S+?\)/is', '**', $s);
		$s = strip_tags($s, '<object><embed><param><a><b><b><em><img><strong><big><br><cite><center><dd><dl><dt><h1><h2><h3><h4><h5><h6><label><map><marquee><object><embed><pre><small><sub><sup><th><hr><div><table><tr><td><thead><tbody><tfoot><span><ul><li><p><ol><u><i><font>');
	}

	public function filter_keyword($s) {
		if(empty($this->search)) {
			include XIUNO_ROOT.'data/www/keyword.php';
			$this->search = array_keys($filter);
			$this->replace = array_values($filter);
		}
		return str_replace($this->search, $this->replace, $s);
	}

	public function strip_style_comment($s) {
		return preg_replace("/\/\*.*?\*\//is", '', $s);
	}

	/*
	public function bbcode_to_html(&$s) {
		//$s = str_replace(array('<', '>'), array('&lt;', '&gt;'), $s);
		$s = htmlspecialchars($s);

		//Σմ
		$s = preg_replace('/expression\s*\(/', 'expression', $s);

		$s = preg_replace("/\[url\](.+?)\[\/url\]/i", "<a href=\"\\1\" target=\"_blank\">\\1</a>", $s);
		$s = preg_replace("/\[url=(.+?)\](.+?)\[\/url\]/i", "<a href=\"\\1\" target=\"_blank\">\\2</a>", $s);
		$s = preg_replace("/\[color=([^\[]+?)\]/i", "<font color=\"\\1\">", $s);
		$s = preg_replace("/\[size=(\d+?)\]/i", "<font size=\"\\1\">", $s);
		$s = preg_replace("/\[font=([^\[]+?)\]/i", "<font face=\"\\1\">", $s);
		$s = preg_replace("/\[font ([^\[]+?)\]/i", "<font \\1>", $s);
		$s = preg_replace("/\[p=([^\[]+?)\]/i", "<p align=\"\\1\">", $s);

		$s = str_replace(
			array('[/color]', '[/size]', '[/font]', '[b]',
			'[/b]','[i]', '[/i]', '[u]', '[/u]',
			'[p]', '[/p]', '[span]', '[/span]', '[div]',
			'[/div]', '[ul]', '[/ul]', '[li]', '[/li]'),
			array('</font>', '</font>', '</font>', '<b>',
			'</b>', '<i>','</i>', '<u>', '</u>',
			'<p>', '</p>','<span>', '</span>', '<div>',
			'</div>','<ul>', '</ul>','<li>', '</li>'), $s);
		$s = preg_replace("/\[img=(\w+)\](.+?)\[\/img\]/i", "<a href=\"\\1\" target=\"_blank\"><img src=\"\\2\" align=\"\\1\"/></a>", $s);
		$s = preg_replace("/\[img\](.+?)\[\/img\]/i", "<a href=\"\\1\" target=\"_blank\"><img src=\"\\1\" /></a>", $s);

		$s = str_replace(array('\t', '  ', '  ', "\r\n", "\n"), array('', '', '', '<br />', '<br />'), $s);
	}*/
}
?>