<?php

define('model/threadmodel.php', 1);

class threadmodel {

	private $db;
	private $base;

	function __construct(&$base) {
		$this->base = $base;
		$this->db = $base->db;
	}

	function ajax_recall_index() {
		return '<avatar>test</avatar>';
	}
/*
	public function get_postlist_by_tid($page, $ppp, $totalnum, $tid, $word) {
		$start = ($page-1) * $ppp;
		$posts = $this->db->fetch_all("SELECT * FROM bbs_post WHERE tid='$tid' ORDER BY pid LIMIT $start, $ppp");
		$userinfo = array();
		foreach($posts as $k=>&$post) {
			$post = array_merge($post, $userinfo[$post['uid']]);
			$post['floor'] = $k + $start + 1;
			$this->format_post($post, $word);
			$post['replylist'] = XIUNO_BBS_POST_REPLY_ON && $post['replies'] ?
				$this->get_postreply_by_pid($post['pid'], $post['replies']) : 0;
		}
		return $posts;
	}*/

	public function get_theadlist_by_tids($tids) {
		$data = array();
		//δ
		$data = $this->db->fetch_all_by_ids('bbs_thread', 'tid', '*', $tids);
		return $data;
	}

	public function get_thread_by_tid($tid, $nocache = FALSE) {
		$sqladd = $nocache || $this->base->isrobot && $this->base->page > XIUNO_MEMCACHE_ROBOT_PAGE ? '' : '/*cachelife=3600&mckey=bbs_thread_'.$tid.'*/';
		return $this->db->fetch_first("$sqladd SELECT * FROM bbs_thread WHERE tid='$tid'");
	}

	public function get_auditthread_by_tid($tid) {
		return $this->db->fetch_first("SELECT * FROM bbs_threadaudit WHERE tid='$tid'");
	}

	public function get_firstpost_by_tid($tid) {
		$pid = $this->db->fetch_first("/*cachelife=3600&mckey=bbs_thread_$tid*/ SELECT * FROM bbs_thread WHERE tid='$tid'");
		$pid = $pid['firstpid'];

		if(!$pid) return array();
                $data = $this->db->fetch_first("/*cachelife=3600&mckey=bbs_post_$pid*/ SELECT * FROM bbs_post WHERE pid='$pid'");
                $data['dateline'] = $this->base->date($data['dateline']);
                $data['avatar'] = $this->base->get_avatar($data['uid']);
                $data['usernameurl'] = urlencode($data['username']);
                $data += (array)$this->db->fetch_first("/*cachelife=3600&mckey=www_user_$data[uid]*/ SELECT * FROM www_user WHERE uid='$data[uid]'");
                $this->base->usermodel->format_user($data);
		return $data;
	}

	public function get_post_by_pid($pid) {
		$sqladd = $this->base->isrobot && $this->base->page > XIUNO_MEMCACHE_ROBOT_PAGE ? '/*mckey=bbs_post_'.$pid.'*/SELECT' : 'SELECT ';
                return $this->db->fetch_first("$sqladd * FROM bbs_post WHERE pid='$pid'");
	}

	public function format_post(&$post, &$word) {
		$post['dateline'] = $this->base->date($post['dateline'], 'Y-m-d H:i:s');
		$post['usernameurl'] = urlencode($post['username']);
		$post['message'] = str_replace($word, "<span class=\"red\">{$word}</span>", $post['message']);
		/*empty($post['htmlon']) && $this->bbcode($post['message']);*/
		if($post['attachnum']) {
			/*if($post['status'] > 0) {
				$post['attachhtml'] = '<div class="quote" style="margin-top:25px;">û, Զ</div>';
			} else {
				$post['attachhtml'] = '<div class="quote" style="margin-top:25px;"><div><b>б</b></div><ul class="attachlist">';
				$attachlist = $this->db->fetch_all("SELECT aid, filename, filetype, downloads, dateline FROM bbs_attachment WHERE pid='$post[pid]'");

				foreach($attachlist as $attach) {
					$dir = substr($attach['filename'], 0, strrpos($attach['filename'], '/'));
			                $filename = substr($attach['filename'], strrpos($attach['filename'], '/')+1);
			              	$attach['filename_url'] = XIUNO_HOST_IMAGE.$dir.'/'.$this->xiuno_urlencode($filename);
					$post['attachhtml'] .= '<li>'.$this->file_to_html($attach['filename'], $attach['filetype'], array('aid'=>$attach['aid'], 'filename_url'=>$attach['filename_url'], 'downloads'=>$attach['downloads'], 'dateline'=>$this->base->date($attach['dateline']))).'</li>';
				}
				$post['attachhtml'] .= '</ul></div>';
			}
			$post['message'] .= $post['attachhtml'];*/
		}
	}
	
	public function get_attach_list($pids) {
		$attachlist = $attachlist2 = array();
		$sqladd = $this->base->array_to_sql_or($pids, 'pid');
		$attachlist = $this->db->fetch_all("SELECT * FROM bbs_attachment WHERE $sqladd");
		foreach($attachlist as &$attach) {
			$attach['icon'] = XIUNO_HOST_IMAGE.'image/filetype/'.$attach['filetype'].'.gif';
			if(XIUNO_NGINX_ACCESS_KEY) {
				$attach['accesskey'] = '?'.md5(XIUNO_NGINX_ACCESS_KEY.$this->base->ip);
			}
			$attachlist2[$attach['pid']][$attach['aid']] = $attach;
		}
		return $attachlist2;
	}
	/*
	//copy from upload.class.php
	public function file_to_html($fileurl, $filetype, $extra = array()) {
		$imageid = !empty($extra['imageid']) ? $extra['imageid'] : 0;
		$downloads = !empty($extra['downloads']) ? $extra['downloads'] : 0;
		$dateline = !empty($extra['dateline']) ? 'ϴ '.$extra['dateline'] : '';
		if($filetype == 'image') {
			list($imagewidth, $imageheight) = getimagesize($fileurl);
			$rate = $imageheight/$imagewidth;
			$imagewidth = $imagewidth >= 740 ? 740 : $imagewidth;
			$imageheight = intval($rate * $imagewidth);
			$dir = substr($fileurl, 0, strrpos($fileurl, '/'));
			$filename = substr($fileurl, strrpos($fileurl, '/') + 1);
			$fileurl = $dir.'/'.urlencode($filename);
			return '<a href="'.$fileurl.'"'.(isset($extra['align']) ? " align=\"$extra[align]\"" : '').' target="_blank"><img src="'.XIUNO_HOST_IMAGE.$fileurl.'" width="'.$imagewidth.'" height="'.$imageheight.'" /></a>'."<!--imageid=$imageid-->";
		} elseif($filetype == 'flash') {
			return '<embed src="'.$fileurl.'" width="400" height="300"></embed>';
		}else {
			$filename = htmlspecialchars(substr($fileurl, strrpos($fileurl, '/') + 1));
			return '<img src="image/filetype/'.$filetype.'.gif" /><a href="'.$fileurl.'.htm" onclick="ajaxmenu(this.href, 1)" target="_blank">'.$filename."</a> {$dateline},ش$downloads";
			//return '<img src="image/filetype/'.$filetype.'.gif" /><a href="'.XIUNO_HOST_IMAGE.'attach-index-'.$extra['aid'].'.htm" onclick="ajaxmenu(this.href, 1)" target="_blank">'.$filename."</a> {$dateline},ش$downloads";
		}
	}
	*/
	public function xiuno_urlencode($s) {
		return str_replace(array('%28', '%29', '+'), array('(', ')', '%20'), urlencode($s));
	}

	//  BBCODE
	public function bbcode(&$message) {
		$searcharray = $replacearray = array();
		$searcharray['bbcode_regexp'] = array(
			"/\s*\[quote\][\n\r]*(.+?)[\n\r]*\[\/quote\]\s*/is",
			"/\[url\]\s*(www.|https?:\/\/|ftp:\/\/|gopher:\/\/|news:\/\/|telnet:\/\/|rtsp:\/\/|mms:\/\/){1}([^\[\"']+?)\s*\[\/url\]/is",
			"/\[url=www.([^\[\"']+?)\](.+?)\[\/url\]/is",
			"/\[url=(https?|ftp|gopher|news|telnet|rtsp|mms){1}:\/\/([^\[\"']+?)\](.+?)\[\/url\]/is",
			"/\[email\]\s*([A-Za-z0-9\-_.]+)@([A-Za-z0-9\-_]+[.][A-Za-z0-9\-_.]+)\s*\[\/email\]/i",
			"/\[email=([A-Za-z0-9\-_.]+)@([A-Za-z0-9\-_]+[.][A-Za-z0-9\-_.]+)\](.+?)\[\/email\]/is",
			"/\[color=([^\[]+?)\]/i",
			"/\[size=([^\[]+?)\]/i",
			"/\[font=([^\[]+?)\]/i",
			"/\[align=([^\[]+?)\]/i",
			"/\[center\]/i"
		);
		$replacearray['bbcode_regexp'] = array(
			"<div class=\"quote\"><b>:</b><div style=\"height: 1px; overflow: hidden; background: ".COLOR4."\"></div>\\1</div>",
			"\\1\\2",
			"<a href=\"http://www.\\1\" target=\"_blank\">\\2</a>",
			"<a href=\"\\1://\\2\" target=\"_blank\">\\3</a>",
			"<a href=\"mailto:\\1@\\2\">\\1@\\2</a>",
			"<a href=\"mailto:\\1@\\2\">\\3</a>",
			"<font color=\"\\1\">",
			"<font size=\"\\1\">",
			"<font face=\"\\1\">",
			"<p align=\"\\1\">",
			"<p align=\"center\">"
		);
		$searcharray['bbcode_str'] = array(
			'[/color]', '[/size]', '[/font]', '[/align]', '[b]', '[/b]',
			'[i]', '[/i]', '[u]', '[/u]', '[list]', '[list=1]', '[list=a]',
			'[list=A]', '[*]', '[/list]','[/center]'
		);
		$replacearray['bbcode_str'] = array(
			'</font>', '</font>', '</font>', '</p>', '<b>', '</b>', '<i>',
			'</i>', '<u>', '</u>', '<ul>', '<ol type=1>', '<ol type=a>',
			'<ol type=A>', '<li>', '</ul></ol>','</p>'
		);
		$searcharray['imgcode'] = array(
			"/\[swf\]\s*([^\[]+?)\s*\[\/swf\]/is",
			"/\[img\]\s*([^\[]+?)\s*\[\/img\]/is",
			"/\[img=(\d{1,3})[x|\,](\d{1,3})\]\s*([^\[]+?)\s*\[\/img\]/is"
		);
		$replacearray['imgcode'] = array(
			'<embed src="\\1" width="400" height="300"></embed>',
			'<img src="\\1" border="0" />',
			'<img width="\\1" height="\\2" src="\\3" border="0" />'
		);
		@$message = str_replace($searcharray['bbcode_str'], $replacearray['bbcode_str'], $message);
		$message = preg_replace($searcharray['bbcode_regexp'], $replacearray['bbcode_regexp'], $message);
		$message = preg_replace($searcharray['imgcode'], $replacearray['imgcode'], $message);
		$message = nl2br($message);
		//return $message;
	}

	public function get_fid_by_tid($tid) {
		return $this->db->result_first("SELECT fid FROM bbs_thread WHERE tid='$tid'");
	}

	public function get_postlist_by_tid_page($page, $ppp, $tid, $word) {
		if(!XIUNO_BBS_POST_PAGE_ON) {
			return false;
		}
		$postlist = $this->db->fetch_all("/*cachelife=3600&mckey=md5()*/ SELECT * FROM bbs_post WHERE tid='$tid' AND page='$page'", 'pid');
		ksort($postlist);
		$start = ($page-1) * $ppp;
		$userinfo = array();
		$floor = 0;
		$groups = $this->base->cache('groups');
		foreach($postlist as &$post) {
			$post['floor'] = $floor + $start + 1;
			$floor++;
			$this->format_post($post, $word);
			$post['replylist'] = XIUNO_BBS_POST_REPLY_ON && $post['replies'] ?
				$this->get_postreply_by_pid($post['pid'], $post['replies']) : array();
		}
		return $postlist;
	}

	//ȡϴλظ
	public function get_threadlastpost_by_tid_uid($tid, $uid, $pid = 0) {
	        if(!empty($pid)) {
                        $sql = "SELECT * FROM bbs_post WHERE tid='$tid' AND uid='$uid' and pid<'$pid' ORDER BY dateline DESC LIMIT 1";
	        } else {
	                $sql = "SELECT * FROM bbs_post WHERE tid='$tid' AND uid='$uid' ORDER BY dateline DESC LIMIT 1";
	        }
                $result = $this->db->fetch_first($sql);
                return $result;
	}

	// ¥㣬˴ view ݲӦ÷ model 㴦
	public function get_postreply_by_pid($pid, $totalnum, $startreplyid = 0, $page=1) {
		$ppp = (defined('XIUNO_BBS_POST_REPLY_PPP') && XIUNO_BBS_POST_REPLY_PPP) ? XIUNO_BBS_POST_REPLY_PPP : 50;
		$replylist = $this->db->fetch_all("SELECT * FROM bbs_post_reply WHERE pid='$pid' AND replyid > $startreplyid ORDER BY replyid LIMIT $ppp");

		// ¥ʾ
		$replystr = '';
		foreach($replylist as $key => $reply) {
			$delete = '';
			if($reply['uid'] == $this->base->user['uid'] || $this->base->user['groupid'] <= XIUNO_MODERATOR_GROUPID) {
				$delete .= '<a href="'.XIUNO_HOST_BBS.'post-deletepostreply-'.$reply['replyid'].'.htm" ';
				$delete .= 'onclick="return ajaxconfirm(\'ȷɾ?\', this.href, del_replay_recall())" class="delete"> </a>';
			}
			$reply['dateline'] = $this->base->date($reply['dateline']);
			$replystr = '<div class="floor">'.$replystr
			.'<div class="floor_head grey">'.$delete.'[ '.(++$key + ($page-1) * $ppp).' ¥ ] '.$reply['username'].'  '.$reply['dateline'].'</div>'
			.'<div class="floor_content">'.$reply['message'].'</div></div>';
		}

		// ҳ
		$fromfloor = ($page * $ppp + 1) > $totalnum ? 1 : ($page * $ppp + 1);
		$tofloor = ($fromfloor + $ppp - 1) > $totalnum ? $totalnum : ($fromfloor + $ppp - 1);
		$page = ++$page > ceil($totalnum / $ppp) ? 1 : $page;
		$startreplyid = $page == 1 ? 0 : $replylist[$key-1]['replyid'];
		$replystr = '<div class="floor">'.$replystr
			.'<div class="floor_head grey"> '.$totalnum.' ¥ <a style="color:'.COLORALERT.'" href="'.XIUNO_HOST_BBS.'post-getpostreply-'.$pid.'-'.$totalnum.'-'.$startreplyid.'.htm?page='.$page.'" onclick="ajaxget(this.href, \'replylist_'.$pid.'\')"> '.$fromfloor.'-'.$tofloor.'</a></div></div>';
		return $replystr;
	}

	public function get_postreply_by_replyid($replyid) {
		return $this->db->fetch_first("SELECT * FROM bbs_post_reply WHERE replyid='$replyid'");
	}

	public function delete_postreply_by_replyid($replyid, $pid) {
		$this->db->query("DELETE FROM bbs_post_reply WHERE replyid='$replyid'");
		$num = intval($this->db->affected_rows());
		$num && $this->db->query("/*primarykey=pid*/ UPDATE bbs_post SET replies=replies-'1' WHERE pid='$pid'");
		return $num;
	}

        public function update_thread_flower($tid) {
        	return $this->db->query("/*primarykey=tid*/ UPDATE LOW_PRIORITY bbs_thread SET flower=flower+'1' WHERE tid='$tid';");
        }

        public function format_file_size($bytes) {
        	$lentharray = array('Bytes', 'KB', 'MB', 'GB', 'TB');
        	$i = 0;
		while($bytes >= 1024) {
			$bytes = sprintf('%.2f', $bytes / 1024);
			$i++;
		}
		return $bytes.' '.$lentharray[$i];
        }
}
?>